!*********************************************
!* This file is generated by FORTRANS.       *
!*********************************************


SUBROUTINE CONMSG( CMI, MSGNUM, R1, R2, I1, I2, TOSCR, FINAL )
!**   LOGICAL OPERATION
!**       Writes a message including variable real and integer
!**       information merged at certain positions.
!*
   Use CONOPT_Data
   Use CONOPT_Utilities
      IMPLICIT NONE

   Type (Conopt_Model_Info) CMI
   INTEGER MSGNUM, I1, I2
   LOGICAL TOSCR, FINAL
   REAL(CO_R)  R1, R2, R3

   character*20 rmsg, rmsg2
   character*12 imsg, imsg2, imsg3, imsg4
   integer      rlen, rlen2, ilen, ilen2, ilen3, ilen4
!
!  Test if we should flush the message buffer before continuing
!  The cases for flushing depend on the current value of Smsg and
!  Dmsg, and Nmsg:
!
!  If Dmsg ne Nmsg, Flush
!  If Smsg gt Nmsg, Flush
!  If Nmsg gt Smsg and Toscr, Flush
!
   IF ( CMI%NMSG .NE. CMI%DMSG .OR. CMI%SMSG .GT. CMI%NMSG .OR. CMI%NMSG .GT. CMI%SMSG .AND. TOSCR ) THEN
      CALL CONOUT( CMI )
   ENDIF
!------------------------------------------------------------
   if ( msgnum .eq. 1002 ) then
!    Residual=           , r1
!    Tolerance (Rtnwtr)= , r2
!
      call cor2c( r1, rmsg, 18, 8, rlen )
      call cor2c( r2, rmsg2, 18, 8, rlen2 )
      cmi%msgv(cmi%nmsg+1) = '    Residual=           ' // rmsg(1:rlen)
      cmi%msgv(cmi%nmsg+2) = '    Tolerance (Rtnwtr)= ' // rmsg2(1:rlen2)
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 1003 ) then
!    The pre-triangular feasibility tolerance may be relaxed with
!    a line:
!
!    Rtnwtr = x.xx
!
!    in the CONOPT control program (Options file).
!
      cmi%msgv(cmi%nmsg+1) = '    The pre-triangular feasibility tolerance may be relaxed with'
      cmi%msgv(cmi%nmsg+2) = '    a line:'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%msgv(cmi%nmsg+4) = '    Rtnwtr = x.xx'
      cmi%msgv(cmi%nmsg+5) = ' '
      cmi%msgv(cmi%nmsg+6) = '    in the CONOPT control program (Options file).'
      cmi%msgv(cmi%nmsg+7) = ' '
      cmi%nmsg = cmi%nmsg + 7

!------------------------------------------------------------
   elseif ( msgnum .eq. 1004 ) then
!    The allowable range can be changed with a line:
!
!    Rtmaxv = x.xxe+xx
!
!    in the CONOPT control program (Options file).
!
      cmi%msgv(cmi%nmsg+1) = '    The allowable range can be changed with a line:'
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%msgv(cmi%nmsg+3) = '    Rtmaxv = x.xxe+xx'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%msgv(cmi%nmsg+5) = '    in the CONOPT control program (Options file).'
      cmi%msgv(cmi%nmsg+6) = ' '
      cmi%nmsg = cmi%nmsg + 6

!------------------------------------------------------------
   elseif ( msgnum .eq. 1005 ) then
!                    You must request more memory.
!                    Current   CONOPT space = ,r3, Mbytes
!                    Estimated CONOPT space = ,r3, Mbytes
!                    Minimum   CONOPT space = ,r3, Mbytes
!
      r3 = cmi%latott / 128. / 1024.
      call cor2f( r3, rmsg, 8, 2 )
      cmi%msgv(cmi%nmsg+1) = '                    You must request more memory.'
      cmi%msgv(cmi%nmsg+2) = '                    Current   CONOPT space =' // rmsg(1:8) // ' Mbytes'
      r3 = cmi%RVESTM / 128. / 1024.
      call cor2f( r3, rmsg, 8, 2 )
      cmi%msgv(cmi%nmsg+3) = '                    Estimated CONOPT space =' // rmsg(1:8) // ' Mbytes'
      r3 = cmi%rvminm / 128. / 1024.
      call cor2f( r3, rmsg, 8, 2 )
      cmi%msgv(cmi%nmsg+4) = '                    Minimum   CONOPT space =' // rmsg(1:8) // ' Mbytes'
      cmi%msgv(cmi%nmsg+5) = ' '
      cmi%nmsg = cmi%nmsg + 5

!------------------------------------------------------------
   elseif ( msgnum .eq. 1006 ) then
!    The feasibility tolerance (Rtnwmi) is ,r1
!    It may may be relaxed with a line:
!
!    Rtnwmi = x.xx
!
!    in the CONOPT control program (Options file).
!
      call cor2c( r1, rmsg, 13, 5, rlen )
      cmi%msgv(cmi%nmsg+1) = '    The feasibility tolerance (Rtnwmi) is ' //  rmsg(1:rlen)
      cmi%msgv(cmi%nmsg+2) = '    It may be relaxed with a line:'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%msgv(cmi%nmsg+4) = '    Rtnwmi = x.xx'
      cmi%msgv(cmi%nmsg+5) = ' '
      cmi%msgv(cmi%nmsg+6) = '    in the CONOPT control program (Options file).'
      cmi%msgv(cmi%nmsg+7) = ' '
      cmi%nmsg = cmi%nmsg + 7

!------------------------------------------------------------
   elseif ( msgnum .eq. 1007 ) then
!    The critical limit may be increased with the line:
!
!    Rtmaxj = x.xxe+xx
!
!    in the CONOPT control program (Options file).
!
      cmi%msgv(cmi%nmsg+1) = '    The critical limit may be increased with the line:'
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%msgv(cmi%nmsg+3) = '    Rtmaxj = x.xxe+xx'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%msgv(cmi%nmsg+5) = '    in the CONOPT control program (Options file).'
      cmi%msgv(cmi%nmsg+6) = ' '
      cmi%nmsg = cmi%nmsg + 6

!------------------------------------------------------------
   elseif ( msgnum .eq. 1008 ) then
!                    It is not possible to allocate enough memory.
!                    Maximum available space <= ,r1, Mbytes
!                    Estimated  CONOPT space =  ,r3, Mbytes
!                    Minimum    CONOPT space =  ,r3, Mbytes
!
      r3 = r1 / 128. / 1024.
      call cor2f( r3, rmsg, 8, 2 )
      cmi%msgv(cmi%nmsg+1) = '                    It is not possible to allocate enough memory.'
      cmi%msgv(cmi%nmsg+2) = '                    Maximum available space <=' // rmsg(1:8) // ' Mbytes'
      r3 = cmi%RVESTM / 128. / 1024.
      call cor2f( r3, rmsg, 9, 2 )
      cmi%msgv(cmi%nmsg+3) = '                    Estimated  CONOPT space =' // rmsg(1:9) // ' Mbytes'
      r3 = cmi%rvminm / 128. / 1024.
      call cor2f( r3, rmsg, 9, 2 )
      cmi%msgv(cmi%nmsg+4) = '                    Minimum    CONOPT space =' // rmsg(1:9) // ' Mbytes'
      cmi%msgv(cmi%nmsg+5) = ' '
      cmi%nmsg = cmi%nmsg + 5

!------------------------------------------------------------
   elseif ( msgnum .eq. 1009 ) then
!    The number of non-fixed non-recursive variables appearing in
!    each non-recursive equation is defined by the negative
!    marginals on the equations. And the number of non-recursive
!    equations that each non-fixed non-recursive variable appears
!    in is defined by the negative marginals on the variables.
!    (Scaling may change the counts. If so, rerun without scaling.)
!
!    You must fix at least one variable with a negative marginal or
!    change an inequality with a negative marginal to an equality
!    to get a recursive model.
!
      cmi%msgv(cmi%nmsg+1) = '    The number of non-fixed non-recursive variables appearing in'
      cmi%msgv(cmi%nmsg+2) = '    each non-recursive equations is defined by the negative'
      cmi%msgv(cmi%nmsg+3) = '    marginals on the equations. And the number of non-recursive'
      cmi%msgv(cmi%nmsg+4) = '    equations that each non-fixed non-recursive variable appears'
      cmi%msgv(cmi%nmsg+5) = '    in is defined by the negative marginals on the variables.'
      cmi%msgv(cmi%nmsg+6) = '    (Scaling may change the counts. If so, rerun without scaling.)'
      cmi%msgv(cmi%nmsg+7) = ' '
      cmi%msgv(cmi%nmsg+8) = '    You must fix at least one variable with a negative marginal or'
      cmi%msgv(cmi%nmsg+9) = '    change an inequality with a negative marginal to an equality'
      cmi%msgv(cmi%nmsg+10) ='    to get a recursive model.'
      cmi%msgv(cmi%nmsg+11) =' '
      cmi%nmsg = cmi%nmsg + 11

!------------------------------------------------------------
   elseif ( msgnum .eq. 1010 ) then
!    The recursive order of the (i1) equations and variables solved
!    until now is defined by the positive values of the nonzero
!    marginals.
!
!    Equations without positive marginals have not been solved yet
!    and you can therefore ignore infeasibility messages for these
!    equations.
!
      call coi2c( i1, imsg, ilen )
      cmi%msgv(cmi%nmsg+1) = '    The recursive order of the ' // imsg(1:ilen) // ' equations and variables solved'
      cmi%msgv(cmi%nmsg+2) = '    until now is defined by the positive values of the nonzero'
      cmi%msgv(cmi%nmsg+3) = '    marginals.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%msgv(cmi%nmsg+5) = '    Equations without positive marginals have not been solved yet'
      cmi%msgv(cmi%nmsg+6) = '    and you can therefore ignore infeasibility messages for these'
      cmi%msgv(cmi%nmsg+7) = '    equations.'
      cmi%msgv(cmi%nmsg+8) = ' '
      cmi%nmsg = cmi%nmsg + 8

!------------------------------------------------------------
   elseif ( msgnum .eq. 1011 ) then
!    The Post-triangular equations may be turned into ordinary
!    equations with a line:
!
!    Lspost = False
!
!    in the CONOPT control program (Options file).
!
      cmi%msgv(cmi%nmsg+1) = '    The Post-triangular equations may be turned into ordinary'
      cmi%msgv(cmi%nmsg+2) = '    equations with a line:'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%msgv(cmi%nmsg+4) = '    Lspost = False'
      cmi%msgv(cmi%nmsg+5) = ' '
      cmi%msgv(cmi%nmsg+6) = '    in the CONOPT control program (Options file).'
      cmi%msgv(cmi%nmsg+7) = ' '
      cmi%nmsg = cmi%nmsg + 7
!------------------------------------------------------------
   elseif ( msgnum .eq. 1012 ) then
!    The Pre-triangular equations may be turned into ordinary
!    equations with a line:
!
!    Lspret = False
!
!    in the CONOPT control program (Options file).
!
!   --- OR in case we have Lstria turned on ----
!    The Triangular equations may be turned into ordinary
!    equations with the lines:
!
!    Lspret = False
!    Lstria = False
!
!    in the CONOPT control program (Options file).
!
      if ( CMI%LSTRIA ) THEN
      cmi%msgv(cmi%nmsg+1) = '    The Triangular equations may be turned into ordinary'
      cmi%msgv(cmi%nmsg+2) = '    equations with the lines:'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%msgv(cmi%nmsg+4) = '    Lspret = False'
      cmi%msgv(cmi%nmsg+5) = '    Lstria = False'
      cmi%msgv(cmi%nmsg+6) = ' '
      cmi%msgv(cmi%nmsg+7) = '    in the CONOPT control program (Options file).'
      cmi%msgv(cmi%nmsg+8) = ' '
      cmi%nmsg = cmi%nmsg + 8
      else
      cmi%msgv(cmi%nmsg+1) = '    The Pre-triangular equations may be turned into ordinary'
      cmi%msgv(cmi%nmsg+2) = '    equations with a line:'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%msgv(cmi%nmsg+4) = '    Lspret = False'
      cmi%msgv(cmi%nmsg+5) = ' '
      cmi%msgv(cmi%nmsg+6) = '    in the CONOPT control program (Options file).'
      cmi%msgv(cmi%nmsg+7) = ' '
      cmi%nmsg = cmi%nmsg + 7
      endif
!------------------------------------------------------------
   elseif ( msgnum .eq. 1013 ) then
!
! CONOPT time ,r1, seconds
      cmi%msgv(cmi%nmsg+1) = ' '
      call cor2f( r1, rmsg, 10, 3 )
      cmi%msgv(cmi%nmsg+2) = ' CONOPT time Total                       ' // rmsg(1:10) // ' seconds'
      cmi%nmsg = cmi%nmsg + 2
!------------------------------------------------------------
   elseif ( msgnum .eq. 1014) then
!   of which: Function evaluations    ,r1,  r2%
      call cor2f( r1, rmsg, 10, 3 )
      call cor2f( r2, rmsg2, 5, 1 )
      cmi%msgv(cmi%nmsg+1) = '   of which: Function evaluations        ' // rmsg(1:10) // ' =' // rmsg2(1:5) // '%'
      cmi%nmsg = cmi%nmsg + 1
!------------------------------------------------------------
   elseif ( msgnum .eq. 1015) then
!             1st Derivative evaluations  ,r1,  r2%
      call cor2f( r1, rmsg, 10, 3 )
      call cor2f( r2, rmsg2, 5, 1 )
      cmi%msgv(cmi%nmsg+1) = '             1st Derivative evaluations  ' // rmsg(1:10) // ' =' // rmsg2(1:5) // '%'
      cmi%nmsg = cmi%nmsg + 1

!------------------------------------------------------------
   elseif ( msgnum .eq. 1016) then
!             2nd Derivative evaluations  ,r1,  r2%
      call cor2f( r1, rmsg, 10, 3 )
      call cor2f( r2, rmsg2, 5, 1 )
      cmi%msgv(cmi%nmsg+1) = '             2nd Derivative evaluations  ' // rmsg(1:10) // ' =' // rmsg2(1:5) // '%'
      cmi%nmsg = cmi%nmsg + 1

!------------------------------------------------------------
   elseif ( msgnum .eq. 1017) then
!             Directional 2nd Derivative  ,r1,  r2%
      call cor2f( r1, rmsg, 10, 3 )
      call cor2f( r2, rmsg2, 5, 1 )
      cmi%msgv(cmi%nmsg+1) = '             Directional 2nd Derivative  ' // rmsg(1:10) // ' =' // rmsg2(1:5) // '%'
      cmi%nmsg = cmi%nmsg + 1
!------------------------------------------------------------
   elseif ( msgnum .eq. 1018) then
!           (blank line)
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%nmsg = cmi%nmsg + 1

!------------------------------------------------------------
   elseif ( msgnum .eq. 1100 ) then
!
! ** The Derivative Debugger has found the following significant
!    differences between the derivatives combuted by the modeler
!    (Computed) and numerical differences computed by CONOPT
!    (Approx) and/or in the structure of the Jacobian:
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** The Derivative Debugger has found the following significant'
      cmi%msgv(cmi%nmsg+3) = '    differences between the derivatives computed by the modeler'
      cmi%msgv(cmi%nmsg+4) = '    (Computed) and numerical differences computed by CONOPT'
      cmi%msgv(cmi%nmsg+5) = '    (Approx) and/or in the structure of the Jacobian:'
      cmi%msgv(cmi%nmsg+6) = ' '
      cmi%nmsg = cmi%nmsg + 6

!------------------------------------------------------------
   elseif ( msgnum .eq. 1101 ) then
!
! ** The Derivative Debugger has found the following insignificant
!    error(s):
!    (You can use the Jcnm argument of FDEval to clear only the
!    nonzero positions of Jac.)
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** The Derivative Debugger has found the following insignificant'
      cmi%msgv(cmi%nmsg+3) = '    error(s):'
      cmi%msgv(cmi%nmsg+4) = '    (You can use the Jcnm argument of FDEval to clear only the'
      cmi%msgv(cmi%nmsg+5) = '    nonzero positions of Jac.)'
      cmi%msgv(cmi%nmsg+6) = ' '
      cmi%nmsg = cmi%nmsg + 6

!------------------------------------------------------------
   elseif ( msgnum .eq. 2000 ) then
!
! ** An equation is inconsistent with other equations in the
!    pre-triangular part of the model.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** An equation is inconsistent with other equations in the'
      cmi%msgv(cmi%nmsg+3) = '    pre-triangular part of the model.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 2001 ) then
!
! ** An equation in the pre-triangular part of the model cannot
!    be solved because the pivot is too small.
!    Adding a bound or initial value may help.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** An equation in the pre-triangular part of the model cannot'
      cmi%msgv(cmi%nmsg+3) = '    be solved because the pivot is too small.'
      cmi%msgv(cmi%nmsg+4) = '    Adding a bound or initial value may help.'
      cmi%msgv(cmi%nmsg+5) = ' '
      cmi%nmsg = cmi%nmsg + 5

!------------------------------------------------------------
   elseif ( msgnum .eq. 2002 .or. msgnum .eq. 2003 ) then
!
! ** An equation in the pre-triangular part of the model cannot be
!    solved because the critical variable is at a bound.
!
! -- or --
!
! ** An equation in the pre-triangular part of the model cannot be
!    solved because the critical slack is at a bound.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** An equation in the pre-triangular part of the model cannot'
      if ( msgnum .eq. 2002 ) then
         cmi%msgv(cmi%nmsg+3) = '    be solved because the critical variable is at a bound.'
      else
         cmi%msgv(cmi%nmsg+3) = '    be solved because the critical slack is at a bound.'
      endif
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 2004 ) then
!
! ** An equation in the pre-triangular part of the model cannot be
!    solved because there are no non-fixed variables left.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** An equation in the pre-triangular part of the model cannot'
      cmi%msgv(cmi%nmsg+3) = '    be solved because there are no non-fixed variables left.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 2005 .or. msgnum .eq. 2006 ) then
!
! ** A derivative is too large (larger than Rtmaxj=,r1,).
!    Scale the variables and/or equations or add bounds.
!
! -- or --
!
! ** An initial derivative is too large (larger than Rtmaxj=,r1,).
!    Scale the variables and/or equations or add bounds.
!
!  Comment: Rtmaxj is not included in the message if the model is scaled
!  since the limiting value in this case is the internal Rtamxj.
!
      call cor2c( r1, rmsg, 8, 1, rlen )
      cmi%msgv(cmi%nmsg+1) = ' '
      if ( msgnum .eq. 2005 ) then
         if ( cmi%lsscal ) then
         cmi%msgv(cmi%nmsg+2) = ' ** A derivative is too large (larger than ' // rmsg(1:rlen) // ').'
         else
         cmi%msgv(cmi%nmsg+2) = ' ** A derivative is too large (larger than Rtmaxj=' // rmsg(1:rlen) // ').'
         endif
      else
         if ( cmi%lsscal ) then
         cmi%msgv(cmi%nmsg+2) = ' ** An initial derivative is too large (larger than ' // rmsg(1:rlen) // ').'
         else
         cmi%msgv(cmi%nmsg+2) = ' ** An initial derivative is too large (larger than Rtmaxj=' // rmsg(1:rlen) // ').'
         endif
      endif
      cmi%msgv(cmi%nmsg+3) = '    Scale the variables and/or equations or add bounds.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 2007 ) then
!
! ** An Upper bound is too large (larger than ,r1,).
!    Change the bound or Scale the variable
!    Note: The bound value may have been changed by scaling.
!
      call cor2c( r1, rmsg, 8, 1, rlen )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** An Upper bound is too large (larger than ' // rmsg(1:rlen) // ').'
      cmi%msgv(cmi%nmsg+3) = '    Change the bound or Scale the variable'
      cmi%msgv(cmi%nmsg+4) = '    Note: The bound value may have been changed by scaling.'
      cmi%msgv(cmi%nmsg+5) = ' '
      cmi%nmsg = cmi%nmsg + 5

!------------------------------------------------------------
   elseif ( msgnum .eq. 2008 ) then
!
! ** An Lower bound is too small (smaller than -Rtmaxv=,r1,).
!    Change the bound or Scale the variable
!    Note: The bound value may have been changed by scaling.
!
      call cor2c( r1, rmsg, 8, 1, rlen )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** An Lower bound is too small (smaller than -Rtmaxv = ' // rmsg(1:rlen) // ').'
      cmi%msgv(cmi%nmsg+3) = '    Change the bound or Scale the variable'
      cmi%msgv(cmi%nmsg+4) = '    Note: The bound value may have been changed by scaling.'
      cmi%msgv(cmi%nmsg+5) = ' '
      cmi%nmsg = cmi%nmsg + 5

!------------------------------------------------------------
   elseif ( msgnum .eq. 2009 ) then
!
! ** A dual variable is too large (larger than,r1,).
!    Scale the variables and/or equations or add bounds.
!
      call cor2c( r1, rmsg, 8, 1, rlen )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** A dual variable is too large' // ' (larger than ' // rmsg(1:rlen) // ').'
      cmi%msgv(cmi%nmsg+3) = '    Scale the variables and/or equations or add bounds.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 2010 ) then
!
! ** An equation in the pre-triangular part of the model cannot
!    be solved because the equation or its derivatives appear to
!    be discontinuous or because the function and derivative are
!    inconsistent.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** An equation in the pre-triangular part of the model cannot'
      cmi%msgv(cmi%nmsg+3) = '    be solved because the equation or its derivatives appear to'
      cmi%msgv(cmi%nmsg+4) = '    be discontinuous or because the function and derivative are'
      cmi%msgv(cmi%nmsg+5) = '    inconsistent.'
      cmi%msgv(cmi%nmsg+6) = ' '
      cmi%nmsg = cmi%nmsg + 6

!------------------------------------------------------------
   elseif ( msgnum .eq. 2011 .or. msgnum .eq. 2012 ) then
!
! ** An equation in the pre-triangular part of the model cannot be
!    solved because the critical variable has reached 'Infinity'.
!    Largest legal value (Rtmaxv) is , r1
!
! -- or --
!
! ** An equation in the pre-triangular part of the model cannot be
!    solved because the critical slack has reached 'Infinity'.
!    Largest legal value (Rtmaxv) is , r1
!
      call cor2c( r1, rmsg, 10, 2, rlen )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** An equation in the pre-triangular part of the model cannot'
      if ( msgnum .eq. 2011 ) then
         cmi%msgv(cmi%nmsg+3) = '    be solved because the critical variable has reached ''Infinity''.'
      else
         cmi%msgv(cmi%nmsg+3) = '    be solved because the critical slack has reached ''Infinity''.'
      endif
      cmi%msgv(cmi%nmsg+4) = '    Largest legal value (Rtmaxv) is ' // rmsg(1:rlen)
      cmi%msgv(cmi%nmsg+5) = ' '
      cmi%nmsg = cmi%nmsg + 5

!------------------------------------------------------------
   elseif ( msgnum .eq. 2013 ) then
!  (Messages beyond <i1>=Lfemsg are skipped.)
!
      call coi2c( i1, imsg, ilen )
      cmi%msgv(cmi%nmsg+1) = '    (Messages beyond ' // imsg(1:ilen) // '=Lfemsg are skipped.)'
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%nmsg = cmi%nmsg + 2

!------------------------------------------------------------
   elseif ( msgnum .eq. 2014 ) then
!
! ** An equation in the pre-triangular part of the model cannot
!    be solved because a 2nd derivative is very large.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** An equation in the pre-triangular part of the model cannot'
      cmi%msgv(cmi%nmsg+3) = '    be solved because the 2nd derivative is very large.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 2015 .OR. msgnum .eq. 2016 ) then
!
! ** A derivative is very large or NaN (Not a Number).  or
! ** An initial derivative is very large or NaN (Not a Number).
!    Add bound to ensure that the derivatives are defined.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      if ( msgnum .eq. 2015 ) then
         cmi%msgv(cmi%nmsg+2) = ' ** A derivative is very large or NaN (Not a Number).'
      else
         cmi%msgv(cmi%nmsg+2) = ' ** An initial derivative is very large or NaN (Not a Number).'
      endif
      cmi%msgv(cmi%nmsg+3) = '    Add bounds to ensure that the derivatives are defined.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 2017 ) then
!
!
! ** A variable was initialized below the internal value of -Inf
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** A variable was initialized below the internal value of -Inf'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 2018 ) then
!
!
! ** A variable was initialized above the internal value of -Inf
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** A variable was initialized above the internal value of +Inf'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 2020 ) then
!
! ** The search for a feasible solution is stopped because a slack variable
!    has reached 'Infinity'.
!    Largest legal value (Rtmaxv) is , r1
!
      call cor2c( r1, rmsg, 10, 2, rlen )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** The search for a feasible solution is stopped because a slack variable'
      cmi%msgv(cmi%nmsg+3) = '    has reached ''Infinity''.'
      cmi%msgv(cmi%nmsg+4) = '    Largest legal value (Rtmaxv) is ' // rmsg(1:rlen)
      cmi%msgv(cmi%nmsg+5) = ' '
      cmi%nmsg = cmi%nmsg + 5

!------------------------------------------------------------
   elseif ( msgnum .eq. 2100 .or. msgnum .eq. 2101 .or. msgnum .eq. 2102 ) then
!
! ** Optimal solution. Convergence too slow. The change in objective
!    has been less than xx.xx for xx consecutive iterations..
!
! -- or --
!
! ** Feasible solution. Convergence too slow. The change in objective
!    has been less than xx.xx for xx consecutive iterations..
!
! -- or --
!
! ** Infeasible solution. Convergence too slow. The change in objective
!    has been less than xx.xx for xx consecutive iterations..
!
      call cor2c( r1, rmsg, 12, 4, rlen )
      call coi2c( i1, imsg, ilen )
      cmi%msgv(cmi%nmsg+1) = ' '
      if ( msgnum .eq. 2100 ) then
         cmi%msgv(cmi%nmsg+2) = ' ** Optimal solution. Convergence too slow. The change in objective'
      elseif ( msgnum .eq. 2101 ) then
         cmi%msgv(cmi%nmsg+2) = ' ** Feasible solution. Convergence too slow. The change in objective'
      elseif ( msgnum .eq. 2102 ) then
         cmi%msgv(cmi%nmsg+2) = ' ** Infeasible solution. Convergence too slow. The change in objective'
      endif
      cmi%msgv(cmi%nmsg+3) = '    has been less than ' // rmsg(1:rlen) // ' for ' // imsg(1:ilen) // ' consecutive iterations'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 2105 .or. msgnum .eq. 2106 ) then
!
!  ** Infeasible solution. The tolerances are minimal and
!     there is no change in objective although the reduced
!     gradient is greater than the tolerance.
!
! -- or --
!
!  ** Feasible solution. The tolerances are minimal and
!     there is no change in objective although the reduced
!     gradient is greater than the tolerance.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      if ( msgnum .eq. 2105 ) then
         cmi%msgv(cmi%nmsg+2) = ' ** Infeasible solution. The tolerances are minimal and'
      else
         cmi%msgv(cmi%nmsg+2) = ' ** Feasible solution. The tolerances are minimal and'
      endif
      cmi%msgv(cmi%nmsg+3) = '    there is no change in objective although the reduced'
      cmi%msgv(cmi%nmsg+4) = '    gradient is greater than the tolerance.'
      cmi%msgv(cmi%nmsg+5) = ' '
      cmi%nmsg = cmi%nmsg + 5

!------------------------------------------------------------
   elseif ( msgnum .eq. 2109 .or. msgnum .eq. 2110 ) then
!
! ** Infeasible solution. There are no superbasic variables.
!
! -- or --
!
! ** Optimal solution. There are no superbasic variables.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      if ( msgnum .eq. 2109 ) then
         cmi%msgv(cmi%nmsg+2) = ' ** Infeasible solution. There are no superbasic variables.'
      else
         cmi%msgv(cmi%nmsg+2) = ' ** Optimal solution. There are no superbasic variables.'
      endif
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 2113 .or. msgnum .eq. 2114 ) then
!
! ** Infeasible solution. A variable has reached 'Infinity'.
!    Largest legal value (Rtmaxv) is xx.xx
!
! -- or --
!
! ** Unbounded solution. A variable has reached 'Infinity'.
!    Largest legal value (Rtmaxv) is xx.xx
!
      call cor2c( r1 , rmsg, 10, 2, rlen )
      cmi%msgv(cmi%nmsg+1) = ' '
      if ( msgnum .eq. 2113 ) then
         cmi%msgv(cmi%nmsg+2) = ' ** Infeasible solution. A variable has reached ''Infinity''.'
      else
         cmi%msgv(cmi%nmsg+2) = ' ** Unbounded solution. A variable has reached ''Infinity''.'
      endif
      cmi%msgv(cmi%nmsg+3) = '    Largest legal value (Rtmaxv) is ' // rmsg(1:rlen)
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 2117 .or. msgnum .eq. 2118 ) then
!
!  ** Infeasible solution. Reduced gradient less than tolerance.
!
! -- or --
!
!  ** Optimal solution. Reduced gradient less than tolerance.
!     Tolerance is relaxed due to large 2nd derivatives. (only if lshesi)
!
!
      cmi%msgv(cmi%nmsg+1) = ' '
      if ( msgnum .eq. 2117 ) then
         cmi%msgv(cmi%nmsg+2) = ' ** Infeasible solution. Reduced gradient less than tolerance.'
      else
         cmi%msgv(cmi%nmsg+2) = ' ** Optimal solution. Reduced gradient less than tolerance.'
      endif
      if ( cmi%lshesi ) then
         cmi%msgv(cmi%nmsg+3) = '    Tolerance is relaxed due to large 2nd derivatives.'
         cmi%nmsg = cmi%nmsg + 1
      endif
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 2121 .or. msgnum .eq. 2122 ) then
!
! ** Infeasible solution. The error in the optimal objective function
!    value estimated from the reduced gradient and the estimated
!    Hessian is less than the minimal tolerance on the objective.
!
! -- or --
!
! ** Optimal solution. The error in the optimal objective function
!    value estimated from the reduced gradient and the estimated
!    Hessian is less than the minimal tolerance on the objective.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      if ( msgnum .eq. 2121 ) then
         cmi%msgv(cmi%nmsg+2) = ' ** Infeasible solution. The error in the optimal objective function'
      else
         cmi%msgv(cmi%nmsg+2) = ' ** Optimal solution. The error in the optimal objective function value'
      endif
      cmi%msgv(cmi%nmsg+3) = '    value estimated from the reduced gradient and the estimated'
      cmi%msgv(cmi%nmsg+4) = '    Hessian is less than the minimal tolerance on the objective.'
      cmi%msgv(cmi%nmsg+5) = ' '
      cmi%nmsg = cmi%nmsg + 5

!------------------------------------------------------------
   elseif ( msgnum .eq. 2125 ) then
!
! ** Infeasible solution. A free variable exceeds the allowable range.'
!    Current value is ,r2, and current upper bound (Rtmaxv) is ,r1
!
      call cor2c( r1, rmsg, 10, 2, rlen )
      call cor2c( r2, rmsg2, 10, 2, rlen2 )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Infeasible solution. A free variable exceeds the allowable range.'
      cmi%msgv(cmi%nmsg+3) = '    Current value is ' // rmsg2(1:rlen2)// ' and current upper bound (Rtmaxv) is ' // rmsg(1:rlen)
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 2127 ) then
!
! ** Infeasible solution. The equations were assumed to be recursive,
!    but they are not.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Infeasible solution. The equations were assumed to be recursive,'
      cmi%msgv(cmi%nmsg+3) = '    but they are not.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 2128 ) then
!
! ** Infeasible solution. The equations were assumed to be recursive,
!    but they are not. A pivot element is too small.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Infeasible solution. The equations were assumed to be recursive,'
      cmi%msgv(cmi%nmsg+3) = '    but they are not. A pivot element is too small.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 2130 ) then
!
! ** Feasible solution to a recursive model.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Feasible solution to a recursive model.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 2131 ) then
!
! ** Feasible solution to a square system.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Feasible solution to a square system.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 2132 ) then
!
! ** Infeasible solution. (i1) artificial(s) have been
!    introduced in the recursive equations.
!
      call coi2c( i1, imsg, ilen )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Infeasible solution. ' // imsg(1:ilen) // ' artificial(s) have been'
      cmi%msgv(cmi%nmsg+3) = '    introduced into the recursive equations.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 2133 ) then
!
! ** Infeasible solution to square system. Convergence too slow.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Infeasible solution to square system. Convergence too slow.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 2134 ) then
!    The artificial(s) are introduced in the equations that are
!    both marked infeasible and have positive marginals.
!
!    Variables and equations with negative marginals or marginals
!    of zero or eps have not been considered yet in the solution
!    sequence.
!
      cmi%msgv(cmi%nmsg+1) = '    The artificial(s) are introduced in the equations that are'
      cmi%msgv(cmi%nmsg+2) = '    both marked infeasible and have positive marginals.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%msgv(cmi%nmsg+4) = '    Variables and equations with negative marginals or marginals'
      cmi%msgv(cmi%nmsg+5) = '    of zero or Eps have not been considered yet in the solution'
      cmi%msgv(cmi%nmsg+6) = '    sequence.'
      cmi%msgv(cmi%nmsg+7) = ' '
      cmi%nmsg = cmi%nmsg + 7

!------------------------------------------------------------
   elseif ( msgnum .eq. 2136 ) then
!
! ** Error in Square System: The number of non-fixed variables (i1)
!    is not equal to the number of equations (ljnrow).
!
      call coi2c( i1, imsg, ilen )
      call coi2c( cmi%ljnrow, imsg, ilen )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Error in Square System: The number of non-fixed variables (' // imsg(1:ilen) // ')'
      cmi%msgv(cmi%nmsg+3) = '    is not equal to the number of equations (' // imsg(1:ilen) // ')'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 2138 ) then
!
! ** Error in Square System: A variable tries to exceed its bound.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Error in Square System: A variable tries  to exceed its bound.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 2140 ) then
!
! ** Error in Square System: Pivot too small.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Error in Square System: Pivot too small.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 2142 ) then
!
!    It may be more efficient to turn the Post-triangular equations
!    into ordinary equations with a line:
!
!    Lspost = False
!
!    in the CONOPT control program (Options file).
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = '    It may be more efficient to turn the Post-triangular equations'
      cmi%msgv(cmi%nmsg+3) = '    into ordinary equations with a line:'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%msgv(cmi%nmsg+5) = '    Lspost = False'
      cmi%msgv(cmi%nmsg+6) = ' '
      cmi%msgv(cmi%nmsg+7) = '    in the CONOPT control program (Options file).'
      cmi%msgv(cmi%nmsg+8) = ' '
      cmi%nmsg = cmi%nmsg + 8
!------------------------------------------------------------
   elseif ( msgnum .eq. 2150 ) then
!
! ** Lstcrs = true is inconsistent with Lssqrs = true.
!    Lstcrs is changed to false.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Lstcrs = true is inconsistent with Lssqrs = true.'
      cmi%msgv(cmi%nmsg+3) = '    Lstcrs is changed to false.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4
!------------------------------------------------------------
   elseif ( msgnum .eq. 2800 ) then
!
! ** Domain error(s) in nonlinear functions.
!    Check bounds on variables.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Domain error(s) in nonlinear functions.'
      cmi%msgv(cmi%nmsg+3) = '    Check bounds on variables.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 2801 ) then
!
! ** Error in the definition of the Jacobian and/or in the function
!    and derivative evaluation subroutine.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Error in the definition of the Jacobian and/or in the function'
      cmi%msgv(cmi%nmsg+3) = '    and derivative evaluation subroutine.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 2802 ) then
!
! ** Limit on error messages from the function and derivative debugger.
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Limit on error messages from the function and derivative debugger.'
      cmi%nmsg = cmi%nmsg + 2

!------------------------------------------------------------
   elseif ( msgnum .eq. 2803 ) then
!    The function has a discontinuous jump of (r1)
!
      call cor2c( r1, rmsg, 15, 5, rlen )
      cmi%msgv(cmi%nmsg+1) = '    The function has a discontinuous jump of ' // rmsg(1:rlen)
      cmi%nmsg = cmi%nmsg + 1

!------------------------------------------------------------
   elseif ( msgnum .eq. 2804 ) then
!  The derivative has a discontinuous jump of (r1)
!
      call cor2c( r1, rmsg, 15, 5, rlen )
      cmi%msgv(cmi%nmsg+1) = '    The derivative has a discontinuous jump of ' // rmsg(1:rlen)
      cmi%nmsg = cmi%nmsg + 1

!------------------------------------------------------------
   elseif ( msgnum .eq. 2805 ) then
!
!  ** Function and Derivative Debugger terminated because FDEval
!     returned an error.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Function and Derivative Debugger terminated because FDEval'
      cmi%msgv(cmi%nmsg+3) = '    returned an error.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 2806 ) then
!
!  ** 2nd Derivative Debugger terminated because FDEval
!     returned an error.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** 2nd Derivative Debugger terminated because FDEval'
      cmi%msgv(cmi%nmsg+3) = '    returned an error.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 2807 ) then
!
! ** Error in the definition of the Hessian and/or in subroutine 2DLagr.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Error in the definition of the Hessian and/or in subroutine 2DLagr.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 2808 ) then
!    The largest relative error was <max_err> and the tolerance is <rt2drv>.
!    The tolerance can be changed by changing Rt2drv.
!
      call cor2c( r1 , rmsg, 10, 2, rlen )
      call cor2c( r2 , rmsg2, 10, 2, rlen2 )
      cmi%msgv(cmi%nmsg+1) = '    The largest relative error was ' // rmsg(1:rlen) // ' and the tolerance is ' &
                             // rmsg2(1:rlen2) // '.'
      cmi%msgv(cmi%nmsg+2) = '    The tolerance can be changed by changing Rt2drv.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 2809 ) then
!
! ** Error in the definition of subroutine 2DDir/2DDirLag.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      IF ( CMI%CB_2DDirLag /= 0 ) THEN
      cmi%msgv(cmi%nmsg+2) = ' ** Error in the definition of subroutine 2DDirLag.'
      Else
      cmi%msgv(cmi%nmsg+2) = ' ** Error in the definition of subroutine 2DDir.'
      Endif
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 2810 ) then
!  in the interval between (r1) and (r2).
!
      call cor2c( r1, rmsg, 20, 9, rlen )
      call cor2c( r2, rmsg2, 20, 9, rlen2 )
      cmi%msgv(cmi%nmsg+1) = '    in the interval between ' // rmsg(1:rlen) // ' and ' // rmsg2(1:rlen2) // '.'
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%nmsg = cmi%nmsg + 2


!------------------------------------------------------------
   elseif ( msgnum .eq. 2900 ) then
!
! ** The time limit has been reached.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** The time limit has been reached.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 2901 ) then
!
! ** The iteration limit has been reached.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** The iteration limit has been reached.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 2902 ) then
!
! ** User Interrupt.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** User Interrupt.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 2903 ) then
!
! ** Quick Mode Termination - Infeasible.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Quick Mode Termination - Infeasible.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 2904 ) then
!
! ** Quick Mode Termination - Feasible.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Quick Mode Termination - Feasible.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3000 ) then
!
! ** Warning **  The number of nonlinear derivatives equal to zero
!                in the initial point is large (=,i1, percent).
!                A better initial point will probably help the
!                optimization.
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Warning **  The number of nonlinear derivatives equal to zero'
      cmi%msgv(cmi%nmsg+3) = '                in the initial point is large (= ' // imsg(1:ilen) // ' percent).'
      cmi%msgv(cmi%nmsg+4) = '                A better initial point will probably help the'
      cmi%msgv(cmi%nmsg+5) = '                optimization.'
      cmi%msgv(cmi%nmsg+6) = ' '
      cmi%nmsg = cmi%nmsg + 6

!------------------------------------------------------------
   elseif ( msgnum .eq. 3001 ) then
!
! ** Warning **  The variance of the derivatives in the initial
!                point is large (=, r1,). A better initial
!                point, a better scaling, or better bounds on the
!                variables will probably help the optimization.
!
      call cor2c( r1, rmsg, 9, 2, rlen )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Warning **  The variance of the derivatives in the initial'
      cmi%msgv(cmi%nmsg+3) = '                point is large (= ' // rmsg(1:rlen) // ' ). A better initial'
      cmi%msgv(cmi%nmsg+4) = '                point, a better scaling, or better bounds on the'
      cmi%msgv(cmi%nmsg+5) = '                variables will probably help the optimization.'
      cmi%msgv(cmi%nmsg+6) = ' '
      cmi%nmsg = cmi%nmsg + 6

!------------------------------------------------------------
   elseif ( msgnum .eq. 3002 ) then
!
! ** Warning **  The number of nonlinear derivatives equal to zero
!                in the final point is large (=,i1, percent).
!                Better bounds on the variables may help the
!                optimization.
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Warning **  The number of nonlinear derivatives equal to zero'
      cmi%msgv(cmi%nmsg+3) = '                in the final point is large (= ' // imsg(1:ilen) // ' percent).'
      cmi%msgv(cmi%nmsg+4) = '                Better bounds on the variables may help the'
      cmi%msgv(cmi%nmsg+5) = '                optimization.'
      cmi%msgv(cmi%nmsg+6) = ' '
      cmi%nmsg = cmi%nmsg + 6

!------------------------------------------------------------
   elseif ( msgnum .eq. 3003 ) then
!
! ** Warning **  The variance of the derivatives in the final
!                point is large (=,r1,). A better scaling or
!                better bounds on the variables will probably
!                help the optimization.
!
      call cor2c( r1, rmsg, 9, 2, rlen )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Warning **  The variance of the derivatives in the final'
      cmi%msgv(cmi%nmsg+3) = '                point is large (= ' // rmsg(1:rlen) // ' ). A better scaling or'
      cmi%msgv(cmi%nmsg+4) = '                better bounds on the variables will probably'
      cmi%msgv(cmi%nmsg+5) = '                help the optimization.'
      cmi%msgv(cmi%nmsg+6) = ' '
      cmi%nmsg = cmi%nmsg + 6

!------------------------------------------------------------
   elseif ( msgnum .eq. 3004 ) then
!
! ** Warning **  All Jacobian elements in the rows marked below are
!                less than the absolute pivot tolerance,r1, (Rtpiva)
!                in the final point. Only slacks or artificials can
!                be basic in these rows.
!                A better scaling or better bounds on the variables
!                may help the optimization.
!
      call cor2c( r1, rmsg, 9, 1, rlen )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Warning **  All Jacobian elements in the rows marked below are'
      cmi%msgv(cmi%nmsg+3) = '                less than the absolute pivot tolerance '// rmsg(1:rlen) // ' (Rtpiva)'
      cmi%msgv(cmi%nmsg+4) = '                in the final point. Only slacks or artificials can'
      cmi%msgv(cmi%nmsg+5) = '                be basic in these rows.'
      cmi%msgv(cmi%nmsg+6) = '                A better scaling or better bounds on the variables'
      cmi%msgv(cmi%nmsg+7) = '                may help the optimization.'
      cmi%msgv(cmi%nmsg+8) = ' '
      cmi%nmsg = cmi%nmsg + 8

!------------------------------------------------------------
   elseif ( msgnum .eq. 3005 ) then
!
! ** Warning **  Cannot switch to a Quasi-Newton Method because
!                there are too many superbasics. If convergence is
!                slow you may try to increase Lfnsup from its
!                current value of ,i1.
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Warning **  Cannot switch to a Quasi-Newton Method because'
      cmi%msgv(cmi%nmsg+3) = '                there are too many superbasics. If convergence is'
      cmi%msgv(cmi%nmsg+4) = '                slow you may try to increase Lfnsup from its'
      cmi%msgv(cmi%nmsg+5) = '                current value of ' // imsg(1:ilen) // '.'
      cmi%msgv(cmi%nmsg+6) = ' '
      cmi%nmsg = cmi%nmsg + 6

!------------------------------------------------------------
   elseif ( msgnum .eq. 3007 ) then
!                This can increase memory usage significantly.
!
      cmi%msgv(cmi%nmsg+1) = '                This can increase memory usage significantly.'
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%nmsg = cmi%nmsg + 2
!------------------------------------------------------------
   elseif ( msgnum .eq. 3008 ) then
!
! ** Warning **  Rtmaxj is very large. Try to scale the model.
! --or--
! ** Warning **  Rtmaxv is very large. Try to scale the model.
! --or--
! ** Warning **  Rtmaxv and Rtmaxj are both very large.
!                Try to scale the model.
!                CONOPT may become unreliable and there are no
!                guaranties.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      IF ( ( CMI%RTMAXJ .GE. 1.D2*CMI%RTDMXJ .AND. CMI%LSMAXJ ) .AND. ( CMI%RTMAXV .GE. 1.D2*CMI%RTDMXV .AND. CMI%LSMAXV ) ) THEN
      CMI%LSMAXJ = .FALSE.
      CMI%LSMAXV = .FALSE.
      cmi%msgv(cmi%nmsg+2) = ' ** Warning **  Rtmaxj and Rtmaxv are both very large.'
      cmi%msgv(cmi%nmsg+3) = '                Try to scale the model.'
      cmi%nmsg = cmi%nmsg + 3
      elseif ( CMI%RTMAXJ .GE. 1.D2*CMI%RTDMXJ .AND. CMI%LSMAXJ ) THEN
      CMI%LSMAXJ = .FALSE.
      cmi%msgv(cmi%nmsg+2) = ' ** Warning **  Rtmaxj is very large. Try to scale the model.'
      cmi%nmsg = cmi%nmsg + 2
      ELSE
      CMI%LSMAXV = .FALSE.
      cmi%msgv(cmi%nmsg+2) = ' ** Warning **  Rtmaxv is very large. Try to scale the model.'
      cmi%nmsg = cmi%nmsg + 2
      ENDIF
      cmi%msgv(cmi%nmsg+1) = '                CONOPT may become unreliable and there are no'
      cmi%msgv(cmi%nmsg+2) = '                guaranties.'
      cmi%nmsg = cmi%nmsg + 2

!------------------------------------------------------------
   elseif ( msgnum .eq. 3009 ) then
!
! ** Warning **  Some variables are considered fixed because their
!                bounds are very close, i.e. within a relative
!                distance of Rtbndt = <r1>.
!                The critical limit may be decreased with the line:
!
!                Rtbndt = x.xxe+xx
!
!                in the CONOPT control program (Options file).
!
      call cor2c( r1, rmsg, 9, 1, rlen )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Warning **  Some variables are considered fixed because their'
      cmi%msgv(cmi%nmsg+3) = '                bounds are very close, i.e. within a relative'
      cmi%msgv(cmi%nmsg+4) = '                distance of Rtbndt = ' // rmsg(1:rlen)
      cmi%msgv(cmi%nmsg+5) = ' '
      cmi%nmsg = cmi%nmsg + 5

!------------------------------------------------------------
   elseif ( msgnum .eq. 3010 ) then
!
      cmi%msgv(cmi%nmsg+1) = '                The critical limit may be decreased with the line:'
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%msgv(cmi%nmsg+3) = '                Rtbndt = x.xx'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%msgv(cmi%nmsg+5) = '                in the CONOPT control program (Options file).'
      cmi%msgv(cmi%nmsg+6) = ' '
      cmi%nmsg = cmi%nmsg + 6

!------------------------------------------------------------
   elseif ( msgnum .eq. 3011 ) then
!
! ** Major Error **  Output called before Optimize.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Major Error **  Output called before Optimize.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3012 ) then
!
! ** Major Error **  Minimal Newton tolerance, Rtnwmi = (r1)
!                    is greater than Maximal Newton Tolerance,
!                    Rtnwma = (r2). Change one of them.
!
      call cor2c( r1, rmsg, 9, 1, rlen )
      call cor2c( r2, rmsg2, 9, 1, rlen2 )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Major Error **  Minimum Newton tolerance Rtnwmi = ' // rmsg(1:rlen)
      cmi%msgv(cmi%nmsg+3) = '                    is greater than Maximum Newton Tolerance,'
      cmi%msgv(cmi%nmsg+4) = '                    Rtnwma = ' // rmsg2(1:rlen2) // '. Change one of them.'
      cmi%msgv(cmi%nmsg+5) = ' '
      cmi%nmsg = cmi%nmsg + 5

!------------------------------------------------------------
   elseif ( msgnum .eq. 3013 ) then
!
! ** Major Error **  Restarting from a different version of CONOPT.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Major Error **  Restarting from a different version of CONOPT.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3014 ) then
!
! ** Major Error **  Insufficient memory for Restarting.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Major Error **  Insufficient memory for Restarting.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3018 ) then
!
! ** Limits for Demo Version Exceeded.
!
!    The demo limits are:
!
!     300 variables
!     300 constraints
!    1000 nonlinear nonzeros
!    2000 nonzeros
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Limits for Demo Version Exceeded.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%msgv(cmi%nmsg+4) = '    The demo limits are:'
      cmi%msgv(cmi%nmsg+5) = ' '
      cmi%msgv(cmi%nmsg+6) = '     300 variables'
      cmi%msgv(cmi%nmsg+7) = '     300 constraints'
      cmi%msgv(cmi%nmsg+8) = '    1000 nonlinear nonzeros'
      cmi%msgv(cmi%nmsg+9) = '    2000 nonzeros'
      cmi%msgv(cmi%nmsg+10) =' '
      cmi%nmsg = cmi%nmsg + 10

!------------------------------------------------------------
   elseif ( msgnum .eq. 3020 ) then
!
! ** Fatal Error **  Insufficient memory for Output.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Insufficient memory for Output.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3021 ) then
!
! ** Fatal Error **  Hessian should be used, but the number of
!                    Hessian elements is not defined.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Hessian should be used, but the number of'
      cmi%msgv(cmi%nmsg+3) = '                    Hessian elements is not defined.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 3022 ) then
!
! ** Fatal Error **  Insufficient memory to continue the
!                    optimization.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Insufficient memory to continue the'
      cmi%msgv(cmi%nmsg+3) = '                    optimization.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 3023 ) then
!
! ** Fatal Error **  Insufficient memory for setup of matrix.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Insufficient memory for setup of matrix.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3024 ) then
!
! ** Fatal Error **  Insufficient memory for setup of optimization
!                    vectors.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Insufficient memory for setup of optimization'
      cmi%msgv(cmi%nmsg+3) = '                    vectors.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 3025 ) then
!
! ** Fatal Error **  Insufficient memory to start CONOPT.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Insufficient memory to start CONOPT.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3026 ) then
!
! ** Fatal Error **  Too many rows.
!                    The upper limit is (i1)
!
      call coi2c( i1, imsg, ilen )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Too many rows.'
      cmi%msgv(cmi%nmsg+3) = '                    The upper limit is ' // imsg(1:ilen) // '.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 3027 ) then
!
! ** Fatal Error **  Too many columns.
!                    The upper limit is (i1)
!
      call coi2c( i1, imsg, ilen )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Too many columns.'
      cmi%msgv(cmi%nmsg+3) = '                    The upper limit is ' // imsg(1:ilen) // '.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 3028 ) then
!
! ** Fatal Error **  Too many rows + columns.
!                    The upper limit is (i1)
!
      call coi2c( i1, imsg, ilen )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Too many rows + columns.'
      cmi%msgv(cmi%nmsg+3) = '                    The upper limit is ' // imsg(1:ilen) // '.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 3029 ) then
!
! ** Fatal Error **  Too many non-zeros.
!                    The upper limit is (i1)
!
      call coi2c( i1, imsg, ilen )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Too many non zeros.'
      cmi%msgv(cmi%nmsg+3) = '                    The upper limit is ' // imsg(1:ilen) // '.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 3031 ) then
!
! ** Fatal Error **  Insufficient memory to process control
!                    program (options file).
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Insufficient memory to process control'
      cmi%msgv(cmi%nmsg+3) = '                    program (options file).'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 3032 ) then
!
! ** Fatal Error **  Inconsistent bounds in input.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Inconsistent bounds in input'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3033 ) then
!
! ** Fatal Error **  Function error in initial point.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Function error in initial point.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3034 ) then
!
! ** Fatal Error **  Function error in Pre-triangular equations.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      if ( CMI%LSTRIA ) then
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Function error in Triangular equations.'
      else
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Function error in Pre-triangular equations.'
      endif
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3035 ) then
!
! ** Fatal Error **  Function error after solving Pre-triangular
!                    equations.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Function error after solving Pre-triangular'
      cmi%msgv(cmi%nmsg+3) = '                    equations.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 3036 ) then
!
! ** Fatal Error **  Function error after small step in Phase 0
!                    procedure.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Function error after small step in Phase 0'
      cmi%msgv(cmi%nmsg+3) = '                    procedure.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 3038 ) then
!
! ** Fatal Error **  Function error very close to a feasible point.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Function error very close to a feasible point.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3039 ) then
!
! ** Fatal Error **  Function error while reducing tolerances.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Function error while reducing tolerances.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3040 ) then
!
! ** Fatal Error **  Function error in Post-triangular equation.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Function error in Post-triangular equation.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3041 ) then
!
! ** Fatal Error **  The objective constraint is not a free equation.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  The objective constraint is not a free equation.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 3042 ) then
!
! ** Fatal Error **  The objective index is out of range.
!                    It has probably not been initialized. (optional)
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  The objective index is out of range.'
      if ( i1 .eq. -1 ) then
      cmi%msgv(cmi%nmsg+3) = '                    It has probably not been initialized.'
      cmi%nmsg = cmi%nmsg + 1
      endif
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 3043 ) then
!
! ** Fatal Error **  More Nonlinear Nonzeros (i1) than Nonzeros (i2).
!
      call coi2c( i1, imsg, ilen )
      call coi2c( i2, imsg2, ilen2 )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  More Nonlinear Nonzeros (' // imsg(1:ilen) // ') than Nonzeros (' &
                             // imsg2(1:ilen2) // ').'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 3044 ) then
!
! ** Fatal Error **  More Nonlinear Nonzeros (i1) than Nonzeros
!                    (i2) updated in UpdtSize.
!
      call coi2c( i1, imsg, ilen )
      call coi2c( i2, imsg2, ilen2 )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  More Nonlinear Nonzeros (' // imsg(1:ilen) // ') than Nonzeros'
      cmi%msgv(cmi%nmsg+3) = '                    (' // imsg2(1:ilen2) // ') updated in UpdtSize.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4
!------------------------------------------------------------
   elseif ( msgnum .eq. 3045 ) then
!
! ** Fatal Error **  Illegal column number returned from UpdtJac.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Illegal column number returned from UpdtJac.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 3046 ) then
!
! ** Fatal Error **  Illegal row number returned from UpdtJac.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Illegal row number returned from UpdtJac.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3047 ) then
!
! ** Fatal Error **  Illegal (row,column) combination returned from
!                    UpdtJac.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Illegal (row,column) combination returned'
      cmi%msgv(cmi%nmsg+3) = '                    from UpdtJac.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4
!------------------------------------------------------------
   elseif ( msgnum .eq. 3048 ) then
!
! ** Fatal Error **  Illegal position number returned from UpdtJac.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Illegal position number returned from UpdtJac.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 3049 ) then
!
! ** Fatal Error **  Illegal column number returned from ReadMatrix.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Illegal column number returned from ReadMatrix.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 3051 ) then
!
! ** Fatal Error **  Illegal row number returned from ReadMatrix.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Illegal row number returned from ReadMatrix.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3052 ) then
!
! ** Fatal Error **  Inconsistent Start of Column pointers
!                    returned from ReadMatrix.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Inconsistent Start of Column pointers'
      cmi%msgv(cmi%nmsg+3) = '                    returned from ReadMatrix.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4
!------------------------------------------------------------
   elseif ( msgnum .eq. 3053 ) then
!
! ** Fatal Error **  Illegal Row type returned from ReadMatrix.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Illegal row type returned from ReadMatrix.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3054 ) then
!
! ** Fatal Error **  Duplicate position in the Jacobian
!                    returned from ReadMatrix.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Duplicate position in the Jacobian'
      cmi%msgv(cmi%nmsg+3) = '                    returned from ReadMatrix.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 3055 ) then
!                    Illegal row number (i2) in position i1.
!
      call coi2c( i1, IMSG, ILEN )
      call coi2c( i2, IMSG2, ILEN2 )
      cmi%msgv(cmi%nmsg+1) = '                    Illegal row number (' // imsg2(1:ilen2) // ') in position ' // imsg(1:ilen) // '.'
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%nmsg = cmi%nmsg + 2

!------------------------------------------------------------
   elseif ( msgnum .eq. 3056 ) then
!                    First element must be 1. Was i1.
!                    It has probably not been defined. (optional)
!
      call coi2c( i1, IMSG, ILEN )
      call coi2c( i2, IMSG2, ILEN2 )
      cmi%msgv(cmi%nmsg+1) = '                    First element must be ' // imsg2(1:ilen2) // '. Was ' // imsg(1:ilen) // '.'
      if ( i1 .eq. -1 ) then
      cmi%msgv(cmi%nmsg+2) = '                    It has probably not been defined.'
      cmi%nmsg = cmi%nmsg + 1
      endif
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%nmsg = cmi%nmsg + 2
!------------------------------------------------------------
   elseif ( msgnum .eq. 3057 ) then
!                    Last element must be number of nonzeros+1 = i1.
!                    Was i2.
!
      call coi2c( i1, IMSG, ILEN )
      call coi2c( i2, IMSG2, ILEN2 )
      if ( CMI%LSBAS0 ) THEN
      cmi%msgv(cmi%nmsg+1) = '                    Last element must be number of nonzeros = ' // imsg(1:ilen) // '.'
      else
      cmi%msgv(cmi%nmsg+1) = '                    Last element must be number of nonzeros+1 = ' // imsg(1:ilen) // '.'
      endif
      cmi%msgv(cmi%nmsg+2) = '                    Was '//imsg2(1:ilen2) // '.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 3058 ) then
!                    Implied column count is not positive in column ii.
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = '                    Implied column count is not positive in column ' // imsg(1:ilen) // '.'
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%nmsg = cmi%nmsg + 2
!------------------------------------------------------------
   elseif ( msgnum .eq. 3059 ) then
!                    Illegal column number (= i2) in position i1.
!
      call coi2c( i1, IMSG, ILEN )
      call coi2c( i2, IMSG2, ILEN2 )
      cmi%msgv(cmi%nmsg+1) = '                    Illegal column number (= ' // imsg2(1:ilen2) // ') in position ' // &
                             imsg(1:ilen) // '.'
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%nmsg = cmi%nmsg + 2

!------------------------------------------------------------
   elseif ( msgnum .eq. 3060 ) then
!                    Illegal row type (= i2) in row i1.
!
      call coi2c( i1, IMSG, ILEN )
      call coi2c( i2, IMSG2, ILEN2 )
      cmi%msgv(cmi%nmsg+1) = '                    Illegal row type (= ' // imsg2(1:ilen2) // ') in row ' // imsg(1:ilen) // '.'
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%nmsg = cmi%nmsg + 2

!------------------------------------------------------------
   elseif ( msgnum .eq. 3061 ) then
!                    Duplicate (row,column) pair in column i1
!                    and row i2.
!
      call coi2c( i1, IMSG, ILEN )
      call coi2c( i2, IMSG2, ILEN2 )
      cmi%msgv(cmi%nmsg+1) = '                    Duplicate (row,column) pair in column ' // imsg(1:ilen)
      cmi%msgv(cmi%nmsg+2) = '                    and row ' // imsg2(1:ilen2) // '.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3062 ) then
!
! ** Fatal Error **  Illegal row number returned from UpdtRow.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Illegal row number returned from UpdtRow.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3063 ) then
!                    Illegal row number (= i2) returned in
!                    call number i1. (or in case i2 = -1)
!                    call number i1. It was probably not defined.
!
      call coi2c( i1, IMSG, ILEN )
      call coi2c( i2, IMSG2, ILEN2 )
      cmi%msgv(cmi%nmsg+1) = '                    Illegal row number (= ' // imsg2(1:ilen2) // ') returned in'
      if ( i2 .eq. -1 ) then
      cmi%msgv(cmi%nmsg+2) = '                    call number ' // imsg(1:ilen) // '. It was probably not defined.'
      else
      cmi%msgv(cmi%nmsg+2) = '                    call number ' // imsg(1:ilen) // '.'
      endif
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3064 ) then
!                    Illegal position number (= i2) returned in
!                    call number i1.
!
      call coi2c( i1, IMSG, ILEN )
      call coi2c( i2, IMSG2, ILEN2 )
      cmi%msgv(cmi%nmsg+1) = '                    Illegal position number (= ' // imsg2(1:ilen2) // ') returned in'
      cmi%msgv(cmi%nmsg+2) = '                    call number ' // imsg(1:ilen) // '.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3065 ) then
!                    Illegal column number (= i2) returned in
!                    call number i1. (or in case i2 = -1)
!                    call number i1. It was probably not defined.
!
      call coi2c( i1, IMSG, ILEN )
      call coi2c( i2, IMSG2, ILEN2 )
      cmi%msgv(cmi%nmsg+1) = '                    Illegal column number (= ' // imsg2(1:ilen2) // ') returned in'
      if ( i2 .eq. -1 ) then
      cmi%msgv(cmi%nmsg+2) = '                    call number ' // imsg(1:ilen) // '. It was probably not defined.'
      else
      cmi%msgv(cmi%nmsg+2) = '                    call number ' // imsg(1:ilen) // '.'
      endif
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3066 ) then
!                    Illegal position returned in call number ii
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = '                    Illegal position returned in call number' // imsg(1:ilen) // '.'
      cmi%nmsg = cmi%nmsg + 1
!------------------------------------------------------------
   elseif ( msgnum .eq. 3067 ) then
!
! ** Fatal Error **  Illegal Row type returned from UpdtRow.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Illegal row type returned from UpdtRow.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3068 ) then
!
! ** Fatal Error **  Function error while computing derivatives.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Function error while computing derivatives.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3069 ) then
!
! ** Fatal Error **  Illegal column number returned from UpdtCol.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Illegal column number returned from UpdtCol.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3070 ) then
!
!  ** Fatal Error **  Jacobian value not defined in UpdtJac.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Jacobian value not defined in UpdtJac.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3071 ) then
!
! ** Fatal Error **  There are empty rows in the model.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  There are empty rows in the model.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3072 ) then
!                    Row number (i) is empty.
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = '                    Row number ' // imsg(1:ilen) // ' is empty.'
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%nmsg = cmi%nmsg + 2

!------------------------------------------------------------
   elseif ( msgnum .eq. 3073 ) then
!                    Row type not defined in row (i)
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = '                    Row type not defined in row ' // imsg(1:ilen)
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%nmsg = cmi%nmsg + 2

!------------------------------------------------------------
   elseif ( msgnum .eq. 3074 ) then
!                    Row number was not defined in position i1.
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = '                    Row number was not defined in position ' // imsg(1:ilen) // '.'
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%nmsg = cmi%nmsg + 2

!------------------------------------------------------------
   elseif ( msgnum .eq. 3075 ) then
!                    Column number was not defined in position i1.
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = '                    Column number was not  defined in position ' // imsg(1:ilen) // '.'
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%nmsg = cmi%nmsg + 2

!------------------------------------------------------------
   elseif ( msgnum .eq. 3076 ) then
!
!  ** Fatal Error **  An initial Jacobian value was not
!                     returned from ReadMatrix.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  An initial Jacobian value was not'
      cmi%msgv(cmi%nmsg+3) = '                    returned from ReadMatrix.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 3077 ) then
!
! ** Fatal Error **  Illegal column number returned from DelCol.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Illegal column number returned from DelCol.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3078 ) then
!
! ** Fatal Error **  Column has already been deleted with DelCol.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Column has already been deleted with DelCol.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3079 ) then
!
! ** Fatal Error **  Illegal row number returned from DelRow.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Illegal row number returned from DelRow.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3080 ) then
!
! ** Fatal Error **  Insufficient memory for model update.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Insufficient memory for model update.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3081 ) then
!
! ** Fatal Error **  Row has already been deleted with DelRow.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Row has already been deleted with DelRow.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3082 ) then
!                    (Row,Column) = (,i1,i2).
!
      call coi2c( i1, IMSG, ILEN )
      call coi2c( i2, IMSG2, ILEN2 )
      cmi%msgv(cmi%nmsg+1) = '                    (Row,Column) = (' // imsg(1:ilen) // ',' // imsg2(1:ilen2) // ')'
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%nmsg = cmi%nmsg + 2

!------------------------------------------------------------
   elseif ( msgnum .eq. 3083 ) then
!                    Implied column count is negative in column ii.
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = '                    Implied column count is negative in column ' // imsg(1:ilen) // '.'
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%nmsg = cmi%nmsg + 2
!------------------------------------------------------------
   elseif ( msgnum .eq. 3084 ) then
!
!  The model has <i1> empty column(s).
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = '  The model has ' // imsg(1:ilen) // ' empty column(s).'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 3085 ) then
!
!  The <i1> largest (scaled) residuals are:
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = '  The ' // imsg(1:ilen) // ' largest (scaled) residuals are:'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 3086 ) then
!
!   ** Warning **    There are empty rows in the model.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = '   ** Warning **    There are empty rows in the model.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3087 ) then
!
!   ** Warning **    There are empty columns in the model.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = '   ** Warning **    There are empty columns in the model.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

! $if defined (old)
! ------------------------------------------------------------
!    elseif ( msgnum .eq. 3088 ) then
!                    Column number (i) is empty.
!
!       call coi2c( i1, IMSG, ILEN )
!       cmi%msgv(cmi%nmsg+1) = '                    Column number ' // imsg(1:ilen) // ' is empty.'
!       cmi%msgv(cmi%nmsg+2) = ' '
!       cmi%nmsg = cmi%nmsg + 2
! $endif
!------------------------------------------------------------
   elseif ( msgnum .eq. 3089 ) then
!
!  The model has <i1> empty row(s).
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = '  The model has ' // imsg(1:ilen) // ' empty row(s).'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 3091 ) then
!
! ** Fatal Error **  More Nonlinear Nonzeros (i1) than Nonzeros
!                    (i2) added in added Columns.
!
      call coi2c( i1, imsg, ilen )
      call coi2c( i2, imsg2, ilen2 )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  More Nonlinear Nonzeros (' // imsg(1:ilen) // ') than Nonzeros'
      cmi%msgv(cmi%nmsg+3) = '                    (' // imsg2(1:ilen2) // ' added in added Columns.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4
!------------------------------------------------------------
   elseif ( msgnum .eq. 3092 ) then
!
! ** Fatal Error **  More Nonlinear Nonzeros (i1) than Nonzeros
!                    (i2) added in added Rows.
!
      call coi2c( i1, imsg, ilen )
      call coi2c( i2, imsg2, ilen2 )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  More Nonlinear Nonzeros (' // imsg(1:ilen) // ') than Nonzeros'
      cmi%msgv(cmi%nmsg+3) = '                    (' // imsg2(1:ilen2) // ' added in added Rows.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 3093 ) then
!
! ** Fatal Error **  Negative column length returned from AddCol.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Negative column length returned from AddCol.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3094 ) then
!                    Column <i1> returned <i2>.
!                    Length was probably not defined (if i2 = -1).
!
      call coi2c( i1, IMSG, ILEN )
      call coi2c( i2, IMSG2, ILEN2 )
      cmi%msgv(cmi%nmsg+1) = '                    Column ' // imsg(1:ilen) // ' returned ' // imsg2(1:ilen2) // '.'
      if ( i2 .eq. -1 ) then
      cmi%msgv(cmi%nmsg+2) = '                    Length was probably not defined.'
      cmi%nmsg = cmi%nmsg + 1
      endif
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%nmsg = cmi%nmsg + 2

!------------------------------------------------------------
   elseif ( msgnum .eq. 3095 ) then
!
! ** Fatal Error **  Aggregate column length too large in AddCol.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Aggregate column length too large in AddCol.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3096 ) then
!
! ** Fatal Error **  Illegal row number returned from AddCol.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Illegal row number returned from AddCol.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3097 ) then
!                    Row number was not defined in column i1.
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = '                    Row number was not defined in column ' // imsg(1:ilen) // '.'
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%nmsg = cmi%nmsg + 2

!------------------------------------------------------------
   elseif ( msgnum .eq. 3098 ) then
!                    Illegal row number (i2) in column i1.
!
      call coi2c( i1, IMSG, ILEN )
      call coi2c( i2, IMSG2, ILEN2 )
      cmi%msgv(cmi%nmsg+1) = '                    Illegal row number (' // imsg2(1:ilen2) // ') in column ' // imsg(1:ilen) // '.'
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%nmsg = cmi%nmsg + 2
!------------------------------------------------------------
   elseif ( msgnum .eq. 3099 ) then
!
! ** Fatal Error **  Illegal Nlflag returned from AddCol.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Illegal Nlflag returned from AddCol.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3100 ) then
!                    Nlflag was not defined in column i1.
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = '                    Nlflag was not defined in column ' // imsg(1:ilen) // '.'
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%nmsg = cmi%nmsg + 2

!------------------------------------------------------------
   elseif ( msgnum .eq. 3101 ) then
!                    Illegal Nlflag (i2) in column i1.
!
      call coi2c( i1, IMSG, ILEN )
      call coi2c( i2, IMSG2, ILEN2 )
      cmi%msgv(cmi%nmsg+1) = '                    Illegal Nlflag (' // imsg2(1:ilen2) // ') in column ' // imsg(1:ilen) // '.'
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%nmsg = cmi%nmsg + 2

!------------------------------------------------------------
   elseif ( msgnum .eq. 3102 ) then
!
!  ** Fatal Error ** The number of nonlinear Jacobian elements
!                    defined in AddCol is not correct. Annlnz =
!                    <i1>, but <i2> nonlinear elements were found.
!
      call coi2c( i1, IMSG, ILEN )
      call coi2c( i2, IMSG2, ILEN2 )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** The number of nonlinear Jacobian elements'
      cmi%msgv(cmi%nmsg+3) = '                   defined in AddCol is not correct. Annlnz = '
      cmi%msgv(cmi%nmsg+4) = '                   ' // imsg(1:ilen) // ', but ' // imsg2(1:ilen2) //' nonlinear elements were found.'
      cmi%msgv(cmi%nmsg+5) = ' '
      cmi%nmsg = cmi%nmsg + 5

!------------------------------------------------------------
   elseif ( msgnum .eq. 3103 ) then
!
!  ** Fatal Error ** The number of nonlinear Jacobian updates
!                    defined in UpdtSize is not correct.
!                    Unlnz = <i1>, but <i2> nonlinear elements
!                    were updated.
!
      call coi2c( i1, IMSG, ILEN )
      call coi2c( i2, IMSG2, ILEN2 )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** The number of nonlinear Jacobian updates'
      cmi%msgv(cmi%nmsg+3) = '                   defined in UpdtSize is not correct.'
      cmi%msgv(cmi%nmsg+4) = '                   Unlnz = ' // imsg(1:ilen) // ', but ' // imsg2(1:ilen2) // ' nonlinear elements'
      cmi%msgv(cmi%nmsg+5) = '                   were updated.'
      cmi%msgv(cmi%nmsg+6) = ' '
      cmi%nmsg = cmi%nmsg + 6

!------------------------------------------------------------
   elseif ( msgnum .eq. 3104 ) then
!
! ** Fatal Error **  Illegal Nlflag returned from ReadMatrix.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Illegal Nlflag returned from ReadMatrix.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3105 ) then
!                    Nlflag was not defined in position i1.
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = '                    Nlflag was not defined in position ' // imsg(1:ilen) // '.'
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%nmsg = cmi%nmsg + 2

!------------------------------------------------------------
   elseif ( msgnum .eq. 3106 ) then
!                    Illegal Nlflag (i2) in position i1.
!
      call coi2c( i1, IMSG, ILEN )
      call coi2c( i2, IMSG2, ILEN2 )
      cmi%msgv(cmi%nmsg+1) = '                    Illegal Nlflag (' // imsg2(1:ilen2) // ') in position ' // imsg(1:ilen) // '.'
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%nmsg = cmi%nmsg + 2

!------------------------------------------------------------
   elseif ( msgnum .eq. 3107 ) then
!
!  ** Fatal Error ** The number of nonlinear Jacobian elements
!                    defined in ReadMatrix is not correct.
!                    NlNz = <i1>, but <i2> nonlinear elements
!                    were found.
!
      call coi2c( i1, IMSG, ILEN )
      call coi2c( i2, IMSG2, ILEN2 )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** The number of nonlinear Jacobian elements'
      cmi%msgv(cmi%nmsg+3) = '                   defined in ReadMatrix is not correct.'
      cmi%msgv(cmi%nmsg+4) = '                   NlNz = ' // imsg(1:ilen) // ' but ' // imsg2(1:ilen2) // ' nonlinear elements'
      cmi%msgv(cmi%nmsg+5) = '                   were found.'
      cmi%msgv(cmi%nmsg+6) = ' '
      cmi%nmsg = cmi%nmsg + 6

!------------------------------------------------------------
   elseif ( msgnum .eq. 3110 ) then
!
! ** Fatal Error ** No columns added in UpdtSize, but nonzeros are added.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** No columns added in UpdtSize, but nonzeros are added.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3111 ) then
!
! ** Fatal Error ** No rows added in UpdtSize, but nonzeros are added.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** No rows added in UpdtSize, but nonzeros are added.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3112 ) then
!
! ** Fatal Error **  Illegal Row type returned from AddRow.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Illegal row type returned from AddRow.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3113 ) then
!
! ** Fatal Error **  Negative row length returned from AddRow.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Negative row length returned from AddRow.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3114 ) then
!                    Call <i1> returned <i2>.
!                    Length was probably not defined (if i2 = -1).
!
      call coi2c( i1, IMSG, ILEN )
      call coi2c( i2, IMSG2, ILEN2 )
      cmi%msgv(cmi%nmsg+1) = '                    Call ' // imsg(1:ilen) // ' returned ' // imsg2(1:ilen2) // '.'
      if ( i2 .eq. -1 ) then
      cmi%msgv(cmi%nmsg+2) = '                    Length was probably not defined.'
      cmi%nmsg = cmi%nmsg + 1
      endif
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%nmsg = cmi%nmsg + 2

!------------------------------------------------------------
   elseif ( msgnum .eq. 3115 ) then
!
! ** Fatal Error **  Aggregate row length too large in AddRow.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Aggregate row length too large in AddRow.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3116 ) then
!
! ** Fatal Error **  Illegal column number returned from AddRow.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Illegal column number returned from AddRow.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3117 ) then
!                    Illegal column number (= i2) in row i1.
!
      call coi2c( i1, IMSG, ILEN )
      call coi2c( i2, IMSG2, ILEN2 )
      cmi%msgv(cmi%nmsg+1) = '                    Illegal column number (= ' // imsg2(1:ilen2) //  ') in position ' // &
                             imsg(1:ilen) // '.'
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%nmsg = cmi%nmsg + 2

!------------------------------------------------------------
   elseif ( msgnum .eq. 3118 ) then
!                    Column number was not defined in row i1.
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = '                    Column number was not  defined in row ' // imsg(1:ilen) // '.'
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%nmsg = cmi%nmsg + 2

!------------------------------------------------------------
   elseif ( msgnum .eq. 3119 ) then
!
! ** Fatal Error **  Illegal Nlflag returned from AddRow.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Illegal Nlflag returned from AddRow.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3120 ) then
!                    Nlflag was not defined in row i1.
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = '                    Nlflag was not defined in row ' // imsg(1:ilen) // '.'
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%nmsg = cmi%nmsg + 2

!------------------------------------------------------------
   elseif ( msgnum .eq. 3121 ) then
!                    Illegal Nlflag (i2) in row i1.
!
      call coi2c( i1, IMSG, ILEN )
      call coi2c( i2, IMSG2, ILEN2 )
      cmi%msgv(cmi%nmsg+1) = '                    Illegal Nlflag (' // imsg2(1:ilen2) // ') in row ' // imsg(1:ilen) // '.'
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%nmsg = cmi%nmsg + 2

!------------------------------------------------------------
   elseif ( msgnum .eq. 3122 ) then
!
!  ** Fatal Error **  An initial Jacobian value was not
!                     returned from AddCol.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  An initial Jacobian value was not'
      cmi%msgv(cmi%nmsg+3) = '                    returned from AddCol.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 3123 ) then
!
!  ** Fatal Error **  An initial Jacobian value was not
!                     returned from AddRow.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  An initial Jacobian value was not'
      cmi%msgv(cmi%nmsg+3) = '                    returned from AddRow.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 3124 ) then
!
!  ** Fatal Error ** The number of nonlinear Jacobian elements
!                    defined in AddRow is not correct. Amnlnz =
!                    <i1>, but <i2> nonlinear elements were found.
!
      call coi2c( i1, IMSG, ILEN )
      call coi2c( i2, IMSG2, ILEN2 )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** The number of nonlinear Jacobian elements'
      cmi%msgv(cmi%nmsg+3) = '                   defined in AddRow is not correct. Amnlnz ='
      cmi%msgv(cmi%nmsg+4) = '                   ' // imsg(1:ilen) // ', but ' // imsg2(1:ilen2) // &
                             ' nonlinear elements were found.'
      cmi%msgv(cmi%nmsg+5) = ' '
      cmi%nmsg = cmi%nmsg + 5

!------------------------------------------------------------
   elseif ( msgnum .eq. 3125 ) then
!
!  ** Fatal Error ** The total number of Jacobian elements defined
!                    defined in AddRow is not correct. Amnz = <i1>,
!                    but <i2> nonlinear elements were found.
!
      call coi2c( i1, IMSG, ILEN )
      call coi2c( i2, IMSG2, ILEN2 )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** The total number of Jacobian elements defined'
      cmi%msgv(cmi%nmsg+3) = '                   in AddRow is not correct. Amnz = ' // imsg(1:ilen) // ', but'
      cmi%msgv(cmi%nmsg+4) = '                   ' // imsg2(1:ilen2) // ' elements were found.'
      cmi%msgv(cmi%nmsg+5) = ' '
      cmi%nmsg = cmi%nmsg + 5

!------------------------------------------------------------
   elseif ( msgnum .eq. 3126 ) then
!
!  ** Fatal Error ** The total number of Jacobian elements defined
!                    defined in AddCol is not correct. Annz = <i1>,
!                    but <i2> nonlinear elements were found.
!
      call coi2c( i1, IMSG, ILEN )
      call coi2c( i2, IMSG2, ILEN2 )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** The total number of Jacobian elements defined'
      cmi%msgv(cmi%nmsg+3) = '                   in AddCol is not correct. Annz = ' // imsg(1:ilen) // ', but'
      cmi%msgv(cmi%nmsg+4) = '                   ' // imsg2(1:ilen2) // ' elements were found.'
      cmi%msgv(cmi%nmsg+5) = ' '
      cmi%nmsg = cmi%nmsg + 5

!------------------------------------------------------------
   elseif ( msgnum .eq. 3127 ) then
!
! ** Fatal Error **  There are empty columns in the model.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  There are empty columns in the model.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3128 ) then
!
! ** Fatal Error **  Duplicate position in the Jacobian after
!                    model revision.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  Duplicate position in the Jacobian after'
      cmi%msgv(cmi%nmsg+3) = '                    model revision.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 3130 ) then
!
!  ** Fatal Error **  The structure of the Hessian of the Lagrangian
!                     is not correct.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error **  The structure of the Hessian of the Lagrangian'
      cmi%msgv(cmi%nmsg+3) = '                    is not correct.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 3131 ) then
!                     Row number in element (i) is not defined.
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = '                    Row number in element (' // imsg(1:ilen) // ') is not defined.'
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%nmsg = cmi%nmsg + 2

!------------------------------------------------------------
   elseif ( msgnum .eq. 3132 ) then
!                     Row number in element (i) = I2
!                     is out of range.
!
      call coi2c( i1, IMSG, ILEN )
      call coi2c( i2, IMSG2, ILEN2 )
      cmi%msgv(cmi%nmsg+1) = '                    Row number in element (' // imsg(1:ilen) // ') = ' // imsg2(1:ilen2)
      cmi%msgv(cmi%nmsg+2) = '                    is out of range.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3133 ) then
!                     Column number in element (i) is not defined.
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = '                    Column number in element (' // imsg(1:ilen) // ') is not defined.'
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%nmsg = cmi%nmsg + 2

!------------------------------------------------------------
   elseif ( msgnum .eq. 3134 ) then
!                     Column number in element (i) = i2
!                     is out of range.
!
      call coi2c( i1, IMSG, ILEN )
      call coi2c( i2, IMSG2, ILEN2 )
      cmi%msgv(cmi%nmsg+1) = '                    Column number in element (' // imsg(1:ilen) // ') = ' // imsg2(1:ilen2)
      cmi%msgv(cmi%nmsg+2) = '                    is out of range.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3135 ) then
!                     Column number in element (i) = i2
!                     is decreasing.
!
      call coi2c( i1, IMSG, ILEN )
      call coi2c( i2, IMSG2, ILEN2 )
      cmi%msgv(cmi%nmsg+1) = '                    Column number in element (' // imsg(1:ilen) // ') = ' // imsg2(1:ilen2)
      cmi%msgv(cmi%nmsg+2) = '                    is decreasing.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3136 ) then
!                     Row number in element (i) in column i2
!                     is decreasing.
!
      call coi2c( i1, IMSG, ILEN )
      call coi2c( i2, IMSG2, ILEN2 )
      cmi%msgv(cmi%nmsg+1) = '                    Row number in element (' // imsg(1:ilen) // ') in column ' // imsg2(1:ilen2)
      cmi%msgv(cmi%nmsg+2) = '                    is decreasing.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 3137 ) then
!                     Row number in element (i) is less than
!                     column number.
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = '                    Row number in element (' // imsg(1:ilen) // ') is less than'
      cmi%msgv(cmi%nmsg+2) = '                    column number.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

! $if defined (old)
! ------------------------------------------------------------
!    elseif ( msgnum .eq. 3138 ) then
!                     Row number in element (i) = i2 refers to a
!                     linear variable.
!
!       call coi2c( i1, IMSG, ILEN )
!       call coi2c( i2, IMSG2, ILEN2 )
!       cmi%msgv(cmi%nmsg+1) = '                    Row number in element (' // imsg(1:ilen) // ') = ' // imsg2(1:ilen2) &
!                              // ' refers to a'
!       cmi%msgv(cmi%nmsg+2) = '                    linear variable.'
!       cmi%msgv(cmi%nmsg+3) = ' '
!       cmi%nmsg = cmi%nmsg + 3

! ------------------------------------------------------------
!    elseif ( msgnum .eq. 3139 ) then
!                     Column number in element (i) = i2 refers to a
!                     linear variable.
!
!       call coi2c( i1, IMSG, ILEN )
!       call coi2c( i2, IMSG2, ILEN2 )
!       cmi%msgv(cmi%nmsg+1) = '                    Column number in element (' // imsg(1:ilen) // ') = ' // imsg2(1:ilen2) &
!                              // ' refers to a'
!       cmi%msgv(cmi%nmsg+2) = '                    linear variable.'
!       cmi%msgv(cmi%nmsg+3) = ' '
!       cmi%nmsg = cmi%nmsg + 3
! $endif
!------------------------------------------------------------
   elseif ( msgnum .eq. 3140 ) then
!
!  ** Fatal Error ** The number of bound updates in the dual option
!                    (i1) is out of range.
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** The number of bound updates in the dual'
      cmi%msgv(cmi%nmsg+3) = '                    option(' // imsg(1:ilen) // ') is out of range.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 3141 ) then
!
!  ** Fatal Error ** An initial basis must be supplied with the
!                    dual option
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** An initial basis must be supplied with the'
      cmi%msgv(cmi%nmsg+3) = '                   dual option.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 3143 ) then
!
!  ** Fatal Error ** The dual option can only be used with an objective
!                    constraint or an objective variable.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** The dual option can only be used with an objective'
      cmi%msgv(cmi%nmsg+3) = '                   constraint or an objective variable.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 3144 ) then
!
!  ** Fatal Error ** Column <i1> is updated more than once in the
!                    data from DualBnd.
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** Column ' // imsg(1:ilen) // ' is updated more than once in the'
      cmi%msgv(cmi%nmsg+3) = '                   data from DualBnd.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 3145 ) then
!
!  ** Fatal Error ** Column index <i1> = <i2> from DualBnd
!                    is out of range.
!
      call coi2c( i1, IMSG, ILEN )
      call coi2c( i2, IMSG2, ILEN2 )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** Column index ' // imsg(1:ilen) // ' = ' // imsg2(1:ilen2) // ' from DualBnd'
      cmi%msgv(cmi%nmsg+3) = '                   is out of range.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 3146 ) then
!
!  ** Fatal Error ** The new bounds from DualBnd on variable <i1>
!                    are not violated.
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** The new bounds from DualBnd on variable' // imsg(1:ilen)
      cmi%msgv(cmi%nmsg+3) = '                   are not violated.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 3147 ) then
!
!  ** Warning ** No bound updates. The dual option turned off.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Warning ** No bound updates. The dual option turned off.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
! $if defined (old)
!    elseif ( msgnum .eq. 3150 ) then
!                     Variable <i> = is nonlinear but does not appear
!                     in the Hessian.
!
!       call coi2c( i1, IMSG, ILEN )
!       cmi%msgv(cmi%nmsg+1) = '                    Variable ' // imsg(1:ilen) // ' is nonlinear but does not appear'
!       cmi%msgv(cmi%nmsg+2) = '                    in the Hessian.'
!       cmi%msgv(cmi%nmsg+3) = ' '
!       cmi%nmsg = cmi%nmsg + 3
! $endif
!------------------------------------------------------------
   elseif ( msgnum .eq. 3200 ) then
!
!     Model has <.> variables and <.> constraints
!     with <.> Jacobian elements, <.> of which are nonlinear.
      call coi2c( cmi%ljnstr, IMSG, ILEN )
      call coi2c( cmi%ljnrow, IMSG2, ILEN2 )
      call coi2c( cmi%lkjace-cmi%ljnrow, IMSG3, ILEN3 )
      call coi2c( cmi%ljnlnz, IMSG4, ILEN4 )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = '    The model has ' // imsg(1:ilen) // ' variables and ' // imsg2(1:ilen2) // ' constraints'
      cmi%msgv(cmi%nmsg+3) = '    with ' // imsg3(1:ilen3) // ' Jacobian elements, ' // imsg4(1:ilen4) // ' of which are nonlinear.'
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 3201 ) then
!     The Hessian of the Lagrangian has <.> elements on the diagonal,
!     <.> elements below the diagonal, and <.> nonlinear variables.
      call coi2c( i2, IMSG, ILEN )
      call coi2c( cmi%lkhess-i2, IMSG2, ILEN2 )
      call coi2c( i1, IMSG3, ILEN3 )
      cmi%msgv(cmi%nmsg+1) = '    The Hessian of the Lagrangian has ' // imsg(1:ilen) //' elements on the diagonal,'
      cmi%msgv(cmi%nmsg+2) = '    ' // imsg2(1:ilen2) // ' elements below the diagonal, and ' // imsg3(1:ilen3) // &
                             ' nonlinear variables.'
      cmi%nmsg = cmi%nmsg + 2
!------------------------------------------------------------
   elseif ( msgnum .eq. 3300 ) then
!
!     The Directional Second Derivative routine has failed <.> times.
!     Directional Second Derivatives will not be used any more.
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = '    The Directional Second Derivative routine has failed ' // imsg(1:ilen) // ' times.'
      cmi%msgv(cmi%nmsg+3) = '    The Directional Second Derivatives will not be used any more.'
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 3301 ) then
!
!     The Hessian Evaluation routine has failed <.> times.
!     The Hessian of the Lagrangian will not be used any more.
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = '    The Hessian Evaluation routine has failed ' // imsg(1:ilen) // ' times.'
      cmi%msgv(cmi%nmsg+3) = '    The Hessian of the Lagrangian will not be used any more.'
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 3302 ) then
!     The SQP routine will therefore be turned off from iteration <.>.
!
      call coi2c( cmi%lkiter, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = '    The SQP routine will therefore be turned off from iteration ' // imsg(1:ilen)
      cmi%nmsg = cmi%nmsg + 2
!------------------------------------------------------------
   elseif ( msgnum .eq. 3310 ) then
!
! **  The size of the Reduced Hessian is reduced to <i1> superbasics
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' **  The size of the Reduced Hessian is reduced to ' // imsg(1:ilen) // &
                             ' superbasics'
      cmi%nmsg = cmi%nmsg + 2
!------------------------------------------------------------
   elseif ( msgnum .eq. 3311 ) then
!     because of insufficient memory.
!     Define a larger Lfnsup or allocate more memory.
!
      call coi2c( cmi%lkiter, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = '     because of insufficient memory.'
      cmi%msgv(cmi%nmsg+2) = '     Define a larger Lfnsup or allocate more memory.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 3400 ) then
!
!  ** Warning ** <i1> variables were initialized close to the internal
!                infinity = <Rtmaxv>. Were moved to <Rtmaxi>.
!
      call coi2c( i1, IMSG, ILEN )
      call cor2c( r1, rmsg , 16, 6, rlen  )
      call cor2c( r2, rmsg2, 16, 6, rlen2 )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Warning ** ' // IMSG(1:ilen) // ' variables were initialized close to the internal'
      cmi%msgv(cmi%nmsg+3) = '               infinity = ' // RMSG(1:rlen) // '. Were moved to ' // RMSG2(1:Rlen2) // '.'
      cmi%msgv(cmi%nmsg+4) = ' '
      cmi%nmsg = cmi%nmsg + 4

!------------------------------------------------------------
   elseif ( msgnum .eq. 4002 ) then
!
! ** Fatal error ** ReadMatrix routine returned Error=,(i1)
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** ReadMatrix routine returned Error=' // IMSG(1:ilen)
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3

!------------------------------------------------------------
   elseif ( msgnum .eq. 4003 ) then
!
! ** Fatal error ** FDEval returned Error=,(i1)
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** FDEval returned Error=' // IMSG(1:ilen)
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 4005 ) then
!
! ** Fatal error ** FDInterval routine returned Error=,(i1)
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** FDInterval routine returned Error=' // IMSG(1:ilen)
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 4007 ) then
!
! ** Fatal error ** 2DLagr routine returned Error=,(i1)
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** 2DLagr routine returned Error=' // IMSG(1:ilen)
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 4008 ) then
!
! ** Fatal error ** 2DDir routine returned Error=,(i1)
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** 2DDir routine returned Error=' // IMSG(1:ilen)
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 4009 ) then
!
! ** Fatal error ** Status routine returned Error=,(i1)
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** Status routine returned Error=' // IMSG(1:ilen)
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 4010 ) then
!
! ** Fatal error ** Solution routine returned Error=,(i1)
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** Solution routine returned Error=' // IMSG(1:ilen)
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 4011 ) then
!
! ** Fatal error ** 2DDirLag routine returned Error=,(i1)
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** 2DDirLag routine returned Error=' // IMSG(1:ilen)
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 4012 ) then
!
! ** Fatal error ** ErrMsg routine returned Error=,(i1)
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** ErrMsg routine returned Error=' // IMSG(1:ilen)
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 4017 ) then
!
! ** Fatal error ** Optfile routine returned Error=,(i1)
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** Optfile routine returned Error=' // IMSG(1:ilen)
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 4018 ) then
!
! ** Fatal error ** Option routine returned Error=,(i1)
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** Option routine returned Error=' // IMSG(1:ilen)
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 4019 ) then
!
! ** Fatal error ** TriOrd routine returned Error=,(i1)
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** TriOrd routine returned Error=' // IMSG(1:ilen)
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 4020 ) then
!
! ** Fatal error ** DualBnd routine returned Error=,(i1)
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** DualBnd routine returned Error=' // IMSG(1:ilen)
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 4021 ) then
!
! ** Fatal error ** UpdtSize routine returned Error=,(i1)
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** UpdtSize routine returned Error=' // IMSG(1:ilen)
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 4022 ) then
!
! ** Fatal error ** UpdtCol routine returned Error=,(i1)
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** UpdtCol routine returned Error=' // IMSG(1:ilen)
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 4023 ) then
!
! ** Fatal error ** UpdtRow routine returned Error=,(i1)
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** UpdtRow routine returned Error=' // IMSG(1:ilen)
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 4024 ) then
!
! ** Fatal error ** UpdtJac routine returned Error=,(i1)
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** UpdtJac routine returned Error=' // IMSG(1:ilen)
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 4025 ) then
!
! ** Fatal error ** DelCol returned Error=,(i1)
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** DelCol returned Error=' // IMSG(1:ilen)
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 4026 ) then
!
! ** Fatal error ** DelRow returned Error=,(i1)
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** DelRow returned Error=' // IMSG(1:ilen)
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 4027 ) then
!
! ** Fatal error ** AddCol returned Error=,(i1)
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** AddCol returned Error=' // IMSG(1:ilen)
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 4028 ) then
!
! ** Fatal error ** AddRow returned Error=,(i1)
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** AddRow returned Error=' // IMSG(1:ilen)
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 4029 ) then
!
! ** Fatal error ** SRFile routine returned Error=,(i1)
!
      call coi2c( i1, IMSG, ILEN )
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** SRFile routine returned Error=' // IMSG(1:ilen)
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 4102 ) then
!
! ** Fatal error ** ReadMatrix routine was not supplied by modeler.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** ReadMatrix routine was not supplied by modeler.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 4103 ) then
!
! ** Fatal error ** FDEval was not supplied by modeler.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** FDEval was not supplied by modeler.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 4104 ) then
!
! ** Fatal error ** ErrMsg routine was not supplied by modeler.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** ErrMsg routine was not supplied by modeler.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 4109 ) then
!
! ** Fatal error ** Status routine was not supplied by modeler.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** Status routine was not supplied by modeler.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 4110 ) then
!
! ** Fatal error ** Solution routine was not supplied by modeler.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** Solution routine was not supplied by modeler.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 4112 ) then
!
! ** Fatal error ** COIDEF_Base has not been called to define a base.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** COIDEF_Base has not been called to define a base.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
! $if defined (updating)
!    elseif ( msgnum .eq. 4121 ) then
!
! ** Fatal error ** UpdtSize routine was not supplied by modeler.
!
!       cmi%msgv(cmi%nmsg+1) = ' '
!       cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** UpdtSize routine was not supplied by modeler.'
!       cmi%msgv(cmi%nmsg+3) = ' '
!       cmi%nmsg = cmi%nmsg + 3
! ------------------------------------------------------------
!    elseif ( msgnum .eq. 4122 ) then
!
! ** Fatal error ** UpdtCol routine was not supplied by modeler.
!
!       cmi%msgv(cmi%nmsg+1) = ' '
!       cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** UpdtCol routine was not supplied by modeler.'
!       cmi%msgv(cmi%nmsg+3) = ' '
!       cmi%nmsg = cmi%nmsg + 3
! ------------------------------------------------------------
!    elseif ( msgnum .eq. 4123 ) then
!
! ** Fatal error ** UpdtRow routine was not supplied by modeler.
!
!       cmi%msgv(cmi%nmsg+1) = ' '
!       cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** UpdtRow routine was not supplied by modeler.'
!       cmi%msgv(cmi%nmsg+3) = ' '
!       cmi%nmsg = cmi%nmsg + 3
! ------------------------------------------------------------
!    elseif ( msgnum .eq. 4124 ) then
!
! ** Fatal error ** UpdtJac routine was not supplied by modeler.
!
!       cmi%msgv(cmi%nmsg+1) = ' '
!       cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** UpdtJac routine was not supplied by modeler.'
!       cmi%msgv(cmi%nmsg+3) = ' '
!       cmi%nmsg = cmi%nmsg + 3
! ------------------------------------------------------------
!    elseif ( msgnum .eq. 4125 ) then
!
! ** Fatal error ** DelCol was not supplied by modeler.
!
!       cmi%msgv(cmi%nmsg+1) = ' '
!       cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** DelCol was not supplied by modeler.'
!       cmi%msgv(cmi%nmsg+3) = ' '
!       cmi%nmsg = cmi%nmsg + 3
! ------------------------------------------------------------
!    elseif ( msgnum .eq. 4126 ) then
!
! ** Fatal error ** DelRow was not supplied by modeler.
!
!       cmi%msgv(cmi%nmsg+1) = ' '
!       cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** DelRow was not supplied by modeler.'
!       cmi%msgv(cmi%nmsg+3) = ' '
!       cmi%nmsg = cmi%nmsg + 3
! ------------------------------------------------------------
!    elseif ( msgnum .eq. 4127 ) then
!
! ** Fatal error ** AddCol was not supplied by modeler.
!
!       cmi%msgv(cmi%nmsg+1) = ' '
!       cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** AddCol was not supplied by modeler.'
!       cmi%msgv(cmi%nmsg+3) = ' '
!       cmi%nmsg = cmi%nmsg + 3
! ------------------------------------------------------------
!    elseif ( msgnum .eq. 4128 ) then
!
! ** Fatal error ** AddRow was not supplied by modeler.
!
!       cmi%msgv(cmi%nmsg+1) = ' '
!       cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** AddRow was not supplied by modeler.'
!       cmi%msgv(cmi%nmsg+3) = ' '
!       cmi%nmsg = cmi%nmsg + 3
! $endif
!------------------------------------------------------------
   elseif ( msgnum .eq. 4129 ) then
!
! ** Fatal error ** SRFile routine was not supplied by modeler.
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ** Fatal Error ** SRFile routine was not supplied by modeler.'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
! $if defined (testout)
!------------------------------------------------------------
   elseif ( msgnum .eq. 5000 ) then
!
! CONTROL PROGRAM DUMP'
!
!   ADR LINE  VERB-N  PARAMS'
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' CONTROL PROGRAM DUMP'
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%msgv(cmi%nmsg+4) = '    ADR LINE  VERB-N  PARAMS'
      cmi%msgv(cmi%nmsg+5) = ' '
      cmi%nmsg = cmi%nmsg + 5
! $endif
!------------------------------------------------------------
   else
      call coi2c( msgnum, imsg, ilen )
      cmi%msgv(cmi%nmsg+1) = ' ** Unknown message number ' // imsg(1:ilen) //' in Conmsg.'
      cmi%nmsg = cmi%nmsg + 1
      CALL CONOUT( CMI )
      CALL COSYSE( CMI, 14, .TRUE. )
      RETURN
   ENDIF
!
!  smsg = number of lines to screen, the first ones of the overall
!         message.
!  dmsg = number of lines to documentation file = all of them
!
   IF ( TOSCR ) CMI%SMSG = CMI%NMSG
   CMI%DMSG = CMI%NMSG
   IF ( FINAL ) THEN
      CALL CONOUT( CMI )
   ENDIF

END SUBROUTINE CONMSG

SUBROUTINE CONMST( CMI, MSGNUM, KN, KLEN, TOSCR, FINAL )
!**   LOGICAL OPERATION
!**       Writes a message including character information merged
!**       at certain positions. The character information is often
!**       file names, that can be longer than one line. This infor-
!**       mation is started on a new line and cut in 75 character
!**       pieces.
!*
   Use CONOPT_Data
   Use CONOPT_Utilities
      IMPLICIT NONE

   Type (Conopt_Model_Info) CMI
   INTEGER   MSGNUM, KLEN
   LOGICAL   TOSCR, FINAL
   CHARACTER KN*(KLEN)

   character*12 :: imsg
   integer      :: ilen
   Integer      :: alen 
!
!  Test if we should flush the message buffer before continuing
!  The cases for flushing depend on the current value of Smsg and
!  Dmsg, and Nmsg:
!
!  If Dmsg ne Nmsg, Flush
!  If Smsg gt Nmsg, Flush
!  If Nmsg gt Smsg and Toscr, Flush
!
   IF ( CMI%NMSG .NE. CMI%DMSG .OR. CMI%SMSG .GT. CMI%NMSG .OR. ( CMI%NMSG .GT. CMI%SMSG .AND. TOSCR ) ) THEN
      CALL CONOUT( CMI )
   ENDIF

   alen = max(1,len_trim(kn))
!------------------------------------------------------------
   if ( msgnum .eq. 3999 ) then
! A
      cmi%msgv(cmi%nmsg+1) = ' ' // kn(1:alen)
      cmi%nmsg = cmi%nmsg + 1
!------------------------------------------------------------
   elseif ( msgnum .eq. 4000 ) then
!A
      cmi%msgv(cmi%nmsg+1) = kn(1:alen)
      cmi%nmsg = cmi%nmsg + 1
!------------------------------------------------------------
   elseif ( msgnum .eq. 4001 ) then
!
! ** Major Error **  Restart file not found. File name=,A
!
      cmi%msgv(cmi%nmsg+1) = ' '
      if ( alen + 54 .le. 80 ) then
         cmi%msgv(cmi%nmsg+2) = ' ** Major Error **  Restart file not found. File name=' // kn(1:alen)
         cmi%nmsg = cmi%nmsg + 2
      else 
         cmi%msgv(cmi%nmsg+2) = ' ** Major Error **  Restart file not found. File name='
         cmi%nmsg = cmi%nmsg + 2
         call conmsf
      endif
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%nmsg = cmi%nmsg + 1
!------------------------------------------------------------
   elseif ( msgnum .eq. 4002 ) then
! Using option file ,A
!
      if ( alen+20 .le. 80 ) then
         cmi%msgv(cmi%nmsg+1) = ' Using option file ' // kn(1:alen)
         cmi%nmsg = cmi%nmsg + 1
      else 
         cmi%msgv(cmi%nmsg+1) = ' Using option file'
         cmi%nmsg = cmi%nmsg + 1
         call conmsf
      endif
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%nmsg = cmi%nmsg + 1
!------------------------------------------------------------
   elseif ( msgnum .eq. 4003 ) then
! Using default options.
!
      cmi%msgv(cmi%nmsg+1) = ' Using default options.'
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%nmsg = cmi%nmsg + 2
!------------------------------------------------------------
   elseif ( msgnum .eq. 4004 ) then
! Cannot find option file ,A
      if ( alen+25 .le. 80 ) then
         cmi%msgv(cmi%nmsg+1) = ' Cannot find option file ' // kn(1:alen)
         cmi%nmsg = cmi%nmsg + 1
      else 
         cmi%msgv(cmi%nmsg+1) = ' Cannot find option file'
         cmi%nmsg = cmi%nmsg + 1
         call conmsf
      endif
!------------------------------------------------------------
   elseif ( msgnum .eq. 4005 ) then
! A             (Message followed by blank line)
!
      cmi%msgv(cmi%nmsg+1) = ' ' // kn(1:alen)
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%nmsg = cmi%nmsg + 2
!------------------------------------------------------------
   elseif ( msgnum .eq. 4006 ) then
!               (Blank line followed by message)
! A
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ' // kn(1:alen)
      cmi%nmsg = cmi%nmsg + 2
!------------------------------------------------------------
   elseif ( msgnum .eq. 4007 ) then
!               (Blank line followed by message followed by blank again)
! A
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' ' // kn(1:alen)
      cmi%msgv(cmi%nmsg+3) = ' '
      cmi%nmsg = cmi%nmsg + 3
!------------------------------------------------------------
   elseif ( msgnum .eq. 4008 ) then
! Could not open option file for reading: ,A
! Continuing with default options
!
      if ( alen+41 .le. 80 ) then
         cmi%msgv(cmi%nmsg+1) = ' Could not open option file for reading: ' // kn(1:alen)
         cmi%nmsg = cmi%nmsg + 1
      else 
         cmi%msgv(cmi%nmsg+1) = ' Could not open option file for reading:'
         cmi%nmsg = cmi%nmsg + 1
         call conmsf
      endif
      cmi%msgv(cmi%nmsg+1) = ' Continuing with default options'
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%nmsg = cmi%nmsg + 2
!------------------------------------------------------------
   elseif ( MSGNUM .EQ. 4999 ) THEN
!
!
!      C O N O P T 3   kn
!      Copyright (C)   ARKI Consulting and Development A/S
!                      Bagsvaerdvej 246 A
!                      DK-2880 Bagsvaerd, Denmark
!
      cmi%msgv(cmi%nmsg+1) = ' '
      cmi%msgv(cmi%nmsg+2) = ' '
      cmi%msgv(cmi%nmsg+3) = '    C O N O P T 3   ' // kn(1:alen)
      cmi%msgv(cmi%nmsg+4) = '    Copyright (C)   ARKI Consulting and Development A/S'
      cmi%msgv(cmi%nmsg+5) = '                    Bagsvaerdvej 246 A'
      cmi%msgv(cmi%nmsg+6) = '                    DK-2880 Bagsvaerd, Denmark'
      cmi%msgv(cmi%nmsg+7) = ' '
      cmi%nmsg = cmi%nmsg + 7
!------------------------------------------------------------
   else
      call coi2c( msgnum, imsg, ilen )
      cmi%msgv(cmi%nmsg+1) = ' ** Unknown message number ' // imsg(1:ilen) // ' in Conmst.'
      cmi%nmsg = cmi%nmsg + 1
      CALL CONOUT( CMI )
      CALL COSYSE( CMI, 14, .TRUE. )
      RETURN
   ENDIF
!
!  smsg = number of lines to screen, the first ones of the overall
!         message.
!  dmsg = number of lines to documentation file = all of them
!
   IF ( TOSCR ) CMI%SMSG = CMI%NMSG
   CMI%DMSG = CMI%NMSG
!
!  We will also write the message out if the buffer is getting
!  full; this may be necessary for printing the control program.
!
   IF ( FINAL .OR. CMI%NMSG .GE. 18 ) THEN
      CALL CONOUT( CMI )
   ENDIF

   CONTAINS

   SUBROUTINE CONMSF
!
!  Breaks the file name into pieces that will fitt on one line
!  each and surrounds the name with quotes.
!
      IMPLICIT NONE

   if ( alen .le. 77 ) then
      cmi%msgv(cmi%nmsg+1) = ' "' // kn(1:alen) // '"'
      cmi%nmsg = cmi%nmsg + 1
   else 
      cmi%msgv(cmi%nmsg+1) = ' "' // kn(1:75)
      if ( alen .le. 150 ) then
         cmi%msgv(cmi%nmsg+2) = '  ' // kn(76:alen) // '"'
         cmi%nmsg = cmi%nmsg + 2
      else
         cmi%msgv(cmi%nmsg+2) = '  ' // kn(76:150)
         if ( alen .le. 225 ) then
            cmi%msgv(cmi%nmsg+3) = '  ' // kn(151:alen) // '"'
            cmi%nmsg = cmi%nmsg + 3
         else
            cmi%msgv(cmi%nmsg+3) = '  ' // kn(151:225)
            cmi%msgv(cmi%nmsg+4) = '  ' // kn(226:alen) // '"'
            cmi%nmsg = cmi%nmsg + 4
         endif 
      endif 
   endif 

   END SUBROUTINE CONMSF

END SUBROUTINE CONMST
