Module CONOPT_Data
   Integer, parameter  :: CO_R = Selected_Real_Kind(12)
   Integer, parameter  :: CO_P =      4
   Integer, parameter, Private :: Number_of_Unames=   202
   Integer, Parameter, Private :: NVect           =     3
   Integer, parameter, Private :: TypV_Real       =     1
   Integer, parameter, Private :: TypV_Int        =     2
   Integer, parameter, Private :: TypV_Char       =     3
   Integer, Parameter, Private :: Max_Msg         =    30
   Integer, Parameter          :: CO_Ilinelen     =    80
   Integer, Parameter          :: CO_Olinelen     =   132
   Integer, Parameter          :: CO_FileLen      =   255
!
! Error return codes for COIDEF_* routines
!
   Integer, Parameter          :: CorruptCntr     =     1
   Integer, Parameter          :: RangeProblem    =     2
   Integer, Parameter          :: LicenseProblem  =     3
!
! Error return codes for COIGET_* routines -- must be negative
!
   Integer, Parameter          :: CorruptGet      =    -1
!
! Indices in control vector for real numbers (stored first)
!
   Integer, Parameter          :: Indx_Reslim     =     3
   Integer, Parameter          :: Indx_WorkSpace  =     5
   Integer, Parameter          :: Indx_WorkFactor =     7
   Integer, Parameter          :: Indx_ZeroNoise  =     9
!
! Indices in control vector for problem sizes (after reals)
!
   Integer, Parameter          :: Indx_NumVar     =    11
   Integer, Parameter          :: Indx_NumCon     =    12
   Integer, Parameter          :: Indx_NumNZ      =    13
   Integer, Parameter          :: Indx_NumNlNz    =    14
   Integer, Parameter          :: Indx_OptDir     =    15
   Integer, Parameter          :: Indx_ObjTyp     =    16
   Integer, Parameter          :: Indx_ObjIndx    =    17
   Integer, Parameter          :: Indx_Base       =    18
   Integer, Parameter          :: Indx_ItLim      =    19
   Integer, Parameter          :: Indx_ErrLim     =    20
   Integer, Parameter          :: Indx_IniStat    =    21
   Integer, Parameter          :: Indx_FVincLin   =    22
   Integer, Parameter          :: Indx_FVforAll   =    23
   Integer, Parameter          :: Indx_DebugFV    =    24
   Integer, Parameter          :: Indx_MaxSup     =    25
   Integer, Parameter          :: Indx_Square     =    26
   Integer, Parameter          :: Indx_EmptyRow   =    27
   Integer, Parameter          :: Indx_EmptyCol   =    28
   Integer, Parameter          :: Indx_Num2D      =    29
   Integer, Parameter          :: Indx_Debug2D    =    30
   Integer, Parameter          :: Indx_OptOrder   =    31
   Integer, Parameter          :: Indx_DisCont    =    32
   Integer, Parameter          :: Indx_StdOut     =    33
   Integer, Parameter          :: Indx_Error      =    34
   Integer, Parameter          :: Indx_ClearM     =    35
   Integer, Parameter          :: Indx_NDual      =    36
   Integer, Parameter          :: Indx_Lwork      =    37
   Integer, Parameter          :: Indx_2DPerturb  =    38
   Integer, Parameter          :: Indx_MaxUsed    =    39
   Integer, Parameter          :: Indx_CurUsed    =    40
!
! Indices in control vector for callback addresses
! Allow two integers for each address for 64 bit pointers
!
   Integer, Parameter          :: Indx_ReadMatrix =    42
   Integer, Parameter          :: Indx_FDEval     =    44
   Integer, Parameter          :: Indx_Status     =    46
   Integer, Parameter          :: Indx_Solution   =    48
   Integer, Parameter          :: Indx_Message    =    50
   Integer, Parameter          :: Indx_Progress   =    52
   Integer, Parameter          :: Indx_Optfile    =    54
   Integer, Parameter          :: Indx_Option     =    56
   Integer, Parameter          :: Indx_ErrMsg     =    58
   Integer, Parameter          :: Indx_TriOrd     =    60
   Integer, Parameter          :: Indx_FDInterval =    62
   Integer, Parameter          :: Indx_2DDir      =    64
   Integer, Parameter          :: Indx_2DDirLag   =    66
   Integer, Parameter          :: Indx_2DLagr     =    68
   Integer, Parameter          :: Indx_SRFile     =    70
   Integer, Parameter          :: Indx_DualBnd    =    72
   Integer, Parameter          :: Indx_UsrMem     =    74
   Integer, Parameter          :: Indx_WorkMem    =    76
   Integer, Parameter          :: NumCallBack     =    78

   Type Conopt_Model_Info

      Sequence
!
!  Timer information
!
      Real(CO_R) :: Firstt  ! Initial value of timer (seconds).
      Real(CO_R) :: Overflt ! Time for overflow of clock (seconds)
!
! Real Crcells:
!

!
      REAL(CO_R), Dimension(1) :: First_RL
      REAL(CO_R) :: RPIOBJ ,RPSOBJ ,RT1PVA ,RT2DRV ,RT2NRM ,RV2MXS ,RTBND1 ,RTBNDI ,  &
                 RTBNDT ,RTCLMX ,RTDCND ,RTDFLV ,RTDFMN ,RTDOBW ,RTDMXJ ,RTDMXV ,  &
                 RTEPSM ,RTEPS0 ,RTEPS2 ,RTERRF ,RTGLRD ,RTGLSL ,RTGRDR ,RTINF  ,  &
                 RTIPVA ,RTIPVR ,RTLCND ,RTLUPS ,RTMAXI ,RTMAXJ ,RTAMXJ ,RTMAXS ,  &
                 RTMAXT ,RTMAXV ,RTMINA ,RTMINJ ,RTMINL ,RTMINS ,RTMNS2 ,RTMXJ2 ,  &
                 RTMXUC ,RTFNSS ,RTNMSS ,RTNEW  ,RTNWAF ,RTNWMA ,RTNWMB ,RTNWMC ,  &
                 RTNWMD ,RTNWMI ,RTNWMJ ,RTNWSL ,RTNWTR ,RTOBJT ,RTOBJD ,RTOBJE ,  &
                 RTOBJF ,RTOBJL ,RTOBJN ,RTOBJR ,RTONED ,RTPIVA ,RTPIVB ,RTPIVI ,  &
                 RTPIVM ,RTPIVN ,RTPIVR ,RTPIIR ,RTPIVT ,RTPIVU ,RTREDG ,RTREDI ,  &
                 RTREDD ,RTREDU ,RTSFC1 ,RTSFC2 ,RTSFC3 ,RTULIM ,RTUMAX ,RTUNDF ,  &
                 RTZERN ,RVBDCR ,RVBDSU ,RVCFNB ,RVDENM ,RVDFLV ,RVDIRL ,RVDIRM ,  &
                 RVDIRO ,RVDRMO ,RVDOEX ,RVDOBM ,RVESTM ,RVDTIM ,RV2TIM ,RVLAN2 ,  &
                 RVLUFC ,RVEXDO ,RVEDGL ,RVFPIV ,RVGLCM ,RVGLBD ,RVGLTS ,RVGMAX ,  &
                 RVRGRM ,RVRGR2 ,RVRGWM ,RVRGRO ,RVRGOL ,RVGTP0 ,RVGTP1 ,RVHESN ,  &
                 RVHSLG ,RVHSMN ,RVHSSM ,RVINFM ,RVINFS ,RVITIM ,RVJACM ,RVJACX ,  &
                 RVLDET ,RVLMDO ,RVLIDO ,RVMINF ,RVMINM ,RVMRAT ,RVNLMX ,RVNLWG ,  &
                 RVOBJB ,RVOBJL ,RVOBJM ,RVOBJO ,RVOBJS ,RVOBJ1 ,RVPINF ,RVPLIM ,  &
                 RVSAMB ,RVSLPL ,RVSLOP ,RVSOBJ ,RVSTLM ,RVSTLN ,RVSUPL ,RVSUPO ,  &
                 RVSPAC ,RVESQN ,RVISQN ,RVTIME ,RVLHDR ,RVSHDR ,RVTHE1 ,RVTHE2 ,  &
                 RVTHE3 ,RVTHAD ,RVTHAM ,RVTHIN ,RVTHLA ,RVTHLN ,RVTHMA ,RVTHMX ,  &
                 RVTHM1 ,RVTHNW ,RVTHOP ,RVTHSL ,RVTH12 ,RVTH23 ,RVTH31 ,RVTRIA ,  &
                 RVULIM ,RVYTP  ,TITER  ,TMRINT ,TMRADD ,TMRSUB ,TMRPRD ,TMRSOL ,  &
                 TMRMUL ,TMDLCL ,LKMSUM ,LKMCOL ,LKMROW ,LKMOCL ,LKMORW ,LKECMX ,  &
                 LKESCM ,LKESRM ,LKESRR ,LKESRL ,LKESR2 ,LOESRR ,LOMSUM ,RVDLIM ,  &
                 RVWSGN ,RVWINI ,RVWEIG ,RVHESS
!
! Pointers for callback addresses stored as long integers
!
   Integer(CO_P) :: CB_ReadMatrix
   Integer(CO_P) :: CB_FDEval
   Integer(CO_P) :: CB_Status
   Integer(CO_P) :: CB_Solution
   Integer(CO_P) :: CB_Message
   Integer(CO_P) :: CB_Progress
   Integer(CO_P) :: CB_Optfile
   Integer(CO_P) :: CB_Option
   Integer(CO_P) :: CB_ErrMsg
   Integer(CO_P) :: CB_TriOrd
   Integer(CO_P) :: CB_FDInterval
   Integer(CO_P) :: CB_2DDir
   Integer(CO_P) :: CB_2DDirLag
   Integer(CO_P) :: CB_2DLagr
   Integer(CO_P) :: CB_SRFile
   Integer(CO_P) :: CB_DualBnd
   Integer(CO_P) :: CB_UsrMem
   Integer(CO_P) :: CB_WorkMem
!
!  Pointers to allocatable arrays:
!  Pointer to the global memory
!
      REAL(CO_R), Dimension(:), Pointer :: XL
!
! Vectors only used internally in memory allocation routines
!
      Integer, Dimension(:), Pointer :: Ltvect, Usvect, Nlvect, Vectst
!
!  Information needed for the compiler - Integer part
!
      Integer, Dimension(:,:), Pointer :: Crdesc
!
!  Names of vectors
!
      Character*4, Dimension(:), Pointer :: Knvect
!
!  Information needed for the compiler - Character part
!
      Character*8, Dimension(:), Pointer :: Crname
!
!  Characters for the Message buffers
!
      character*(CO_OLineLen), dimension(:), Pointer :: Msgv
!
      REAL    RVERS
!
      Integer   , Dimension(1) :: First_IS
      Integer    :: LBINVR ,LBINT  ,LBRNCH ,LFALOG ,LFBLCK ,LFBSLP ,LFBSQP ,LFCON3 ,  &
                 LFDEGI ,LFDERR ,LFDLM0 ,LFDLM1 ,LFDLM2 ,LFDLM3 ,LFHSOK ,LF2DRV ,  &
                 LFMMAX ,LFMARK ,LFRSCN ,LFEERR ,LFEMSG ,LFILOG ,LFILOS ,LFITER ,  &
                 LFINVL ,LFIST1 ,LFIST2 ,LFLERR ,LFMIDL ,LFMAXP ,LFMXNS ,LFMXP4 ,  &
                 LFMXQN ,LFMXST ,LFNICR ,LFNOUI ,LFNUPD ,LFNSUP ,LINSUP ,LFNWIT ,  &
                 LFNWMJ ,LFONEB ,LFONEW ,LFRINL ,LFRINQ ,LFRINS ,LFSCAL ,LFSHRT ,  &
                 LFSLIM ,LFSLOP ,LFSLPI ,LFSLPS ,LFSQPB ,LFSQPI ,LFSQPS ,LFSTAL ,  &
                 LFTABU ,LFTEST ,LJCJMP ,LJCLCR ,LJCLCO ,LJCLSU ,LJCRSU ,LJCOLI ,  &
                 LJDEGI ,LJDGRF ,LJDOTI ,LJINCR ,LJLINE ,LJLSUP ,LJNBSI ,LJNCOL ,  &
                 LJNIRG ,LJNLNZ ,LJNROW ,LJNSEQ ,LJNSTR ,LJOBJC ,LJOBJR ,LJPHAS ,  &
                 LJOPHS ,LJRAGE ,LJSCOL ,LJSLST ,LJIGNE ,LJSROW ,LJSTAT ,LJSUPM ,  &
                 LKANIT ,LKANUP ,LKASUP ,LKBADL ,LKBSLC ,LKBSLP ,LKBSQP ,LKCALL ,  &
                 LKCFNB ,LKCN15 ,LKCOLF ,LKCON3 ,LKCRSH ,LKDEGI ,LKDEBG ,LKDEB2 ,  &
                 LKDEBC ,LKDLEV ,LKDSTR ,LKDUMM ,LKDUM1 ,LKDUMI ,LKDUMP ,LKEMSG ,  &
                 LKFFS  ,LKFIXR ,LKFUNS ,LKGRAD ,LKGRD2 ,LKHSIT ,LKHDIA ,LKHSOK ,  &
                 LK2DIT ,LK2DRV ,LKLAN2 ,LKLS17 ,LKIBAS ,LKIERR ,LKINCR ,LFINCR ,  &
                 LKINDX ,LKINVT ,LKISUP ,LKITDG ,LKITER ,LKITR0 ,LKITQN ,LKITSD ,  &
                 LKITSL ,LKJACE ,LKJRFR ,LKHESS ,LKHRFR ,LKLABS ,LKLCPR ,LKLFIL ,  &
                 LKLFIN ,LKLFPR ,LKLINL ,LKLNBD ,LKLNOK ,LKLOG  ,LKLSTR ,LKLUCL ,  &
                 LKMVWD ,LKMXSL ,LKMXSD ,LKMXQN ,LKNNFX ,LKNOUI ,LKNOUP ,LKNUPD ,  &
                 LKOKQN ,LKOKSD ,LKOKSL ,LKPIIR ,LKPVID ,LKSEED ,LKSELC ,LKSLPI ,  &
                 LKSLPL ,LKSTAL ,LKSTL2 ,LKSQPB ,LKSQPI ,LKSTLN ,LKSUMM ,LKLORG ,  &
                 LKLUF  ,LKUIN  ,LKUPSD ,LKUPQN ,LKVCPR ,LKVFPR ,LKLUIN ,LKMARK ,  &
                 LKMARO ,LKMAXP ,LKMIDL ,LKMXST ,LKNBAS ,LKNEWT ,LKNICR ,LKNOON ,  &
                 LKNSUP ,LKNSP2 ,LKNWIT ,LKNWMI ,LKNWTT ,LKNWMJ ,LKONEB ,LKONEW ,  &
                 LKPOST ,LKPRET ,LKQPSP ,LKREDC ,LKREDR ,LKREDU ,LKRGIN ,LKPOSL ,  &
                 LKRINV ,LKTHEC ,LKTHER ,LKTRIA ,LKROWF ,LKSCAL ,LKSING ,LKSLOP ,  &
                 LKSLRS ,LKSTOP ,LKTEST ,LKUFIL ,LKUFIN ,LKX1AB ,LKX1RW ,LMDEBG ,  &
                 LMDEGI ,LMNDIA ,LMMXSF ,LMMXST ,LMSCAL ,LMSMOD ,LOANRM ,LOBDTG ,  &
                 LOCLMX ,LOCNPT ,LOCON3 ,LOCON4 ,LOCORP ,LODEGI ,LOFFS  ,LOGMSI ,  &
                 LOGMSO ,LOHESS ,LOINIB ,LOINVL ,LONEWT ,LOOLDB ,LOONED ,LOOPTC ,  &
                 LOREDG ,LORHES ,LOSCAL ,LOSLP  ,LOSQP  ,LOSTAT ,LOSTPM ,LOTANG ,  &
                 LOTIGH ,LOTRIA ,LOUPDT ,LMUSEB ,LUREAD ,LUSVRS ,NVUSED ,LIBAS  ,  &
                 LATOT  ,LIFREE ,LATOTT ,TINUSE ,LAMAXU ,REMNUM ,NCRINT ,NCRADD ,  &
                 NCRSUB ,NCRPRD ,NCRSOL ,NCRMUL ,NCDLCL ,LKRFIL ,LKMMAX ,LKCCME ,  &
                 LKCCMP ,LKRCME ,LKRCMP ,LKCMVE ,LKRMVE ,LKDCCM ,LKDCCE ,LKDRCM ,  &
                 LKDRCE ,LKNMZC ,LKNMZR ,LKNMDC ,LKNMDR ,LKNMCL ,LKNMRL ,LOINDX ,  &
                 LKTCMX ,LKTSCM ,LKTSRM ,LKTSRR ,LKTSRL ,LKTSR2 ,LKNPVC ,LKNPVR ,  &
                 LKPTZC ,LKPTZR ,LKPTDC ,LKPTDR ,LKPTMR ,LKCRRC ,LKNRC1 ,LKNRC2 ,  &
                 LKNCC1 ,LKNCC2 ,LKNC22 ,LKNGPV ,LKNGPC ,LKNGDV ,LKLIBL ,LKUIBL ,  &
                 LKMRVT ,LKMRVM ,LKMSMC ,LKMNCC ,LKMNRC ,INITLN ,CPFRST ,CPLAST ,  &
                 RPFRST ,RPLAST ,SWITCH ,NPCLMX ,NPRLMX ,NCEXTR ,NCEXTC ,NEXTRC ,  &
                 NACCPT ,LKNBND ,LJOROW ,LJOCOL ,LJOJAC ,LJOSTR ,LKDUI1 ,LKDUI2
!
      Logical   , Dimension(1) :: First_LS
      Logical    :: LSFCPR ,LS2DNM ,LS2NDI ,LS2PTJ ,LS2UPD ,LSADDS ,LSAFFS ,LSANIN ,  &
                 LSANRM ,LSANFL ,LSAZCL ,LSAZRW ,LSBAS0 ,LSBDIP ,LSBDPT ,LSBOBC ,  &
                 LSBSOK ,LSCRSH ,LSDCRS ,LSDEGI ,LSDEGF ,LSDEMO ,LSDERV ,LSDNLP ,  &
                 LSDNSL ,LSDORI ,LSDOSQ ,LSDOTI ,LSEMSG ,LSDRPD ,LSERRS ,LSESLP ,  &
                 LSESQP ,LSFAST ,LSFCER ,LSFCSQ ,LSFCZE ,LSFEAS ,LSFFS1 ,LSFSSM ,  &
                 LSFVCN ,LSFVLN ,LSFXOU ,LSGBAS ,LSGRES ,LSGMSO ,LSHDIA ,LSHESI ,  &
                 LSHSOK ,LSHSUS ,LSHSSM ,LSIERR ,LSIMSG ,LSIMXB ,LSINVN ,LSINTR ,  &
                 LSIOND ,LSISLP ,LSISMP ,LSISQP ,LSI15F ,LSJSQR ,LSLACK ,LSLINC ,  &
                 LSLINR ,LSLINP ,LSLINT ,LSLJAC ,LSNJAC ,LSLNEQ ,LSNPTZ ,LSTSLU ,  &
                 LSTSRI ,LSTSUP ,LSLRGU ,LSMAXJ ,LSMAXV ,LSMINT ,LSMXBS ,LSMXST ,  &
                 LSNEGC ,LSNEWB ,LSNEWR ,LSNLEQ ,LSNOBS ,LSNOUP ,LSNOHS ,LSNOP2 ,  &
                 LSNOON ,LSNOZR ,LSNSQR ,LSNSUP ,LSNWCN ,LSNWIN ,LSOPTO ,LSOLDR ,  &
                 LSONDI ,LSONDS ,LSONWL ,LSPFBS ,LSPHES ,LSPIVE ,LSPOSE ,LSPOST ,  &
                 LSPRET ,LSPRTI ,LSPRZE ,LSPSBS ,LSQUIZ ,LSREDG ,LSREST ,LSRGOK ,  &
                 LSRINF ,LSRSOK ,LSRSTR ,LSRVNL ,LSSASS ,LSSCAL ,LSSETP ,LSSLPI ,  &
                 LSSLPP ,LSSMPT ,LSSPAC ,LSSQPD ,LSSQPI ,LSSQPN ,LSSQRS ,LSSQSI ,  &
                 LSSYSE ,LSSTLN ,LSTCRS ,LSTIGH ,LSTRIA ,LSUIN  ,LSUNBD ,LSUPDT ,  &
                 LSUSEB ,LSUSRI ,LSXUOK ,LSX1AB ,LSX2TN ,LSX2WG ,LS2DRV ,REMVNG ,  &
                 INCSNG ,DECSNG ,LSLSPC ,LSMSPC ,LSDMOD ,SWITCP ,LSDUAL ,LSDUIN ,  &
                 DOHESS ,DO2DIR ,TESTLG ,TESTF  ,TESTD  ,TEST1F ,TESTZM ,TESTPI ,  &
                 TESTBL ,TEST2D ,TSTHDR ,PRNTRP ,PRNTR2 ,PRNTRI ,PRDERV ,PRDERI ,  &
                 PRHSTR ,PR2DRV ,PR2VAL ,PRCMPR ,PRCMP2
!
! Indices for Start of the vectors
!
      Integer, Dimension(1) :: LlFirst_vec
      Integer :: LlANRM ,LlAMAT ,LlLMAT ,LlLROW ,LlLCOL ,LlLSTR ,LlBASC ,LlBASI ,  &
                 LlBMAT ,LlBSTA ,LlC2RP ,LlCCC  ,LlCCNT ,LlCCOL ,LlCFNB ,LlCFNV ,  &
                 LlCLEN ,LlCLMX ,LlCLMN ,LlCNUM ,LlCNTO ,LlCOTN ,LlCBTO ,LlCODE ,  &
                 LlCP   ,LlCRIC ,LlCRIR ,LlCROW ,LlCSTR ,LlCSCL ,LlCSTK ,LlDBND ,  &
                 LlDCOL ,LlDIR  ,LlDGRS ,LlDHES ,LlDSTK ,LlESTA ,LlFZSL ,LlFUNC ,  &
                 LlGBAS ,LlGIND ,LlGMAX ,LlGRES ,LlGRSL ,LlGSGN ,LlHEAP ,LlHDIA ,  &
                 LlHLP1 ,LlHLP2 ,LlHLP3 ,LlHLP4 ,LlHLPZ ,LlHSRW ,LlHSCL ,LlHSVL ,  &
                 LlHSST ,LlIC   ,LlIFSI ,LlIFSL ,LlIMIN ,LlIMAX ,LlIR   ,LlJACE ,  &
                 LlJACR ,LlJC2R ,LlJACT ,LlJCNM ,LlJMAX ,LlJMIN ,LlJPIV ,LlJSQR ,  &
                 LlLABA ,LlLABP ,LlLABL ,LlLCL  ,LlLJNR ,LlLNLR ,LlLNEQ ,LlLRL  ,  &
                 LlLSOR ,LlLPIV ,LlLW   ,LlNLEQ ,LlNWK1 ,LlNWK2 ,LlNWKZ ,LlOCBC ,  &
                 LlOMIN ,LlOMAX ,LlOSCL ,LlPCHR ,LlPCOL ,LlPINT ,LlPINV ,LlPLOG ,  &
                 LlPRL  ,LlPLVL ,LlPROW ,LlPSTR ,LlR2CP ,LlRCNT ,LlRCNU ,LlRJAC ,  &
                 LlRGIN ,LlRGFR ,LlRGLD ,LlRGRA ,LlRGRE ,LlRHES ,LlRHSV ,LlRLEN ,  &
                 LlRLNK ,LlRNUM ,LlRNTO ,LlROTN ,LlROWT ,LlRSTR ,LlRWCL ,LlRWSZ ,  &
                 LlSLCL ,LlSLRW ,LlSMAX ,LlSMIN ,LlSTCL ,LlSTEL ,LlSTLR ,LlSTRW ,  &
                 LlTHCR ,LlTHEC ,LlTHER ,LlTMAX ,LlTMIN ,LlUM   ,LlUBAS ,LlUD   ,  &
                 LlUIN  ,LlUPDT ,LlVH   ,LlVARI ,LlVIS  ,LlVRL  ,LlWMXC ,LlXSLP ,  &
                 LlXMIN ,LlXMAX ,LlXSOL ,LlXSQR ,LlDELX ,LlXUNS ,LlX1   ,LlX2   ,  &
                 LlXHL1 ,LlY    ,LlLBND ,LlUBND ,LlCOLS ,LlNXTC ,LlNXTR ,LlPRVC ,  &
                 LlPRVR ,LlCLOK ,LlMACT ,LlMLOW ,LlMROW ,LlMREX ,LlSTCC ,LlSTCR ,  &
                 LlSTMC ,LlCLOL ,LlCLIN ,LlRLOL ,LlRLIN ,LlLISC ,LlLISR ,LlMMAT ,  &
                 LlCPNX ,LlCPPR ,LlRPNX ,LlRPPR
!
! Length of the vectors
!
      Integer, Dimension(1) :: LjFirst_vec
      Integer :: LjANRM ,LjAMAT ,LjLMAT ,LjLROW ,LjLCOL ,LjLSTR ,LjBASC ,LjBASI ,  &
                 LjBMAT ,LjBSTA ,LjC2RP ,LjCCC  ,LjCCNT ,LjCCOL ,LjCFNB ,LjCFNV ,  &
                 LjCLEN ,LjCLMX ,LjCLMN ,LjCNUM ,LjCNTO ,LjCOTN ,LjCBTO ,LjCODE ,  &
                 LjCP   ,LjCRIC ,LjCRIR ,LjCROW ,LjCSTR ,LjCSCL ,LjCSTK ,LjDBND ,  &
                 LjDCOL ,LjDIR  ,LjDGRS ,LjDHES ,LjDSTK ,LjESTA ,LjFZSL ,LjFUNC ,  &
                 LjGBAS ,LjGIND ,LjGMAX ,LjGRES ,LjGRSL ,LjGSGN ,LjHEAP ,LjHDIA ,  &
                 LjHLP1 ,LjHLP2 ,LjHLP3 ,LjHLP4 ,LjHLPZ ,LjHSRW ,LjHSCL ,LjHSVL ,  &
                 LjHSST ,LjIC   ,LjIFSI ,LjIFSL ,LjIMIN ,LjIMAX ,LjIR   ,LjJACE ,  &
                 LjJACR ,LjJC2R ,LjJACT ,LjJCNM ,LjJMAX ,LjJMIN ,LjJPIV ,LjJSQR ,  &
                 LjLABA ,LjLABP ,LjLABL ,LjLCL  ,LjLJNR ,LjLNLR ,LjLNEQ ,LjLRL  ,  &
                 LjLSOR ,LjLPIV ,LjLW   ,LjNLEQ ,LjNWK1 ,LjNWK2 ,LjNWKZ ,LjOCBC ,  &
                 LjOMIN ,LjOMAX ,LjOSCL ,LjPCHR ,LjPCOL ,LjPINT ,LjPINV ,LjPLOG ,  &
                 LjPRL  ,LjPLVL ,LjPROW ,LjPSTR ,LjR2CP ,LjRCNT ,LjRCNU ,LjRJAC ,  &
                 LjRGIN ,LjRGFR ,LjRGLD ,LjRGRA ,LjRGRE ,LjRHES ,LjRHSV ,LjRLEN ,  &
                 LjRLNK ,LjRNUM ,LjRNTO ,LjROTN ,LjROWT ,LjRSTR ,LjRWCL ,LjRWSZ ,  &
                 LjSLCL ,LjSLRW ,LjSMAX ,LjSMIN ,LjSTCL ,LjSTEL ,LjSTLR ,LjSTRW ,  &
                 LjTHCR ,LjTHEC ,LjTHER ,LjTMAX ,LjTMIN ,LjUM   ,LjUBAS ,LjUD   ,  &
                 LjUIN  ,LjUPDT ,LjVH   ,LjVARI ,LjVIS  ,LjVRL  ,LjWMXC ,LjXSLP ,  &
                 LjXMIN ,LjXMAX ,LjXSOL ,LjXSQR ,LjDELX ,LjXUNS ,LjX1   ,LjX2   ,  &
                 LjXHL1 ,LjY    ,LjLBND ,LjUBND ,LjCOLS ,LjNXTC ,LjNXTR ,LjPRVC ,  &
                 LjPRVR ,LjCLOK ,LjMACT ,LjMLOW ,LjMROW ,LjMREX ,LjSTCC ,LjSTCR ,  &
                 LjSTMC ,LjCLOL ,LjCLIN ,LjRLOL ,LjRLIN ,LjLISC ,LjLISR ,LjMMAT ,  &
                 LjCPNX ,LjCPPR ,LjRPNX ,LjRPPR
!
! Internal numbers of the vectors
!
      Integer, Dimension(1) :: LnFirst_vec
      Integer :: LnANRM ,LnAMAT ,LnLMAT ,LnLROW ,LnLCOL ,LnLSTR ,LnBASC ,LnBASI ,  &
                 LnBMAT ,LnBSTA ,LnC2RP ,LnCCC  ,LnCCNT ,LnCCOL ,LnCFNB ,LnCFNV ,  &
                 LnCLEN ,LnCLMX ,LnCLMN ,LnCNUM ,LnCNTO ,LnCOTN ,LnCBTO ,LnCODE ,  &
                 LnCP   ,LnCRIC ,LnCRIR ,LnCROW ,LnCSTR ,LnCSCL ,LnCSTK ,LnDBND ,  &
                 LnDCOL ,LnDIR  ,LnDGRS ,LnDHES ,LnDSTK ,LnESTA ,LnFZSL ,LnFUNC ,  &
                 LnGBAS ,LnGIND ,LnGMAX ,LnGRES ,LnGRSL ,LnGSGN ,LnHEAP ,LnHDIA ,  &
                 LnHLP1 ,LnHLP2 ,LnHLP3 ,LnHLP4 ,LnHLPZ ,LnHSRW ,LnHSCL ,LnHSVL ,  &
                 LnHSST ,LnIC   ,LnIFSI ,LnIFSL ,LnIMIN ,LnIMAX ,LnIR   ,LnJACE ,  &
                 LnJACR ,LnJC2R ,LnJACT ,LnJCNM ,LnJMAX ,LnJMIN ,LnJPIV ,LnJSQR ,  &
                 LnLABA ,LnLABP ,LnLABL ,LnLCL  ,LnLJNR ,LnLNLR ,LnLNEQ ,LnLRL  ,  &
                 LnLSOR ,LnLPIV ,LnLW   ,LnNLEQ ,LnNWK1 ,LnNWK2 ,LnNWKZ ,LnOCBC ,  &
                 LnOMIN ,LnOMAX ,LnOSCL ,LnPCHR ,LnPCOL ,LnPINT ,LnPINV ,LnPLOG ,  &
                 LnPRL  ,LnPLVL ,LnPROW ,LnPSTR ,LnR2CP ,LnRCNT ,LnRCNU ,LnRJAC ,  &
                 LnRGIN ,LnRGFR ,LnRGLD ,LnRGRA ,LnRGRE ,LnRHES ,LnRHSV ,LnRLEN ,  &
                 LnRLNK ,LnRNUM ,LnRNTO ,LnROTN ,LnROWT ,LnRSTR ,LnRWCL ,LnRWSZ ,  &
                 LnSLCL ,LnSLRW ,LnSMAX ,LnSMIN ,LnSTCL ,LnSTEL ,LnSTLR ,LnSTRW ,  &
                 LnTHCR ,LnTHEC ,LnTHER ,LnTMAX ,LnTMIN ,LnUM   ,LnUBAS ,LnUD   ,  &
                 LnUIN  ,LnUPDT ,LnVH   ,LnVARI ,LnVIS  ,LnVRL  ,LnWMXC ,LnXSLP ,  &
                 LnXMIN ,LnXMAX ,LnXSOL ,LnXSQR ,LnDELX ,LnXUNS ,LnX1   ,LnX2   ,  &
                 LnXHL1 ,LnY    ,LnLBND ,LnUBND ,LnCOLS ,LnNXTC ,LnNXTR ,LnPRVC ,  &
                 LnPRVR ,LnCLOK ,LnMACT ,LnMLOW ,LnMROW ,LnMREX ,LnSTCC ,LnSTCR ,  &
                 LnSTMC ,LnCLOL ,LnCLIN ,LnRLOL ,LnRLIN ,LnLISC ,LnLISR ,LnMMAT ,  &
                 LnCPNX ,LnCPPR ,LnRPNX ,LnRPPR
      Integer :: Nwordr
      Integer :: Nwordi
      Integer :: Nwordc
!
!  Timer information- Integer Part
!
      Integer :: Count_Old ! previous value of Count.
      Integer :: Count_Acc ! Accuracy limit for Count.

!
!  Error Returns
!
      Integer :: Syserr  ! Systems Error Number
      Integer :: Usrerr  ! User Error Number
      Logical :: ErrorR  ! Logical that flags that we should return
                         ! immediately
      Integer :: ErrorS  ! Users Error value. 0 means that we can write
                         ! a message to the screen and a nonzero value
                         ! means that we should just terminate
!
! Information from Prtsys.i:
!
      Integer :: LPBASP  ! Start address-1 for printing vectors. Used
                         ! for printing parts of a vector.
      Integer :: LPLINS  ! Number of sparse reals per line
      Integer, Dimension(Nvect) :: Lpline  ! Number of elements per line
                                           ! depending on type
      INTEGER, Dimension(Nvect) :: NCHAR
!
! Information from Crcore.i
!
      Integer, Dimension(Nvect) :: Lword
!
!  Information needed in ProbSize and UpdtSize routines
!
!      Integer, Dimension(Len_Ipsz) :: Ipsz
!
!  Integers for the message routines
!
      Integer :: smsg  ! Number of messages lines for the Screen File.
      Integer :: dmsg  ! Number of messages lines for the Documentation
                       ! File.
      Integer :: nmsg  ! Number of messages lines for the Summary
                       ! Listing File.
!
!  Characters for the Message routines
!
      character*(CO_OLineLen) :: Msgtxt
!
!  Misc.
!
      Character*1  :: RVERSS
   End Type Conopt_Model_Info

   Integer, parameter, Private :: Number_of_Reals =   196
   Integer, parameter, Private :: Number_of_Ints  =   344
   Integer, parameter, Private :: Number_of_Logs  =   173
   Integer, parameter, Private :: Number_of_Vects =   180
!
!  Private entry points are declared private here
!
   Private Co_Real0, Co_Int0, CO_Log0
   Private Co_Get_CRRI, Co_Get_CRII, Co_Get_CRLI
   Private Co_Set_CRRI, Co_Set_CRII, Co_Set_CRLI
   Private Co_Get_VLenI, Co_Set_VLenI
   Private Co_Get_VStrI, Co_Set_VStrI
   Private               Co_Set_VnumI
   Private Co_RealW,  Co_IntW,  Co_LogW
   Private Co_RealWi, Co_IntWi, Co_LogWi
   Private Co_RealR,  Co_IntR,  Co_LogR
   Private Co_RealRi, Co_IntRi, Co_LogRi
   Private Co_LenW, Co_LenR, Co_StrW, Co_StrR

   Contains
!
!  Allocate and Initialize CMI data structure and define default values.
!
   Subroutine COI_Allocate( CMI )
      Implicit None
      Type (conopt_model_info), pointer :: cmi
      Integer :: i

      allocate( cmi )
!
!  Initialize the vector start, length, and number.
!
      DO i = 1, Number_of_Vects
         call Co_Set_Vstr(CMI, i, -10000000)
         call Co_Set_Vlen(CMI, i, -1)
         call Co_Set_Vnum(CMI, i )
      ENDDO
!
      CMI%ErrorS     = 0 ! Users Error value. 1 means that we can write
                         ! a message using write(*,*) and 0 means that
                         ! we should just terminate
      CMI%USRERR     = 0 ! initially no errors
      CMI%SYSERR     = 0 ! initially no errors
      CMI%NCHAR      = (/ 19, 7, 12 /)
      CALL CO_Def_Words( CMI%Nwordr, CMI%Nwordi, CMI%Nwordc )

   END Subroutine COI_Allocate
!
!  Initialize all Real CR cells to zero
!
   Subroutine Co_Real0(Realv)
      Implicit none
      REAL(CO_R),  Dimension(:) :: Realv
      Integer I

      DO I = 2, Number_of_Reals+1
          Realv(I) = 0.D0
      ENDDO

   END Subroutine Co_Real0
!
!  Initialize all Integer CR cells to zero
!
   Subroutine Co_Int0(Intv)
      Implicit none
      Integer, Dimension (:) :: Intv
      Integer I

      DO I = 2, Number_of_Ints+1
          Intv(I) = 0
      ENDDO

   END Subroutine Co_Int0
!
!  Initialize all Logical CR cells to false.
!
   Subroutine Co_Log0(Logv)
      Implicit none
      Logical, Dimension(:) :: Logv
      Integer I

      DO I = 2, Number_of_Logs+1
          Logv(I) = .FALSE.
      ENDDO

   END Subroutine Co_Log0
!
!  Get the value of a real CR cell
!
   Subroutine Co_Get_CRR( CMI, Num, Rl )
      Implicit none
      Type (Conopt_Model_Info) CMI
      Integer  :: Num
      REAL(CO_R) :: Rl

      Call Co_Get_CRRI( CMI%First_rl, Num, Rl )

   End Subroutine Co_Get_CRR

   Subroutine Co_Get_CRRI( Realv, Num, Rl )
      Implicit none
      REAL(CO_R), Dimension(:) :: Realv
      REAL(CO_R) :: Rl
      Integer  :: Num

      Rl = Realv(Num+1)

   End Subroutine Co_Get_CRRI
!
!  Set the value of a real CR cell
!
   Subroutine Co_Set_CRR( CMI, Num, Rl )
      Implicit none
      Type (Conopt_Model_Info) CMI
      Integer  :: Num
      REAL(CO_R) :: Rl

      Call Co_Set_CRRI( CMI%First_rl, Num, Rl )

   End Subroutine Co_Set_CRR

   Subroutine Co_Set_CRRI( Realv, Num, Rl )
      Implicit none
      REAL(CO_R), Dimension(:) :: Realv
      REAL(CO_R) :: Rl
      Integer  :: Num

      Realv(Num+1) = Rl

   End Subroutine Co_Set_CRRI
!
!  Get the value of an integer CR cell
!
   Subroutine Co_Get_CRI( CMI, Num, Int )
      Implicit none
      Type (Conopt_Model_Info) CMI
      Integer :: Num, Int

      Call Co_Get_CRII( CMI%First_is, Num, Int )

   End Subroutine Co_Get_CRI

   Subroutine Co_Get_CRII( Intv, Num, Int )
      Implicit none
      Integer, Dimension(:) :: Intv
      Integer :: Int
      Integer :: Num

      Int = Intv(Num+1)

   End Subroutine Co_Get_CRII
!
!  Set the value of an integer CR Cell
!
   Subroutine Co_Set_CRI( CMI, Num, Int )
      Implicit none
      Type (Conopt_Model_Info) CMI
      Integer :: Num
      Integer :: Int

      Call Co_Set_CRII( CMI%First_is, Num, Int )

   End Subroutine Co_Set_CRI

   Subroutine Co_Set_CRII( Intv, Num, Int )
      Implicit none
      Integer, Dimension(:) :: Intv
      Integer :: Int
      Integer :: Num

      Intv(Num+1) = Int

   End Subroutine Co_Set_CRII
!
!  Get the value of a logical CR cell
!
   Subroutine Co_Get_CRL( CMI, Num, Log )
      Implicit none
      Type (Conopt_Model_Info) CMI
      Integer :: Num
      Logical :: Log

      Call Co_Get_CRLI( CMI%First_Ls, Num, Log )

   End Subroutine Co_Get_CRL

   Subroutine Co_Get_CRLI( Logv, Num, Log )
      Implicit none
      Logical, Dimension(:) :: Logv
      Logical :: Log
      Integer :: Num

      Log = Logv(Num+1)

   End Subroutine Co_Get_CRLI
!
!  Set the value of a logical CR Cell
!
   Subroutine Co_Set_CRL( CMI, Num, Log )
      Implicit none
      Type (Conopt_Model_Info) CMI
      Integer :: Num
      Logical :: Log

      Call Co_Set_CRLI( CMI%First_Ls, Num, Log )

   End Subroutine Co_Set_CRL

   Subroutine Co_Set_CRLI( Logv, Num, Log )
      Implicit none
      Logical, Dimension(:) :: Logv
      Logical :: Log
      Integer :: Num

      Logv(Num+1) = Log

   End Subroutine Co_Set_CRLI
!
!  Get the length of a vector
!
   Subroutine Co_Get_Vlen( CMI, Vnum, Len )
      Implicit none
      Type (Conopt_Model_Info) CMI
      Integer :: Vnum, Len

      Call Co_Get_VlenI( CMI%LjFirst_vec, Vnum, Len )

   End Subroutine Co_Get_Vlen

   Subroutine Co_Get_VlenI( Lvec, Vnum, Len )
      Implicit none
      Integer :: Vnum, Len
      Integer, Dimension(:) :: Lvec

      Len = Lvec(Vnum+1)

   End Subroutine Co_Get_VlenI
!
!  Set the length of a vector
!
   Subroutine Co_Set_Vlen( CMI, Vnum, Len )
      Implicit none
      Type (Conopt_Model_Info) CMI
      Integer :: Vnum, Len

      Call Co_Set_VlenI( CMI%LjFirst_vec, Vnum, Len )

   End Subroutine Co_Set_Vlen

   Subroutine Co_Set_VlenI( Lvec, Vnum, Len )
      Implicit none
      Integer :: Vnum, Len
      Integer, Dimension(:) :: Lvec

      Lvec(Vnum+1) = Len

   End Subroutine Co_Set_VlenI
!
!  Set the number of a vector
!
   Subroutine Co_Set_Vnum( CMI, Vnum )
      Implicit none
      Type (Conopt_Model_Info) CMI
      Integer :: Vnum

      Call Co_Set_VnumI( CMI%LnFirst_vec, Vnum )

   End Subroutine Co_Set_Vnum

   Subroutine Co_Set_VnumI( Lvec, Vnum )
      Implicit none
      Integer :: Vnum
      Integer, Dimension(:) :: Lvec

      Lvec(Vnum+1) = Vnum

   End Subroutine Co_Set_VnumI
!
!  Get the start of a vector
!
   Subroutine Co_Get_Vstr( CMI, Vnum, Str )
      Implicit none
      Type (Conopt_Model_Info) CMI
      Integer :: Vnum, Str

      Call Co_Get_VstrI( CMI%LlFirst_vec, Vnum, Str )

   End Subroutine Co_Get_Vstr

   Subroutine Co_Get_VstrI( Lvec, Vnum, Str )
      Implicit none
      Integer :: Vnum, Str
      Integer, Dimension(:) :: Lvec

      Str = Lvec(Vnum+1)

   End Subroutine Co_Get_VstrI
!
!  Set the start of a vector
!
   Subroutine Co_Set_Vstr( CMI, Vnum, Str )
      Implicit none
      Type (Conopt_Model_Info) CMI
      Integer :: Vnum, Str

      Call Co_Set_VstrI( CMI%LlFirst_vec, Vnum, Str )

   End Subroutine Co_Set_Vstr

   Subroutine Co_Set_VstrI( Lvec, Vnum, Str )
      Implicit none
      Integer :: Vnum, Str
      Integer, Dimension(:) :: Lvec

      Lvec(Vnum+1) = Str

   End Subroutine Co_Set_VstrI
!
!  Clean up and deallocate all small allocated arrays
!
   Subroutine COI_Deallocate( CMI, Error )
      Implicit none
      Type (conopt_model_info), pointer :: cmi
      Integer :: Error, Error1

      Error = 0
      deallocate( cmi%Ltvect, STAT = Error1 )
      Error = Max( Error, Error1 )
      deallocate( cmi%Usvect, STAT = Error1 )
      Error = Max( Error, Error1 )
      deallocate( cmi%Nlvect, STAT = Error1 )
      Error = Max( Error, Error1 )
      deallocate( cmi%Vectst, STAT = Error1 )
      Error = Max( Error, Error1 )
      deallocate( cmi%Knvect, STAT = Error1 )
      Error = Max( Error, Error1 )
      deallocate( cmi%Crdesc, STAT = Error1 )
      Error = Max( Error, Error1 )
      deallocate( cmi%Crname, STAT = Error1 )
      Error = Max( Error, Error1 )
      deallocate( cmi%Msgv  , STAT = Error1 )
      Error = Max( Error, Error1 )
      deallocate( cmi       , STAT = Error1 )
      Error = Max( Error, Error1 )

   End Subroutine COI_Deallocate
!
!  Write all Cr-cells to a file
!
   Subroutine CO_Write_Cr( CMI )
      Implicit none
      Type (Conopt_Model_Info) CMI

      Integer :: I

      WRITE(CMI%LUSVRS) Number_of_Ints, Number_of_Logs, &
                        Number_of_Reals, Number_of_Vects
      WRITE(CMI%LUSVRS) (CMI%First_IS(I+1), I = 1, Number_of_Ints)
      WRITE(CMI%LUSVRS) (CMI%First_LS(I+1), I = 1, Number_of_Logs)
      WRITE(CMI%LUSVRS) (CMI%First_RL(I+1), I = 1, Number_of_Reals)

   End Subroutine CO_Write_Cr
!
!  Read all Cr-cells from a file
!
   Subroutine CO_Read_Cr( CMI, Error )
      Implicit none
      Type (Conopt_Model_Info) CMI
      Integer :: Error

      Integer :: I
      Integer :: H2, H3, H4, H5, Unit
      Integer :: Libas, Lifree, Latot, Nvused

      Error = 1
      Unit = CMI%Lusvrs
      READ(Unit) H2, H3, H4, H5
      IF ( H2 .NE. Number_of_Ints  ) Return
      IF ( H3 .NE. Number_of_Logs  ) Return
      IF ( H4 .NE. Number_of_Reals ) Return
      IF ( H5 .NE. Number_of_Vects ) Return
      Libas  = CMI%Libas    ! Keep values to prevent overwriting
      Lifree = CMI%Lifree
      Latot  = CMI%Latot
      Nvused = CMI%Nvused
      READ(Unit) (CMI%First_IS(I+1), I = 1, Number_of_Ints)
      READ(Unit) (CMI%First_LS(I+1), I = 1, Number_of_Logs)
      READ(Unit) (CMI%First_RL(I+1), I = 1, Number_of_Reals)
      CMI%Libas  = Libas    ! Restore original values
      CMI%Lifree = Lifree
      CMI%Latot  = Latot
      CMI%Nvused = Nvused
      CMI%LATOTT = CMI%LATOT     ! Reinitialize memory use cells.
      CMI%LAMAXU = CMI%LIFREE-1
      CMI%TINUSE = CMI%LIFREE-1
      Error = 0

   End Subroutine CO_Read_Cr
!
!  Copy all Real Cr cells to the vector Realv
!
   Subroutine Co_RealR( CMI, Realv )
      Implicit none
      Type (CONOPT_Model_Info) CMI
      REAL(CO_R), Dimension(Number_Of_Reals) :: Realv

      Call Co_RealRI( CMI%First_rl, Realv )

   End Subroutine Co_RealR

   Subroutine Co_RealRI( Realv1, Realv )
      Implicit none
      REAL(CO_R), Dimension(:) :: Realv1, Realv
      Integer I

      DO I = 1, Number_of_Reals
          Realv(I) = Realv1(I+1)
      ENDDO

   End Subroutine Co_RealRI
!
!  Overwrite all Real CR Cells with the content of vector Realv
!
   Subroutine Co_RealW( CMI, Realv )
      Implicit none
      Type (CONOPT_Model_Info) CMI
      REAL(CO_R), Dimension(Number_of_Reals) :: Realv

      Call Co_RealWI( CMI%First_rl, Realv )

   End Subroutine Co_RealW

   Subroutine Co_RealWI( Realv1, Realv )
      Implicit none
      REAL(CO_R), Dimension(:) :: Realv1, Realv
      Integer I

      DO I = 1, Number_of_Reals
          Realv1(I+1) = Realv(I)
      ENDDO

   End Subroutine Co_RealWI
!
!  Copy all Integer Cr cells to the vector Intv
!
   Subroutine Co_IntR( CMI, Intv )
      Implicit none
      Type (CONOPT_Model_Info) CMI
      Integer, Dimension(Number_Of_Ints) :: Intv

      Call Co_IntRI( CMI%First_IS, Intv )

   End Subroutine Co_IntR

   Subroutine Co_IntRI( Intv1, Intv )
      Implicit none
      Integer, Dimension(:) :: Intv1, Intv
      Integer I

      DO I = 1, Number_of_Ints
          Intv(I) = Intv1(I+1)
      ENDDO

   End Subroutine Co_IntRI
!
!  Overwrite all Integer CR Cells with the content of vector Intv
!
   Subroutine Co_IntW( CMI, Intv )
      Implicit none
      Type (CONOPT_Model_Info) CMI
      Integer, Dimension(Number_Of_Ints) :: Intv

      Call Co_IntWI( CMI%First_IS, Intv )

   End Subroutine Co_IntW

   Subroutine Co_IntWI( Intv1, Intv )
      Implicit none
      Integer,  Dimension(:) :: Intv1, Intv
      Integer I

      DO I = 1, Number_of_Ints
          Intv1(I+1) = Intv(I)
      ENDDO

   End Subroutine Co_IntWI
!
!  Copy all Logical Cr cells to the integer vector Logv, where they
!  are stored as 0 for false and 1 for true.
!
   Subroutine Co_LogR( CMI, Logv )
      Implicit none
      Type (CONOPT_Model_Info) CMI
      Integer, Dimension(Number_of_logs) :: Logv

      Call Co_LogRI( CMI%First_LS, Logv )

   End Subroutine Co_LogR

   Subroutine Co_LogRI( Logv1, Logv )
      Implicit none
      Integer, Dimension(:) :: Logv
      Logical, Dimension(:) :: Logv1
      Integer I

      DO I = 1, Number_of_Logs
          If ( Logv1(I+1) ) then
             Logv(I) = 1
          Else
             Logv(I) = 0
          Endif
      ENDDO

   End Subroutine Co_LogRI
!
!  Overwrite all Logical CR Cells with the content of Integer vector
!  Logv, translating 0 to false and nonzero to true
!
   Subroutine Co_LogW( CMI, Logv )
      Implicit none
      Type (CONOPT_Model_Info) CMI
      Integer, Dimension(Number_of_Logs) :: Logv

      Call Co_LogWI( CMI%First_LS, Logv )

   End Subroutine Co_LogW

   Subroutine Co_LogWI( Logv1, Logv )
      Implicit none
      Integer,  Dimension(:) :: Logv
      Logical,  Dimension(:) :: Logv1
      Integer I

      DO I = 1, Number_of_Logs
          Logv1(I+1) = Logv(I) .NE. 0
      ENDDO

   End Subroutine Co_LogWI
!
!  Overwrite all vector lengths with the content of the integer vector
!  Intv
!
   Subroutine Co_LenW( CMI, Intv )
      Implicit none
      Type (CONOPT_Model_Info) CMI
      Integer, Dimension(Number_Of_Vects) :: Intv
      Integer I

      Do I = 1, Number_of_Vects
         Call Co_Set_Vlen( CMI, I, Intv(i) )
      Enddo

   End Subroutine Co_LenW
!
!  Read all vector lengths and copy them to the integer vector Intv
!
   Subroutine Co_LenR( CMI, Intv )
      Implicit none
      Type (CONOPT_Model_Info) CMI
      Integer, Dimension(Number_Of_Vects) :: Intv
      Integer I

      Do I = 1, Number_of_Vects
         Call Co_Get_Vlen( CMI, I, Intv(i) )
      Enddo

   End Subroutine Co_LenR
!
!  Overwrite all vector starts with the content of the integer vector
!  Intv
!
   Subroutine Co_StrW( CMI, Intv )
      Implicit none
      Type (CONOPT_Model_Info) CMI
      Integer, Dimension(Number_Of_Vects) :: Intv
      Integer I

      Do I = 1, Number_of_Vects
         Call Co_Set_Vstr( CMI, I, Intv(i) )
      Enddo

   End Subroutine Co_StrW
!
!  Read all vector starts and copy them to the integer vector Intv
!
   Subroutine Co_StrR( CMI, Intv )
      Implicit none
      Type (CONOPT_Model_Info) CMI
      Integer, Dimension(Number_Of_Vects) :: Intv
      Integer I

      Do I = 1, Number_of_Vects
         Call Co_Get_Vstr( CMI, I, Intv(i) )
      Enddo

   End Subroutine Co_StrR
!
!  Write all integer + logical CR cells to vector Intv followed by
!  all vector lengths and all vectors starts
!  Also write all Real CR cells to vector Realv
!
   Subroutine Co_KeepCMI( CMI, Intv, Realv )
      Implicit None
      Type (Conopt_Model_Info) CMI
      Integer, Dimension(Number_of_Ints+Number_of_Logs+ &
                         2*Number_of_Vects+2) :: Intv
      REAL(CO_R) , Dimension(Number_of_Reals) :: Realv

      Integer :: is, i

      Intv(1) = 13572468 ! Magic number 1
      is = 2
      Call Co_IntR( CMI, Intv(is) )
      is = is + Number_of_Ints
      Call Co_LogR( CMI, Intv(is) )
      is = is + Number_of_Logs
      Call Co_LenR( CMI, Intv(is) )
      is = is + Number_of_Vects
      Call Co_StrR( CMI, Intv(is) )
      Intv(is) = 86427531 ! Magic number 2

      Call Co_RealR( CMI, Realv )

   End Subroutine Co_KeepCMI
!
!  Read all integer + logical CR cells from vector Intv followed by
!  all vector lengths and all vectors starts
!
   Subroutine Co_RestCMI1( CMI, Intv, Lwork, Errorc )
      Implicit None
      Type (Conopt_Model_Info) CMI
      Integer, Dimension(Number_of_Ints+Number_of_Logs+ &
                         2*Number_of_Vects+2) :: Intv
      Integer, Intent(IN)  :: Lwork
      Integer, Intent(OUT) :: Errorc

      Integer :: is, i

      IF ( Intv(1) .NE. 13572468 ) Then
         Errorc = 1  ! Corrupted Work vector
         Return
      Elseif ( ( Number_of_Ints + Number_of_Logs + 2*Number_of_Vects+2 &
                 + CMI%Nwordi-1) / CMI%Nwordi                          &
               + Number_of_Reals .GE. Lwork ) Then
         Errorc = 2  ! Insufficient memory
         Return
      Endif
      is = 2
      Call Co_IntW( CMI, Intv(is) )
      is = is + Number_of_Ints
      Call Co_LogW( CMI, Intv(is) )
      is = is + Number_of_Logs
      Call Co_LenW( CMI, Intv(is) )
      is = is + Number_of_Vects
      Call Co_StrW( CMI, Intv(is) )
      IF ( Intv(is) .NE. 86427531 ) Then
         Errorc = 1  ! Corrupted Work vector
      Else
         ErrorC = 0  ! OK
      Endif

   End Subroutine Co_RestCMI1

   Subroutine Co_RestCMI2( CMI, Realv )
      Implicit None
      Type (Conopt_Model_Info) CMI
      REAL(CO_R) , Dimension(Number_of_Reals) :: Realv
      Integer :: i

      Call Co_RealW( CMI, Realv )

   End Subroutine Co_RestCMI2

   Subroutine CO_CMI_Ini(CMI, Restart, Error)
      Implicit none
      Type (Conopt_Model_Info) CMI
      Logical Restart, Error

      Integer astat

      Integer i

      Error = .true.
      allocate( cmi%Ltvect(Number_Of_Vects), stat= astat )
      If ( astat .ne. 0 ) Return
      allocate( cmi%Usvect(Number_Of_Vects), stat= astat )
      If ( astat .ne. 0 ) Return
      allocate( cmi%Nlvect(Number_Of_Vects), stat= astat )
      If ( astat .ne. 0 ) Return
      allocate( cmi%Vectst(Number_Of_Vects), stat= astat )
      If ( astat .ne. 0 ) Return
      allocate( cmi%Knvect(Number_Of_Vects), stat= astat )
      If ( astat .ne. 0 ) Return
      allocate( cmi%Crdesc(3,Number_of_Unames+1), stat= astat )
      If ( astat .ne. 0 ) Return
      allocate( cmi%Crname(Number_of_Unames+1), stat= astat )
      If ( astat .ne. 0 ) Return
      allocate( cmi%Msgv(Max_Msg), stat= astat )
      If ( astat .ne. 0 ) Return
      Error = .false.
      If ( .not. Restart ) then
         call Co_Real0(CMI%First_RL)
         call Co_Int0(CMI%First_IS)
         call Co_Log0(CMI%First_LS)
         do i = 1, Number_Of_Vects
            call Co_Set_Vstr(CMI, i, -10000000)
            call Co_Set_Vlen(CMI, i, -1)
            call Co_Set_Vnum(CMI, i )
         enddo
      Endif


      CMI%Knvect = (/ &
         'ANRM' ,'AMAT' ,'LMAT' ,'LROW' ,'LCOL' ,'LSTR' ,'BASC' ,'BASI' , &
         'BMAT' ,'BSTA' ,'C2RP' ,'CCC ' ,'CCNT' ,'CCOL' ,'CFNB' ,'CFNV' , &
         'CLEN' ,'CLMX' ,'CLMN' ,'CNUM' ,'CNTO' ,'COTN' ,'CBTO' ,'CODE' , &
         'CP  ' ,'CRIC' ,'CRIR' ,'CROW' ,'CSTR' ,'CSCL' ,'CSTK' ,'DBND' , &
         'DCOL' ,'DIR ' ,'DGRS' ,'DHES' ,'DSTK' ,'ESTA' ,'FZSL' ,'FUNC' , &
         'GBAS' ,'GIND' ,'GMAX' ,'GRES' ,'GRSL' ,'GSGN' ,'HEAP' ,'HDIA' , &
         'HLP1' ,'HLP2' ,'HLP3' ,'HLP4' ,'HLPZ' ,'HSRW' ,'HSCL' ,'HSVL' , &
         'HSST' ,'IC  ' ,'IFSI' ,'IFSL' ,'IMIN' ,'IMAX' ,'IR  ' ,'JACE' , &
         'JACR' ,'JC2R' ,'JACT' ,'JCNM' ,'JMAX' ,'JMIN' ,'JPIV' ,'JSQR' , &
         'LABA' ,'LABP' ,'LABL' ,'LCL ' ,'LJNR' ,'LNLR' ,'LNEQ' ,'LRL ' , &
         'LSOR' ,'LPIV' ,'LW  ' ,'NLEQ' ,'NWK1' ,'NWK2' ,'NWKZ' ,'OCBC' , &
         'OMIN' ,'OMAX' ,'OSCL' ,'PCHR' ,'PCOL' ,'PINT' ,'PINV' ,'PLOG' , &
         'PRL ' ,'PLVL' ,'PROW' ,'PSTR' ,'R2CP' ,'RCNT' ,'RCNU' ,'RJAC' , &
         'RGIN' ,'RGFR' ,'RGLD' ,'RGRA' ,'RGRE' ,'RHES' ,'RHSV' ,'RLEN' , &
         'RLNK' ,'RNUM' ,'RNTO' ,'ROTN' ,'ROWT' ,'RSTR' ,'RWCL' ,'RWSZ' , &
         'SLCL' ,'SLRW' ,'SMAX' ,'SMIN' ,'STCL' ,'STEL' ,'STLR' ,'STRW' , &
         'THCR' ,'THEC' ,'THER' ,'TMAX' ,'TMIN' ,'UM  ' ,'UBAS' ,'UD  ' , &
         'UIN ' ,'UPDT' ,'VH  ' ,'VARI' ,'VIS ' ,'VRL ' ,'WMXC' ,'XSLP' , &
         'XMIN' ,'XMAX' ,'XSOL' ,'XSQR' ,'DELX' ,'XUNS' ,'X1  ' ,'X2  ' , &
         'XHL1' ,'Y   ' ,'LBND' ,'UBND' ,'COLS' ,'NXTC' ,'NXTR' ,'PRVC' , &
         'PRVR' ,'CLOK' ,'MACT' ,'MLOW' ,'MROW' ,'MREX' ,'STCC' ,'STCR' , &
         'STMC' ,'CLOL' ,'CLIN' ,'RLOL' ,'RLIN' ,'LISC' ,'LISR' ,'MMAT' , &
         'CPNX' ,'CPPR' ,'RPNX' ,'RPPR'/)
      CMI%Ltvect = (/ &
         TypV_Real ,TypV_Real ,TypV_Real ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  , &
         TypV_Real ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Real , &
         TypV_Int  ,TypV_Real ,TypV_Real ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  , &
         TypV_Char ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Real ,TypV_Int  ,TypV_Real , &
         TypV_Int  ,TypV_Real ,TypV_Real ,TypV_Real ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  , &
         TypV_Real ,TypV_Int  ,TypV_Real ,TypV_Real ,TypV_Real ,TypV_Real ,TypV_Int  ,TypV_Real , &
         TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Real , &
         TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Real ,TypV_Real ,TypV_Int  ,TypV_Real , &
         TypV_Real ,TypV_Real ,TypV_Int  ,TypV_Int  ,TypV_Real ,TypV_Real ,TypV_Int  ,TypV_Real , &
         TypV_Int  ,TypV_Int  ,TypV_Char ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  , &
         TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Real ,TypV_Real ,TypV_Real ,TypV_Int  , &
         TypV_Real ,TypV_Real ,TypV_Real ,TypV_Char ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  , &
         TypV_Real ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Real , &
         TypV_Int  ,TypV_Int  ,TypV_Real ,TypV_Real ,TypV_Real ,TypV_Real ,TypV_Real ,TypV_Int  , &
         TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Real , &
         TypV_Int  ,TypV_Int  ,TypV_Real ,TypV_Real ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  , &
         TypV_Real ,TypV_Real ,TypV_Real ,TypV_Real ,TypV_Real ,TypV_Real ,TypV_Real ,TypV_Real , &
         TypV_Int  ,TypV_Real ,TypV_Real ,TypV_Int  ,TypV_Int  ,TypV_Real ,TypV_Real ,TypV_Real , &
         TypV_Real ,TypV_Real ,TypV_Real ,TypV_Real ,TypV_Real ,TypV_Real ,TypV_Real ,TypV_Real , &
         TypV_Real ,TypV_Real ,TypV_Real ,TypV_Real ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  , &
         TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  , &
         TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Real , &
         TypV_Int  ,TypV_Int  ,TypV_Int  ,TypV_Int /)
!
! Initialize Compiler data
!
      Cmi%Crname = (/ &
         'LFBLCK' ,'LFBSLP' ,'LFBSQP' ,'LFCON3' ,'LFDEGI' ,'LFDERR' ,'LFDLM0' ,'LFHSOK' , &
         'LF2DRV' ,'LFMARK' ,'LFRSCN' ,'LFEERR' ,'LFEMSG' ,'LFILOG' ,'LFILOS' ,'LFITER' , &
         'LFINVL' ,'LFIST1' ,'LFIST2' ,'LFLERR' ,'LFMIDL' ,'LFMAXP' ,'LFMXNS' ,'LFMXP4' , &
         'LFMXQN' ,'LFMXST' ,'LFNICR' ,'LFNOUI' ,'LFNUPD' ,'LFNSUP' ,'LFNWIT' ,'LFNWMJ' , &
         'LFONEB' ,'LFONEW' ,'LFRINL' ,'LFRINQ' ,'LFRINS' ,'LFSCAL' ,'LFSHRT' ,'LFSLIM' , &
         'LFSLOP' ,'LFSQPS' ,'LFSTAL' ,'LFTABU' ,'LFTEST' ,'LKDEBG' ,'LKDEB2' ,'LKDUMM' , &
         'LKDUM1' ,'LKDUMI' ,'LKDUMP' ,'LFINCR' ,'LMDEBG' ,'LMDEGI' ,'LMNDIA' ,'LMMXSF' , &
         'LMMXST' ,'LMSCAL' ,'LOANRM' ,'LOBDTG' ,'LOCLMX' ,'LOCNPT' ,'LOCON3' ,'LOCON4' , &
         'LOCORP' ,'LODEGI' ,'LOFFS ' ,'LOGMSI' ,'LOGMSO' ,'LOHESS' ,'LOINIB' ,'LOINVL' , &
         'LONEWT' ,'LOOLDB' ,'LOONED' ,'LOOPTC' ,'LOREDG' ,'LORHES' ,'LOSCAL' ,'LOSLP ' , &
         'LOSQP ' ,'LOSTAT' ,'LOSTPM' ,'LOTANG' ,'LOTIGH' ,'LOTRIA' ,'LOUPDT' ,'LS2NDI' , &
         'LS2PTJ' ,'LSADDS' ,'LSANRM' ,'LSAZCL' ,'LSAZRW' ,'LSCRSH' ,'LSDNLP' ,'LSDNSL' , &
         'LSESLP' ,'LSESQP' ,'LSFCSQ' ,'LSFCZE' ,'LSFVLN' ,'LSISMP' ,'LSLACK' ,'LSTSLU' , &
         'LSTSRI' ,'LSTSUP' ,'LSMXBS' ,'LSNOP2' ,'LSPFBS' ,'LSPOST' ,'LSPRET' ,'LSPRZE' , &
         'LSPSBS' ,'LSSCAL' ,'LSSQRS' ,'LSTCRS' ,'LSTRIA' ,'RT2DRV' ,'RT2NRM' ,'RV2MXS' , &
         'RTBND1' ,'RTBNDT' ,'RTDCND' ,'RTDOBW' ,'RTERRF' ,'RTGLRD' ,'RTGLSL' ,'RTGRDR' , &
         'RTIPVA' ,'RTIPVR' ,'RTLCND' ,'RTLUPS' ,'RTMAXJ' ,'RTMAXS' ,'RTMAXV' ,'RTMINA' , &
         'RTMINJ' ,'RTMINS' ,'RTMNS2' ,'RTMXJ2' ,'RTNEW ' ,'RTNWAF' ,'RTNWMA' ,'RTNWMB' , &
         'RTNWMC' ,'RTNWMD' ,'RTNWMI' ,'RTNWMJ' ,'RTNWTR' ,'RTOBJD' ,'RTOBJF' ,'RTOBJL' , &
         'RTOBJN' ,'RTOBJR' ,'RTONED' ,'RTPIVA' ,'RTPIVR' ,'RTPIVT' ,'RTPIVU' ,'RTREDG' , &
         'RTREDD' ,'RTSFC1' ,'RTSFC2' ,'RTSFC3' ,'RTZERN' ,'RVCFNB' ,'RVNLMX' ,'RVNLWG' , &
         'RVOBJL' ,'RVPLIM' ,'RVSTLM' ,'RVSTLN' ,'RVSPAC' ,'RVTIME' ,'RVULIM' ,'RVDLIM' , &
         'LSDUAL' ,'LKNBND' ,'RVWINI' ,'RVWEIG' ,'DOHESS' ,'DO2DIR' ,'RVHESS' ,'TESTLG' , &
         'TESTF ' ,'TESTD ' ,'TEST1F' ,'TESTZM' ,'TESTPI' ,'TESTBL' ,'TEST2D' ,'TSTHDR' , &
         'PRNTRP' ,'PRNTR2' ,'PRNTRI' ,'PRDERV' ,'PRDERI' ,'PRHSTR' ,'PR2DRV' ,'PR2VAL' , &
         'PRCMPR' ,'PRCMP2' ,'      '/)
      Cmi%Crdesc(1,1: 203) = (/ &
            2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 , &
            2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 , &
            2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 , &
            2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 , &
            2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 , &
            2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 , &
            2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 , &
            2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 , &
            2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 , &
            2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 , &
            2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   3 , &
            3 ,   3 ,   3 ,   3 ,   3 ,   3 ,   3 ,   3 , &
            3 ,   3 ,   3 ,   3 ,   3 ,   3 ,   3 ,   3 , &
            3 ,   3 ,   3 ,   3 ,   3 ,   3 ,   3 ,   3 , &
            3 ,   3 ,   3 ,   3 ,   3 ,   1 ,   1 ,   1 , &
            1 ,   1 ,   1 ,   1 ,   1 ,   1 ,   1 ,   1 , &
            1 ,   1 ,   1 ,   1 ,   1 ,   1 ,   1 ,   1 , &
            1 ,   1 ,   1 ,   1 ,   1 ,   1 ,   1 ,   1 , &
            1 ,   1 ,   1 ,   1 ,   1 ,   1 ,   1 ,   1 , &
            1 ,   1 ,   1 ,   1 ,   1 ,   1 ,   1 ,   1 , &
            1 ,   1 ,   1 ,   1 ,   1 ,   1 ,   1 ,   1 , &
            1 ,   1 ,   1 ,   1 ,   1 ,   1 ,   1 ,   1 , &
            3 ,   2 ,   1 ,   1 ,   3 ,   3 ,   1 ,   3 , &
            3 ,   3 ,   3 ,   3 ,   3 ,   3 ,   3 ,   3 , &
            3 ,   3 ,   3 ,   3 ,   3 ,   3 ,   3 ,   3 , &
            3 ,   3 ,   0/)
      Cmi%Crdesc(2,1: 203) = (/ &
            5 ,   6 ,   7 ,   8 ,   9 ,  10 ,  11 ,  15 , &
           16 ,  18 ,  19 ,  20 ,  21 ,  22 ,  23 ,  24 , &
           25 ,  26 ,  27 ,  28 ,  29 ,  30 ,  31 ,  32 , &
           33 ,  34 ,  35 ,  36 ,  37 ,  38 ,  40 ,  41 , &
           42 ,  43 ,  44 ,  45 ,  46 ,  47 ,  48 ,  49 , &
           50 ,  55 ,  56 ,  57 ,  58 , 103 , 104 , 108 , &
          109 , 110 , 111 , 128 , 224 , 225 , 226 , 227 , &
          228 , 229 , 231 , 232 , 233 , 234 , 235 , 236 , &
          237 , 238 , 239 , 240 , 241 , 242 , 243 , 244 , &
          245 , 246 , 247 , 248 , 249 , 250 , 251 , 252 , &
          253 , 254 , 255 , 256 , 257 , 258 , 259 ,   3 , &
            4 ,   6 ,   9 ,  11 ,  12 ,  18 ,  24 ,  25 , &
           32 ,  33 ,  36 ,  37 ,  42 ,  59 ,  63 ,  72 , &
           73 ,  74 ,  79 ,  88 , 100 , 104 , 105 , 107 , &
          108 , 118 , 127 , 131 , 133 ,   4 ,   5 ,   6 , &
            7 ,   9 ,  11 ,  14 ,  20 ,  21 ,  22 ,  23 , &
           25 ,  26 ,  27 ,  28 ,  30 ,  32 ,  34 ,  35 , &
           36 ,  38 ,  39 ,  40 ,  44 ,  45 ,  46 ,  47 , &
           48 ,  49 ,  50 ,  51 ,  53 ,  55 ,  57 ,  58 , &
           59 ,  60 ,  61 ,  62 ,  67 ,  69 ,  70 ,  71 , &
           73 ,  75 ,  76 ,  77 ,  81 ,  84 , 127 , 128 , &
          130 , 136 , 141 , 142 , 145 , 148 , 169 , 192 , &
          151 , 338 , 194 , 195 , 153 , 154 , 196 , 155 , &
          156 , 157 , 158 , 159 , 160 , 161 , 162 , 163 , &
          164 , 165 , 166 , 167 , 168 , 169 , 170 , 171 , &
          172 , 173 ,   0/)
      Cmi%Crdesc(3,1: 203) = (/ &
            2 ,   2 ,   2 ,   2 ,   1 ,   1 ,   2 ,   1 , &
            1 ,   2 ,   2 ,   1 ,   1 ,   1 ,   1 ,   1 , &
            2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   1 ,   2 , &
            2 ,   2 ,   1 ,   2 ,   2 ,   1 ,   2 ,   2 , &
            2 ,   2 ,   2 ,   2 ,   2 ,   1 ,   2 ,   2 , &
            2 ,   2 ,   1 ,   2 ,   2 ,   2 ,   2 ,   2 , &
            2 ,   2 ,   2 ,   2 ,   1 ,   2 ,   1 ,   1 , &
            1 ,   1 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 , &
            2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 , &
            2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 , &
            2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   1 , &
            1 ,   2 ,   1 ,   2 ,   2 ,   1 ,   2 ,   2 , &
            1 ,   1 ,   2 ,   2 ,   2 ,   1 ,   1 ,   2 , &
            2 ,   2 ,   2 ,   2 ,   2 ,   1 ,   1 ,   2 , &
            2 ,   1 ,   1 ,   1 ,   1 ,   1 ,   2 ,   2 , &
            1 ,   1 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 , &
            1 ,   1 ,   2 ,   2 ,   1 ,   1 ,   1 ,   1 , &
            1 ,   1 ,   1 ,   2 ,   0 ,   0 ,   1 ,   0 , &
            0 ,   0 ,   1 ,   0 ,   1 ,   2 ,   2 ,   1 , &
            2 ,   1 ,   1 ,   1 ,   1 ,   1 ,   1 ,   1 , &
            2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 , &
            2 ,   2 ,   2 ,   2 ,   2 ,   1 ,   2 ,   2 , &
            2 ,   2 ,   2 ,   2 ,   1 ,   1 ,   1 ,   2 , &
            2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 , &
            2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 ,   2 , &
            2 ,   2 ,   0/)

   END Subroutine CO_CMI_Ini

   Subroutine CO_Def_Words( Nwordr, Nwordi, Nwordc )
      Implicit none
      Integer :: Nwordr, Nwordi, Nwordc
      Nwordr = 1
      Nwordi = 2
      Nwordc = 1
   END Subroutine CO_Def_Words


End Module CONOPT_Data

