!*********************************************
!* This file is generated by FORTRANS.       *
!*********************************************


Module CONOPT_Utilities

   Use CONOPT_Data
      IMPLICIT NONE

   Integer, parameter, Private :: TypV_Real       =     1
   Integer, parameter, Private :: TypV_Int        =     2
   Integer, parameter, Private :: TypV_Char       =     3
   Integer, Parameter, Private :: NVect           =     3
   Integer, Parameter, Private :: Max_Msg         =    30
   REAL(CO_R),  Parameter, Private :: One = 1.d0
   INCLUDE 'numbers.i'
   Character*8, Dimension(Nvect), Parameter :: Kptype = (/ 'LNG.REAL', 'INTEGER ', 'CHARACTR' /)
!
!  Parameters for used with Co2doc, Co2scr, and Co2sdoc
!
   Integer, Parameter :: Asis = 1  
   Integer, Parameter :: Blb  = 2  
   Integer, Parameter :: Bla  = 3  
   Integer, Parameter :: BLba = 4  
!
!  Parameters describing the type of CR cells:
!
   INTEGER, PARAMETER :: TypC_Real = 1, TypC_Int = 2, TypC_Log = 3
!
!  Parameters describing the content of the first index of Crdesc:
!
   INTEGER, PARAMETER :: CR_TYPE = 1, CR_INDEX = 2, CR_RESET = 3
!
!  Parameter describing the Search types:
!
   Integer, Parameter :: Src_ffs   = 1  
   Integer, Parameter :: Src_SLP   = 2  
   Integer, Parameter :: Src_Steep = 3  
   Integer, Parameter :: Src_QN    = 4  
   Integer, Parameter :: Src_SQP   = 5  
!
!  Verbs used by the Control Program
!
   INTEGER, Parameter :: Num_Verb = 23
   CHARACTER*8, Parameter, Dimension(Num_Verb) :: VERB = (/          &
       'BRANCH  ', 'EXIT    ', 'NEXT    ', 'PERFORM ', 'SET     ',   &
       'STEP    ', 'TEST    ', 'MESSAGE ', 'INPUT   ', 'OPTIMIZE',   &
       'SERIES  ', 'OUTPUT  ', 'SAVE    ', 'RESTART ', 'DUMP    ',   &
       'LIST    ', 'PICTURE ', 'CRPRINT ', 'TITLE   ', 'USER    ',   &
       'TIME    ', 'WRITE   ', 'CHECK   ' /)
!
!  Arguments used in Copitr and Coipr1
!
   INTEGER, Parameter :: PRGINT = 5, PRGRL = 3

   CONTAINS

   SUBROUTINE COPRTI( CMI )
!**   LOGICAL OPERATION
!**       INITIALIZES THE PRINT ROUTINE SUBSYSTEM.
!**
      IMPLICIT NONE
   Type (Conopt_Model_Info) CMI

   INTEGER LTVEC

   CMI%LPBASP = 0
   DO LTVEC = 1, Size(CMI%Lpline)
      CMI%LPLINE(LTVEC) = (CMI%LKLINL-19)/CMI%NCHAR(LTVEC)
   ENDDO
   CMI%LPLINS = (CMI%LKLINL-4)/25

   END SUBROUTINE COPRTI

! $if defined (testout)
   SUBROUTINE COPVRL( CMI, LNVEC, VEC )
!**   LOGICAL OPERATION
!**       Prints a real vector for use as test output.
!**   DESCRIPTION OF PARAMETERS
!**       Lnvec  - Contains the number of the vector in Knvect, Llvect
!**                etc.
!**       VEC    - The vector itself.
!**
      IMPLICIT NONE
   Type (Conopt_Model_Info) CMI

   REAL(CO_R)      VEC(*), RVEC(10)
   INTEGER     LNVEC, LJVEC, LTVEC, LLINE, NLINE, IFROM, ITO, I, ILINE, NZERO, IVEC(10), J, K
   CHARACTER*4 KNVEC

   IF ( LNVEC .LT. 0 .OR. LNVEC .GT. Size(CMI%Ltvect) ) THEN
      WRITE(CMI%MSGTXT,"(' ** Systems Error **  Illegal vector number in',' Copvrl: ',I6)") LNVEC
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1405, .TRUE. )
      RETURN
   ENDIF
   KNVEC = CMI%KNVECT(LNVEC)
   CALL Co_Get_Vlen( CMI, Lnvec, Ljvec )
   IF ( LJVEC .LT. 0 ) THEN
      WRITE(CMI%MSGTXT,"(' ** Systems Error **  Undefined vector in Copvrl: ',A4)") KNVEC
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1406, .TRUE. )
      RETURN
   ENDIF
   LTVEC = CMI%LTVECT(LNVEC)
   IF ( LTVEC .NE. TypV_Real ) THEN
      WRITE(CMI%MSGTXT,"(' ** Systems Error **  Vector in Copvrl: ',A4,' is not type Real.')") KNVEC
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1407, .TRUE. )
      RETURN
   ENDIF
   IF ( LJVEC .LE. CMI%LPBASP ) THEN
!
!  Empty vector
!
      CMI%MSGTXT = ' ' // KNVEC // ' : Empty.'
      CALL CO2DOC( CMI, Asis )
      CMI%LPBASP = 0
      RETURN
   ENDIF
   if ( .NOT. CMI%LSPRZE .AND. ljvec - CMI%LPBASP .gt. 10 ) then
      nzero = 0
      do i = CMI%LPBASP+1,ljvec
         if ( vec(i) .ne. 0.d0 ) nzero = nzero + 1
      enddo
   else
      nzero = ljvec-CMI%LPBASP
   endif
   if ( nzero .lt. (ljvec-CMI%LPBASP)/2 ) then
!
!  The vector is sparse - use sparse output format
!
      IF ( NZERO .EQ. 0 ) THEN
!
!  All-Zero sparse vector
!
         CMI%MSGTXT = ' ' // KNVEC // ' : Zero.'
         CALL CO2DOC( CMI, Asis )
         CMI%LPBASP = 0
      ELSE
         j = 0
         do i = CMI%LPBASP+1,ljvec
            if ( vec(i) .ne. 0.d0 ) then
               j       = j + 1
               ivec(j) = i
               rvec(j) = vec(i)
               if ( j .eq. CMI%lplins ) then
                  WRITE(CMI%MSGTXT,"(A4,10(1X,I5,':',1P,E18.11))") KNVEC,(ivec(k),rvec(k),k=1,j)
                  CALL CO2DOC( CMI, Asis )
                  j = 0
               endif
            endif
         enddo
         if ( j .gt. 0 ) then
            WRITE(CMI%MSGTXT,"(A4,10(1X,I5,':',1P,E18.11))") KNVEC,(ivec(k),rvec(k),k=1,j)
            CALL CO2DOC( CMI, Asis )
         endif
      ENDIF
   else
!
!  The vector is dense - Use dense output format.
!
      ITO        = CMI%LPBASP
      LLINE      = CMI%LPLINE(LTVEC)
      NLINE      = (LJVEC-CMI%LPBASP+LLINE-1)/LLINE
      CMI%LPBASP = 0
      DO ILINE = 1, NLINE
         IFROM = ITO+1
         ITO   = MIN(ITO+LLINE,LJVEC)
         WRITE(CMI%MSGTXT,"(A4,'(',I5,'-',I5,') ',1P,10E19.11)") KNVEC,IFROM,ITO,(VEC(I),I=IFROM,ITO)
         CALL CO2DOC( CMI, Asis )
      ENDDO
   ENDIF

   END SUBROUTINE COPVRL

   SUBROUTINE COPVJL( CMI, LNVEC, VEC )
!**   LOGICAL OPERATION
!**       Prints an integer vector for use as test output.
!**   DESCRIPTION OF PARAMETERS
!**       Lnvec  - Contains the number of the vector in Knvect, Llvect
!**                etc.
!**       VEC    - The vector itself.
!**
      IMPLICIT NONE
   Type (Conopt_Model_Info) CMI

   INTEGER     VEC(*)
   INTEGER     LNVEC, LJVEC, LTVEC, LLINE, NLINE, IFROM, ITO, I, ILINE
   CHARACTER*4 KNVEC

   IF ( LNVEC .LT. 0 .OR. LNVEC .GT. Size(CMI%Ltvect) ) THEN
      WRITE(CMI%MSGTXT,"(' ** Systems Error **  Illegal vector number in Copvjl: ',I6)") LNVEC
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1408, .TRUE. )
      RETURN
   ENDIF
   KNVEC = CMI%KNVECT(LNVEC)
   CALL Co_Get_Vlen( CMI, Lnvec, Ljvec )
   IF ( LJVEC .LT. 0 ) THEN
      CMI%MSGTXT = ' ** Systems Error **  Undefined vector in Copvjl: ' // KNVEC
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1409, .TRUE. )
      RETURN
   ENDIF
   LTVEC = CMI%LTVECT(LNVEC)
   IF ( LTVEC .NE. TypV_Int ) THEN
      CMI%MSGTXT = ' ** Systems Error **  Vector in Copvjl: ' // KNVEC // ' is not type Integer.'
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1410, .TRUE. )
      RETURN
   ENDIF
   IF ( LJVEC .LE. CMI%LPBASP ) THEN
      CMI%MSGTXT = ' ' // KNVEC // ' : Empty.'
      CALL CO2DOC( CMI, Asis )
      CMI%LPBASP = 0
      RETURN
   ENDIF
   LLINE = CMI%LPLINE(LTVEC)
   NLINE = (LJVEC-CMI%LPBASP+LLINE-1)/LLINE
   ITO   = CMI%LPBASP
   CMI%LPBASP = 0
   DO ILINE = 1, NLINE
      IFROM = ITO+1
      ITO   = MIN(ITO+LLINE,LJVEC)
      WRITE(CMI%MSGTXT,"(A4,'(',I5,'-',I5,') ',30I7)") KNVEC,IFROM,ITO,(VEC(I),I=IFROM,ITO)
      CALL CO2DOC( CMI, Asis )
   ENDDO

   END SUBROUTINE COPVJL

   SUBROUTINE COPVKL( CMI, LNVEC, VEC )
!**   LOGICAL OPERATION
!**       Prints a character vector for use as test output.
!**   DESCRIPTION OF PARAMETERS
!**       Lnvec  - Contains the number of the vector in Knvect, Llvect
!**                etc.
!**       VEC    - The vector itself.
!**
      IMPLICIT NONE
   Type (Conopt_Model_Info) CMI

   REAL(CO_R)      VEC(*)
   CHARACTER*8 KLTEMP(12)
   INTEGER     LNVEC, LJVEC, LTVEC, LLINE, NLINE, IFROM, ITO, I, ILINE, J
   CHARACTER*4 KNVEC, KNPRM, KNBL

   DATA KNPRM /''''/, KNBL / '  '/

   IF ( LNVEC .LT. 0 .OR. LNVEC .GT. Size(CMI%Ltvect) ) THEN
      WRITE(CMI%MSGTXT,"(' ** Systems Error **  Illegal vector number in Copvkl: ',I6)") LNVEC
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1411, .TRUE. )
      RETURN
   ENDIF
   KNVEC = CMI%KNVECT(LNVEC)
   CALL Co_Get_Vlen( CMI, Lnvec, Ljvec )
   IF ( LJVEC .LT. 0 ) THEN
      CMI%MSGTXT =  ' ** Systems Error **  Undefined vector in Copvkl: ' // KNVEC
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1412, .TRUE. )
      RETURN
   ENDIF
   LTVEC = CMI%LTVECT(LNVEC)
   IF ( LTVEC .NE. TypV_Char ) THEN
      CMI%MSGTXT = ' ** Systems Error **  Vector in Copvkl: ' // KNVEC // ' is not type Character.'
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1413, .TRUE. )
      RETURN
   ENDIF
   IF ( LJVEC .LE. CMI%LPBASP ) THEN
      CMI%MSGTXT = ' ' // KNVEC // ' : Empty.'
      CALL CO2DOC( CMI, Asis )
      CMI%LPBASP = 0
      RETURN
   ENDIF
   LLINE  = CMI%LPLINE(LTVEC)
   NLINE  = (LJVEC-CMI%LPBASP+LLINE-1)/LLINE
   ITO    = CMI%LPBASP
   CMI%LPBASP = 0
   DO ILINE = 1, NLINE
      IFROM = ITO+1
      ITO   = MIN(ITO+LLINE,LJVEC)
      J = 0
      DO I = IFROM, ITO
         J = J + 1
         CALL COGTCH( KLTEMP(J), VEC(I) )
      ENDDO
      WRITE(CMI%MSGTXT,"(A4,'(',I5,'-',I5,') ',15(A2,A1,A8,A1))") &
         KNVEC, IFROM, ITO, ( KNBL, KNPRM, KLTEMP(I), KNPRM, I = 1, J )
      CALL CO2DOC( CMI, Asis )
   ENDDO

   END SUBROUTINE COPVKL

   SUBROUTINE COPSRL( CMI, LNVEC, VEC, LENGTH )
!**   LOGICAL OPERATION
!**       Print Short, i.e. print the first part of a Real vector.
!**       Used for test output.
!**   DESCRIPTION OF PARAMETERS
!**       LNVEC  - Gives the number of the vector in the system of
!**                all vectors.
!**       VEC    - Contains the vector itself.
!**       LENGTH - The number of elements to be printed.
!**   ABNORMAL CONDITIONS
!**       Aborts if Lnvec is out of range, if the vector is not
!**       defined, or if length is too large.
!**
      IMPLICIT NONE
   Type (Conopt_Model_Info) CMI

   REAL(CO_R)      VEC(*)
   INTEGER     LNVEC, LENGTH, LSAVE, LTVEC

   IF ( LNVEC .LT. 0 .OR. LNVEC .GT. Size(CMI%Ltvect) ) THEN
      WRITE(CMI%MSGTXT,"(' ** Systems Error **  Illegal vector number in Copsrl:',I6)") LNVEC
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1414, .TRUE. )
      RETURN
   ENDIF
   CALL Co_Get_Vlen( CMI, Lnvec, Lsave )
   IF ( LSAVE .LT. 0 .OR. LSAVE .LT. LENGTH ) THEN
      CMI%MSGTXT = ' ** Systems Error **  Illegal vector length in Copsrl for vector ' // CMI%KNVECT(LNVEC) // ':'
      CALL CO2DOC( CMI, Blb )
      WRITE(CMI%MSGTXT,"(22X,'Stored length=',I6,' and print length=',I6)") LSAVE, LENGTH
      CALL CO2DOC( CMI, Asis )
      CALL COSYSE( CMI, 1415, .TRUE. )
      RETURN
   ENDIF
   LTVEC = CMI%LTVECT(LNVEC)
   IF ( LTVEC .NE. TypV_Real ) THEN
      CMI%MSGTXT = ' ** Systems Error **  Vector in Copsrl: ' // CMI%KNVECT(LNVEC) // ' is not type Real.'
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1416, .TRUE. )
      RETURN
   ENDIF
   CALL Co_Set_Vlen( CMI, Lnvec, Length )
   CALL COPVRL( CMI, LNVEC, VEC )
   CALL Co_Set_Vlen( CMI, Lnvec, Lsave )

   END SUBROUTINE COPSRL

   SUBROUTINE COPSJL( CMI, LNVEC, VEC, LENGTH )
!**   LOGICAL OPERATION
!**       Print Short, i.e. print the first part of an Integer vector.
!**       Used for test output.
!**   DESCRIPTION OF PARAMETERS
!**       LNVEC  - Gives the number of the vector in the system of
!**                all vectors.
!**       VEC    - Contains the vector itself.
!**       LENGTH - The number of elements to be printed.
!**   ABNORMAL CONDITIONS
!**       Aborts if Lnvec is out of range, if the vector is not
!**       defined, or if length is too large.
!**
      IMPLICIT NONE
   Type (Conopt_Model_Info) CMI

   INTEGER     VEC(*)
   INTEGER     LNVEC, LENGTH, LSAVE, LTVEC

   IF ( LNVEC .LT. 0 .OR. LNVEC .GT. Size(CMI%Ltvect) ) THEN
      WRITE(CMI%MSGTXT,"(' ** Systems Error **  Illegal vector number in Copsjl:',I6)") LNVEC
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1422, .TRUE. )
      RETURN
   ENDIF
   CALL Co_Get_Vlen( CMI, Lnvec, Lsave )
   IF ( LSAVE .LT. 0 .OR. LSAVE .LT. LENGTH ) THEN
      CMI%MSGTXT = ' ** Systems Error **  Illegal vector length in Copsjl for vector ' // CMI%KNVECT(LNVEC) // ':'
      CALL CO2DOC( CMI, Blb )
      WRITE(CMI%MSGTXT,"(22X,'Stored length=',I6,' and print length=',I6)") LSAVE, LENGTH
      CALL CO2DOC( CMI, Asis )
      CALL COSYSE( CMI, 1417, .TRUE. )
      RETURN
   ENDIF
   LTVEC = CMI%LTVECT(LNVEC)
   IF ( LTVEC .NE. TypV_Int ) THEN
      CMI%MSGTXT = ' ** Systems Error **  Vector in Copsjl: ' // CMI%KNVECT(LNVEC) // ' is not type Integer.'
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1418, .TRUE. )
      RETURN
   ENDIF
   CALL Co_Set_Vlen( CMI, Lnvec, Length )
   CALL COPVJL( CMI, LNVEC, VEC )
   CALL Co_Set_Vlen( CMI, Lnvec, Lsave )

   END SUBROUTINE COPSJL

   SUBROUTINE COPSKL( CMI, LNVEC, VEC, LENGTH )
!**   LOGICAL OPERATION
!**       Print Short, i.e. print the first part of a Character vector.
!**       Used for test output.
!**   DESCRIPTION OF PARAMETERS
!**       LNVEC  - Gives the number of the vector in the system of
!**                all vectors.
!**       VEC    - Contains the vector itself.
!**       LENGTH - The number of elements to be printed.
!**   ABNORMAL CONDITIONS
!**       Aborts if Lnvec is out of range, if the vector is not
!**       defined, or if length is too large.
!**
      IMPLICIT NONE
   Type (Conopt_Model_Info) CMI

   REAL(CO_R)      VEC(*)
   INTEGER     LNVEC, LENGTH, LSAVE, LTVEC

   IF ( LNVEC .LT. 0 .OR. LNVEC .GT. Size(CMI%Ltvect) ) THEN
      WRITE(CMI%MSGTXT,"(' ** Systems Error **  Illegal vector number in Copskl:',I6)") LNVEC
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1419, .TRUE. )
      RETURN
   ENDIF
   CALL Co_Get_Vlen( CMI, Lnvec, Lsave )
   IF ( LSAVE .LT. 0 .OR. LSAVE .LT. LENGTH ) THEN
      CMI%MSGTXT =  ' ** Systems Error **  Illegal vector length in Copskl for vector ' // CMI%KNVECT(LNVEC) // ':'
      CALL CO2DOC( CMI, Blb )
      WRITE(CMI%MSGTXT,"(22X,'Stored length=',I6,' and print length=',I6)") LSAVE, LENGTH
      CALL CO2DOC( CMI, Asis )
      CALL COSYSE( CMI, 1420, .TRUE. )
      RETURN
   ENDIF
   LTVEC = CMI%LTVECT(LNVEC)
   IF ( LTVEC .NE. TypV_Char ) THEN
      CMI%MSGTXT = ' ** Systems Error **  Vector in Copskl: ' // CMI%KNVECT(LNVEC) // ' is not type Character.'
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1421, .TRUE. )
      RETURN
   ENDIF
   CALL Co_Set_Vlen( CMI, Lnvec, Length )
   CALL COPVKL( CMI, LNVEC, VEC )
   CALL Co_Set_Vlen( CMI, Lnvec, Lsave )

   END SUBROUTINE COPSKL

   SUBROUTINE COPPRL( CMI, LNVEC, VEC, IBASE, LENGTH )
!**   LOGICAL OPERATION
!**       Prints part of a Real vector for use as test output.
!**   DESCRIPTION OF PARAMETERS
!**       Lnvec  - The number of the vector in knvect, llvect, etc.
!**       Vec    - The vector itself
!**       Ibase  - Contains a base pointer to the vector, i.e. the
!**                first element to be printed is Ibase+1.
!**       Length - Contains the number of elements to be printed.
!**                A negative length will result in a printout of
!**                "EMPTY".
!**   ABNORMAL CONDITIONS
!**       Aborts if lnvec is out of range or if the vector is not
!**       defined.
!**
      IMPLICIT NONE
   Type (Conopt_Model_Info) CMI
   REAL(CO_R)      VEC(*)
   INTEGER     LNVEC, IBASE, LENGTH, LSAVE

   IF ( LNVEC .LT. 0 .OR. LNVEC .GT. Size(CMI%Ltvect) ) THEN
      WRITE(CMI%MSGTXT,"(' ** Systems Error **  Illegal vector number in Copprl: ',I6)") LNVEC
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1423, .TRUE. )
      RETURN
   ENDIF
   CMI%LPBASP = IBASE
   CALL Co_Get_Vlen( CMI, Lnvec, Lsave )
   IF ( LSAVE .LT. 0 ) THEN
      CMI%MSGTXT =  ' ** Systems Error **  Undefined vector in Copprl: ' // CMI%KNVECT(LNVEC)
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1424, .TRUE. )
      RETURN
   ENDIF
   IF ( IBASE .LT. 0 ) THEN
      WRITE(CMI%MSGTXT,"(' ** Systems Error **  Negative Base pointer in Copprl: ',A4,' Ibase=',i6)") &
         CMI%KNVECT(LNVEC), IBASE
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1425, .TRUE. )
      RETURN
   ENDIF
   IF ( CMI%LTVECT(LNVEC) .NE. TypV_Real ) THEN
      CMI%MSGTXT =  ' ** Systems Error **  Vector in Copprl: ' // CMI%KNVECT(LNVEC) // ' is not type Real.'
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1426, .TRUE. )
      RETURN
   ENDIF
   CALL Co_Set_Vlen( CMI, Lnvec, Ibase + Length )
   IF ( Ibase + Length .GT. LSAVE ) THEN
      CMI%MSGTXT = ' ** Systems Error **  Illegal vector length in Copprl for vector ' // CMI%KNVECT(LNVEC) // ':'
      CALL CO2DOC( CMI, Blb )
      WRITE(CMI%MSGTXT,"(22X,'Stored length=',I6,' Ibase=',I6,' and print length=',I6)") LSAVE, IBASE, LENGTH
      CALL CO2DOC( CMI, Asis )
      CALL COSYSE( CMI, 1427, .TRUE. )
      RETURN
   ENDIF
   CALL COPVRL( CMI, LNVEC, VEC )
   CALL Co_Set_Vlen( CMI, Lnvec, Lsave )

   END SUBROUTINE COPPRL

   SUBROUTINE COPPJL( CMI, LNVEC, VEC, IBASE, LENGTH )
!**   LOGICAL OPERATION
!**       Prints part of an Integer vector for use as test output.
!**   DESCRIPTION OF PARAMETERS
!**       Lnvec  - The number of the vector in knvect, llvect, etc.
!**       Vec    - The vector itself
!**       Ibase  - Contains a base pointer to the vector, i.e. the
!**                first element to be printed is Ibase+1.
!**       Length - Contains the number of elements to be printed.
!**                A negative length will result in a printout of
!**                "EMPTY".
!**   ABNORMAL CONDITIONS
!**       Aborts if lnvec is out of range or if the vector is not
!**       defined.
!**
      IMPLICIT NONE
   Type (Conopt_Model_Info) CMI
   INTEGER     VEC(*)
   INTEGER     LNVEC, IBASE, LENGTH, LSAVE

   IF ( LNVEC .LT. 0 .OR. LNVEC .GT. Size(CMI%Ltvect) ) THEN
      WRITE(CMI%MSGTXT,"(' ** Systems Error **  Illegal vector number in Coppjl: ',I6)") LNVEC
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1428, .TRUE. )
      RETURN
   ENDIF
   CMI%LPBASP = IBASE
   CALL Co_Get_Vlen( CMI, Lnvec, Lsave )
   IF ( LSAVE .LT. 0 ) THEN
      CMI%MSGTXT = ' ** Systems Error **  Undefined vector in Coppjl: ' // CMI%KNVECT(LNVEC)
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1429, .TRUE. )
      RETURN
   ENDIF
   IF ( IBASE .LT. 0 ) THEN
      WRITE(CMI%MSGTXT,"(' ** Systems Error **  Negative Base pointer in Coppjl: ',A4,' Ibase=',i6)") &
         CMI%KNVECT(LNVEC), IBASE
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1430, .TRUE. )
      RETURN
   ENDIF
   IF ( CMI%LTVECT(LNVEC) .NE. TypV_Int ) THEN
      CMI%MSGTXT = ' ** Systems Error **  Vector in Coppjl: ' // CMI%KNVECT(LNVEC) // ' is not type Integer.'
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1431, .TRUE. )
      RETURN
   ENDIF
   IF ( Ibase + Length .GT. LSAVE ) THEN
      CMI%MSGTXT = ' ** Systems Error **  Illegal vector length in Coppjl for vector ' // CMI%KNVECT(LNVEC) // ':'
      CALL CO2DOC( CMI, Blb )
      WRITE(CMI%MSGTXT,"(22X,'Stored length=',I6,' Ibase=',I6,' and print length=',I6)") LSAVE, IBASE, LENGTH
      CALL CO2DOC( CMI, Asis )
      CALL COSYSE( CMI, 1432, .TRUE. )
      RETURN
   ENDIF
   CALL Co_Set_Vlen( CMI, Lnvec, Ibase + Length )
   CALL COPVJL( CMI, LNVEC, VEC )
   CALL Co_Set_Vlen( CMI, Lnvec, Lsave )

   END SUBROUTINE COPPJL

   SUBROUTINE COPPKL( CMI, LNVEC, VEC, IBASE, LENGTH )
!**   LOGICAL OPERATION
!**       Prints part of a Character vector for use as test output.
!**   DESCRIPTION OF PARAMETERS
!**       Lnvec  - The number of the vector in knvect, llvect, etc.
!**       Vec    - The vector itself
!**       Ibase  - Contains a base pointer to the vector, i.e. the
!**                first element to be printed is Ibase+1.
!**       Length - Contains the number of elements to be printed.
!**                A negative length will result in a printout of
!**                "EMPTY".
!**   ABNORMAL CONDITIONS
!**       Aborts if lnvec is out of range or if the vector is not
!**       defined.
!**
      IMPLICIT NONE
   Type (Conopt_Model_Info) CMI
   REAL(CO_R)      VEC(*)
   INTEGER     LNVEC, IBASE, LENGTH, LSAVE

   IF ( LNVEC .LT. 0 .OR. LNVEC .GT. Size(CMI%Ltvect) ) THEN
      WRITE(CMI%MSGTXT,"(' ** Systems Error **  Illegal vector number in Coppkl: ',I6)") LNVEC
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1433, .TRUE. )
      RETURN
   ENDIF
   CMI%LPBASP = IBASE
   CALL Co_Get_Vlen( CMI, Lnvec, Lsave )
   IF ( LSAVE .LT. 0 ) THEN
      CMI%MSGTXT =  ' ** Systems Error **  Undefined vector in Coppkl: ' // CMI%KNVECT(LNVEC)
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1434, .TRUE. )
      RETURN
   ENDIF
   IF ( IBASE .LT. 0 ) THEN
      WRITE(CMI%MSGTXT,"(' ** Systems Error **  Negative Base pointer in Coppkl: ',A4,' Ibase=',i6)") &
         CMI%KNVECT(LNVEC), IBASE
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1435, .TRUE. )
      RETURN
   ENDIF
   IF ( CMI%LTVECT(LNVEC) .NE. TypV_Char ) THEN
      CMI%MSGTXT = ' ** Systems Error **  Vector in Coppkl: ' // CMI%KNVECT(LNVEC) //  ' is not type Character.'
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1436, .TRUE. )
      RETURN
   ENDIF
   CALL Co_Set_Vlen( CMI, Lnvec, Ibase + Length )
   IF ( Ibase + Length .GT. LSAVE ) THEN
      CMI%MSGTXT = ' ** Systems Error **  Illegal vector length in  Coppkl for vector' // CMI%KNVECT(LNVEC) // ':'
      CALL CO2DOC( CMI, Blb )
      WRITE(CMI%MSGTXT,"(22X,'Stored length=',I6,' Ibase=',I6,' and print length=',I6)") LSAVE, IBASE, LENGTH
      CALL CO2DOC( CMI, Asis )
      CALL COSYSE( CMI, 1437, .TRUE. )
      RETURN
   ENDIF
   CALL COPVKL( CMI, LNVEC, VEC )
   CALL Co_Set_Vlen( CMI, Lnvec, Lsave )

   END SUBROUTINE COPPKL

   SUBROUTINE COPVRIP( CMI, LNVEC, VEC, VECI, START, LENGTH )
!**   LOGICAL OPERATION
!**       Prints a part of a real vector with indices defined by an
!**       integer vector.
!**   DESCRIPTION OF PARAMETERS
!**       Lnvec  - Contains the number of the vector in Knvect, Llvect
!**                etc.
!**       VEC    - The vector to be printed.
!**       VECI   - The index vector (name is not printed and number is
!**                not tested).
!**       START  - The nmber of the first element to be printed
!**       LENGTH - The length of the part to be printed.
!**
      IMPLICIT NONE
   Type (Conopt_Model_Info) CMI
   REAL(CO_R)  VEC(*), RVEC(10)
   INTEGER     VECI(*), START, LENGTH
   INTEGER     LNVEC, LJVEC, LTVEC, I, IVEC(10), J, K
   CHARACTER*4 KNVEC

   IF ( LNVEC .LT. 0 .OR. LNVEC .GT. Size(CMI%Ltvect) ) THEN
      WRITE(CMI%MSGTXT,"(' ** Systems Error **  Illegal vector number in Copvrip: ',I6)") LNVEC
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1438, .TRUE. )
      RETURN
   ENDIF
   KNVEC = CMI%KNVECT(LNVEC)
   CALL Co_Get_Vlen( CMI, Lnvec, Ljvec )
   IF ( LJVEC .LT. 0 ) THEN
      CMI%MSGTXT = ' ** Systems Error **  Undefined vector in Copvrip: ' // KNVEC
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1439, .TRUE. )
      RETURN
   ENDIF
   LTVEC = CMI%LTVECT(LNVEC)
   IF ( LTVEC .NE. TypV_Real ) THEN
      CMI%MSGTXT = ' ** Systems Error **  Vector in Copvrip: ' //  KNVEC //' is not type Real.'
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1440, .TRUE. )
      RETURN
   ENDIF
   IF ( LENGTH .LT. 0 ) THEN
      WRITE(CMI%MSGTXT,"(' ** Systems Error **  Negative length of Vector ',A4,' in Copvrip ',I10)") KNVEC, LENGTH
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1441, .TRUE. )
      RETURN
   ENDIF
   IF ( START .LE. 0 ) THEN
      WRITE(CMI%MSGTXT,"(' ** Systems Error **  Start of Vector ',A4,' in Copvrip is not positive:',I10)") KNVEC, START
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1442, .TRUE. )
      RETURN
   ENDIF
   IF ( LJVEC .LT. START+LENGTH-1 ) THEN
      WRITE(CMI%MSGTXT,"(' ** Systems Error **  Vector in Copvrip: ',A4,' with print length',I6)") KNVEC, LJVEC
      CALL CO2DOC( CMI, Blb )
      WRITE(CMI%MSGTXT,"(22X,'when Start=',I6,' and vector Length=',I6)") START, LENGTH
      CALL CO2DOC( CMI, Asis )
      CALL COSYSE( CMI, 1443, .TRUE. )
      RETURN
   ENDIF
   IF ( LENGTH .EQ. 0 ) THEN
      CMI%MSGTXT = ' ' // KNVEC // ' : Length zero.'
      CALL CO2DOC( CMI, Asis )
      RETURN
   ENDIF
   J = 0
   DO I = 1, LENGTH
      J       = J + 1
      IVEC(J) = VECI(START-1+I)
      RVEC(J) = VEC(START-1+I)
      IF ( J .EQ. CMI%LPLINS ) THEN
         WRITE(CMI%MSGTXT,"(A4,10(1X,I5,':',1P,E18.11))") KNVEC,(IVEC(K),RVEC(K),K=1,J)
         CALL CO2DOC( CMI, Asis )
         J = 0
      ENDIF
   ENDDO
   IF ( J .GT. 0 ) THEN
      WRITE(CMI%MSGTXT,"(A4,10(1X,I5,':',1P,E18.11))") KNVEC,(IVEC(K),RVEC(K),K=1,J)
      CALL CO2DOC( CMI, Asis )
   ENDIF

   END SUBROUTINE COPVRIP
! $endif

   SUBROUTINE COSYSE( CMI, I, FATAL )
!**   LOGICAL OPERATION
!**       Reports a systems error and stops if it is fatal.
!**   DESCRIPTION OF PARAMETERS
!**       I     - The number identifying the error. See the file
!**               syserr.doc for details
!**       FATAL - Logical that is true if the error is Fatal.
!**               In this case we set the system error flag so we will
!**               exit immediately all the way to the entry point.
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   INTEGER I, J, ERROR, NLIN
   LOGICAL FATAL
   INTEGER   LLEN(8)

   CALL CONOUT( CMI )
   IF ( FATAL ) THEN
      WRITE(CMI%MSGV(1),"(' **** Fatal System Error Number',I5)") I
      NLIN = 1
   ELSE
      WRITE(CMI%MSGV(1),"(' **** Non-Fatal Internal Error Number',I5)") I
      CMI%MSGV(2) ='      The solution process will recover and continue correctly.'
      NLIN = 2
   ENDIF
   IF ( .NOT. CMI%LSSYSE ) THEN
      CMI%LSSYSE = .TRUE.
      CMI%MSGV(NLIN+1) =' '
      CMI%MSGV(NLIN+2) ='      Please check that you have the latest version of CONOPT and'
      CMI%MSGV(NLIN+3) ='      upgrade your system -- the problem may already be fixed.'
      CMI%MSGV(NLIN+4) ='      If your system is up to date, please send a copy of your'
      CMI%MSGV(NLIN+5) ='      model (input and output files) by e-mail to adrud@arki.dk'
      CMI%MSGV(NLIN+6) =' '
      NLIN = NLIN + 6
   ENDIF

   DO J = 1, NLIN
      LLEN(J) = MAX(1,LEN_TRIM(CMI%MSGV(J)))
   ENDDO
   ERROR = 0
   CALL CALL_Message( CMI%CB_Message, NLIN, NLIN, NLIN, LLEN, ERROR, CMI%CB_USRMEM, CMI%MSGV(1) )

   IF ( FATAL ) CMI%SYSERR = 200

   END SUBROUTINE COSYSE
!
!  This block holds the Core Allocation and Management Routines.
!
   SUBROUTINE CORINI( CMI, KEEP, CONT )
!**   Logical Operation
!**       Initializes the core allocation routines
!**   DESCRIPTION OF PARAMETERS
!**       Keep - specified whether to keep a model afterwards. If Keep
!**              is 1 we must allocate memory to save the CR cells and
!**              the Memory vectors
!**
      IMPLICIT NONE
   Type (Conopt_Model_Info) CMI
   Integer, Intent (IN) :: KEEP, CONT

   INTEGER   I, INDX, LENGTH, MAXMEM, REQMEM, MINMM1, Lnvec

   CMI%Lword(TypV_Real) = CMI%Nwordr
   CMI%Lword(TypV_Int ) = CMI%Nwordi
   CMI%Lword(TypV_Char) = CMI%Nwordc

   CMI%LSSPAC = .TRUE.
   CMI%LIBAS  = 0
   CMI%LATOTT = CMI%LATOT
   IF ( CONT .EQ. 0 ) THEN
!
!  This is not a continuation. Initialize memory to start in position 1,
!  no vectors in use and Len = -1 and Start = -1000000 for all vectors
!
      CMI%LIFREE = 1
      CMI%NVUSED = 0
      DO Lnvec = 1, Number_of_Vects
         Call Co_Set_Vstr( CMI, Lnvec, -10000000 )
         Call Co_Set_Vlen( CMI, Lnvec, -1 )
         CMI%USVECT(Lnvec) = 0
      ENDDO
   ENDIF
   CMI%LAMAXU = CMI%LIFREE-1
   CMI%TINUSE = CMI%LIFREE-1
   CMI%REMNUM = 0
   CMI%INCSNG = .FALSE.
   CMI%DECSNG = .FALSE.
   CMI%REMVNG = .FALSE.
! $if defined (testout)
   IF ( CMI%LOCORP .GE. 1 ) THEN
      WRITE(CMI%MSGTXT,"('Length of work space initialized to',i8,' words starting at',i8)") CMI%LATOTT, CMI%LIFREE
      CALL CO2DOC( CMI, Blb )
      WRITE(CMI%MSGTXT,"('Request was',f9.0,' words. Minimum was',f9.0,' words.')") CMI%RVESTM, CMI%RVMINM
      CALL CO2DOC( CMI, Asis )
   ENDIF
! $endif
   IF ( KEEP .EQ. 1 .AND. CONT .EQ. 0 ) THEN
!
!  We are going to store CMI in Working memory. Allocate vectors for
!  this now so they will be stored in the beginning of Working memory.
!
      CALL CORDEF( CMI, CMI%LNVIS, Number_of_Ints + Number_of_Logs + Number_of_Vects*2 + 2 )
      IF ( CMI%SYSERR .NE. 0 ) RETURN
      CALL CORDEF( CMI, CMI%LNVRL,  Number_of_Reals  )
   ENDIF


   END SUBROUTINE CORINI

   SUBROUTINE CORKEEP( NIL, NRL )
!**   Logical Operation
!**       NIL = Number of Integers and NRL = Number of Reals
!**       needed for storing the vectors VIS and VRL defined in the
!**       previous routine.
!*
   INTEGER, Intent (IN OUT) :: NIL, NRL

   NIL = Number_of_Ints + Number_of_Logs + Number_of_Vects*2 + 2
   NRL = Number_of_Reals

   END SUBROUTINE CORKEEP

   SUBROUTINE CORDEF( CMI, LNVEC, LJVEC )
!**   LOGICAL OPERATION
!**       defines a new vector at the end of the presently used core,
!**       i.e. starting in lifree. the vector to be defined has number
!**       lnvec in common block crcore and it should be defined with
!**       length ljvec elements. lj- and ll- will be defined by this
!**       subroutine. at entry, the first free word is assumed to be
!**       lifree, and lifree is updated by this routine. the routine
!**       request core if necessary.
!**   DESCRIPTION OF PARAMETERS
!**       LNVEC  - contains the number in crcore of the vector to be
!**                defined. type: is.
!**       LJVEC  - gives the number of elements in the new vector.
!**                type: is.
!**       LSSPAC - logical return code. if the necessary core is not
!**                available, lsspac is set to .false. and cordef
!**                returns. it is the responsibility of the calling
!**                routine to write any error messages. in this case
!**                the vector will be defined, but with length zero.
!**                if lsspac is false on entry, it is not changed.
!*
      IMPLICIT NONE
   Type (Conopt_Model_Info) CMI

   INTEGER   LNVEC, ITYPE, LWORDT, JCODE, LJVEC, LA, ICORE, AVAIL, LENGTH, Start
!
!  Check the input arguments
!
   IF ( LNVEC .LE. 0 .OR. LNVEC .GT. Size(CMI%Ltvect) ) THEN
!
!  Error: Illegal vector number
!
      WRITE(CMI%MSGTXT,"(' ** Systems Error **  The vector number in Cordef is out of range: Lnvec=',i8)") LNVEC
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1306, .TRUE. )
      RETURN
   ELSEIF ( LJVEC .LT. 0 ) THEN
!
!  Error: Negative length
!
      CMI%MSGTXT = ' ** Systems Error **  The length of ' // CMI%KNVECT(LNVEC) // ' is negative in Cordef.'
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1305, .TRUE. )
      RETURN
   ELSE
      CALL CO_GET_Vlen( CMI, LNVEC, LENGTH )
      IF ( LENGTH .GE. 0 ) THEN
!
!  Error: The vector is already defined
!
         WRITE(CMI%MSGTXT,"(' ** Systems Error **  Vector ',a4,' is already defined with length',i8)") &
            CMI%KNVECT(LNVEC), LENGTH
         CALL CO2DOC( CMI, Blb )
         CALL COSYSE( CMI, 1307, .TRUE. )
         RETURN
      ELSEIF ( CMI%INCSNG .OR. CMI%DECSNG .OR. CMI%REMVNG ) THEN
!
!  Error: Other memory change activities are in progress
!
         CMI%MSGTXT = ' ** Systems Error **  At vector ' // CMI%KNVECT(LNVEC) // &
                      ' in Cordef: Other memory activities are in progress.'
         CALL CO2DOC( CMI, Blb )
         CALL COSYSE( CMI, 1308, .TRUE. )
         RETURN
      ENDIF
   ENDIF
   CALL CO_Set_Vlen( CMI, Lnvec, Ljvec )
   ITYPE                  = CMI%LTVECT(LNVEC)
   LWORDT                 = CMI%LWORD(ITYPE)
   Start                  = (CMI%LIFREE-1)*LWORDT
   CALL Co_Set_Vstr( CMI, Lnvec, Start )
   CMI%NVUSED             = CMI%NVUSED + 1
   CMI%NLVECT(CMI%NVUSED) = 0
   CMI%VECTST(CMI%NVUSED) = LNVEC
   CMI%USVECT(LNVEC)      = CMI%NVUSED
   LA                     = MAX( 1, (LJVEC+LWORDT-1)/LWORDT )
   AVAIL                  = CMI%LATOT - CMI%LIFREE + 1
!
!  If there is insufficient memory then set Ljvect to 0, but keep all
!  other markings above. Correm will recognize this. Since all vector
!  use at least one word we make a pseudo allocation of 1.
!
   IF ( AVAIL .LT. LA ) THEN
      ICORE = CMI%LIFREE + LA - CMI%LATOT + 1
      CALL CORMEM( CMI, JCODE, ICORE )
      IF ( JCODE .LE. 0 ) THEN
         CMI%LSSPAC = .FALSE.
         CALL CO_Set_Vlen( CMI, Lnvec, 0 )
         CMI%LIFREE = CMI%LIFREE + 1
         CMI%TINUSE = CMI%TINUSE + 1
         CMI%LAMAXU = MAX( CMI%TINUSE, CMI%LAMAXU )
! $if defined (testout)
         IF ( CMI%LOCORP .GE. 1 ) THEN
            WRITE(CMI%MSGTXT,"(A4,' was not defined with length',i8,' because of insufficient memory. lifree=',i8)") &
               CMI%KNVECT(LNVEC), LJVEC, CMI%LIFREE
            CALL CO2DOC( CMI, Asis )
            WRITE(CMI%MSGTXT,"(6x,'Words in use=',i9,' and Max used=',i9)") CMI%TINUSE, CMI%LAMAXU
            CALL CO2DOC( CMI, Asis )
         ENDIF
! $endif
         RETURN
      ENDIF
   ENDIF
   CMI%LIFREE = CMI%LIFREE + LA
   CMI%TINUSE = CMI%TINUSE + LA
   CMI%LAMAXU = MAX( CMI%TINUSE, CMI%LAMAXU )
! $if defined (testout)
   IF ( CMI%LOCORP .GE. 1 ) THEN
      WRITE(CMI%MSGTXT,"(A4,' defined as #',i3,' with length',i8,' elements and base pointer',i9)")&
         CMI%KNVECT(LNVEC), CMI%NVUSED, LJVEC, Start
      CALL CO2DOC( CMI, Asis )
      WRITE(CMI%MSGTXT,"(6x,'Words in use=',i9,' and Max used=',i9)") CMI%TINUSE, CMI%LAMAXU
      CALL CO2DOC( CMI, Asis )
   ENDIF
! $endif

   END SUBROUTINE CORDEF

   SUBROUTINE CORCHA( CMI, LNVEC, JEXTRA )
!**   Logical Operation
!**       Changes the length of the vector with number Lnvec in common
!**       block Crcr with Jextra new elements. A negative Jextra indi-
!**       cates a decrease in the length of the vector. The vectors
!**       stored after the one that is changed must all be moved and all
!**       pointers must be updated with a call to Corupd after a sequence
!**       of Corcha calls. The sequence of Corcha calls must all have
!**       positive or negative Jextra, and they must not be interrupted
!**       by calls of Correm.
!**   Description of Parameters
!**       Lnvec  - Contains the number of the vector whose length should
!**                be changed, counted in the relative order used in
!**                common block crcore. Type: Is.
!**       Jextra - Contains the number of extra elements that should be
!**                added to the vector. A negative number indicates a
!**                decrease in length. Type: Is.
!**   Abnormal Conditions
!**       The vector whose length is changed must have been defined by a
!**       call to Cordef, otherwise a Systems Error is issued.
!*
      IMPLICIT NONE
   Type (Conopt_Model_Info) CMI

   INTEGER LNVEC, JEXTRA, STACK, Length
!
!  Test that this is a legal vector, and that it has been
!  defined.
!
   IF ( LNVEC .LE. 0 .OR. LNVEC .GT. Size(CMI%Ltvect) ) THEN
!
!  Error: Illegal Lnvec
!
      WRITE(CMI%MSGTXT,"(' ** Systems Error **  The first arguments of Corcha was Lnvec=',i6)") LNVEC
      CALL CO2DOC( CMI, Blb )
   ELSE
      STACK = CMI%USVECT(LNVEC)
      CALL Co_Get_Vlen( CMI, Lnvec, Length )
      IF ( STACK .EQ. 0 ) THEN
!
!  Error: Vector is not on the stack.
!
         CMI%MSGTXT = ' ** Systems Error **  Vector ' // CMI%KNVECT(LNVEC) //' is changed in Corcha but is not on the stack.'
         CALL CO2DOC( CMI, Blb )
      ELSEIF ( CMI%NLVECT(STACK) .NE. 0 ) THEN
!
!  Error: Vector is already marked to be changed.
!
         CMI%MSGTXT = ' ** Systems Error **  Vector ' // CMI%KNVECT(LNVEC) // &
                      ' is changed in Corcha but it is already marked for change.'
         CALL CO2DOC( CMI, Blb )
      ELSEIF ( Length .lt. 0 ) THEN
!
!  Error: Vector is being changed before it is defined.
!
         CMI%MSGTXT = ' ** Systems Error **  Vector ' // CMI%KNVECT(LNVEC) // &
                      ' is changed in Corcha before it is defined in Cordef.'
         CALL CO2DOC( CMI, Blb )
      ELSEIF ( Length + JEXTRA .LT. 0 ) THEN
!
!  Error: Vector is changed to a negative length.
!
         CMI%MSGTXT = ' ** Systems Error **  Vector ' // CMI%KNVECT(LNVEC) // ' is changed to a negative length.'
         CALL CO2DOC( CMI, Blb )
         WRITE(CMI%MSGTXT,"(22X,'Old length=',i7,' and change=',i7)") Length, JEXTRA
         CALL CO2DOC( CMI, Asis )
      ELSEIF ( CMI%REMVNG ) THEN
!
!  Error: Already in the process of removing vectors
!
         CMI%MSGTXT = ' ** Systems Error **  Vector ' // CMI%KNVECT(LNVEC) // ' is changed before Correm is finished.'
         CALL CO2DOC( CMI, Blb )
      ELSEIF ( JEXTRA .EQ. 0 ) THEN
!
!  No change - just skip the vector.
!
         RETURN
      ELSEIF ( JEXTRA .GT. 0 ) THEN
         IF ( CMI%DECSNG ) THEN
            CMI%MSGTXT = ' ** Systems Error **  Vector ' // CMI%KNVECT(LNVEC) // ' is increased while other vectors are decreased.'
            CALL CO2DOC( CMI, Blb )
         ELSE
            CMI%INCSNG = .TRUE.
            CMI%NLVECT(STACK) = JEXTRA
! $if defined (testout)
            IF ( CMI%LOCORP .GT. 0 ) THEN
               WRITE(CMI%MSGTXT,"('Corcha: Vector ',a4,' (#',i3,' on stack) will be increased by',i8,' elements.')") &
                  CMI%KNVECT(LNVEC), STACK, JEXTRA
               CALL CO2DOC( CMI, Asis )
            ENDIF
! $endif
            RETURN
         ENDIF
      ELSE
         IF ( CMI%INCSNG ) THEN
            CMI%MSGTXT = ' ** Systems Error **  Vector ' // CMI%KNVECT(LNVEC) // ' is decreased while other vectors are increased.'
            CALL CO2DOC( CMI, Blb )
         ELSE
            CMI%DECSNG = .TRUE.
            CMI%NLVECT(STACK) = JEXTRA
! $if defined (testout)
            IF ( CMI%LOCORP .GT. 0 ) THEN
               WRITE(CMI%MSGTXT,"('Corcha: Vector ',a4,' (#',i3,' on stack) will be ',a2,'creased by',i8,' elements.')") &
                  CMI%KNVECT(LNVEC), STACK, 'de', -JEXTRA
               CALL CO2DOC( CMI, Asis )
            ENDIF
! $endif
            RETURN
         ENDIF
      ENDIF
   ENDIF
   CALL COSYSE( CMI, 1303, .TRUE. )

   END SUBROUTINE CORCHA

   SUBROUTINE CORCOP( CMI, LNFVEC, LNTVEC, XL )
!**   LOGICAL OPERATION
!**       COPIES ONE VECTOR ONTO ANOTHER.
!**   DESCRIPTION OF PARAMETERS
!**       LNFVEC - CONTAINS THE NUMBER IN CRCORE OF THE VECTOR TO COPY
!**                FROM. TYPE: INTEGER. INPUT.
!**       LNTVEC - CONTAINS THE NUMBER IN CRCORE OF THE VECTOR TO COPY
!**                TO. TYPE: INTEGER. INPUT.
!**   ABNORMAL CONDITIONS.
!**       ABORTS IF LNFVEC OR LNTVEC ARE OUT OF RANGE, IF THE VECTORS
!**       ARE NOT DEFINED, IF THEY DO NOT HAVE THE SAME TYPE, OR IF THEY
!**       DO NOT HAVE THE SAME LENGTH.
!*
      IMPLICIT NONE
   Type (Conopt_Model_Info) CMI
!
!  Define denorm if the movement of reals can cause de-normalized
!  reals to be normalized so the bit-pattern is change by a move.
!
! $if defined (denorm)
!    INTEGER   XL(*), I1, I2
! $else
   REAL(CO_R) XL(*)
! $endif
   INTEGER   LNFVEC, LNTVEC, I, LENGTH, ITYPE, LWORDT, LLFVEC, LLTVEC, Lenfr, Lento
!
!  Check the arguments
!
   IF ( LNFVEC .LE. 0 .OR. LNFVEC .GT. Size(CMI%Ltvect) ) THEN
!
!  Error: Illegal From vector number
!
      WRITE(CMI%MSGTXT,"(' ** Systems Error **  Corcop: Illegal From vector number =',i8)") LNFVEC
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1304, .TRUE. )
      RETURN
   ELSEIF ( LNTVEC .LE. 0 .OR. LNTVEC .GT. Size(CMI%Ltvect) ) THEN
!
!  Error: Illegal To vector number
!
      WRITE(CMI%MSGTXT,"(' ** Systems Error **  Corcop: Illegal To vector number =',i8)") LNTVEC
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1304, .TRUE. )
      RETURN
   ELSE
      Call Co_Get_Vlen( CMI, Lnfvec, Lenfr )
      Call Co_Get_Vlen( CMI, Lntvec, Lento )
      IF ( Lenfr .LT. 0 ) THEN
!
!  Error: The 'From' vector is not defined
!
         CMI%MSGTXT = ' ** Systems Error **  Corcop: The From vector = ' // CMI%KNVECT(LNFVEC) //' is not defined.'
         CALL CO2DOC( CMI, Blba )
         CALL COSYSE( CMI, 1304, .TRUE. )
         RETURN
      ELSEIF ( Lento .LT. 0 ) THEN
!
!  Error: The 'To' vector is not defined
!
         CMI%MSGTXT = ' ** Systems Error **  Corcop: The To vector = ' // CMI%KNVECT(LNTVEC) //' is not defined.'
         CALL CO2DOC( CMI, Blba )
         CALL COSYSE( CMI, 1304, .TRUE. )
         RETURN
      ELSEIF ( CMI%LTVECT(LNFVEC) .NE. CMI%LTVECT(LNTVEC) ) THEN
!
!  Error: The types are not the same
!
         CMI%MSGTXT = ' ** Systems Error **  Corcop: The vectors do not have the same type.'
         CALL CO2DOC( CMI, Blb )
         CMI%MSGTXT = '                      From=' // CMI%KNVECT(LNFVEC) // ' and To=' // CMI%KNVECT(LNTVEC)
         CALL CO2DOC( CMI, Bla )
         CALL COSYSE( CMI, 1304, .TRUE. )
         RETURN
      ELSEIF ( Lenfr .NE. Lento ) THEN
!
!  Error: The lengths are not the same
!
         CMI%MSGTXT = ' ** Systems Error **  Corcop: The vectors do not have the same length.'
         CALL CO2DOC( CMI, Blb )
         WRITE(CMI%MSGTXT,"(22X,'From  =',A,' has length',i7)") CMI%KNVECT(LNFVEC), Lenfr
         CALL CO2DOC( CMI, Asis )
         WRITE(CMI%MSGTXT,"(22X,'and To=',A,' has length',i7)") CMI%KNVECT(LNTVEC), Lento
         CALL CO2DOC( CMI, Bla )
         CALL COSYSE( CMI, 1304, .TRUE. )
         RETURN
      ENDIF
   ENDIF

   ITYPE  = CMI%LTVECT(LNFVEC)
   LWORDT = CMI%LWORD(ITYPE)
   LENGTH = ( Lenfr+LWORDT-1 )/LWORDT
   Call Co_Get_Vstr( CMI, Lnfvec, LLfvec )
   Call Co_Get_Vstr( CMI, Lntvec, LLtvec )
   LLFVEC = LLFVEC / LWORDT
   LLTVEC = LLTVEC / LWORDT
! $if defined (denorm)
!    I1 = LLTVEC * 2 - 1
!    I2 = LLFVEC * 2 - 1
!    DO I = 1, LENGTH
!       XL(I1)   = XL(I2)
!       XL(I1+1) = XL(I2+1)
!       I1       = I1 + 2
!       I2       = I2 + 2
!    ENDDO
! $else
   DO I = 1, LENGTH
      XL(LLTVEC+I) = XL(LLFVEC+I)
   ENDDO
! $endif

   END SUBROUTINE CORCOP

   SUBROUTINE CORREM( CMI, LNVEC, TEST )
!**   LOGICAL OPERATION
!**       REMOVES A VECTOR FROM THE LIST OF DEFINED VECTORS AND RETURNS
!**       THE CORE TO THE POOL OF AVAILABLE CORE.
!**   DESCRIPTION OF PARAMETERS
!**       LNVEC  - CONTAINS THE NUMBER OF THE VECTOR TO BE REMOVED.
!**                TYPE: IS.
!**       TEST   - A LOGICAL VECTOR THAT DETERMINES IF WE SHOULD TEST
!**                FOR UNALLOCATED VECTORS. IF TEST=.TRUE. AN UNALLO-
!**                CATED VECTOR CAUSES A FATAL ERROR, BUT IF TEST=
!**                .FALSE. CORREM WILL JUST RETURN. TYPE: LS.
!**   ABNORMAL CONDITIONS
!**       - ABORTS WITH AN ERROR MESSAGE IF THE VECTOR TO BE REMOVED DID
!**         NOT EXIST AND TEST IS TRUE.
!**       - ABORTS WITH AN ERROR MESSAGE IF THE VECTOR NUMBER IS
!**         UNKNOWN.
!**

      IMPLICIT NONE
   Type (Conopt_Model_Info) CMI

   INTEGER LNVEC, STACK, ITYPE, LWORDT, Lenele, LENGTH
   LOGICAL TEST
!
!  Check the input arguments
!
   IF ( LNVEC .LT. 0 .OR. LNVEC .GT. Size(CMI%Ltvect) ) THEN
!
!  Error: Illegal vector number
!
      WRITE(CMI%MSGTXT,"(' ** Systems Error **  The vector number in Correm was Lnvec=',i8)") LNVEC
      CALL CO2DOC( CMI, Blb )
   ELSE
      CALL CO_Get_Vlen( CMI, Lnvec, Lenele )
      IF ( Lenele .LT. 0 ) THEN
!
!  Error: Vector is not defined
!
         IF ( .NOT. TEST ) THEN
! $if defined (testout)
            IF ( CMI%LOCORP .GE. 1 ) THEN
               CMI%MSGTXT = CMI%KNVECT(LNVEC) // ' should be removed but was not allocated.'
               CALL CO2DOC( CMI, Asis )
            ENDIF
! $endif
            RETURN
         ENDIF
         CMI%MSGTXT = ' ** Systems Error **  Correm call for undefined vector ' // CMI%KNVECT(LNVEC)
         CALL CO2DOC( CMI, Blb )
      ELSEIF ( CMI%INCSNG .OR. CMI%DECSNG ) THEN
!
!  Error: Already increasing or decreasing other vectors
!
         CMI%MSGTXT = ' ** Systems Error **  Correm called before Corcha calls were finished.'
         CALL CO2DOC( CMI, Blb )
         CMI%MSGTXT = '                      Vector = ' // CMI%KNVECT(LNVEC)
         CALL CO2DOC( CMI, Asis )
      ELSEIF ( CMI%USVECT(LNVEC) .LE. 0 ) THEN
!
!  Error: Vector is not marked on the stack
!
         CMI%MSGTXT = ' ** Systems Error **  The vector ' // CMI%KNVECT(LNVEC) // ' was not marked on the stack.'
         CALL CO2DOC( CMI, Blb )
      ELSE
!
!  All tests were passed succesfully. Mark the vector with Nlvect = 1
!
         STACK  = CMI%USVECT(LNVEC)
         IF ( CMI%NLVECT(STACK) .NE. 0 ) THEN
!
!  Error: Vector is already marked for removal.
!
            CMI%MSGTXT = ' ** Systems Error **  The vector ' // CMI%KNVECT(LNVEC) // ' is already marked for removal.'
            CALL CO2DOC( CMI, Blb )
         ELSE
            CMI%REMVNG = .TRUE.
            if ( stack .eq. CMI%nvused ) then
               itype  = CMI%ltvect(lnvec)
               lwordt = CMI%lword(itype)
               length = max(1,(Lenele+lwordt-1)/lwordt)
! $if defined (testout)
               IF ( CMI%LOCORP .GE. 1 ) THEN
                  WRITE(CMI%MSGTXT,"(A4,' has been removed from top of stack. Length was',i8,' = ',I8,' words.')") &
                     CMI%knvect(lnvec), Lenele, LENGTH
                  CALL CO2DOC( CMI, Asis )
               ENDIF
! $endif
               Call Co_Set_Vstr( CMI, Lnvec, -10000000 )
               Call Co_Set_Vlen( CMI, Lnvec, -1 )
               CMI%usvect(lnvec) = 0
               CMI%nlvect(stack) = 0
               CMI%nvused        = CMI%nvused - 1
               CMI%lifree        = CMI%lifree - length
               CMI%tinuse        = CMI%tinuse - length
            else
               CMI%NLVECT(STACK) = 1
               CMI%REMNUM        = CMI%REMNUM + 1
! $if defined (testout)
               IF ( CMI%LOCORP .GE. 1 ) THEN
                  WRITE(CMI%MSGTXT,"(A4,' will be removed. Length was',i8,' Stack=',i3,' of',i3)") &
                     CMI%KNVECT(LNVEC), Lenele, STACK, CMI%NVUSED
                  CALL CO2DOC( CMI, Asis )
               ENDIF
! $endif
            ENDIF
            RETURN
         ENDIF
      ENDIF
   ENDIF
!
!  We will only get to this place if there was an error
!
   CALL COSYSE( CMI, 1308, .TRUE. )

   END SUBROUTINE CORREM

   SUBROUTINE CORSAV( CMI, LNVEC, XL, JL )
!**   LOGICAL OPERATION
!**       SAVES A VECTOR ON A SCRATCH FILE FOR USE AT SOME LATER STAGE.
!**       THE ROUTINE ALSO SAVES INFORMATION IDENTIFYING THE VECTOR.
!**       IT PRINTS TESTOUTPUT IF TESTOUTPUT IS REQUESTED.
!**   DESCRIPTION OF PARAMETERS
!**       LNVEC  - CONTAINS THE NUMBER OF THE VECTOR TO BE SAVED.
!**                TYPE: IS.
!**   ABNORMAL CONDITIONS
!**       ABORTS IF THE VECTOR IS NOT DEFINED OR IF LNVEC IS AN ILLEGAL
!**       VECTOR NUMBER.
!*
      IMPLICIT NONE
   Type (Conopt_Model_Info) CMI

   REAL(CO_R) XL(*); INTEGER JL(*)

   INTEGER LNVEC, LUNIT, ITYPE, LJVEC, I, LLVEC, NREC, IREC, RECLEN, IFROM, ITO
   PARAMETER ( RECLEN = 750 )
!
!  Test that this is a legal vector number and that the vector is
!  defined.
!
   IF ( LNVEC .LE. 0 .OR. LNVEC .GT. Size(CMI%Ltvect) ) THEN
      CMI%MSGTXT = ' ** Systems Error **  The argument of Corsav was out of range.'
      CALL CO2DOC( CMI, Blb )
      WRITE(CMI%MSGTXT,"(22X,'Lnvec=',i6)") LNVEC
      CALL CO2DOC( CMI, Asis )
      CALL COSYSE( CMI, 1309, .TRUE. )
      RETURN
   ENDIF
   CALL CO_Get_Vlen( CMI, Lnvec, Ljvec )
!
!     Write the name and length of the vector
!
   WRITE(CMI%LUSVRS) CMI%KNVECT(LNVEC), LJVEC
!
!  Write the vector itself. Use a format depending on the type
!  of the vector.
!
   IF ( LJVEC .GT. 0 ) THEN
      CALL CO_Get_Vstr( CMI, Lnvec, LLvec )
      ITYPE = CMI%LTVECT(LNVEC)
      NREC = ( LJVEC + RECLEN - 1 ) / RECLEN
      IFROM = 1
      ITO   = 0
      IF ( ITYPE .EQ. TypV_Real ) THEN
         DO IREC = 1, NREC
            ITO   = MIN( ITO+RECLEN, LJVEC )
            WRITE(CMI%LUSVRS) ( XL(LLVEC+I), I = IFROM, ITO )
            IFROM = ITO + 1
         ENDDO
      ELSEIF ( ITYPE .EQ. TypV_Int ) THEN
         DO IREC = 1, NREC
            ITO   = MIN( ITO+RECLEN, LJVEC )
            WRITE(CMI%LUSVRS) ( JL(LLVEC+I), I = IFROM, ITO )
            IFROM = ITO + 1
         ENDDO
      ELSEIF ( ITYPE .EQ. TypV_Char ) THEN
         DO IREC = 1, NREC
            ITO   = MIN( ITO+RECLEN, LJVEC )
            WRITE(CMI%LUSVRS) ( XL(LLVEC+I), I = IFROM, ITO )
            IFROM = ITO + 1
         ENDDO
      ELSE
         CMI%MSGTXT = ' ** Systems Error **  Illegal vector type in Corsav for vector ' // CMI%KNVECT(LNVEC)
         CALL CO2DOC( CMI, Blb )
         CALL COSYSE( CMI, 1325, .TRUE. )
         RETURN
      ENDIF
   ENDIF
! $if defined (testout)
!
!  Write test output if needed.
!
   IF ( CMI%LOCORP .GE. 1 ) THEN
      WRITE(CMI%MSGTXT,"('Vector ',A,' with length',i8,' is saved on unit',i4)") &
         CMI%KNVECT(LNVEC), LJVEC, CMI%LUSVRS
      CALL CO2DOC( CMI, Asis )
      IF ( CMI%LOCORP .GE. 2 .AND. LJVEC .GE. 0 ) THEN
         IF ( ITYPE .EQ. TypV_Real ) THEN
            CALL COPVRL( CMI, LNVEC, XL(Llvec+1) )
         ELSEIF ( ITYPE .EQ. TypV_Int ) THEN
            CALL COPVJL( CMI, LNVEC, JL(Llvec+1) )
         ELSEIF ( ITYPE .EQ. TypV_Char ) THEN
            CALL COPVKL( CMI, LNVEC, XL(Llvec+1) )
         ELSE
            CMI%MSGTXT = ' ** Systems Error **  Illegal vector type in Corsav for vector ' // CMI%KNVECT(LNVEC)
            CALL CO2DOC( CMI, Blb )
            CALL COSYSE( CMI, 1325, .TRUE. )
            RETURN
         ENDIF
      ENDIF
   ENDIF
! $endif
   RETURN

   END SUBROUTINE CORSAV

   SUBROUTINE CORSWP( CMI, LNFVEC, LNTVEC )
!**   LOGICAL OPERATION
!**       SWAPS ONE VECTOR WITH ANOTHER.
!**   DESCRIPTION OF PARAMETERS
!**       LNFVEC - CONTAINS THE NUMBER IN CRCORE OF THE FIRST VECTOR TO
!**                SWAP. TYPE: INTEGER. INPUT.
!**       LNTVEC - CONTAINS THE NUMBER IN CRCORE OF THE SECOND VECTOR TO
!**                SWAP. TYPE: INTEGER. INPUT.
!**   ABNORMAL CONDITIONS.
!**       ABORTS IF LNFVEC OR LNTVEC ARE OUT OF RANGE, IF THE VECTORS
!**       ARE NOT DEFINED, IF THEY DO NOT HAVE THE SAME TYPE, OR IF THEY
!**       DO NOT HAVE THE SAME LENGTH.
!*
      IMPLICIT NONE
   Type (Conopt_Model_Info) CMI

   INTEGER LNFVEC, LNTVEC, STACKF, STACKT, Lenfr, Lento, Strfr, Strto

   IF ( LNFVEC .LE. 0 .OR. LNFVEC .GT. Size(CMI%Ltvect) ) THEN
      WRITE(CMI%MSGTXT,"(' ** Systems Error **  The FROM vector in Corswp is out of range =',i6)") LNFVEC
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1310, .TRUE. )
      RETURN
   ENDIF
   Call Co_Get_Vlen( CMI, Lnfvec, Lenfr )
   IF ( Lenfr .LT. 0 ) THEN
      CMI%MSGTXT = ' ** Systems Error **  The FROM vector ' // CMI%KNVECT(LNFVEC) // ' in Corswp has not been defined.'
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1310, .TRUE. )
      RETURN
   ENDIF
   IF ( LNTVEC .LE. 0 .OR. LNTVEC .GT. Size(CMI%Ltvect) ) THEN
      WRITE(CMI%MSGTXT,"(' ** Systems Error **  The TO vector in Corswp is out of range =',i6)") LNTVEC
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1310, .TRUE. )
      RETURN
   ENDIF
   Call Co_Get_Vlen( CMI, Lntvec, Lento )
   IF ( Lento .LT. 0 ) THEN
      CMI%MSGTXT = ' ** Systems Error **  The TO vector ' // CMI%KNVECT(LNFVEC) // ' in Corswp has not been defined.'
      CALL CO2DOC( CMI, Blb )
      CALL COSYSE( CMI, 1310, .TRUE. )
      RETURN
   ENDIF
   IF ( CMI%LTVECT(LNFVEC) .NE. CMI%LTVECT(LNTVEC) ) THEN
      CMI%MSGTXT = ' ** Systems Error **  The type of vector ' // CMI%KNVECT(LNFVEC) // ' is different from'
      CALL CO2DOC( CMI, Blb )
      CMI%MSGTXT = '                      the type of vector ' // CMI%KNVECT(LNTVEC) // ' in Corswp.'
      CALL CO2DOC( CMI, Asis )
      CALL COSYSE( CMI, 1310, .TRUE. )
      RETURN
   ENDIF
   IF ( Lenfr .NE. Lento ) THEN
      CMI%MSGTXT = ' ** Systems Error **  The length of vector ' // CMI%KNVECT(LNFVEC) // ' is different from'
      CALL CO2DOC( CMI, Blb )
      CMI%MSGTXT = '                      the length of vector ' // CMI%KNVECT(LNTVEC) // ' in Corswp.'
      CALL CO2DOC( CMI, Asis )
      CALL COSYSE( CMI, 1310, .TRUE. )
      RETURN
   ENDIF
!
!  Swap the base pointers
!
   Call Co_Get_Vstr( CMI, LNFVEC, Strfr )
   Call Co_Get_Vstr( CMI, LNTVEC, Strto )
   Call Co_Set_Vstr( CMI, LNFVEC, Strto )
   Call Co_Set_Vstr( CMI, LNTVEC, Strfr )
!
!  Exchange the two vectors in the stack
!
   STACKF             = CMI%USVECT(LNFVEC)
   STACKT             = CMI%USVECT(LNTVEC)
   CMI%USVECT(LNFVEC) = STACKT
   CMI%USVECT(LNTVEC) = STACKF
   CMI%VECTST(STACKT) = LNFVEC
   CMI%VECTST(STACKF) = LNTVEC
   RETURN

   END SUBROUTINE CORSWP

   SUBROUTINE CORRES( CMI, LNVEC, XL, JL )
!**   LOGICAL OPERATION
!**       Restores a vector from a scratch file in the format used by
!**       Corsav. The routine checks which vector is read and
!**       allocates core. It prints testoutput if testoutput is
!**       requested.
!**   DESCRIPTION OF PARAMETERS
!**       Lnvec  - Returns the number of the vector being restored.
!**                A zero is returned if end-of-file is reached or
!**                if the special vector name '*END' is read.
!**       Lsspac - Logical return code. If the necessary core is not
!**                available, Lsspac is set to .False. and Corres
!**                returns. It is the responsibility of the calling
!**                subroutine to write any error messages. In this case
!**                the vector is defined with length zero and the header
!**                is read, but not the vector itself.
!*
      IMPLICIT NONE
   Type (Conopt_Model_Info) CMI
   INTEGER     LNVEC

   REAL(CO_R) XL(*); INTEGER JL(*)

   CHARACTER*4 KNVEC
   INTEGER     LLVEC, LJVEC, ITYPE, I, NREC, IREC, RECLEN, IFROM, ITO

   PARAMETER ( RECLEN = 750 )
!
!  Read the name and length of the vector and check that the name
!  is correct.
!
   READ(CMI%LUSVRS,END=100) KNVEC, LJVEC
   IF ( KNVEC .EQ. '*END' ) THEN
      LNVEC = 0
      RETURN
   ENDIF
   DO LNVEC = 1, Size(CMI%Ltvect)
      IF ( KNVEC .EQ. CMI%KNVECT(LNVEC) ) GO TO 111
   ENDDO
   CMI%MSGTXT = ' ** Systems Error **  Unrecognized vector ' // KNVEC // ' in Corres.'
   CALL CO2DOC( CMI, Blb )
   CALL COSYSE( CMI, 1300, .TRUE. )
   RETURN
!
!  Read the vector itself. Use a format depending on the type
!  of the vector.
!  Start by creating the vector.
!
111 ITYPE = CMI%LTVECT(LNVEC)
   CALL CORDEF( CMI, LNVEC, LJVEC )
   IF ( .NOT. CMI%LSSPAC ) RETURN
   IF ( LJVEC .GT. 0 ) THEN
      Call Co_Get_Vstr( CMI, Lnvec, Llvec )
      NREC = ( LJVEC + RECLEN - 1 ) / RECLEN
      IFROM = 1
      ITO   = 0
      IF ( ITYPE .EQ. TypV_Real ) THEN
         DO IREC = 1, NREC
            ITO   = MIN( ITO+RECLEN, LJVEC )
            READ(CMI%LUSVRS,ERR=2221,END=2222) (XL(LLVEC+I), I = IFROM, ITO)
            IFROM = ITO + 1
         ENDDO
      ELSEIF ( ITYPE .EQ. TypV_Int ) THEN
         DO IREC = 1, NREC
            ITO   = MIN( ITO+RECLEN, LJVEC )
            READ(CMI%LUSVRS,ERR=2221,END=2222) (JL(LLVEC+I), I = IFROM, ITO)
            IFROM = ITO + 1
         ENDDO
      ELSEIF ( ITYPE .EQ. TypV_Char ) THEN
         DO IREC = 1, NREC
            ITO   = MIN( ITO+RECLEN, LJVEC )
            READ(CMI%LUSVRS,ERR=2221,END=2222) (XL(LLVEC+I), I = IFROM, ITO)
            IFROM = ITO + 1
         ENDDO
      ELSE
         CMI%MSGTXT = ' ** Systems Error **  Illegal vector type in Corres for vector ' // CMI%KNVECT(LNVEC)
         CALL CO2DOC( CMI, Blb )
         CALL COSYSE( CMI, 1325, .TRUE. )
         RETURN
      ENDIF
   ENDIF
! $if defined (testout)
!
!  Write test output if needed.
!
   IF ( CMI%LOCORP .GE. 1 ) THEN
      WRITE(CMI%MSGTXT,"('Vector ',a4,' with length',i7,' is restored from unit', i4)") &
         CMI%KNVECT(LNVEC), LJVEC, CMI%LUSVRS
      CALL CO2DOC( CMI, Asis )
      IF ( CMI%LOCORP .GE. 2 .AND. LJVEC .GE. 0 ) THEN
         IF ( ITYPE .EQ. TypV_Real ) THEN
            CALL COPVRL( CMI, LNVEC, XL(LLVEC+1) )
         ELSEIF ( ITYPE .EQ. TypV_Int ) THEN
            CALL COPVJL( CMI, LNVEC, JL(LLVEC+1) )
         ELSEIF ( ITYPE .EQ. TypV_Char ) THEN
            CALL COPVKL( CMI, LNVEC, XL(LLVEC+1) )
         ELSE
            CMI%MSGTXT = ' ** Systems Error **  Illegal vector type in Corres for vector ' // CMI%KNVECT(LNVEC)
            CALL CO2DOC( CMI, Blb )
            CALL COSYSE( CMI, 1325, .TRUE. )
            RETURN
         ENDIF
      ENDIF
   ENDIF
! $endif
   RETURN
!
!  End of file while trying to read a header
!
100 LNVEC = 0
   RETURN
!
!  Error: Error while reading a vector
!
2221 WRITE(CMI%MSGTXT,"('Error while reading ',a4,' element=',i9,' Llvec=',i9,' and Ljvec=',i9)") &
        KNVEC, I, LLVEC, LJVEC
   CALL CO2DOC( CMI, Asis )
   CALL COSYSE( CMI, 1301, .TRUE. )
   RETURN
!
!  Error: End of file while reading a vector
!
2222 WRITE(CMI%MSGTXT,"('End-of-file while reading ',a4,' element=',i7)") KNVEC, I
   CALL CO2DOC( CMI, Asis )
   CALL COSYSE( CMI, 1302, .TRUE. )
   RETURN

   END SUBROUTINE CORRES

   SUBROUTINE CORUPD( CMI, XL, JL )
!**   Logical Operation
!**       Finishes the update of the memory allocation after a sequence
!**       of calls to Corcha with either all increasing lengths or all
!**       descreasing lengths, or a sequence of calls of Correm.
!**   Description of Parameters
!**       Lsspac - Logical return code. If the necessary core is not
!**                available, Lsspac is set to .false. and corupd
!**                returns. it is the responsibility of the calling
!**                subroutine to write any error messages.  in this case
!**                nothing is moved and the pointers are left unchanged.
!*
      IMPLICIT NONE
   Type (Conopt_Model_Info) CMI
   REAL(CO_R) XL(*); INTEGER JL(*)

   INTEGER STACK, LNVEC, ITYPE, LWORDT, LENGTH, OLDLEN, NEWLEN, DMOVE, FROM, TO, AVAIL
   INTEGER REMOVD, JCODE, ICORE, OLDELE, NEWELE, EMOVE, LJVEC
   LOGICAL MOVING

   DMOVE = 0
   EMOVE = 0
   IF ( CMI%REMVNG ) THEN
!
!  Removing vectors. Simply compress the vectors that remain. All
!  memory movements is down over the vectors that are removed.
!
      CMI%REMVNG = .FALSE.
      IF ( CMI%REMNUM .EQ. 0 ) THEN
! $if defined (testout)
         IF ( CMI%LOCORP .GE. 2 ) THEN
            CMI%MSGTXT = ' Corupd: Nothing to remove.'
            CALL CO2DOC( CMI, Asis )
         ENDIF
! $endif
         RETURN
      ENDIF
      MOVING = .FALSE.
      REMOVD = 0
      DO STACK = 1, CMI%NVUSED
         LNVEC  = CMI%VECTST(STACK)
         ITYPE  = CMI%LTVECT(LNVEC)
         LWORDT = CMI%LWORD(ITYPE)
         CALL CO_GET_VLEN( CMI, LNVEC, LJVEC )
         LENGTH = MAX(1, (LJVEC+LWORDT-1)/LWORDT)
         IF ( CMI%NLVECT(STACK) .EQ. 1 ) THEN
! $if defined (testout)
            IF ( CMI%LOCORP .GE. 2 ) THEN
               WRITE(CMI%MSGTXT,"('Corupd: Vector ',a4,' with length',i8,' = ',i8,' words is removed.')") &
                  CMI%KNVECT(LNVEC), LJVEC, LENGTH
               CALL CO2DOC( CMI, Asis )
            ENDIF
! $endif
            DMOVE  = DMOVE + LENGTH
            MOVING = .TRUE.
            CALL CO_SET_VSTR( CMI, LNVEC, -10000000 )
            CALL CO_SET_VLEN( CMI, LNVEC, -1 )
            CMI%USVECT(LNVEC) = 0
            CMI%NLVECT(STACK) = 0
            REMOVD        = REMOVD + 1
         ELSEIF ( MOVING ) THEN
! $if defined (testout)
            IF ( CMI%LOCORP .GE. 2 ) THEN
               WRITE(CMI%MSGTXT,"('Corupd: Vector ',a4,' with length',i8,' is moved down by',i8,' words.')") &
                  CMI%KNVECT(LNVEC), LJVEC, DMOVE
               CALL CO2DOC( CMI, Asis )
            ENDIF
! $endif
            CALL CO_GET_VSTR( CMI, LNVEC, FROM )
            FROM   = FROM / LWORDT + 1
            TO     = FROM - DMOVE
            EMOVE  = EMOVE + LENGTH
            CALL CORMOV( FROM, TO, LENGTH, XL )
            CALL CO_SET_VSTR( CMI, LNVEC, (TO-1)*LWORDT )
            CMI%VECTST(STACK-REMOVD) = LNVEC
            CMI%USVECT(LNVEC)        = STACK-REMOVD
         ENDIF
      ENDDO
      CMI%NVUSED = CMI%NVUSED - REMOVD
      CMI%LIFREE = CMI%LIFREE - DMOVE
      CMI%TINUSE = CMI%TINUSE - DMOVE
      CMI%REMNUM = 0
! $if defined (testout)
      IF ( CMI%LOCORP .GE. 2 ) THEN
         WRITE(CMI%MSGTXT,"('Corupd: Removing vectors. ',i8,' words of memory recovered.')") DMOVE
         CALL CO2DOC( CMI, Asis )
      ENDIF
! $endif
   ELSEIF ( CMI%INCSNG ) THEN
      CMI%INCSNG = .FALSE.
      DO STACK = 1, CMI%NVUSED
         IF ( CMI%NLVECT(STACK) .NE. 0 ) THEN
            LNVEC  = CMI%VECTST(STACK)
            ITYPE  = CMI%LTVECT(LNVEC)
            LWORDT = CMI%LWORD(ITYPE)
            CALL CO_GET_VLEN( CMI, LNVEC, LJVEC )
            OLDLEN = MAX(1,(LJVEC+LWORDT-1)/LWORDT)
            NEWLEN = MAX(1, (LJVEC+CMI%NLVECT(STACK)+LWORDT-1)/LWORDT)
            DMOVE  = DMOVE + NEWLEN - OLDLEN
         ENDIF
      ENDDO
! $if defined (testout)
      IF ( CMI%LOCORP .GE. 2 ) THEN
         WRITE(CMI%MSGTXT,"('Corupd: Increasing vectors. Extra memory needed is',i8,' words.')") DMOVE
         CALL CO2DOC( CMI, Asis )
      ENDIF
! $endif
!
!  Check if the memory is available:
!
      avail  = CMI%latot - CMI%lifree + 1
      if ( avail .lt. dmove ) then
         icore = CMI%lifree + dmove - CMI%latot + 1
         call cormem( cmi, jcode, icore )
         if ( jcode .le. 0 ) then
            cmi%lsspac = .false.
! $if defined (testout)
            if ( CMI%LOCORP .ge. 1 ) then
               write(CMI%MSGTXT,"('Corupd: Vectors were not increased because of insufficient memory. Lifree=',i8)") &
                  CMI%lifree
               CALL CO2DOC( CMI, Asis )
            endif
! $endif
            do stack = 1, CMI%nvused
               CMI%nlvect(stack) = 0
            enddo
            return
         endif
      endif
      CMI%lifree = CMI%lifree + dmove
      CMI%tinuse = CMI%tinuse + dmove
      CMI%lamaxu = max( CMI%tinuse, CMI%lamaxu )
! $if defined (testout)
      if ( CMI%LOCORP .ge. 2 ) then
         write(CMI%MSGTXT,"(8x,'Words in use=',i9,' and Max used=',i9)") CMI%tinuse, CMI%lamaxu
         CALL CO2DOC( CMI, Asis )
      endif
! $endif
      moving = dmove .ne. 0
      do stack = CMI%nvused, 1, -1
         lnvec  = CMI%vectst(stack)
         itype  = CMI%ltvect(lnvec)
         lwordt = CMI%lword(itype)
         Call Co_Get_Vlen( CMI, Lnvec, Oldele )
         oldlen = max(1,(Oldele+lwordt-1)/lwordt)
         if ( CMI%nlvect(stack) .ne. 0 ) then
            Newele = Oldele+CMI%nlvect(stack)
            Call Co_Set_Vlen( CMI, Lnvec, Newele )
            newlen = max(1,(Newele+lwordt-1)/lwordt)
! $if defined (testout)
            if ( CMI%LOCORP .ge. 2 ) then
               write(CMI%MSGTXT,"('Corupd: Vector ',a4,' with length',i8,' = ',i8,' words')") &
                  CMI%knvect(lnvec), oldele, oldlen
               CALL CO2DOC( CMI, Asis )
               write(CMI%MSGTXT,"(9x,'is increased to length',i8,' = ',i8,' words.')") newele, newlen
               CALL CO2DOC( CMI, Asis )
            endif
! $endif
            dmove  = dmove + oldlen - newlen
            moving = dmove .ne. 0
            CMI%nlvect(stack) = 0
         endif
         if ( moving ) then
! $if defined (testout)
            if ( CMI%LOCORP .ge. 2 ) then
               write(CMI%MSGTXT,"('Corupd: Vector ',a4,' with length',i8,' is moved up by',i8,' words.')") &
                  CMI%knvect(lnvec), oldele, dmove
               CALL CO2DOC( CMI, Asis )
            endif
! $endif
            Call Co_Get_Vstr( CMI, Lnvec, From )
            from   = From / lwordt + 1
            to            = from + dmove
            emove         = emove + oldlen
            call cormov( from, to, oldlen, xl )
            Call Co_Set_Vstr( CMI, Lnvec, (to-1)*lwordt )
         endif
      enddo
   elseif ( CMI%decsng ) then
      CMI%decsng = .false.
      moving = .false.
      do stack = 1, CMI%nvused
         lnvec  = CMI%vectst(stack)
         itype  = CMI%ltvect(lnvec)
         lwordt = CMI%lword(itype)
         if ( moving ) then
            Call Co_Get_Vlen( CMI, Lnvec, Oldele )
            length = max(1, (Oldele+CMI%nlvect(stack)+lwordt-1)/lwordt)
! $if defined (testout)
            if ( CMI%LOCORP .ge. 2 ) then
               write(CMI%MSGTXT,"('Corupd: Vector ',a4,' with length',i8,' is moved down by',i8,' words.')") &
                  CMI%knvect(lnvec), Oldele+CMI%nlvect(stack), dmove
               CALL CO2DOC( CMI, Asis )
            endif
! $endif
            Call Co_Get_Vstr( CMI, Lnvec, From )
            from   = From / lwordt + 1
            to            = from - dmove
            emove         = emove + length
            call cormov( from, to, length, xl )
            Call Co_Set_Vstr( CMI, Lnvec, (to-1)*lwordt )
         endif
         if ( CMI%nlvect(stack) .ne. 0 ) then
            Call Co_Get_Vlen( CMI, Lnvec, Oldele )
            oldlen = max(1,(Oldele+lwordt-1)/lwordt)
            Newele = Oldele+CMI%nlvect(stack)
            Call Co_Set_Vlen( CMI, Lnvec, Newele )
            newlen = max(1,(Newele+lwordt-1)/lwordt)
! $if defined (testout)
            if ( CMI%LOCORP .ge. 2 ) then
               write(CMI%MSGTXT,"('Corupd: Vector ',a4,' with length',i8,' = ',i8,' words')") &
                  CMI%knvect(lnvec), Oldele, oldlen
               CALL CO2DOC( CMI, Asis )
               write(CMI%MSGTXT,"(12x,'is reduced to length',i8,' = ',i8,' words.')") Newele, newlen
               CALL CO2DOC( CMI, Asis )
            endif
! $endif
            dmove  = dmove + oldlen - newlen
            moving = dmove .ne. 0
            CMI%nlvect(stack) = 0
         endif
      enddo
      CMI%lifree = CMI%lifree - dmove
      CMI%tinuse = CMI%tinuse - dmove
! $if defined (testout)
      if ( CMI%LOCORP .ge. 2 ) then
         write(CMI%MSGTXT,"('Corupd: Decreasing vectors. ',i8,' words of memory recovered.')") dmove
         CALL CO2DOC( CMI, Asis )
      endif
   else
      if ( CMI%LOCORP .ge. 2 ) then
         CMI%MSGTXT = 'Corupd called and neither of Remvng, Incsng, or Decsng are .true.'
         CALL CO2DOC( CMI, Asis )
      endif
! $endif
   endif

   CMI%LKMVWD = CMI%LKMVWD + emove
! $if defined (testout)
   if ( CMI%LOCORP .ge. 2 ) then
      write(CMI%MSGTXT,"('Corupd: Total number of words moved =',i8,'. Accumulated words =',i9)") emove, CMI%LKMVWD
      CALL CO2DOC( CMI, Asis )
      IF ( CMI%LOCORP .EQ. 3 ) THEN
         CALL CORPRT( CMI, 1, XL, JL )
      ELSEIF ( CMI%LOCORP .GT. 3 ) THEN
         CALL CORPRT( CMI, 2, XL, JL )
      ENDIF
   ENDIF
! $endif

   END SUBROUTINE CORUPD

   SUBROUTINE CORLFT( CMI, Num_REAL, Num_INT, Num_CHAR, Fix_REAL, FIX_INT, FIX_CHAR, &
                      NUMELE )
!**   LOGICAL OPERATION
!**       Returns the number of elements of a particular structure
!**       that can be allocated if each element needs Num_real reals,
!**       Num_int integers, and Num_char characters, and if Fix_REAL,
!**       Fix_INT, and Fix_CHAR Real, Integer, and Character element also
!**       are needed.
!**   DESCRIPTION OF PARAMETERS
!**       See above.
!**

      IMPLICIT NONE
   Type (Conopt_Model_Info) CMI

   INTEGER   Num_REAL, Num_INT, Num_CHAR, Fix_REAL, FIX_INT, FIX_CHAR, NUMELE, AVAIL
   REAL      SIZER, SIZEF

   SIZER = FLOAT(Num_REAL) / CMI%NWORDR + FLOAT(Num_INT) / CMI%NWORDI + FLOAT(Num_CHAR) / CMI%NWORDC
   SIZEF = FLOAT(Fix_REAL) / CMI%NWORDR + FLOAT(FIX_INT) / CMI%NWORDI + FLOAT(FIX_CHAR) / CMI%NWORDC + 3
   AVAIL  = CMI%LATOT - CMI%LIFREE + 1 - SIZEF
   NUMELE = AVAIL / SIZER - 1

! $if defined (testout)
   IF (CMI%LOCORP.GE.1) THEN
      WRITE(CMI%MSGTXT,"('Corlft called with Num_real=',i9,' Num_int=',i9,' and Num_char=',i9)") &
         Num_REAL, Num_INT, Num_CHAR
      CALL CO2DOC( CMI, Asis )
      WRITE(CMI%MSGTXT,"('               and Fix_real=',i9,' Fix_int=',i9,' and Fix_char=',i9)") &
         Fix_REAL, FIX_INT, FIX_CHAR
      CALL CO2DOC( CMI, Asis )
      WRITE(CMI%MSGTXT,"('Available memory =',i9,' and Numele=',i9)") AVAIL, NUMELE
      CALL CO2DOC( CMI, Asis )
   ENDIF
! $endif

   END SUBROUTINE CORLFT

   SUBROUTINE CORMEM( CMI, JCODE, ICORE )
!**   LOGICAL OPERATION
!**       MANAGES THE REQUEST FOR ADDITIONAL CORE WHEN A VECTOR GROWS
!**       THE CURRENT CORE ALLOCATION IS INSUFFICIENT.
!**   DESCRIPTION OF PARAMETERS
!**       JCODE - A RETURN CODE THAT IS SET TO ZERO IF THE REQUESTED
!**               CORE WAS NOT SUPPLIED, AND 1 OTHERWISE. TYPE: IS.
!**       ICORE - THE NUMBER OF WORDS REQUESTED. THE SUBROUTINE MAY
!**               ALLOCATE CORE IN BLOCKS SO MORE THAN ICORE CAN BE
!**               ALLOCATED. LATOT IS ALWAYS UPDATED TO REFLECT THE
!**               NEW NUMBER OF WORDS AVAILABLE. TYPE: IL.
!*
      IMPLICIT NONE
   Type (Conopt_Model_Info) CMI

   INTEGER JCODE, ICORE, LATOTO
!
!  So far we only work with machines without dynamic memory
!  allocation
!
   LATOTO = CMI%LATOTT
   JCODE  = 0
! $if defined (testout)
   IF (CMI%LOCORP.GE.1) THEN
      WRITE(CMI%MSGTXT,"('Length of work space changed from',i8,' to',i8,' words.')") LATOTO, CMI%LATOTT
      CALL CO2DOC( CMI, Blb )
   ENDIF
! $endif


   END SUBROUTINE CORMEM

! $if defined (testout)
   SUBROUTINE CORPRT( CMI, IPRINT, XL, JL )
!**   LOGICAL OPERATION
!**       Prints the content of all vectors in common /CRCONM/ that are
!**       currently defined. The amount of information printed depends
!**       on the value of Iprint.
!**   DESCRIPTION OF PARAMETERS
!**       Iprint - If Iprint=1 only the positions of the vectors are
!**                printed, i.e. Knvect, Ljvect, Llvect, and Ltvect.
!**                If Iprint=2 we also print the current content of the
!**                vectors. Type: Is.
!*
      IMPLICIT NONE
   Type (Conopt_Model_Info) CMI

   REAL(CO_R) XL(*); INTEGER JL(*)

   INTEGER  IPRINT, LHDR1, LHDR2, LJVEC, LLVEC, LTVEC, LAVEC, LNVEC, LIVEC, I
   CHARACTER*4 KNVEC

   WRITE(CMI%MSGTXT,"('Memory content - base:',i8,' free:',i8,' length:',i8)") CMI%LIBAS, CMI%LIFREE, CMI%LATOT
   CALL CO2DOC( CMI, Blb )
   CMI%MSGTXT = 'NAME  FIRST WORD  LENGTH IN WORDS  BASE INDEX  LENGTH IN ELEMENTS  TYPE'
   CALL CO2DOC( CMI, Blba )
   DO I = 1, CMI%NVUSED
      LNVEC = CMI%VECTST(I)
      KNVEC = CMI%KNVECT(LNVEC)
      Call Co_Get_Vlen( CMI, Lnvec, Ljvec )
      Call Co_Get_Vstr( CMI, Lnvec, Llvec )
      LTVEC = CMI%LTVECT(LNVEC)
      LAVEC = MAX( 1, (LJVEC+CMI%LWORD(LTVEC)-1)/CMI%LWORD(LTVEC) )
      LIVEC = LLVEC / CMI%LWORD(LTVEC)+1
      WRITE(CMI%MSGTXT,"(A4,I11,I15,I13,I16,8X,A)") KNVEC, LIVEC, LAVEC, LLVEC, LJVEC, KPTYPE(LTVEC)
      CALL CO2DOC( CMI, Asis )
   ENDDO
   IF ( IPRINT.LE.1 ) RETURN
   CMI%MSGTXT = 'CONTENT OF THE VECTORS:'
   CALL CO2DOC( CMI, Blba )
   DO I = 1, CMI%NVUSED
      LNVEC = CMI%VECTST(I)
      Call Co_Get_Vstr( CMI, Lnvec, Llvec )
      IF ( CMI%LTVECT(LNVEC) .EQ. TypV_Real ) THEN
         CALL COPVRL( CMI, LNVEC, XL(LLVEC+1) )
      ELSEIF ( CMI%LTVECT(LNVEC) .EQ. TypV_Int ) THEN
         CALL COPVJL( CMI, LNVEC, JL(LLVEC+1) )
      ELSEIF ( CMI%LTVECT(LNVEC) .EQ. TypV_Char ) THEN
         CALL COPVKL( CMI, LNVEC, XL(LLVEC+1) )
      ELSE
         WRITE(CMI%MSGTXT,"(' ** Systems Error **  Illegal vector type for vector',A)") CMI%KNVECT(LNVEC)
         CALL CO2DOC( CMI, Blb )
         CALL COSYSE( CMI, 1325, .TRUE. )
      ENDIF
   ENDDO

   END SUBROUTINE CORPRT
! $endif

   SUBROUTINE CORMOV( IFROM, ITO, LENGTH, XL )
!**   LOGICAL OPERATION
!**       Moves words around in common /CRCONM/. If the move is to
!**       higher addresses the high address end is moved first to
!**       avoid overwriting.
!**   PARAMETER DESCRIPTION
!**       Ifrom  - The word number where the first word is moved from.
!**                Type: Il.
!**       Ito    - The word number where the first word is moved to.
!**                Type: Il.
!**       Length - The number of words moved. Type: Il.
!**       The input parameters are not changed.
!*
      IMPLICIT NONE

   INTEGER   IFROM, ITO, LENGTH, I1, I2, I
! $if defined (denorm)
!    INTEGER   XL(*)
!    IF ( ITO .GT. IFROM ) THEN
!
!  ITO IS GREATER THAN IFROM. MOVE THE HIGH ADDRESS END FIRST.
!
!       I1 = 2 * ( ITO   + LENGTH - 1 )
!       I2 = 2 * ( IFROM + LENGTH - 1 )
!       DO I = 1, LENGTH
!          XL(I1)   = XL(I2)
!          XL(I1-1) = XL(I2-1)
!          I1       = I1 - 2
!          I2       = I2 - 2
!       ENDDO
!    ELSE
!
!  ITO IS SMALLER THAN IFROM. MOVE THE LOW ADDRESS END FIRST.
!
!       I1 = 2 * ITO   - 1
!       I2 = 2 * IFROM - 1
!       DO I = 1, LENGTH
!          XL(I1)   = XL(I2)
!          XL(I1+1) = XL(I2+1)
!          I1       = I1 + 2
!          I2       = I2 + 2
!       ENDDO
!       ENDIF
! $else
   REAL(CO_R) XL(*)
   IF ( ITO .GT. IFROM ) THEN
!
!  ITO IS GREATER THAN IFROM. MOVE THE HIGH ADDRESS END FIRST.
!
      I1 = ITO   + LENGTH
      I2 = IFROM + LENGTH
      DO I = 1, LENGTH
         XL(I1 - I) = XL(I2 - I)
      ENDDO
   ELSE
!
!  ITO IS SMALLER THAN IFROM. MOVE THE LOW ADDRESS END FIRST.
!
      I1 = ITO   - 1
      I2 = IFROM - 1
      DO I = 1, LENGTH
         XL(I1 + I) = XL(I2 + I)
      ENDDO
   ENDIF
! $endif

   END SUBROUTINE CORMOV

   SUBROUTINE COCLEA( CMI, XL, JL )
!**   LOGICAL OPERATION
!**       Cleans up in core before returning. Is only used if the
!**       model should be kept for later restarts.
!*
   Type (conopt_model_info) CMI
   REAL(CO_R) XL(*); INTEGER JL(*)

!
!  These first five vectors may or may not be allocated, but if they
!  are, they will be in high memory
!
   CALL CORREM( CMI, CMI%LNLCL , .FALSE. )
   CALL CORREM( CMI, CMI%LNLRL , .FALSE. )
   CALL CORREM( CMI, CMI%LNSLCL, .FALSE. )
   CALL CORREM( CMI, CMI%LNSLRW, .FALSE. )
   CALL CORREM( CMI, CMI%LNOCBC, .FALSE. )

   CALL CORREM( CMI, CMI%LNLNEQ, .FALSE. )
   CALL CORREM( CMI, CMI%LNNLEQ, .FALSE. )
   CALL CORREM( CMI, CMI%LNLSTR, .FALSE. )
   CALL CORREM( CMI, CMI%LNLMAT, .FALSE. )
   CALL CORREM( CMI, CMI%LNLPIV, .FALSE. )
   CALL CORREM( CMI, CMI%LNLCOL, .FALSE. )
   CALL CORREM( CMI, CMI%LNLROW, .FALSE. )
   CALL CORREM( CMI, CMI%LNR2CP, .FALSE. )
   CALL CORREM( CMI, CMI%LNC2RP, .FALSE. )
   CALL CORREM( CMI, CMI%LNBMAT, .FALSE. )
   CALL CORREM( CMI, CMI%LNAMAT, .FALSE. )
   CALL CORREM( CMI, CMI%LNIR  , .FALSE. )
   CALL CORREM( CMI, CMI%LNIC  , .FALSE. )
   CALL CORREM( CMI, CMI%LNRHES, .FALSE. )
   CALL CORREM( CMI, CMI%LNDBND, .FALSE. )
   CALL CORREM( CMI, CMI%LNDCOL, .FALSE. )
   CALL CORREM( CMI, CMI%LNFZSL, .FALSE. )
   CALL CORREM( CMI, CMI%LNHEAP, .FALSE. )
   CALL CORREM( CMI, CMI%LNHLPZ, .FALSE. )
   CALL CORREM( CMI, CMI%LNHLP1, .FALSE. )
   CALL CORREM( CMI, CMI%LNCLMX, .FALSE. )
   CALL CORREM( CMI, CMI%LNNWK2, .FALSE. )
   CALL CORREM( CMI, CMI%LNNWKZ, .FALSE. )
   CALL CORREM( CMI, CMI%LNNWK1, .FALSE. )
   CALL CORREM( CMI, CMI%LNLSOR, .FALSE. )
   CALL CORREM( CMI, CMI%LNCLEN, .FALSE. )
   CALL CORREM( CMI, CMI%LNCSTR, .FALSE. )
   CALL CORREM( CMI, CMI%LNRLEN, .FALSE. )
   CALL CORREM( CMI, CMI%LNRSTR, .FALSE. )
   CALL CORREM( CMI, CMI%LNCBTO, .FALSE. )
   CALL CORREM( CMI, CMI%LNCOTN, .FALSE. )
   CALL CORREM( CMI, CMI%LNCNTO, .FALSE. )
   CALL CORREM( CMI, CMI%LNROTN, .FALSE. )
   CALL CORREM( CMI, CMI%LNRNTO, .FALSE. )
   CALL CORREM( CMI, CMI%LNUM  , .FALSE. )
   CALL CORREM( CMI, CMI%LNX2  , .FALSE. )
   CALL CORREM( CMI, CMI%LNX1  , .FALSE. )
   CALL CORREM( CMI, CMI%LNDSTK, .FALSE. )
   CALL CORREM( CMI, CMI%LNCSCL, .FALSE. )
   CALL CORREM( CMI, CMI%LNRWSZ, .FALSE. )
   CALL CORREM( CMI, CMI%LNOMAX, .FALSE. )
   CALL CORREM( CMI, CMI%LNOMIN, .FALSE. )
   CALL CORREM( CMI, CMI%LNGRSL, .FALSE. )
   CALL CORREM( CMI, CMI%LNGRES, .FALSE. )
   CALL CORREM( CMI, CMI%LNRWCL, .FALSE. )
   CALL CORREM( CMI, CMI%LNRGLD, .FALSE. )
   CALL CORREM( CMI, CMI%LNDIR , .FALSE. )
   CALL CORREM( CMI, CMI%LNRGRA, .FALSE. )
   CALL CORREM( CMI, CMI%LNUIN , .FALSE. )
   CALL CORREM( CMI, CMI%LNRGIN, .FALSE. )
   CALL CORREM( CMI, CMI%LNRGFR, .FALSE. )
   CALL CORREM( CMI, CMI%LNANRM, .FALSE. )
   CALL CORREM( CMI, CMI%LNCFNV, .FALSE. )
   CALL CORREM( CMI, CMI%LNCFNB, .FALSE. )
   CALL CORREM( CMI, CMI%LNIFSL, .FALSE. )
   CALL CORREM( CMI, CMI%LNLNLR, .FALSE. )
   CALL CORREM( CMI, CMI%LNSTLR, .FALSE. )
   CALL CORREM( CMI, CMI%LNRJAC, .FALSE. )
   CALL CORREM( CMI, CMI%LNRCNU, .FALSE. )
   CALL CORREM( CMI, CMI%LNLJNR, .FALSE. )
   CALL CORREM( CMI, CMI%LNXUNS, .FALSE. )
   CALL CORREM( CMI, CMI%LNVARI, .FALSE. )
   CALL CORREM( CMI, CMI%LNFUNC, .FALSE. )
!
!  These are allocated if we have used the dual option
!
   CALL CORREM( CMI, CMI%LNCOLS, .FALSE. )
   CALL CORREM( CMI, CMI%LNUBND, .FALSE. )
   CALL CORREM( CMI, CMI%LNLBND, .FALSE. )
!
!  Should these be removed? Hsvl is allocated in Cosetp should.
!  If kept, it should be allocated in Coiin where Hsrw, Hscl, and
!  Hsst are allocated.
!
   CALL CORREM( CMI, CMI%LNHSVL, .FALSE. )
!
!  The following requires movement of the upper part of memory.
!
   CALL CORREM( CMI, CMI%LNPLOG, .FALSE. )
   CALL CORREM( CMI, CMI%LNPINT, .FALSE. )
   CALL CORREM( CMI, CMI%LNPRL , .FALSE. )
   CALL CORREM( CMI, CMI%LNPCHR, .FALSE. )
   CALL CORREM( CMI, CMI%LNCODE, .FALSE. )
   CALL CORUPD( CMI, XL, JL )
!
!  Memory should now hold the following nine or ten arrays:
!  RHSV, XMIN, XMAX, XSOL, STCL, BASC, JACE, RNUM, CNUM and
!  JACT, provided the model is nonlinear.
!  If there was a Hessian (LSHSOK) then HSRW, HSCL, and HSST
!  will also be present.

!      write(CMI%MSGTXT,*) 'Memory After Coclea:'
!      CALL CO2DOC( CMI, Blb )
!      CALL CORPRT( CMI, 1, XL, JL )

   END SUBROUTINE COCLEA


   SUBROUTINE COABPR( CMI, XSOL, DX, XMIN, XMAX, CBTO, THETA )
!**   Logical Operation
!**       Adjust the non-triangular basic variables in the
!**       direction Dx, and projects the solution on the
!**       bounds. A critical variable is always moved to the
!**       bound:
!**       XSOL(ICOL) = XSOL(ICOL) + THETA*DX(ICOL)
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R)  XSOL(*), DX(*), XMIN(*), XMAX(*), THETA
   INTEGER CBTO(*)

   INTEGER INDX, ICOL

   IF ( THETA .EQ. ONE ) THEN
      DO INDX = CMI%LKTRIA+1, CMI%LJNROW
         ICOL = CBTO(INDX)
         XSOL(ICOL) = MIN( XMAX(ICOL), MAX( XMIN(ICOL), XSOL(ICOL) + DX(ICOL) ) )
      ENDDO
   ELSE
      DO INDX = CMI%LKTRIA+1, CMI%LJNROW
         ICOL = CBTO(INDX)
         XSOL(ICOL) = MIN( XMAX(ICOL), MAX( XMIN(ICOL), XSOL(ICOL) + THETA * DX(ICOL) ) )
      ENDDO
   ENDIF
   IF ( CMI%LJCLCR .NE. 0 ) XSOL(CMI%LJCLCR) = CMI%RVBDCR

   END SUBROUTINE COABPR

   SUBROUTINE COBEPR( CMI, XSOL, XBAS, DX, XMIN, XMAX, CBTO, THETA )
!**   Logical Operation
!**       Makes a linear extrapolation of the non-triangular
!**       basic variables and projects the result on the bounds:
!**       XSOL(ICOL) = XBAS(ICOL) + THETA*DX(ICOL)
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R)  XSOL(*), XBAS(*), DX(*), XMIN(*), XMAX(*), THETA
   INTEGER CBTO(*)

   INTEGER INDX, ICOL

   IF ( THETA .EQ. ONE ) THEN
      DO INDX = CMI%LKPRET+1, CMI%LJNROW
         ICOL = CBTO(INDX)
         XSOL(ICOL) = MIN( XMAX(ICOL), MAX( XMIN(ICOL), XBAS(ICOL) + DX(ICOL) ) )
      ENDDO
   ELSE
      DO INDX = CMI%LKPRET+1, CMI%LJNROW
         ICOL = CBTO(INDX)
         XSOL(ICOL) = MIN( XMAX(ICOL), MAX( XMIN(ICOL), XBAS(ICOL) + THETA * DX(ICOL) ) )
      ENDDO
   ENDIF

   END SUBROUTINE COBEPR

   SUBROUTINE COBIPR( CMI, XSOL, X1, X2, XMIN, XMAX, CBTO, F1, F2 )
!**   Logical Operation
!**       Makes a linear interpolation of the non-triangular
!**       basic variables and projects the result on the bounds:
!**       XSOL(ICOL) = F1 * X1(ICOL) + F2 * X2(ICOL)
!**       where it is known that F1 + F2 = 1 (but one of them may
!**       be negative).
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R)  XSOL(*), X1(*), X2(*), XMIN(*), XMAX(*), F1, F2
   INTEGER CBTO(*)

   INTEGER INDX, ICOL

   DO INDX = CMI%LKPRET+1, CMI%LJNROW
      ICOL = CBTO(INDX)
      XSOL(ICOL) = MIN( XMAX(ICOL), MAX( XMIN(ICOL), F1 * X1(ICOL) + F2 * X2(ICOL) ) )
   ENDDO

   END SUBROUTINE COBIPR

   SUBROUTINE COB3PR( CMI, XSOL, X1, X2, XMIN, XMAX, CBTO, F1, F2, F3 )
!*****COB3PR
!**   Logical Operation
!**       Makes an interpolation of the non-triangular basic
!**       variables using three points and projects the result
!**       on the bounds:
!**       XSOL(ICOL) = F1 * X1(ICOL) + F2 * X2(ICOL) + F3 * XSOL(ICOL)
!**       where the last point is overwritten.
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R)  XSOL(*), X1(*), X2(*), XMIN(*), XMAX(*), F1, F2, F3
   INTEGER CBTO(*)

   INTEGER INDX, ICOL

   DO INDX = CMI%LKPRET+1, CMI%LJNROW
      ICOL = CBTO(INDX)
      XSOL(ICOL) = MIN( XMAX(ICOL), &
                        MAX( XMIN(ICOL), F1 * X1(ICOL) + F2 * X2(ICOL) + F3 * XSOL(ICOL) ) )
   ENDDO

   END SUBROUTINE COB3PR

   SUBROUTINE COLIPR( CMI, XSOL, XBAS, DX, XMIN, XMAX, MAP, LMAP, THETA )
!**   Logical Operation
!**       Makes a linear indirectly addressed extrapolation of
!**       some variables and projects the result on the bounds.
!**       Can be used for Superbasics:
!**       XSOL(MAP(INDX)) = XBAS(MAP(INDX)) + THETA*DX(INDX)
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R)  XSOL(*), XBAS(*), DX(*), XMIN(*), XMAX(*), THETA
   INTEGER MAP(*), LMAP

   INTEGER INDX, ICOL

   IF ( THETA .EQ. ONE ) THEN
      DO INDX = 1, LMAP
         ICOL = MAP(INDX)
         XSOL(ICOL) = MIN( XMAX(ICOL), MAX( XMIN(ICOL), XBAS(ICOL) + DX(INDX) ) )
      ENDDO
   ELSE
      DO INDX = 1, LMAP
         ICOL = MAP(INDX)
         XSOL(ICOL) = MIN( XMAX(ICOL), MAX( XMIN(ICOL), XBAS(ICOL) + THETA * DX(INDX) ) )
      ENDDO
   ENDIF

   END SUBROUTINE COLIPR

   SUBROUTINE COAIPR( CMI, XSOL, DX, XMIN, XMAX, MAP, LMAP, THETA )
!**   Logical Operation
!**       Adjusts some indirectly addressed variables and projects
!**       the result on the bounds. Only Xsol is mapped. Dx is
!         direct. Can be used for Superbasics:
!**       XSOL(MAP(INDX)) = XSOL(MAP(INDX)) + THETA*DX(INDX)
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R)  XSOL(*), DX(*), XMIN(*), XMAX(*), THETA
   INTEGER MAP(*), LMAP

   INTEGER INDX, ICOL

   IF ( THETA .EQ. ONE ) THEN
      DO INDX = 1, LMAP
         ICOL = MAP(INDX)
         XSOL(ICOL) = MIN( XMAX(ICOL), MAX( XMIN(ICOL), XSOL(ICOL) + DX(INDX) ) )
      ENDDO
   ELSE
      DO INDX = 1, LMAP
         ICOL = MAP(INDX)
         XSOL(ICOL) = MIN( XMAX(ICOL), MAX( XMIN(ICOL), XSOL(ICOL) + THETA * DX(INDX) ) )
      ENDDO
   ENDIF

   END SUBROUTINE COAIPR

   SUBROUTINE COA2PR( CMI, XSOL, DX, XMIN, XMAX, MAP, LMAP, THETA )
!**   Logical Operation
!**       Adjusts some indirectly addressed variables and projects
!**       the result on the bounds. Both Xsol and DX are mapped:
!**       XSOL(MAP(INDX)) = XSOL(MAP(INDX)) + THETA*DX(MAP(INDX))
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R)  XSOL(*), DX(*), XMIN(*), XMAX(*), THETA
   INTEGER MAP(*), LMAP

   INTEGER INDX, ICOL

   IF ( THETA .EQ. ONE ) THEN
      DO INDX = 1, LMAP
         ICOL = MAP(INDX)
         XSOL(ICOL) = MIN( XMAX(ICOL), MAX( XMIN(ICOL), XSOL(ICOL) + DX(ICOL) ) )
      ENDDO
   ELSE
      DO INDX = 1, LMAP
         ICOL = MAP(INDX)
         XSOL(ICOL) = MIN( XMAX(ICOL), MAX( XMIN(ICOL), XSOL(ICOL) + THETA * DX(ICOL) ) )
      ENDDO
   ENDIF

   END SUBROUTINE COA2PR

   SUBROUTINE COSWB2( CMI, X1, X2, CBTO )
!**   Logical Operation
!**      Swap the basic non pre-triangular positions in two vectors.
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R)  X1(*), X2(*)
   INTEGER CBTO(*)

   INTEGER INDX, ICOL
   REAL(CO_R)  XHOLD

   DO INDX = CMI%LKPRET+1, CMI%LJNROW
      ICOL = CBTO(INDX)
      XHOLD    = X1(ICOL)
      X1(ICOL) = X2(ICOL)
      X2(ICOL) = XHOLD
   ENDDO

   END SUBROUTINE COSWB2

   SUBROUTINE COSWB3( CMI, X1, X2, X3, CBTO )
!**   Logical Operation
!**      Swap the basic non pre-triangular positions of three
!**      vectors:
!**      X1 <- X2
!**      X2 <- X3
!**      X3 <- X1
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R)  X1(*), X2(*), X3(*)
   INTEGER CBTO(*)

   REAL(CO_R)  XHOLD
   INTEGER INDX, ICOL

   DO INDX = CMI%LKPRET+1, CMI%LJNROW
      ICOL = CBTO(INDX)
      XHOLD    = X1(ICOL)
      X1(ICOL) = X2(ICOL)
      X2(ICOL) = X3(ICOL)
      X3(ICOL) = XHOLD
   ENDDO

   END SUBROUTINE COSWB3

   SUBROUTINE COMVBS( CMI, XFROM, XTO, CBTO )
!**   Logical Operation
!**      Move the basic non pre-triangular positions in one vector
!**      into the same positions in a second vector.
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R)  XFROM(*), XTO(*)
   INTEGER CBTO(*)

   INTEGER INDX, ICOL

   DO INDX = CMI%LKPRET+1, CMI%LJNROW
      ICOL      = CBTO(INDX)
      XTO(ICOL) = XFROM(ICOL)
   ENDDO

   END SUBROUTINE COMVBS

   SUBROUTINE CONWSC( CMI, XL, JL )
!**   Logical Operation
!**       Scales the Newton tolerances. Is called at regular
!**       intervals from Conwtn and Coscal and initially from Coffs.
!**
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R) XL(*); INTEGER JL(*)

   INTEGER J, ICOL

   CMI%LKNWMJ = CMI%LKITER + CMI%LFNWMJ
   IF ( CMI%LSSCAL ) RETURN
!
!  Compute the largest Jacobian Element and the Largest Jacobian term.
!
   CMI%RVJACM = 1.D0
   CMI%RVJACX = 1.D0

   CALL CORDEF( CMI, CMI%LNLW  , CMI%LJNCOL )
   IF ( CMI%LSSPAC ) THEN
      CALL COMKVR( CMI, JL(CMI%LLLW  +1), XL, JL )
      DO J = 1, CMI%LKJACE
         ICOL = JL(CMI%LLCNUM+J)
         IF ( JL(CMI%LLLW  +ICOL) .NE. 0 .AND.    &
              JL(CMI%LLLW  +CMI%LJNSTR+JL(CMI%LLRNUM+J)) .NE. 0 ) THEN
            CMI%RVJACM = MAX( CMI%RVJACM, ABS( XL(CMI%LLJACE+J) ) )
            CMI%RVJACX = MAX( CMI%RVJACX, ABS( XL(CMI%LLJACE+J) * XL(CMI%LLXSOL+ICOL) ) )
         ENDIF
      ENDDO
   ELSE
      CMI%LSSPAC = .TRUE.
   ENDIF
   CALL CORREM( CMI, CMI%LNLW  , .TRUE. )
   CALL CORUPD( CMI, XL, JL )

   CMI%RTNWAF = SQRT( MAX( 1.D0, CMI%RVJACM / 1.D2, CMI%RVJACX / 1.D4 ) )

! $if defined (testout)
   IF ( CMI%LONEWT + CMI%LOSCAL + CMI%LOFFS .GT. 0 ) THEN
      WRITE(CMI%MSGTXT,"('Adjustment of RTNWMJ. Initial RTNWMJ =',1p,e18.10,' and Rvnwmi=',1p,e18.10)") &
         CMI%RTNWMJ, CMI%RTNWMI
      CALL CO2DOC( CMI, Asis )
      WRITE(CMI%MSGTXT,"(30x,'RVJACM=',1p,e18.10,' and RVJACX=',1p,e18.10)") CMI%RVJACM, CMI%RVJACX
      CALL CO2DOC( CMI, Asis )
      WRITE(CMI%MSGTXT,"(30x,'RTNWAF=',1p,e18.10)") CMI%RTNWAF
      CALL CO2DOC( CMI, Asis )
   ENDIF
! $endif
!
!  The minimum newton tolerance must be at least RTEPSM times the
!  largest term * 16, and the maximum must be at least 4 times as
!  large.
!
   CMI%RTNWMJ = MAX( CMI%RTNWMI * CMI%RTNWAF, 16.D0 * CMI%RTEPSM * MAX(CMI%RVJACM,CMI%RVJACX) )
   IF ( CMI%LJPHAS .EQ. 1 ) THEN
      CMI%RTNWMB = CMI%RTNWMD * CMI%RTNWAF
   ELSE
      CMI%RTNWMB = CMI%RTNWMC * CMI%RTNWAF
   ENDIF
   CMI%RTNWMB = MAX( CMI%RTNWMB, CMI%RTNWMJ*4.D0 )

   CMI%RTNEW  = MIN( CMI%RTNWMB, MAX( CMI%RTNEW, CMI%RTNWMJ ) )
   CMI%RTBNDI = MAX( CMI%RTBND1 / CMI%RTNWAF, CMI%RTEPSM * 16. )
! $if defined (testout)
   IF ( CMI%LONEWT + CMI%LOSCAL + CMI%LOFFS .GT. 0 ) THEN
      WRITE(CMI%MSGTXT,*) 'LKNWMJ=',CMI%LKNWMJ,' and final RTNWMJ=',CMI%RTNWMJ
      CALL CO2DOC( CMI, Asis )
      WRITE(CMI%MSGTXT,*) 'RTBNDI=',CMI%RTBNDI,' and RTNEW=',CMI%RTNEW
      CALL CO2DOC( CMI, Asis )
      WRITE(CMI%MSGTXT,*) 'RTNWMA=',CMI%RTNWMA,' and RTNWMB=',CMI%RTNWMB
      CALL CO2DOC( CMI, Asis )
      WRITE(CMI%MSGTXT,*) 'RTNWMC=',CMI%RTNWMC,' and RTNWMD=',CMI%RTNWMD
      CALL CO2DOC( CMI, Asis )
   ENDIF
! $endif

   END SUBROUTINE CONWSC

! $if defined (testout)
   SUBROUTINE CONWDB( CMI, STATUS, EDF, XL, JL )
!**   Logical Operation
!**       Prints debugging information for Conwtn
!**   Description of parameters
!**       STATUS - Character string that contains "Initial"
!**                or "       ".
!**
      IMPLICIT NONE
    Type (conopt_model_info) CMI
   REAL(CO_R) XL(*); INTEGER JL(*)
   CHARACTER*(*) STATUS
   REAL(CO_R)  EDF

   INTEGER IFDX
   INTEGER IROWMI, IROWME
   REAL(CO_R)  MAXERR, MAXINF

   IF ( STATUS .EQ. '      ' ) THEN
      IFDX = 2
   ELSE
      IFDX = 0
   ENDIF
   WRITE(CMI%MSGTXT,"(A7,' sum of absolute residuals=',1p,e20.10)") STATUS, CMI%RVGLCM
   CALL CO2DOC( CMI, Asis )
   WRITE(CMI%MSGTXT,"(A7,' maximal residual=',1p,e29.10,' Feas=',L2)") STATUS, CMI%RVGMAX, &
                CMI%RVGMAX .LE. CMI%RTNEW
   CALL CO2DOC( CMI, Asis )
   WRITE(CMI%MSGTXT,"('and estimated error in objective:' ,1p,e21.10,' Feas=',L2)") EDF, &
                ABS(EDF) .LE. CMI%RTOBJT
   CALL CO2DOC( CMI, Asis )
   IF ( CMI%LONEWT .GT. 3 ) THEN
      CALL COERIN( CMI, MAXINF, MAXERR, IROWMI, IROWME, XL, JL )
      IF ( IROWMI .EQ. 0 .AND. IROWME .EQ. 0 ) THEN
         CMI%MSGTXT = 'No infeasible rows.'
         CALL CO2DOC( CMI, Asis )
      ELSE
         WRITE(CMI%MSGTXT,"('Max. Infeasibility=',1P,E12.4,' in row',I6)") MAXINF, IROWMI
         CALL CO2DOC( CMI, Asis )
         WRITE(CMI%MSGTXT,"('Max. Error        =',1P,E12.4,' in row',I6)") MAXERR, IROWME
         CALL CO2DOC( CMI, Asis )
         IF ( IFDX .EQ. 0 .AND. CMI%LSX2TN ) THEN
            CALL COJAC2( CMI, IROWMI, CMI%RVTHE3, XL, JL )
            IF ( IROWMI .NE. IROWME ) CALL COJAC2( CMI, IROWME, CMI%RVTHE3, XL, JL )
         ELSE
            CALL COJACI( CMI, IROWMI, IFDX, XL(CMI%LLX1  +1), XL, JL )
            IF ( IROWMI .NE. IROWME ) CALL COJACI( CMI, IROWME, IFDX, XL(CMI%LLX1   +1), XL, JL )
         ENDIF
         IF ( CMI%LONEWT .GT. 4 ) CALL COPVRL( CMI, CMI%LNGRES, XL(CMI%LLGRES+1) )
      ENDIF
   ENDIF

   END SUBROUTINE CONWDB
! $endif

   SUBROUTINE COERIN( CMI, MAXINF, MAXERR, IROWMI, IROWME, XL, JL )
!**   LOGICAL OPERATION
!**       Finds the rows with the largest infeasibility and the
!**       largest estemated error. Only non-triangular rows are
!**       included.
!**   DESCRIPTION OF PARAMETERS (ALL OUTPUT)
!**       MAXINF - The value of the largest infeasibility
!**       MAXERR - The value of the largest estimated error
!**       IROWMI - The row in which maxinf is found
!**       IROWME - The row in which irowme is found
!**
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R) XL(*); INTEGER JL(*)
   REAL(CO_R)  MAXINF, MAXERR
   INTEGER IROWMI, IROWME

   INTEGER IROW, INDX
   REAL(CO_R)  ABSERR

   MAXINF = -1.D0
   MAXERR = -1.D0
   IROWMI = 0
   IROWME = 0

   DO INDX = CMI%LKTRIA+1, CMI%LJNROW
      IROW = JL(CMI%LLRNTO+INDX)
      IF ( ABS( XL(CMI%LLGRES+IROW) ) .GT. MAXINF ) THEN
         MAXINF = ABS( XL(CMI%LLGRES+IROW) )
         IROWMI = IROW
      ENDIF
      ABSERR = ABS( XL(CMI%LLGRES+IROW) * XL(CMI%LLUM  +IROW) )
      IF ( ABSERR .GT. MAXERR ) THEN
         MAXERR = ABSERR
         IROWME = IROW
      ENDIF
   ENDDO

   END SUBROUTINE COERIN

! $if defined (testout)
   SUBROUTINE COJACI( CMI, IROWMI , IFDX, DELX, XL, JL )
!**   LOGICAL OPERATION
!**      PRINTS INFORMATION ABOUT ROW IROWMI OF THE JACOBIAN
!**      INCLUDING DERIVATIVE VALUES, EXPECTED CHANGES, AND
!**      DISTANCES TO BOUND
!**   DESCRIPTION OF PARAMETERS
!**       IROWMI - THE NUMBER OF THE INTERESTING ROW.
!**       IFDX   - An integer with the following interpretation:
!**                0 - No change information is available
!**                1 - The prefered change in variable Icol is zero
!**                    if non-basic and otherwise in Delx(Icol)
!**                2 - The prefered change in variable Icol is zero
!**                    if non-basic and otherwise Grsl(Rnto(Indx))
!**                    where Icol=Cbto(indx).
!**
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R) XL(*); INTEGER JL(*)
   INTEGER IROWMI, IFDX
   REAL(CO_R)  DELX(*)

   INTEGER J, ICOL, INDX
   LOGICAL NLJAC
   REAL(CO_R)  DXBND, DJAC, DJACB, DX, X2, DJACA, ROWSCL

   DJAC  = 0.D0
   DJACA = 0.D0
   DJACB = 0.D0
   NLJAC = .FALSE.
   IF ( CMI%LSSCAL ) THEN
      WRITE(CMI%MSGTXT,"('Information about row',I6,'. Residual=',1P,E17.10,' u=',1P,E17.10,' Scale=',1p,E15.8)") &
         IROWMI, XL(CMI%LLGRES+IROWMI), XL(CMI%LLUM  +IROWMI), XL(CMI%LLCSCL+CMI%LJNSTR+IROWMI)
      ROWSCL = XL(CMI%LLRWSZ+IROWMI)
   ELSE
      WRITE(CMI%MSGTXT,"('Information about row',I6,'. Residual=',1P,E17.10,' u=',1P,E17.10)") &
         IROWMI, XL(CMI%LLGRES+IROWMI), XL(CMI%LLUM  +IROWMI)
      ROWSCL = 1.D0
   ENDIF
   CALL CO2DOC( CMI, Asis )
   IF ( CMI%LJPHAS .LE. 1 ) THEN
      WRITE(CMI%MSGTXT,"('Rwsz=',1p,e15.8,' Ifsl=',i2)") ROWSCL, JL(CMI%LLIFSL+IROWMI)
   ELSE
      WRITE(CMI%MSGTXT,"('Rwsz=',1p,e15.8)") ROWSCL
   ENDIF
   CALL CO2DOC( CMI, Asis )
   CMI%MSGTXT = '   col bs nl      Jac               Xsol               Dx             Dxbnd'
   IF ( CMI%LSSCAL ) THEN
      CMI%MSGTXT = '   col bs nl      Jac               Xsol               Dx             Dxbnd          Scale'
   ELSE
      CMI%MSGTXT = '   col bs nl      Jac               Xsol               Dx             Dxbnd'
   ENDIF
   CALL CO2DOC( CMI, Asis )
   DO J = 1, CMI%LJCNUM
      IF ( JL(CMI%LLRNUM+J) .EQ. IROWMI ) THEN
         ICOL = JL(CMI%LLCNUM+J)
         IF ( .NOT. CMI%LSLINR ) NLJAC = JL(CMI%LLJACT+J) .NE. 0
         IF ( IFDX .EQ. 0 .OR. JL(CMI%LLBASC+ICOL) .LE. 0 ) THEN
            WRITE(CMI%MSGTXT,"(I6,L2,L3,1P,E16.8,E20.12,E16.8,E16.8,E16.8)") &
               ICOL, JL(CMI%LLBASC+ICOL) .GT. 0, NLJAC, XL(CMI%LLJACE+J), XL(CMI%LLXSOL+ICOL)
         ELSE
            IF ( IFDX .EQ. 1 ) THEN
               X2 = DELX(ICOL)
            ELSE
               DO INDX = CMI%LKTRIA+1, CMI%LJNROW
                  IF ( ICOL .EQ. JL(CMI%LLCBTO+INDX) ) GO TO 101
               ENDDO
101            X2 = -XL(CMI%LLGRSL+JL(CMI%LLRNTO+INDX))
            ENDIF
            IF ( X2 .GT. 0.D0 ) THEN
               DXBND = XL(CMI%LLXMAX+ICOL) - XL(CMI%LLX1  +ICOL)
               DX    = MIN( X2 , DXBND )
            ELSEIF ( X2 .LT. 0.D0 ) THEN
               DXBND = XL(CMI%LLXMIN+ICOL) - XL(CMI%LLX1  +ICOL)
               DX    = MAX( X2 , DXBND )
            ELSE
               DXBND = 0.D0
               DX    = 0.D0
            ENDIF
            DJAC  = DJAC  + XL(CMI%LLJACE+J) * X2
            DJACA = DJACA + ABS( XL(CMI%LLJACE+J) * X2 )
            DJACB = DJACB + XL(CMI%LLJACE+J) * DX
            IF ( CMI%LSSCAL ) THEN
               WRITE(CMI%MSGTXT,"(I6,L2,L3,1P,E16.8,E20.12,E16.8,E16.8,2E16.8)") &
                  ICOL, JL(CMI%LLBASC+ICOL) .GT. 0, NLJAC, XL(CMI%LLJACE+J), &
                  XL(CMI%LLXSOL+ICOL),  X2, DXBND, XL(CMI%LLCSCL+ICOL)
            ELSE
               WRITE(CMI%MSGTXT,"(I6,L2,L3,1P,E16.8,E20.12,E16.8,E16.8,E16.8)") &
                  ICOL, JL(CMI%LLBASC+ICOL) .GT. 0, NLJAC, XL(CMI%LLJACE+J), &
                  XL(CMI%LLXSOL+ICOL),  X2, DXBND
            ENDIF
         ENDIF
         CALL CO2DOC( CMI, Asis )
      ENDIF
   ENDDO
   IF ( IFDX .NE. 0 ) THEN
      WRITE(CMI%MSGTXT,"('Expected change=',1P,E18.8,' Projected=',1P,E18.8)") DJAC, DJACB
      CALL CO2DOC( CMI, Asis )
      WRITE(CMI%MSGTXT,"('Absolute sum   =',1P,E18.8,' Exp./Abss=',1P,E18.8)") DJACA, ABS(DJAC)/MAX(1.D-30,DJACA)
      CALL CO2DOC( CMI, Asis )
   ENDIF

   END SUBROUTINE COJACI

   SUBROUTINE COJAC2( CMI, IROWMI, STEP, XL, JL )
!**   LOGICAL OPERATION
!**      Prints information about row Irowmi and the Jacobian
!**      values, variable values, variable changes, and tangent
!**      direction
!**      Cojac2 can be called inside Conwtn before any Newton
!**      iterations have been taken. X1 = Base solution, Xsol =
!**      trial solution, and X2 = tangent.
!**   DESCRIPTION OF PARAMETERS
!**       IROWMI - THE NUMBER OF THE INTERESTING ROW.
!**       STEP   - The steplength taken
!**
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R) XL(*); INTEGER JL(*)
   INTEGER IROWMI
   REAL(CO_R)  STEP

   INTEGER J, ICOL, INDX, IR
   REAL(CO_R)  X2, DJACTN, DJACDX, ROWSCL
   Character*1 Stat, Lin

   DJACTN = 0.D0
   DJACDX = 0.D0
   WRITE(CMI%MSGTXT,"('Information about row',I6,'. Residual=',1P,E17.10,' u=',1P,E17.10)") &
      IROWMI, XL(CMI%LLGRES+IROWMI), XL(CMI%LLUM  +IROWMI)
   CALL CO2DOC( CMI, Asis )
   IF ( CMI%LSSCAL ) THEN
      ROWSCL = XL(CMI%LLRWSZ+IROWMI)
   ELSE
      ROWSCL = 1.D0
   ENDIF
   IF ( CMI%LJPHAS .LE. 1 ) THEN
      WRITE(CMI%MSGTXT,"('Rwsz=',1p,e15.8,' Ifsl=',i2)") ROWSCL, JL(CMI%LLIFSL+IROWMI)
   ELSE
      WRITE(CMI%MSGTXT,"('Rwsz=',1p,e15.8)") ROWSCL
   ENDIF
   CALL CO2DOC( CMI, Asis )
   CMI%MSGTXT = &
 '   col bs nl      Jac               Xbas              Xsol             Tang              Min              Max'
   CALL CO2DOC( CMI, Asis )
   DO J = 1, CMI%LJCNUM
      IF ( JL(CMI%LLRNUM+J) .EQ. IROWMI ) THEN
         ICOL = JL(CMI%LLCNUM+J)
         X2   = XL(CMI%LLX2  +ICOL)
         Lin  = 'L'
         IF ( .NOT. CMI%LSLINR ) THEN
            IF ( JL(CMI%LLJACT+J) .NE. 0 ) Lin = 'N'
         ENDIF
         IF ( JL(CMI%LLBASC+ICOL) .GT. 0 ) THEN
            Stat = 'B'
         ELSE
            DO IR = 1, CMI%LKNSUP
               IF ( ICOL .EQ. JL(CMI%LLRGFR+IR) ) THEN
                  STAT = 'S'
                  GO TO 100
               ENDIF
            ENDDO
            STAT = 'N'
            X2   = 0.D0
100         CONTINUE
         ENDIF
         DJACTN = DJACTN + XL(CMI%LLJACE+J) * X2
         DJACDX = DJACTN + XL(CMI%LLJACE+J) * (XL(CMI%LLXSOL+ICOL) - XL(CMI%LLX1  +ICOL))
         WRITE(CMI%MSGTXT,"(I6,1X,A1,2X,A1,1P,E16.8,E20.12,E16.8,3E16.8)") &
            ICOL, STAT, LIN, XL(CMI%LLJACE+J)   , XL(CMI%LLX1  +ICOL), &
            XL(CMI%LLXSOL+ICOL), X2, XL(CMI%LLXMIN+ICOL), XL(CMI%LLXMAX+ICOL)
         CALL CO2DOC( CMI, Asis )
      ENDIF
   ENDDO
   WRITE(CMI%MSGTXT,"('Steplength                  =',1P,E18.8)") STEP
   CALL CO2DOC( CMI, Asis )
   WRITE(CMI%MSGTXT,"('Expected change from tangent=',1P,E18.8)") DJACTN
   CALL CO2DOC( CMI, Asis )
   WRITE(CMI%MSGTXT,"('Expected change from delta X=',1P,E18.8)") DJACDX
   CALL CO2DOC( CMI, Asis )

   END SUBROUTINE COJAC2
! $endif

   SUBROUTINE COMKVR( CMI, LW, XL, JL )
!*****Logical operation
!**       Marks the columns not to be scaled or used in computing
!**       the variability of the Jacobian because they are pre-
!*        or post-triangular or fixed by Lw = 0. The rows that
!**       are not included are marked with Lw = 0 in the slack
!**       columns.
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R) XL(*); INTEGER JL(*)
   INTEGER LW(*)

   INTEGER ICOL, INDX

   DO ICOL = 1, CMI%LJNCOL
      LW(ICOL) = 1
   ENDDO
!
!  Mark the columns not to be scaled because they are pre-
!  or post-triangular or fixed by Lw = 0 and mark the rows
!  that are not included with Lw = 0 in the slack columns.
!
   DO INDX = 1, CMI%LKTRIA
      LW(JL(CMI%LLCBTO+INDX))        = 0
      LW(CMI%LJNSTR+JL(CMI%LLRNTO+INDX)) = 0
   ENDDO
   DO ICOL = 1, CMI%LJNSTR
      IF ( XL(CMI%LLXMIN+ICOL) .EQ. XL(CMI%LLXMAX+ICOL) ) LW(ICOL) = 0
   ENDDO

   END SUBROUTINE COMKVR

   SUBROUTINE COBCHN( CMI, IN, OUT, XL, JL )
!**   Logical operation
!**       Records a basis change by checking and updating Basc and
!**       Fzsl
!**   Description of parameters
!**       In  - The column to enter the basis. This is an original
!**             column number between 1 and LJNCOL.
!**       Out - The column to leave the basis. This is also an original
!**             column number between 1 and LJNCOL.
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R) XL(*); INTEGER JL(*)
   INTEGER IN, OUT

   IF ( JL(CMI%LLBASC+OUT) .NE. 2 ) THEN
      write(CMI%MSGTXT,*) '** Error in Cobchn. Leaving column', out, ' has Basc=',jl(CMI%LLBASC+out)
      CALL CO2DOC( CMI, Asis )
      CALL COSYSE( CMI,985, .TRUE. )
      RETURN
   ELSEIF ( JL(CMI%LLBASC+IN) .GT. 0 ) THEN
      write(CMI%MSGTXT,*) '** Error in Cobchn. Entering column', in, ' has Basc=',jl(CMI%LLBASC+in)
      CALL CO2DOC( CMI, Asis )
      CALL COSYSE( CMI,984, .TRUE. )
      RETURN
   ENDIF
   IF ( IN .GT. CMI%LJNSTR ) THEN
      IF ( JL(CMI%LLFZSL+IN-CMI%LJNSTR) .EQ. 1 ) THEN
         WRITE(CMI%MSGTXT,*) '** Error in Cobchn. Entering column', in, ' is a frozen slack'
         CALL CO2DOC( CMI, Asis )
         CALL COSYSE( CMI,987, .TRUE. )
         RETURN
      ENDIF
   ENDIF

   JL(CMI%LLBASC+IN)  = 2
   IF ( XL(CMI%LLXMIN+OUT) .EQ. XL(CMI%LLXMAX+OUT) ) THEN
      JL(CMI%LLBASC+OUT) = -1
   ELSE
      JL(CMI%LLBASC+OUT) = 0
   ENDIF

   END SUBROUTINE COBCHN

   SUBROUTINE COEEC( CMI, COLNO, MSG )

      IMPLICIT NONE
   Type (conopt_model_info) CMI

   INTEGER      COLNO, COL1, OTHER
   CHARACTER*(CO_ILineLen) MSG

   INTEGER      MSGLEN

   CALL CONOUT( CMI )
   MSGLEN = MAX(1, LEN_TRIM(MSG) )
   IF ( CMI%LSBAS0 ) THEN
      COL1  = COLNO - 1
      OTHER = -1
   ELSE
      COL1  = COLNO
      OTHER = 0
   ENDIF
! $if defined (write20)
!    write(20,"('Variable',i6,': ',A)") col1, trim(msg)
! $endif
   CALL CALL_ErrMsg( CMI%CB_ErrMsg, OTHER, COL1, OTHER, MSGLEN, CMI%USRERR, CMI%CB_USRMEM, MSG )
   IF ( CMI%USRERR .NE. 0 ) THEN
!
! ** Fatal error ** ErrMsg routine returned Error=,(i1)
!
      CALL CONMSG( CMI, 4012, 0.D0, 0.D0, CMI%USRERR, 0, .TRUE., .TRUE. )
   ENDIF

   END SUBROUTINE COEEC

   SUBROUTINE COEER( CMI, ROWNO, MSG )

      IMPLICIT NONE
   Type (conopt_model_info) CMI
   INTEGER      ROWNO, ROW1, OTHER
   CHARACTER*(CO_ILineLen) MSG

   INTEGER      MSGLEN

   CALL CONOUT( CMI )
   MSGLEN = MAX(1, LEN_TRIM(MSG) )
   IF ( CMI%LSBAS0 ) THEN
      ROW1  = ROWNO - 1
      OTHER = -1
   ELSE
      ROW1  = ROWNO
      OTHER = 0
   ENDIF
! $if defined (write20)
!    write(20,"('Constrnt',i6,': ',A)") row1, trim(msg)
! $endif
   CALL CALL_ErrMsg( CMI%CB_ErrMsg, ROW1, OTHER, OTHER, MSGLEN, CMI%USRERR, CMI%CB_USRMEM, MSG )
   IF ( CMI%USRERR .NE. 0 ) THEN
!
! ** Fatal error ** ErrMsg routine returned Error=,(i1)
!
      CALL CONMSG( CMI, 4012, 0.D0, 0.D0, CMI%USRERR, 0, .TRUE., .TRUE. )
   ENDIF

   END SUBROUTINE COEER

   SUBROUTINE COEENZ( CMI, COLNO, ROWNO, POSNO, MSG )

      IMPLICIT NONE
   Type (Conopt_Model_Info) CMI
   INTEGER      COLNO, ROWNO, POSNO
   INTEGER      COL1 , ROW1 , POS1
   CHARACTER*(CO_ILineLen) MSG

   INTEGER      MSGLEN

   CALL CONOUT( CMI )
   MSGLEN = MAX(1, LEN_TRIM(MSG) )
   IF ( CMI%LSBAS0 ) THEN
      ROW1 = ROWNO - 1
      COL1 = COLNO - 1
      POS1 = POSNO - 1
   ELSE
      ROW1 = ROWNO
      COL1 = COLNO
      POS1 = POSNO
   ENDIF
! $if defined (write20)
!    write(20,"('Jac(',i6,',',i6,'): ',A)") row1, col1, trim(msg)
! $endif
   CALL CALL_ErrMsg( CMI%CB_ErrMsg, ROW1, COL1, POS1, MSGLEN, CMI%USRERR, CMI%CB_USRMEM, MSG )
   IF ( CMI%USRERR .NE. 0 ) THEN
!
! ** Fatal error ** ErrMsg routine returned Error=,(i1)
!
      CALL CONMSG( CMI, 4012, 0.D0, 0.D0, CMI%USRERR, 0, .TRUE., .TRUE. )
   ENDIF

   END SUBROUTINE COEENZ

   SUBROUTINE COSSSP( CMI, IROWP, ICOLP, POS, XL, JL )
!**   LOGICAL OPERATION
!**       Handles Square Systems with Small Pivot.
!**       Will essentially record the error and write the error
!**       message.
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R) XL(*); INTEGER JL(*)
   INTEGER ICOLP, IROWP, POS

   CHARACTER*(CO_ILineLen) MSG
!
! ** Error in Square System: Pivot too small.
!
   CALL CONMSG( CMI, 2140, 0.D0, 0.D0, 0, 0, .TRUE., .TRUE. )
!
!  The message about the pivot uses COEER/COEEC when there is
!  no well defined nonzero:
!
   MSG = 'Pivot too small.'
   IF ( POS .EQ. 0 ) THEN
      CALL COEER( CMI, IROWP, MSG )
      IF ( CMI%USRERR .NE. 0 ) RETURN
      CALL COEEC( CMI, ICOLP, MSG )
   ELSE
      CALL COEENZ( CMI, ICOLP, IROWP, POS, MSG )
   ENDIF

   CMI%LJSTAT = 21
   CMI%LSNSQR = .TRUE.
   CMI%LSSQSI = .TRUE. 
   CMI%LSIMSG = .TRUE.
   CMI%LJSROW = IROWP
   CMI%LJSCOL = ICOLP
   CMI%LBRNCH = 2

   END SUBROUTINE COSSSP

! $if defined (testout)
   SUBROUTINE COPRSC( CMI, AMAT, XL, JL )
!**   LOGICAL OPERATION
!**       Prints the distribution of the sizes of the Jacobian
!**       elements.
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R) XL(*); INTEGER JL(*)
   REAL(CO_R)  AMAT(*)

   INTEGER, PARAMETER :: NNUM = 20
   INTEGER INDX, J, NZ, IROW, ICOL, ADD, NZA, NUMBER(NNUM), NUMEPR(NNUM)
   REAL(CO_R)  SMALL, LARGE, JAC

!
!  Number count the total number of Jacobian elements of a certain
!         size.
!  Numepr counts the number of Jacobian elements excluding the
!         pre- and post-triangular rows marked with Lw = 0.
!
   DO J = 1, NNUM
      NUMBER(J) = 0
      NUMEPR(J) = 0
   ENDDO
   NZ    = CMI%LJCNUM - CMI%LJNROW
   NZA   = 0  
   SMALL = CMI%RTMINJ
   DO J = 1, NZ
      JAC = ABS( AMAT(J) )
      IF ( JL(CMI%LLLW  +JL(CMI%LLCNUM+J)) .NE. 0 .AND. &
           JL(CMI%LLLW  +CMI%LJNSTR+JL(CMI%LLRNUM+J)) .NE. 0 ) THEN
         ADD = 1
      ELSE
         ADD = 0
      ENDIF
      NZA = NZA + ADD
      IF ( JAC .EQ. 0.D0 ) THEN
         NUMBER(1) = NUMBER(1) + 1
         NUMEPR(1) = NUMEPR(1) + ADD
      ELSEIF ( JAC .LE. SMALL ) THEN
         NUMBER(2) = NUMBER(2) + 1
         NUMEPR(2) = NUMEPR(2) + ADD
      ELSE
         INDX = LOG10( JAC / SMALL ) + 2.501
         INDX = MIN(INDX,NNUM)
         NUMBER(INDX) = NUMBER(INDX) + 1
         NUMEPR(INDX) = NUMEPR(INDX) + ADD
      ENDIF
   ENDDO
   LARGE = SMALL
   SMALL = 0.D0
   CMI%MSGTXT = ' Distribution of Jacobian sizes:'
   CALL CO2DOC( CMI, Blb )
   CMI%MSGTXT = '  From       To   Number   %   Exc.Tr.  %'
   CALL CO2DOC( CMI, Asis )
   WRITE(CMI%MSGTXT,"(1p,e8.1,1p,e9.1,i6,0p,f6.1,i7,f6.1)") SMALL, SMALL, &
      NUMBER(1), 1.D2 * NUMBER(1) / NZ, NUMEPR(1), 1.D2 * NUMEPR(1) / MAX(1, NZA)
   CALL CO2DOC( CMI, Asis )
   DO J = 2, NNUM
      WRITE(CMI%MSGTXT,"(1p,e8.1,1p,e9.1,i6,0p,f6.1,i7,f6.1)") SMALL, LARGE, &
         NUMBER(J), 1.D2 * NUMBER(J) / NZ, NUMEPR(J), 1.D2 * NUMEPR(J) / MAX(1, NZA)
      CALL CO2DOC( CMI, Asis )
      SMALL = LARGE
      LARGE = LARGE * 10.D0
   ENDDO
   WRITE(CMI%MSGTXT,"('Total elements',i9,6x,i7)") NZ, NZA
   CALL CO2DOC( CMI, Asis )
   IF ( CMI%LSSCAL ) RETURN
   IF ( CMI%LJCSCL .LT. CMI%LJNCOL ) RETURN 
                                            ! vector or allocate memory
   DO ICOL = 1, CMI%LJNCOL
      XL(CMI%LLCSCL+ICOL) = 0.D0
   ENDDO
   DO J = 1, NZ
      JAC = ABS( AMAT(J) )
      INDX = JL(CMI%LLRNUM+J) + CMI%LJNSTR
      XL(CMI%LLCSCL+INDX) = MAX( XL(CMI%LLCSCL+INDX), JAC )
      INDX = JL(CMI%LLCNUM+J)
      XL(CMI%LLCSCL+INDX) = MAX( XL(CMI%LLCSCL+INDX), JAC )
   ENDDO
   DO J = 1, NNUM
      NUMBER(J) = 0
   ENDDO
   SMALL = 1.D-6
   DO IROW = 1, CMI%LJNROW
      JAC = XL(CMI%LLCSCL+CMI%LJNSTR+IROW)
      IF ( JAC .EQ. 0.D0 ) THEN
         NUMBER(1) = NUMBER(1) + 1
      ELSEIF ( JAC .LE. SMALL ) THEN
         NUMBER(2) = NUMBER(2) + 1
      ELSE
         INDX = LOG10( JAC / SMALL ) + 2.501
         INDX = MIN(INDX,NNUM)
         NUMBER(INDX) = NUMBER(INDX) + 1
      ENDIF
   ENDDO
   LARGE = SMALL
   SMALL = 0.D0
   CMI%MSGTXT = ' Distribution of maximum Jacobian in each row:'
   CALL CO2DOC( CMI, Blb )
   CMI%MSGTXT = '  From       To   Number   %'
   CALL CO2DOC( CMI, Asis )
   WRITE(CMI%MSGTXT,"(1p,e8.1,1p,e9.1,i6,0p,f6.1,i7,f6.1)") SMALL, SMALL, &
      NUMBER(1), 1.D2 * NUMBER(1) / CMI%LJNROW
   CALL CO2DOC( CMI, Asis )
   DO J = 2, NNUM
      WRITE(CMI%MSGTXT,"(1p,e8.1,1p,e9.1,i6,0p,f6.1,i7,f6.1)") SMALL, LARGE, &
         NUMBER(J), 1.D2 * NUMBER(J) / CMI%LJNROW
      CALL CO2DOC( CMI, Asis )
      SMALL = LARGE
      LARGE = LARGE * 10.
   ENDDO
   DO J = 1, NNUM
      NUMBER(J) = 0
   ENDDO
   SMALL = 1.D-6
   DO ICOL = 1, CMI%LJNSTR
      JAC = XL(CMI%LLCSCL+ICOL)
      IF ( JAC .EQ. 0.D0 ) THEN
         NUMBER(1) = NUMBER(1) + 1
      ELSEIF ( JAC .LE. SMALL ) THEN
         NUMBER(2) = NUMBER(2) + 1
      ELSE
         INDX = LOG10( JAC / SMALL ) + 2.501
         INDX = MIN(INDX,NNUM)
         NUMBER(INDX) = NUMBER(INDX) + 1
      ENDIF
   ENDDO
   LARGE = SMALL
   SMALL = 0.D0
   CMI%MSGTXT = ' Distribution of maximum Jacobian in each column:'
   CALL CO2DOC( CMI, Blb )
   CMI%MSGTXT = '  From       To   Number   %'
   CALL CO2DOC( CMI, Asis )
   WRITE(CMI%MSGTXT,"(1p,e8.1,1p,e9.1,i6,0p,f6.1,i7,f6.1)") SMALL, SMALL, &
      NUMBER(1), 1.D2 * NUMBER(1) / CMI%LJNSTR
   CALL CO2DOC( CMI, Asis )
   DO J = 2, NNUM
      WRITE(CMI%MSGTXT,"(1p,e8.1,1p,e9.1,i6,0p,f6.1,i7,f6.1)") SMALL, LARGE, &
         NUMBER(J), 1.D2 * NUMBER(J) / CMI%LJNSTR
      CALL CO2DOC( CMI, Asis )
      SMALL = LARGE
      LARGE = LARGE * 10.
   ENDDO
   DO ICOL = 1, CMI%LJNCOL
      XL(CMI%LLCSCL+ICOL) = ONE
   ENDDO

   END SUBROUTINE COPRSC
! $endif

   REAL FUNCTION CORNDX( CMI )
!**   LOGICAL OPERATION
!**       Generates a random number between 0. and 1. using a
!**       simple multiplicative generator.
!**   DESCRIPTION OF FUNCTION VALUE.
!**       CORNDX - Returns the random number as a single precision
!**                real.
!**   ABNORMAL CONDITIONS
!**       Assumes that an integer has at least 31 bits. If not
!**       the multiplication inside the mod may overflow.
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI

   CMI%LKSEED = MOD(CMI%LKSEED*1027+25,1048576)
   CORNDX = FLOAT(CMI%LKSEED)/FLOAT(1048576)

   END FUNCTION CORNDX

   SUBROUTINE COEOPT( CMI )
!**   Logical Operation
!**       Calls the user's option defining subroutine and
!**       sets CONOPT options.
!**   Abnormal condiotions
!**       Ignores the first 20 errors. Unknown names and cr-cells
!**       that are not allowed to be reset are counted as error.
!**       After that it stops without reaching the end of the
!**       option list.
!**
      IMPLICIT NONE
   Type (conopt_model_info) CMI

   CHARACTER*8  NAME
   CHARACTER*8, PARAMETER :: KNVERB = 'SET     '
   CHARACTER*10 LNAME1, LNAME2
   REAL(CO_R)   RVAL
   INTEGER      IVAL
   INTEGER      IP, NERROR, NBLK, IPOS, LEN, NCALL, UERROR
   LOGICAL      LVAL, ERROR

   IF ( CMI%CB_Option == 0 ) RETURN
   NERROR = 0
   ERROR  = .FALSE.
   IF ( CMI%LSBAS0 ) THEN
      NCALL  = -1
   ELSE
      NCALL  = 0
   ENDIF
100 NCALL  = NCALL + 1
   CALL CONOUT( CMI ) 
   IF ( CMI%USRERR .NE. 0 ) RETURN
   CALL CALL_Option( CMI%CB_Option, NCALL, RVAL, IVAL, LVAL, CMI%USRERR, CMI%CB_USRMEM, NAME )
   IF ( CMI%USRERR .NE. 0 ) THEN
!
! ** Fatal error ** Option routine returned Error=,(i1)
!
      CALL CONMSG( CMI, 4018, 0.D0, 0.D0, CMI%USRERR, 0, .TRUE., .TRUE. )
      RETURN
   ENDIF
   IF ( NAME .NE. ' ' ) THEN
      LNAME1 = NAME
      CALL COCLB( LNAME1, LNAME2 )
      CALL COCUP( LNAME2, LNAME1, LEN )
      CALL COCCR( CMI, LNAME1, IP )
      IF ( CMI%CRNAME(IP) .NE. ' ' ) THEN
         NBLK = CMI%CRDESC(CR_TYPE ,IP)
         IPOS = CMI%CRDESC(CR_INDEX,IP)
         IF ( CMI%CRDESC(CR_RESET,IP) .EQ. 0 ) THEN
!
!  This is a CR-cells, but it cannot be reset.
!
            ERROR = .TRUE.
            CMI%MSGV(1) = ' ** Option name "' // LNAME1(1:LEN) // '" cannot be reset.'
         ELSE
            CALL COESET( CMI, NBLK, IPOS, IVAL, RVAL, LVAL, 1 )
            CALL COECRP( CMI, 0, KNVERB, CMI%CRNAME(IP), IVAL, RVAL, LVAL, NBLK )
! $if defined (write20)
!             if ( nblk .eq. TYPC_INT ) THEN
!                write(20,"('Option ',A,' set to',I6)") LNAME1(1:LEN), IVAL
!             elseif ( nblk .eq. TYPC_LOG ) THEN
!                write(20,"('Option ',A,' set to',L2)") LNAME1(1:LEN), LVAL
!             elseif ( nblk .eq. TYPC_REAL ) THEN
!                write(20,"('Option ',A,' set to',1p,e20.10)") LNAME1(1:LEN), RVAL
!             endif
! $endif
         ENDIF
      ELSE
!
!  This is not a valid CR-cell.
!
         ERROR = .TRUE.
         CMI%MSGV(1) = ' ** Option name "' // LNAME1(1:LEN) // '" is unknown.'
      ENDIF
      IF ( ERROR ) THEN
         CMI%SMSG = 1
         CMI%DMSG = 1
         CMI%NMSG = 1
         CALL CONOUT( CMI )
         ERROR    = .FALSE.
         NERROR   = NERROR + 1
         IF ( NERROR .GE. 20 ) RETURN
      ENDIF
      GO TO 100
   ENDIF

   END SUBROUTINE COEOPT

   SUBROUTINE COI2C( I, CH, LEN )
!**   LOGICAL OPERATION
!**       This subroutine converts an integer into a character
!**       string and returns its length.
!**   DESCRIPTION OF PARAMETERS
!**       I   - The integer to be converted into a character
!**             string
!**       CH  - The character string of fixed length 12 used to
!**             return I.
!**       LEN - The length of the output character string. Only
!**             the first LEN characters in CH are defined.
!*
      IMPLICIT NONE
   INTEGER I, LEN
   CHARACTER*12 CH

   INTEGER J
   CHARACTER*12 CH1

   WRITE(CH1,"(I12)") I
   DO J = 1, 12
      IF ( CH1(J:J) .NE. ' ' ) GO TO 101
   ENDDO
101 LEN = 13-J
   CH(1:LEN) = CH1(J:12)

   END SUBROUTINE COI2C

   SUBROUTINE COR2C( R, CH, W, D, LEN )
!**   LOGICAL OPERATION
!**       This subroutine converts a real into a character string
!**       with prespecified width and decimals and returns its
!**       final length.
!**   DESCRIPTION OF PARAMETERS
!**       R   - The real to be converted into a character string.
!**       CH  - The character string of fixed length 20 used to
!**             return R.
!**       W   - The target width of the output.
!**       D   - The number of decimals in the output. R is
!**             converted using a GW.D format and all blanks are
!**             removed before the result is returned in CH.
!**       LEN - The length of the output character string. Only
!**             the first LEN characters in CH are defined.
!*
      IMPLICIT NONE
   REAL(CO_R)      R
   CHARACTER*20 CH
   INTEGER     W, D, LEN

   CHARACTER*2  I2C(20)
   CHARACTER*11 FORM
   INTEGER      I, J
   CHARACTER*20 CH1

   DATA I2C / '01','02','03','04','05','06','07','08','09','10',   &
              '11','12','13','14','15','16','17','18','19','20' /

   FORM = '(1P,G' // I2C(W) // '.' // I2C(D) // ')'
   WRITE(CH1,FORM) R
   DO I = 1, W
      IF ( CH1(I:I) .NE. ' ' ) GO TO 101
   ENDDO
101 DO J = W, 1, -1
      IF ( CH1(J:J) .NE. ' ' ) GO TO 103
   ENDDO
103 LEN = J - I + 1
   CH(1:LEN) = CH1(I:J)

   END SUBROUTINE COR2C

   SUBROUTINE COR2F( R, CH, W, D )
!**   LOGICAL OPERATION
!**       This subroutine converts a real into a character string
!**       with prespecified width and decimals and returns its
!**       final length. Uses F-format.
!**   DESCRIPTION OF PARAMETERS
!**       R   - The real to be converted into a character string.
!**       CH  - The character string of fixed length 20 used to
!**             return R.
!**       W   - The target width of the output.
!**       D   - The number of decimals in the output. R is
!**             converted using a GW.D format and all blanks are
!**             removed before the result is returned in CH.
!*
      IMPLICIT NONE
   REAL(CO_R)      R
   CHARACTER*20 CH
   INTEGER     W, D

   CHARACTER*8 FORM
   CHARACTER*2  I2C(20)

   DATA I2C / '01','02','03','04','05','06','07','08','09','10',  &
              '11','12','13','14','15','16','17','18','19','20' /

   FORM = '(F' // I2C(W) // '.' // I2C(D) // ')'
   WRITE(CH,FORM) R

   END SUBROUTINE COR2F

   SUBROUTINE CONOUT( CMI )
!     Logical Operation
!         This subroutine passes the lines in Msgv to the user-written
!         Message routine for further processing.
!
      IMPLICIT NONE
   Type (conopt_model_info) CMI

   INTEGER   LEN, I, ERROR
   LOGICAL   PRINT
   INTEGER   LLEN(Max_Msg)

   IF ( CMI%SMSG .EQ. 0 .AND. CMI%DMSG .EQ. 0 ) RETURN
!
!  Find the length of the lines
!
   DO I = 1, MAX( CMI%SMSG, CMI%DMSG )
      LLEN(I) = MAX(1,LEN_TRIM(CMI%MSGV(I)))
! $if defined (write20)
!       write(20,"(A)") TRIM(CMI%MSGV(I))
! $endif
   ENDDO
   ERROR = 0

   CALL CALL_Message( CMI%CB_Message, CMI%SMSG, CMI%DMSG, CMI%NMSG, LLEN, ERROR, CMI%CB_USRMEM, CMI%MSGV(1) )

   CMI%SMSG = 0
   CMI%DMSG = 0
   CMI%NMSG = 0

   IF ( ERROR .NE. 0 ) THEN
!
!  If there were errors, use write(*,*) if OK. Other message methods
!  cannot be used.
!
      IF ( CMI%ERRORS == 1 ) THEN
         WRITE(*,*)
         WRITE(*,*) ' ** Fatal error ** Message routine returned Error=',ERROR
         WRITE(*,*)
      ENDIF
      IF ( CMI%USRERR .EQ. 0 ) CMI%USRERR = ERROR
   ENDIF

   END SUBROUTINE CONOUT

   SUBROUTINE COCLMX( CMI, XL, JL )
!**   Logical Operation
!**       Computes Clmx, an estimate of the required accuracy for
!**       each individual variable. The accuracy is defined to
!**       be the change in the variable that will change the
!**       largest infeasibility by 0.1*RTNEW and/or the largest
!**       error in objective by 0.1*RTOBJT. The last term is only
!**       included if duals are defined, i.e. if LJPHAS > 0 and
!**       if RTNEW > RTNWMJ (since the objective is not included
!**       in feasibility tests when RTNEW = RTNWMJ).
!**       Derivatives smaller than 0.1 are counted as 0.1 to avoid
!**       very large Clmx values that can push variables around
!**       by large amounts.
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R) XL(*); INTEGER JL(*)

   INTEGER IROW, ICOL, J
   REAL(CO_R)  R1, R2, R3, S

   IF ( CMI%LJPHAS .GT. 0 .AND. CMI%RTNEW .GT. CMI%RTNWMJ ) THEN
      R1 = CMI%RTOBJT / CMI%RTNEW
      R2 = R1     * 0.1D0
      R3 = CMI%RTOBJT * 0.1D0
! $if defined (testout)
      IF ( CMI%LOCLMX .GT. 0 ) THEN
         WRITE(CMI%MSGTXT,*) 'Coclmx: RTOBJT=',CMI%RTOBJT,' RTNEW=',CMI%RTNEW
         CALL CO2DOC( CMI, Asis )
         WRITE(CMI%MSGTXT,*) 'Coclmx: R1=',R1,' and R2=',R2
         CALL CO2DOC( CMI, Asis )
         WRITE(CMI%MSGTXT,*) 'Coclmx: R3=',R3,' and R3/R1=',R3/R1
         CALL CO2DOC( CMI, Asis )
         WRITE(CMI%MSGTXT,*) 'Coclmx: R3/R2=',R3/R2,' RVJACM=',CMI%RVJACM
         CALL CO2DOC( CMI, Asis )
      ENDIF
! $endif
      DO ICOL = 1, CMI%LJNSTR
         S = R2
         DO J = JL(CMI%LLSTCL+ICOL), JL(CMI%LLSTCL+ICOL+1)-1
            S = MAX( S, ABS( XL(CMI%LLJACE+J) ) *   &
                        MAX( R1, ABS( XL(CMI%LLUM  +JL(CMI%LLRNUM+J) ) ) ) )
         ENDDO
         XL(CMI%LLCLMX+ICOL) = R3 / S
      ENDDO
      DO IROW = 1, CMI%LJNROW
         XL(CMI%LLCLMX+CMI%LJNSTR+IROW) = R3 / MAX( R1 , ABS( XL(CMI%LLUM  +IROW) ) )
      ENDDO
   ELSE
      R3 = MAX( CMI%RTNWMJ, MIN( CMI%RTNEW , CMI%RVGMAX * 0.1D0) ) * 0.1D0
! $if defined (testout)
      IF ( CMI%LOCLMX .GT. 0 ) THEN
         WRITE(CMI%MSGTXT,*) 'Coclmx: R3=',r3
         CALL CO2DOC( CMI, Asis )
      ENDIF
! $endif
      DO ICOL = 1, CMI%LJNSTR
         S = 0.1D0
         DO J = JL(CMI%LLSTCL+ICOL), JL(CMI%LLSTCL+ICOL+1)-1
            S = MAX( S, ABS( XL(CMI%LLJACE+J) ) )
         ENDDO
         XL(CMI%LLCLMX+ICOL) = R3 / S
      ENDDO
      DO IROW = 1, CMI%LJNROW
         XL(CMI%LLCLMX+CMI%LJNSTR+IROW) = R3
      ENDDO
   ENDIF
! $if defined (testout)
   IF ( CMI%LOCLMX .GT. 1 ) THEN
      CALL COPVRL( CMI, CMI%LNCLMX, XL(CMI%LLCLMX+1) )
   ENDIF
! $endif

   END SUBROUTINE COCLMX

   SUBROUTINE COMVPR( CMI, FROMRI, XL, JL )
!**   Logical operation
!**       Moves the fixed pre-triangular columns from the Jacobian
!**       to Lmat where they form the first part of the L-factor of
!**       the basis. Also move the pivots into singleton rows in U.
!**   DESCRIPTION OF PARAMETERS
!**      Fromri - Logical variable that is true if Comprv is called
!**               from Corinv and false if called from Coinv2.
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R) XL(*); INTEGER JL(*)
   LOGICAL   FROMRI

   INTEGER   ICOL, INDX, ICOLP, IROWP, LEN, ISTART, JMM, IEND, UINDX
   REAL(CO_R)    PIVOT

!      write(CMI%MSGTXT,*) 'Entering Comvpr. LKPRET=',CMI%LKPRET,' Fromri=',fromri
!      CALL CO2DOC( CMI, Asis )
   IF ( .NOT. FROMRI ) THEN
      CMI%LKLUIN = CMI%LJIR   + 1
      DO INDX = 1, CMI%LKPRET
         IROWP             = JL(CMI%LLRNTO+INDX)
         CMI%LKLUIN            = CMI%LKLUIN - 1
         JL(CMI%LLRSTR+IROWP)  = CMI%LKLUIN
         JL(CMI%LLRLEN+IROWP)  = 1
         JL(CMI%LLCSTR+INDX)   = 1
         JL(CMI%LLCLEN+INDX)   = 0
      ENDDO
   ENDIF
   ICOLP  = 0
   DO INDX = 1, CMI%LKPRET
      ICOL              = JL(CMI%LLCBTO+INDX)
      IROWP             = JL(CMI%LLRNTO+INDX)
!     WRITE(CMI%MSGTXT,*) 'Pre-triangular ',ICOL,' moved directly to L'
!     CALL CO2DOC( CMI, Asis )
      UINDX             = JL(CMI%LLRSTR+IROWP)
      JL(CMI%LLIC  +UINDX)  = INDX
      ISTART            = JL(CMI%LLSTCL+ICOL)
      IEND              = JL(CMI%LLSTCL+ICOL+1) - 1
      LEN               = IEND - ISTART + 1
!     write(CMI%MSGTXT,*) 'Istart,Iend,Len',istart,iend,len
!     CALL CO2DOC( CMI, Asis )
      IF ( LEN .EQ. 1 ) THEN
         XL(CMI%LLAMAT+UINDX) = XL(CMI%LLJACE+ISTART)
!        WRITE(CMI%MSGTXT,*) 'L-column ',ICOL,' row',IROWP,' Pivot=',xl(CMI%LLAMAT+uindx),' Len=',len
!        CALL CO2DOC( CMI, Asis )
      ELSE
!
!  Move the column to Nwk2, extract the pivot element, and move
!  the rest of the column to L while dividing by the pivot.
!
         DO JMM = ISTART, IEND
            XL(CMI%LLNWK2+JL(CMI%LLRNUM+JMM)) = XL(CMI%LLJACE+JMM)
         ENDDO
         ICOLP             = ICOLP + 1
         PIVOT             = XL(CMI%LLNWK2+IROWP)
         XL(CMI%LLAMAT+UINDX)  = PIVOT
         IF ( JL(CMI%LLLSOR+ICOLP) + LEN -1 .NE. JL(CMI%LLLSOR+ICOLP+1) ) THEN
            write(CMI%MSGTXT,*) 'Icolp=',icolp,' Lsor=', JL(CMI%LLLSOR+ICOLP),  &
                                ' Lsor(Icolp+1)=',jl(CMI%LLLSOR+icolp+1)
            CALL CO2DOC( CMI, Asis )
            CALL COSYSE( CMI,141, .TRUE. )
            RETURN
         ENDIF
!        WRITE(CMI%MSGTXT,*) 'L-column ',ICOL,' row',IROWP,' Pivot=',pivot,' Len=',len
!        CALL CO2DOC( CMI, Asis )
         DO JMM = JL(CMI%LLLSOR+ICOLP), JL(CMI%LLLSOR+ICOLP+1)-1
            XL(CMI%LLLMAT+JMM) = XL(CMI%LLNWK2+JL(CMI%LLLROW+JMM)) / PIVOT
!           write(CMI%MSGTXT,*) 'Row',jl(CMI%LLLROW+jmm),': L(',jmm,')=', xl(CMI%LLLMAT+jmm)
!           CALL CO2DOC( CMI, Asis )
         ENDDO
      ENDIF
   ENDDO

   END SUBROUTINE COMVPR

   SUBROUTINE COSIN0( CMI, FOBJ, XL, JL )
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R) XL(*); INTEGER JL(*)
   REAL(CO_R)  FOBJ

   INTEGER IROW, ICOL

   FOBJ = 0.D0
   DO IROW = 1,CMI%LJNROW
      IF ( JL(CMI%LLIFSL+IROW) .NE. 0 ) THEN
         ICOL = CMI%LJNSTR + IROW
         IF     ( XL(CMI%LLXSOL+ICOL) .LT. XL(CMI%LLOMIN+IROW) ) THEN
            FOBJ = FOBJ + XL(CMI%LLOMIN+IROW) - XL(CMI%LLXSOL+ICOL)
         ELSEIF ( XL(CMI%LLXSOL+ICOL) .GT. XL(CMI%LLOMAX+IROW) ) THEN
            FOBJ = FOBJ + XL(CMI%LLXSOL+ICOL) - XL(CMI%LLOMAX+IROW)
         ENDIF
      ENDIF
   ENDDO

   END SUBROUTINE COSIN0

   SUBROUTINE Block_of_PostTria( CMI, Ifrom, Ito, INewcr, XCR, PRINT, CHANGE, XL, JL )
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R) XL(*); INTEGER JL(*)

   INTEGER Ifrom, Ito, INEWCR
   LOGICAL PRINT, CHANGE
   REAL(CO_R)  XCR

   INTEGER FROM, TO, I, J, IROW, ICOL, IROW1, INDX, ROWNEW
   REAL(CO_R)  FERROR, DX

!  write(cmi%msgtxt,*) 'Inside Block_of_PostTria. Ifrom=',Ifrom,' and Ito=',Ito,' Lsintr=',cmi%lsintr;call co2doc(cmi,asis)
   CHANGE = .FALSE.
   TO     = CMI%LKTRIA + 1 - IFROM
   FROM   = CMI%LKTRIA + 1 - ITO
   CALL CONST3( CMI, .TRUE., FROM, TO, 0, FERROR, XL, JL )
   CMI%LSNPTZ = .FALSE.
   IF ( CMI%LSFCER ) THEN 
                          ! We could run through them one at a time to get better
                          ! function values and therefore recursive variables, but it is
                          ! hardly useful.
   !  write(cmi%msgtxt,*) 'Error returned from CONST3.'; call co2doc(cmi,asis)
      IF ( INEWCR .EQ. 0 ) THEN
         INEWCR = -1
      ENDIF
      IF ( PRINT ) THEN
         CMI%LSFCER = .FALSE.  
      ELSE
         RETURN                
      ENDIF
   ELSE 
      DO I = Ifrom, Ito
         IROW = JL(CMI%LLRNTO+CMI%LKTRIA+1-I)
      !  write(cmi%msgtxt,*) 'I=',I,' Row',irow,' with Gres=',XL(CMI%LLGRES+IROW);call co2doc(cmi,asis)
         IF ( XL(CMI%LLGRES+IROW) .NE. 0.D0 ) THEN
            CHANGE = .TRUE.
            ICOL   = JL(CMI%LLRWCL+IROW)
!
!  We use the element from the U-factor of the Basis. This is
!  ok because it is constant and it is therefore always up to
!  date.
!
            DX     = - XL(CMI%LLGRES+IROW) / XL(CMI%LLAMAT+JL(CMI%LLRSTR+IROW))
            XL(CMI%LLGRES+IROW) = 0.D0
            XL(CMI%LLXSOL+ICOL) = XL(CMI%LLXSOL+ICOL) + DX
         !  write(cmi%msgtxt,*) 'Col',icol,' with DX=',DX;call co2doc(cmi,asis)
!
!  If the triangular variable exceeds infinity, then
!  - report the first in Inewcr and Xcr
!  - reset the value to 'infinity', and
!  - if print is true, i.e. this is a final solution, then
!    recalculate the residual to be used during output.
!
            IF ( XL(CMI%LLXSOL+ICOL) .GT. CMI%RTMAXV ) THEN
               IF ( INEWCR .EQ. 0 ) THEN
                  INEWCR = CMI%LKTRIA+1-I
                  XCR    = XL(CMI%LLXSOL+ICOL)
               ENDIF
            !  write(cmi%msgtxt,*) 'Icol=',icol,' greater than max. Inewcr=',inewcr;call co2doc(cmi,asis)
               IF ( PRINT ) XL(CMI%LLGRES+IROW) =  &
                  ( CMI%RTMAXV - XL(CMI%LLXSOL+ICOL) ) * XL(CMI%LLAMAT+JL(CMI%LLRSTR+IROW))
               DX = DX + CMI%RTMAXV - XL(CMI%LLXSOL+ICOL)
               XL(CMI%LLXSOL+ICOL) = CMI%RTMAXV
            ELSEIF ( XL(CMI%LLXSOL+ICOL) .LT. -CMI%RTMAXV ) THEN
               IF ( INEWCR .EQ. 0 ) THEN
                  INEWCR = CMI%LKTRIA+1-I
                  XCR    = XL(CMI%LLXSOL+ICOL)
               ENDIF
            !  write(cmi%msgtxt,*) 'Icol=',icol,' less than min. Inewcr=',inewcr;call co2doc(cmi,asis)
               IF ( PRINT ) XL(CMI%LLGRES+IROW) = &
                  ( -CMI%RTMAXV - XL(CMI%LLXSOL+ICOL) ) * XL(CMI%LLAMAT+JL(CMI%LLRSTR+IROW))
               DX = DX - CMI%RTMAXV - XL(CMI%LLXSOL+ICOL)
               XL(CMI%LLXSOL+ICOL) = -CMI%RTMAXV
            ENDIF
            DO J = JL(CMI%LLSTCL+ICOL), JL(CMI%LLSTCL+ICOL+1)-1
               IROW1 = JL(CMI%LLRNUM+J)
               ROWNEW = JL(CMI%LLROTN+IROW1)
               INDX  = CMI%LKTRIA+1-ROWNEW
            !  write(cmi%msgtxt,*) 'J=',j,' Row1=',irow1,' Rownew=',Rownew,' Indx=',indx;call co2doc(cmi,asis)
               IF ( INDX .GT. I .AND. INDX .LE. ITO ) THEN
               !  write(cmi%msgtxt,*) 'Row1',irow1,' Gres from',XL(CMI%LLGRES+IROW1),' to',XL(CMI%LLGRES+IROW1) + DX*XL(CMI%LLJACE+J)
               !  call co2doc(cmi,asis)
                  XL(CMI%LLGRES+IROW1) = XL(CMI%LLGRES+IROW1) + DX*XL(CMI%LLJACE+J)
               ELSE
               !  write(cmi%msgtxt,*) 'Row1',irow1,' Skipped.';  call co2doc(cmi,asis)
               ENDIF
            ENDDO
            IF ( CMI%LSSCAL .AND. ICOL .LE. CMI%LJNSTR ) &
               XL(CMI%LLXUNS+ICOL) = XL(CMI%LLXSOL+ICOL) * XL(CMI%LLCSCL+ICOL)
         ENDIF
      ENDDO
   ENDIF

   END SUBROUTINE Block_of_PostTria

   SUBROUTINE COADJP( CMI, CHANGE, INEWCR, XCR, PRINT, XL, JL )
!**       Adjusts the post triangular columns so that the equations
!**       are satisfied exactly.
!**   DESCRIPTION OF PARAMETERS
!**       Change - A logical variable that on entry is .true. if
!**                the current point has changed since the last
!**                reinversion. In this case we force a reinversion
!**                in this routine.
!**       Inewcr - If a post triangular variable exceeds infinity
!**                then the first such variable is reported in
!**                Inewcr (new number). Also, LJSTAT is set to
!**                19 and LBRNCH to 3.
!**                If a function evaluation error occurs first then
!**                Inewcr is returned as the negative of the
!**                critical equation.
!**       Xcr    - Returns the value that the critical triangular
!**                variable should have taken. The real value is
!**                set to + or -RTMAXV.
!**       Print  - Logical variable that controls if error
!**                messages should be printed when a variable
!**                exceeds infinity (input). It is only false when
!**                Coadjp is called from Conwtn.
!**   Abnormal conditions
!**       Sets LJSTAT to 19 and returns of a free variable exceeds
!**       infinity. Also writes the proper error message. Sets
!**       LBRNCH to 3.
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R) XL(*); INTEGER JL(*)

   INTEGER IROW, ICOL, J, I, INEWCR
   LOGICAL CHANGE, PRINT, INIERR
   REAL(CO_R)  DX, XCR
   REAL(CO_R)  GMAX_HLD, GLCM_HLD
   CHARACTER*(CO_ILineLen) MSG
   INTEGER IFROM, ITO

   GMAX_HLD = CMI%RVGMAX 
   GLCM_HLD = CMI%RVGLCM 
   INEWCR = 0
   IF ( CMI%LKPOST .LE. 0 ) RETURN
   INIERR     = CMI%LSFCER
   IF ( CMI%LKTRIA .EQ. CMI%LJNROW .AND. CMI%LSSCAL ) THEN  
      DO ICOL = 1, CMI%LJNSTR
         XL(CMI%LLXUNS+ICOL) = XL(CMI%LLXSOL+ICOL) * XL(CMI%LLCSCL+ICOL)
      ENDDO
   ENDIF
   CMI%LSINTR = .FALSE.           
   CMI%LSXUOK = CMI%LKITER .GT. 1 
   IF ( CMI%LSLINC ) THEN
      IF ( CMI%LKPRET + CMI%LKPOST .NE. CMI%LJNROW .AND. CMI%LSFVCN ) THEN
         CMI%LSNPTZ = .TRUE. 
      ENDIF
   ELSE
      CMI%LSNPTZ = .TRUE. 
   ENDIF
   IFROM = 1
   DO I = 1, CMI%LKPOST-1
      IF ( JL(CMI%LLPLVL+I+1) .GT. JL(CMI%LLPLVL+IFROM) ) THEN
         CALL Block_of_PostTria( CMI, Ifrom, I, INEWCR, XCR, PRINT, CHANGE, XL, JL )
         IF ( CMI%USRERR .NE. 0 ) RETURN
         IF ( INEWCR .LT. 0 ) EXIT
         Ifrom = I + 1
      ENDIF
   ENDDO
   IF ( INEWCR .GE. 0 ) THEN
      CALL Block_of_PostTria( CMI, Ifrom, CMI%LKPOST, INEWCR, XCR, PRINT, CHANGE, XL, JL )
      IF ( CMI%USRERR .NE. 0 ) RETURN
   ENDIF
   CMI%RVGMAX = GMAX_HLD 
   CMI%RVGLCM = GLCM_HLD 
   CMI%LSXUOK = .FALSE.
   CMI%LSNPTZ = .FALSE.
   IF ( INEWCR .GT. 0 ) THEN
      CMI%LJSTAT = 19
      CMI%LBRNCH = 3
      IF ( PRINT ) THEN
         ICOL = JL(CMI%LLCBTO+INEWCR)
         IF ( ICOL .LE. CMI%LJNSTR ) THEN
            MSG = 'Free variable becomes too large'
            CALL COEEC( CMI, ICOL, MSG )
         ELSE
            IROW = ICOL - CMI%LJNSTR
            MSG = 'Free slack becomes too large'
            CALL COEER( CMI, IROW, MSG )
         ENDIF
         IF ( CMI%USRERR .NE. 0 ) RETURN
!
! ** Infeasible solution. A free variable exceeds the allowable range.'
!    Current value is ,r2, and current upper bound (RTMAXV) is ,r1
!
         CALL CONMSG( CMI, 2125, CMI%RTMAXV, XCR, 0, 0, .TRUE., .FALSE. )
!    The allowable range can be changed with a line:
!
!    RTMAXV = X.XXE+XX
!
!    in the CONOPT control program.
!
         CALL CONMSG( CMI, 1004, 0.D0, 0.D0, 0, 0, .FALSE., .TRUE. )
      ENDIF
   ELSEIF ( INEWCR .LT. 0 ) THEN
      IF ( PRINT .AND. .NOT. CMI%LSIERR ) THEN  
!
! ** FATAL ERROR **  Function error in Post-triangular equation.
!
         IF ( .NOT. INIERR ) THEN
            CALL CONMSG( CMI, 3040, 0.D0, 0.D0, 0, 0, .TRUE., .FALSE. )
!     The Post-triangular equations may be turned into ordinary
!     equations with a line:
!
!          SET       LSPOST    .FALSE.
!
!     in the CONOPT control program.
!
            CALL CONMSG( CMI, 1011, 0.D0, 0.D0, 0, 0, .FALSE., .TRUE. )
         ENDIF
         CMI%LSFCER = .TRUE.
         CMI%LJSTAT = 14
         CMI%LBRNCH = 3
      ENDIF
   ENDIF
! $if defined (testout)
   IF ( CMI%LJPHAS .LE. 1 .AND. CMI%LOFFS  .GT. 0 ) THEN
      WRITE(CMI%MSGTXT,"('Adjusting post triangular variables. change=',l2)") CHANGE
      CALL CO2DOC( CMI, Asis )
      IF ( CMI%LOFFS  .GT. 2 ) THEN
         CALL COPVRL( CMI, CMI%LNXSOL, XL(CMI%LLXSOL+1) )
         CALL COPVRL( CMI, CMI%LNGRES, XL(CMI%LLGRES+1) )
      ENDIF
   ENDIF
! $endif

   END SUBROUTINE COADJP

   SUBROUTINE COSUFX( CMI, IRG, XL, JL )
!**   Logical Operation
!**       Performs the permutations in Rgfr, Rrga, and Dir when a
!**       superbasic variable is removed from the superbasis and is
!**       fixed.
!**   Description of parameters
!**       Irg - The position of the superbasic variable in
!**             Rgfr, Rgra, and Dir (Input).
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R) XL(*); INTEGER JL(*)
   INTEGER IRG

   REAL(CO_R)  HOLD
   INTEGER ICOL

   ICOL = JL(CMI%LLRGFR+IRG)
   JL(CMI%LLBASC+ICOL)   = -1
   IF ( IRG .NE. CMI%LKNNFX ) THEN
      JL(CMI%LLRGFR+IRG)        = JL(CMI%LLRGFR+CMI%LKNNFX)
      JL(CMI%LLRGFR+CMI%LKNNFX) = ICOL
      HOLD                      = XL(CMI%LLRGRA+IRG)
      XL(CMI%LLRGRA+IRG)        = XL(CMI%LLRGRA+CMI%LKNNFX)
      XL(CMI%LLRGRA+CMI%LKNNFX) = HOLD
      HOLD                      = XL(CMI%LLDIR +IRG)
      XL(CMI%LLDIR +IRG)        = XL(CMI%LLDIR +CMI%LKNNFX)
      XL(CMI%LLDIR +CMI%LKNNFX) = HOLD
   ENDIF
   CMI%LKNNFX            = CMI%LKNNFX - 1

   END SUBROUTINE COSUFX

   SUBROUTINE COSINF( CMI, FOBJ, XSOL, IFSL )
!**   LOGICAL OPERATION
!**       Calculates the sum of infeasibilities as the sum of the
!**       'large slacks'.
!**   ABNORMAL CONDITIONS
!**       Systems error if the number of nonzeros in ifsl is incon-
!**       sistent with LKSLRS
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI

   REAL(CO_R)  XSOL(*)
   INTEGER IFSL(*)
   REAL(CO_R)  FOBJ
   INTEGER IROW, ICOL, NSLCK

   FOBJ   = 0.D0
   NSLCK  = 0
   DO IROW = 1, CMI%LJNROW
      ICOL = CMI%LJNSTR + IROW
      IF ( IFSL(IROW) .LT. 0 ) THEN
         IF ( XSOL(ICOL) .LT. 0. ) FOBJ = FOBJ - XSOL(ICOL)
         NSLCK = NSLCK + 1
      ELSEIF ( IFSL(IROW) .GT. 0 ) THEN
         IF ( XSOL(ICOL) .GT. 0. ) FOBJ = FOBJ + XSOL(ICOL)
         NSLCK = NSLCK + 1
      ENDIF
   ENDDO

   IF ( NSLCK .NE. CMI%LKSLRS ) THEN
      WRITE(CMI%MSGTXT,"('In Cosinf. LKSLRS=',i6,' and nslck=',i6)") CMI%LKSLRS
      CALL CO2DOC( CMI, Asis )
      CALL COSYSE( CMI, 12, .TRUE. )
   ENDIF

   END SUBROUTINE COSINF

   SUBROUTINE COSHDR( CMI )
!**   LOGICAL OPERATION
!**      Maintains the screen header
!**
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   DOUBLE PRECISION TNOW

   CMI%LKSUMM = CMI%LKSUMM + 1
   IF ( CMI%LKSUMM .GE. 10 ) THEN  
      CMI%LKSUMM = 0
      TNOW       = COCLCK( CMI )
      IF ( TNOW .GT. CMI%RVSHDR + 30.D0 ) THEN
         WRITE(CMI%MSGTXT,"('   Elapsed time',F11.1,' seconds.')") TNOW
         CALL CO2SCR( CMI, Asis )
         CMI%RVSHDR = TNOW
      ENDIF
      IF ( CMI%LSDUIN ) THEN
         IF ( CMI%LJPHAS .LE. 1 ) THEN
            CMI%MSGTXT = '   Iter Phase Ninf   Infeasibility   RGmax    NSB   Step InItr MX OK Dualw'
         ELSE
            CMI%MSGTXT = '   Iter Phase Ninf     Objective     RGmax    NSB   Step InItr MX OK Dualw'
         ENDIF
      ELSE
         IF ( CMI%LJPHAS .LE. 1 ) THEN
            CMI%MSGTXT = '   Iter Phase Ninf   Infeasibility   RGmax    NSB   Step InItr MX OK'
         ELSE
            CMI%MSGTXT = '   Iter Phase Ninf     Objective     RGmax    NSB   Step InItr MX OK'
         ENDIF
      ENDIF
      CALL CO2SCR( CMI, Blb )
   ENDIF

   END SUBROUTINE COSHDR

   SUBROUTINE COLHDR( CMI )
!**   LOGICAL OPERATION
!**      Maintains the log header
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   DOUBLE PRECISION TNOW

   CMI%LKLOG  = CMI%LKLOG  + 1
   IF ( CMI%LKLOG  .GE. 20 ) THEN  
      CMI%LKLOG  = 0
      TNOW       = COCLCK( CMI )
      IF ( TNOW .GT. CMI%RVLHDR + 30.D0 ) THEN
         WRITE(CMI%MSGTXT,"('   Elapsed time',F11.1,' seconds.')") TNOW
         CALL CO2DOC( CMI, Asis )
         CMI%RVLHDR = TNOW
      ENDIF
      IF ( CMI%LSDUIN ) THEN
         IF ( CMI%LJPHAS .LE. 1 ) THEN
            CMI%MSGTXT = '   Iter Phase Ninf   Infeasibility   RGmax    NSB   Step InItr MX OK Dualw'
         ELSE
            CMI%MSGTXT = '   Iter Phase Ninf     Objective     RGmax    NSB   Step InItr MX OK Dualw'
         ENDIF
      ELSE
         IF ( CMI%LJPHAS .LE. 1 ) THEN
            CMI%MSGTXT = '   Iter Phase Ninf   Infeasibility   RGmax    NSB   Step InItr MX OK'
         ELSE
            CMI%MSGTXT = '   Iter Phase Ninf     Objective     RGmax    NSB   Step InItr MX OK'
         ENDIF
      ENDIF
      CALL CO2DOC( CMI, Blb )
   ENDIF

   END SUBROUTINE COLHDR

   SUBROUTINE COPITR( CMI, SCREEN, XSOL, TCONPT, NCALL )
!**   Logical Operation
!**       Prints the iteration logs during the Conopt Iterations
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R)  XSOL(*)
   LOGICAL SCREEN
   DOUBLE PRECISION TCONPT
   INTEGER NCALL

   INTEGER     INT( PRGINT )
   REAL(CO_R)  RL( PRGRL )

   REAL(CO_R)  FOBJPR, SUMINF, OBJVAL
   INTEGER PRPHAS
   LOGICAL FINAL, MAXADJ
   DOUBLE PRECISION THOLD

   IF ( CMI%LJPHAS .EQ. 2 ) THEN
      FOBJPR = CMI%RVOBJO * CMI%RPIOBJ
   ELSE
      FOBJPR = CMI%RVOBJO
   ENDIF
   CMI%LKITER = CMI%LKITER+1
   IF ( CMI%LMSMOD .EQ. SRC_SLP ) THEN
      CMI%LKITSL = CMI%LKITSL + 1
      IF ( CMI%LSMXST ) CMI%LKMXSL = CMI%LKMXSL + 1
      IF ( CMI%LSONWL ) CMI%LKOKSL = CMI%LKOKSL + 1
      IF ( CMI%RVTHMA .GT. 0 ) &
         CMI%RVTHSL = CMI%RVTHSL + MAX( 0.D0, MIN( 1.D0, CMI%RVTHOP / CMI%RVTHMA ) )
   ELSEIF ( CMI%LSDEGI ) THEN
      CMI%LKITDG = CMI%LKITDG + 1
   ELSEIF ( CMI%LMSMOD .EQ. SRC_SLP .OR. CMI%LMSMOD .EQ. SRC_Steep ) THEN
      CMI%LKITSD = CMI%LKITSD + 1
      IF ( CMI%LSMXST ) CMI%LKMXSD = CMI%LKMXSD + 1
      IF ( CMI%LSONWL ) CMI%LKOKSD = CMI%LKOKSD + 1
      IF ( CMI%LSMXST .AND. CMI%LSONWL .AND.   &
           ( CMI%LMSMOD .EQ. SRC_SLP .OR. CMI%LMSMOD .EQ. SRC_Steep .OR. CMI%LJRAGE .LT. 5 ) &
           .AND. NCALL .LE. 5 .AND. .NOT. CMI%LSRVNL ) &
           CMI%LKUPSD = CMI%LKUPSD + 1
   ELSE
      CMI%LKITQN = CMI%LKITQN + 1
      IF ( CMI%LSMXST ) CMI%LKMXQN = CMI%LKMXQN + 1
      IF ( CMI%LSONWL ) CMI%LKOKQN = CMI%LKOKQN + 1
      IF ( CMI%LSMXST .AND. CMI%LSONWL .AND.  &
           ( CMI%LMSMOD .EQ. SRC_SLP .OR. CMI%LMSMOD .EQ. SRC_Steep .OR. CMI%LJRAGE .LT. 5 ) &
           .AND. NCALL .LE. 5 .AND. .NOT. CMI%LSRVNL )  &
           CMI%LKUPQN = CMI%LKUPQN + 1
   ENDIF
   PRPHAS = CMI%LJPHAS * 2
   FINAL  = CMI%LJSTAT .GE. 6
   IF ( CMI%LMSMOD .EQ. SRC_SLP .OR. CMI%LMSMOD .EQ. SRC_Steep ) PRPHAS = PRPHAS - 1
   CALL COLHDR( CMI )
   IF ( SCREEN ) CALL COSHDR( CMI )
   IF ( CMI%LSDUIN) THEN
      IF ( CMI%LJPHAS .EQ. 1 ) THEN
         IF ( FINAL ) THEN
            WRITE(CMI%MSGTXT,"(I7,I4,I6,1P,E18.10,1P,E8.1,I6,   18X        ,E10.3)") &
               CMI%LKITER, PRPHAS, CMI%LKSLRS, FOBJPR, CMI%RVRGRM, CMI%LKASUP ,CMI%RVWEIG
         ELSEIF ( CMI%LMSMOD .EQ. SRC_SLP ) THEN
            MAXADJ = CMI%LSMXST
            IF ( CMI%RVTHOP .GE. 0.99D0 ) MAXADJ = .TRUE.
            WRITE(CMI%MSGTXT,"(I7,I4,I6,1P,E18.10,1P,E8.1,I6,1P,E8.1,I5,L2,L3,E10.3)") &
               CMI%LKITER, PRPHAS, CMI%LKSLRS, FOBJPR, CMI%RVRGRM, CMI%LKASUP, CMI%RVTHOP, &
               CMI%LKSLPI, MAXADJ    , CMI%LSONWL, CMI%RVWEIG
         ELSEIF ( CMI%LSSQPD ) THEN
            WRITE(CMI%MSGTXT,"(I7,I4,I6,1P,E18.10,1P,E8.1,I6,1P,E8.1,I5,L2,L3,E10.3)") &
               CMI%LKITER, PRPHAS, CMI%LKSLRS, FOBJPR, CMI%RVRGRM, CMI%LKASUP, CMI%RVTHOP, &
               CMI%LKSQPI, CMI%LSMXST, CMI%LSONWL, CMI%RVWEIG
         ELSE
            WRITE(CMI%MSGTXT,"(I7,I4,I6,1P,E18.10,1P,E8.1,I6,1P,E8.1,4X,2L3,E10.3)") &
               CMI%LKITER, PRPHAS, CMI%LKSLRS, FOBJPR, CMI%RVRGRM, CMI%LKASUP, CMI%RVTHOP, &
                           CMI%LSMXST, CMI%LSONWL, CMI%RVWEIG
         ENDIF
      ELSE
         IF ( FINAL ) THEN
            WRITE(CMI%MSGTXT,"(I7,I4,6X,1P,E18.10,1P,E8.1,I6,   18X        ,E10.3)") &
               CMI%LKITER, PRPHAS,             FOBJPR, CMI%RVRGRM, CMI%LKASUP,             &
                                                   CMI%RVWEIG
         ELSEIF ( CMI%LMSMOD .EQ. SRC_SLP ) THEN
            WRITE(CMI%MSGTXT,"(I7,I4,6X,1P,E18.10,1P,E8.1,I6,1P,E8.1,I5,L2,L3,E10.3)") &
               CMI%LKITER, PRPHAS,             FOBJPR, CMI%RVRGRM, CMI%LKASUP, CMI%RVTHOP, &
               CMI%LKSLPI, CMI%LSMXST, CMI%LSONWL, CMI%RVWEIG
         ELSEIF ( CMI%LSSQPD ) THEN
            WRITE(CMI%MSGTXT,"(I7,I4,6X,1P,E18.10,1P,E8.1,I6,1P,E8.1,I5,L2,L3,E10.3)") &
               CMI%LKITER, PRPHAS,             FOBJPR, CMI%RVRGRM, CMI%LKASUP, CMI%RVTHOP, &
               CMI%LKSQPI, CMI%LSMXST, CMI%LSONWL, CMI%RVWEIG
         ELSE
            WRITE(CMI%MSGTXT,"(I7,I4,6X,1P,E18.10,1P,E8.1,I6,1P,E8.1,4X,2L3,E10.3)") &
               CMI%LKITER, PRPHAS,             FOBJPR, CMI%RVRGRM, CMI%LKASUP, CMI%RVTHOP, &
                           CMI%LSMXST, CMI%LSONWL, CMI%RVWEIG
         ENDIF
      ENDIF
   ELSE
      IF ( CMI%LJPHAS .EQ. 1 ) THEN
         IF ( FINAL ) THEN
            WRITE(CMI%MSGTXT,"(I7,I4,I6,1P,E18.10,1P,E8.1,I6,1P,E8.1,I5,L2,L3)") &
               CMI%LKITER, PRPHAS, CMI%LKSLRS, FOBJPR, CMI%RVRGRM, CMI%LKASUP
         ELSEIF ( CMI%LMSMOD .EQ. SRC_SLP ) THEN
            MAXADJ = CMI%LSMXST
            IF ( CMI%RVTHOP .GE. 0.99D0 ) MAXADJ = .TRUE.
            WRITE(CMI%MSGTXT,"(I7,I4,I6,1P,E18.10,1P,E8.1,I6,1P,E8.1,I5,L2,L3)") &
               CMI%LKITER, PRPHAS, CMI%LKSLRS, FOBJPR, CMI%RVRGRM, CMI%LKASUP, CMI%RVTHOP, &
               CMI%LKSLPI, MAXADJ    , CMI%LSONWL
         ELSEIF ( CMI%LSSQPD ) THEN
            WRITE(CMI%MSGTXT,"(I7,I4,I6,1P,E18.10,1P,E8.1,I6,1P,E8.1,I5,L2,L3)") &
               CMI%LKITER, PRPHAS, CMI%LKSLRS, FOBJPR, CMI%RVRGRM, CMI%LKASUP, CMI%RVTHOP, &
               CMI%LKSQPI, CMI%LSMXST, CMI%LSONWL
         ELSE
            WRITE(CMI%MSGTXT,"(I7,I4,I6,1P,E18.10,1P,E8.1,I6,1P,E8.1,4X,2L3)") &
               CMI%LKITER, PRPHAS, CMI%LKSLRS, FOBJPR, CMI%RVRGRM, CMI%LKASUP, CMI%RVTHOP, &
                           CMI%LSMXST, CMI%LSONWL
         ENDIF
      ELSE
         IF ( FINAL ) THEN
            WRITE(CMI%MSGTXT,"(I7,I4,6X,1P,E18.10,1P,E8.1,I6,1P,E8.1,I5,L2,L3)") &
               CMI%LKITER, PRPHAS,             FOBJPR, CMI%RVRGRM, CMI%LKASUP
         ELSEIF ( CMI%LMSMOD .EQ. SRC_SLP ) THEN
            WRITE(CMI%MSGTXT,"(I7,I4,6X,1P,E18.10,1P,E8.1,I6,1P,E8.1,I5,L2,L3)") &
               CMI%LKITER, PRPHAS,             FOBJPR, CMI%RVRGRM, CMI%LKASUP, CMI%RVTHOP, &
               CMI%LKSLPI, CMI%LSMXST, CMI%LSONWL
         ELSEIF ( CMI%LSSQPD ) THEN
            WRITE(CMI%MSGTXT,"(I7,I4,6X,1P,E18.10,1P,E8.1,I6,1P,E8.1,I5,L2,L3)") &
               CMI%LKITER, PRPHAS,             FOBJPR, CMI%RVRGRM, CMI%LKASUP, CMI%RVTHOP, &
               CMI%LKSQPI, CMI%LSMXST, CMI%LSONWL
         ELSE
            WRITE(CMI%MSGTXT,"(I7,I4,6X,1P,E18.10,1P,E8.1,I6,1P,E8.1,4X,2L3)") &
               CMI%LKITER, PRPHAS,             FOBJPR, CMI%RVRGRM, CMI%LKASUP, CMI%RVTHOP, &
                           CMI%LSMXST, CMI%LSONWL
         ENDIF
      ENDIF
   ENDIF
   IF ( SCREEN ) THEN
      CALL CO2SDOC( CMI, Asis )
   ELSE
      CALL CO2DOC( CMI, Asis )
   ENDIF
   IF ( CMI%LJPHAS .EQ. 1 ) THEN
      SUMINF = FOBJPR
      OBJVAL = 0.D0
   ELSE
      SUMINF = 0.D0
      OBJVAL = FOBJPR
   ENDIF
!
!  Numnop (argument 5) is for the time being set to LKASUP
!
   INT(1) = CMI%LKITER
   INT(2) = PRPHAS
   INT(3) = CMI%LKSLRS
   INT(4) = CMI%LKASUP
   INT(5) = CMI%LKASUP
   RL(1)  = SUMINF
   RL(2)  = OBJVAL
   RL(3)  = CMI%RVRGRM
   CALL COIPR1( CMI, PRGINT, INT, PRGRL, RL, XSOL )

   CMI%LKSLPI = 0

! $if defined (testout)
   IF ( CMI%LOCNPT .GT. 0 ) THEN
      THOLD  = COCLCK( CMI )
      TCONPT = THOLD - TCONPT
      WRITE(CMI%MSGTXT,"('Iteration time:',f8.3,1X,A)") TCONPT, 'Seconds'
      CALL CO2DOC( CMI, Blb )
      TCONPT = THOLD
   ENDIF
! $endif

   END SUBROUTINE COPITR

   SUBROUTINE COIPR1( CMI, Len_Int, INT_Arg, Len_Rl, RL_Arg, X )
!**   Logical Operation
!**      Wrapper routine that calles the user-definable COIPRG and the
!**      debugging communication routine.
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   INTEGER Len_Int, INT_Arg(Len_Int), Len_Rl, FINISH
   REAL(CO_R)  RL_Arg(Len_Rl), X(*)

   IF ( CMI%CB_Progress .NE. 0 ) THEN
      CALL CONOUT( CMI ) 
      CALL CALL_Progress( CMI%CB_Progress, Len_Int, INT_Arg, Len_Rl, RL_Arg, X, CMI%CB_USRMEM, FINISH )
      IF ( FINISH .NE. 0 ) THEN
         CMI%LSUSRI = .TRUE.
      ENDIF
   ENDIF

   END SUBROUTINE COIPR1

   SUBROUTINE COSUMR( CMI, GLSUM, GLMAX, XL, JL)
!**   LOGICAL OPERATION
!**       Calculates the sum of residuals and the largest residual
!**       given the vector of residuals.
!**       Only the expressions from row LKTRIA+1 to row LJNROW
!**       (new or permuted row numbers) should be included in the
!**       evaluation.
!**   DESCRIPTION OF PARAMETERS
!**       Glsum  - Returns the sum of absolute residuals
!**       Glmax  - Returns the largest absolute residual
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R) XL(*); INTEGER JL(*)
   REAL(CO_R)  GLSUM, GLMAX

   REAL(CO_R)  ABSRES
   INTEGER INDX
   integer keep
   parameter ( keep = 10 )
   REAL(CO_R) gmax( keep ), glim, sum
   integer indxk( keep ), added, i, j, imax

   GLSUM = 0.D0
   GLMAX = 0.D0
   IF ( CMI%LKTRIA .GE. CMI%LJNROW ) RETURN
   DO INDX = CMI%LKTRIA+1, CMI%LJNROW
      ABSRES = ABS( XL(CMI%LLGRES+JL(CMI%LLRNTO+INDX)) )
      GLSUM  = GLSUM + ABSRES
      GLMAX  = MAX( GLMAX , ABSRES )
   ENDDO
   if ( .false. ) then
      glim = 0.d0
      added = 0
      do 120 indx = CMI%LKTRIA+1, CMI%LJNROW
         absres = abs( xl(CMI%LLGRES+jl(CMI%LLRNTO+indx)) )
         if ( absres .le. glim ) go to 120
         do i = 1, added
            if ( absres .gt. gmax(i) ) go to 128
         enddo
         added = added + 1
         if ( added .gt. keep ) then
            call COSYSE( CMI, 998, .true. )
            return
         endif
         gmax( added ) = absres
         indxk( added ) = indx
         glim = absres
         go to 120
  128    imax = min( keep-1, added )
         do j = imax, i, -1
            gmax(j+1) = gmax(j)
            indxk(j+1) = indxk(j)
         enddo
         added = imax + 1
         gmax(i) = absres
         indxk(i) = indx
         glim = gmax(added)
  120 continue
      sum=0.d0
      do i = 1, added
         sum = sum + gmax(i)
      enddo
      write(CMI%MSGTXT,"('The worst',i3,' constraints. Sum=',1p,e14.5,' %=',1p,f7.3)") &
         added, sum, sum/glsum*100.d0
      CALL CO2DOC( CMI, Asis )
      write(CMI%MSGTXT,"('Indx=',10i7)") (indxk(i), i = 1, added)
      CALL CO2DOC( CMI, Asis )
      write(CMI%MSGTXT,"( ('Gres=',5(1p,e14.5) ) )") (gmax(i), i = 1, added)
      CALL CO2DOC( CMI, Asis )
      write(CMI%MSGTXT,"( ('Gr% =',f10.3,4f14.3 ) )") (gmax(i)/glsum*100.d0, i = 1, added)
      CALL CO2DOC( CMI, Asis )
   endif
! $if defined (testout)
   IF (CMI%LOCON3.GT.0) THEN
      WRITE(CMI%MSGTXT,"('Sum of absolute residuals=',1p,e20.10)") GLSUM
      CALL CO2DOC( CMI, Asis )
      WRITE(CMI%MSGTXT,"('Largest absolute residual=',1p,e20.10)") GLMAX
      CALL CO2DOC( CMI, Asis )
      IF ( CMI%LOCON3 .GT. 1 ) &
         CALL COPVRL( CMI, CMI%LNGRES, XL(CMI%LLGRES+1) )
   ENDIF
! $endif

   END SUBROUTINE COSUMR

   SUBROUTINE COSUME( CMI, FERROR, XL, JL )
!**   LOGICAL OPERATION
!**       Calculates the expected error in the objective based on
!**       the scalar product of the residuals with the duals.
!**       Only the equations from LKTRIA+1 to LJNROW (new row
!**       numbers) are included in the test.
!**   DESCRIPTION OF PARAMETERS
!**       Ferror - Returns the expected error in the objective with
!**                sign (output).
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R) XL(*); INTEGER JL(*)
   REAL(CO_R)  FERROR

   INTEGER IROW, INDX

   FERROR = 0.D0
   IF ( CMI%LKTRIA .GE. CMI%LJNROW ) RETURN
   DO INDX = CMI%LKTRIA+1, CMI%LJNROW
      IROW = JL(CMI%LLRNTO+INDX)
      FERROR = FERROR - XL(CMI%LLGRES+IROW) * XL(CMI%LLUM  +IROW)
   ENDDO

   END SUBROUTINE COSUME

   SUBROUTINE CO2SCR( CMI, Type )
!**   Logical operation
!**       Intermediate routine for sending the message stored in
!**       MSGTXT to the screen via the Message routine, that
!**       must be supplied by the user.
!**
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   Integer :: Type

   INTEGER   LEN, ERROR
!
!  Flush the queue if there are Dmsg waiting or many Smsg
!
   IF ( CMI%SMSG .GT. 18 .OR. CMI%DMSG .GT. 0 ) THEN
      CALL CONOUT( CMI )
   ENDIF

   IF ( Type .eq. Asis ) Then            
      CMI%SMSG           = CMI%SMSG + 1
      CMI%MSGV(CMI%SMSG) = CMI%MSGTXT
   Elseif ( Type .eq. Blb ) Then         
      CMI%SMSG           = CMI%SMSG + 1
      CMI%MSGV(CMI%SMSG) = ' '
      CMI%SMSG           = CMI%SMSG + 1
      CMI%MSGV(CMI%SMSG) = CMI%MSGTXT
   Elseif ( Type .eq. Bla ) Then         
      CMI%SMSG           = CMI%SMSG + 1
      CMI%MSGV(CMI%SMSG) = CMI%MSGTXT
      CMI%SMSG           = CMI%SMSG + 1
      CMI%MSGV(CMI%SMSG) = ' '
   Elseif ( Type .eq. Blba ) Then        
      CMI%SMSG           = CMI%SMSG + 1
      CMI%MSGV(CMI%SMSG) = ' '
      CMI%SMSG           = CMI%SMSG + 1
      CMI%MSGV(CMI%SMSG) = CMI%MSGTXT
      CMI%SMSG           = CMI%SMSG + 1
      CMI%MSGV(CMI%SMSG) = ' '
   Endif

   CALL CONOUT( CMI ) 

   END SUBROUTINE CO2SCR

   SUBROUTINE CO2DOC( CMI, Type )
!     Logical Operation
!        Adds the message stored in CMI%Msgtxt to the message queue for
!        the document file and writes the messages out if the queue is
!        becomming full.
!     Type: Asis - write the line as is
!           Blb  - add a blank line before
!           Bla  - add a blank line after
!           Blba - add a blank line before and after
!
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   Integer, Intent (IN) :: Type
!
!  Flush the queue if there are Smsg or Nmsg waiting.
!
   IF ( CMI%SMSG .GT. 0 .OR. CMI%NMSG .GT. 0 ) THEN
      CALL CONOUT( CMI )
   ENDIF
   IF ( Type .eq. Asis ) Then            
      CMI%DMSG           = CMI%DMSG + 1
      CMI%MSGV(CMI%DMSG) = CMI%Msgtxt
   Elseif ( Type .eq. Blb ) Then         
      CMI%DMSG           = CMI%DMSG + 1
      CMI%MSGV(CMI%DMSG) = ' '
      CMI%DMSG           = CMI%DMSG + 1
      CMI%MSGV(CMI%DMSG) = CMI%Msgtxt
   Elseif ( Type .eq. Bla ) Then         
      CMI%DMSG           = CMI%DMSG + 1
      CMI%MSGV(CMI%DMSG) = CMI%Msgtxt
      CMI%DMSG           = CMI%DMSG + 1
      CMI%MSGV(CMI%DMSG) = ' '
   Elseif ( Type .eq. Blba ) Then        
      CMI%DMSG           = CMI%DMSG + 1
      CMI%MSGV(CMI%DMSG) = ' '
      CMI%DMSG           = CMI%DMSG + 1
      CMI%MSGV(CMI%DMSG) = CMI%Msgtxt
      CMI%DMSG           = CMI%DMSG + 1
      CMI%MSGV(CMI%DMSG) = ' '
   Endif

! $if defined (write20)
!    CALL CONOUT( CMI )
! $else
   IF ( CMI%DMSG .GE. 18 ) THEN
      CALL CONOUT( CMI )
   ENDIF
! $endif

   END SUBROUTINE CO2DOC

   SUBROUTINE CO2SDOC( CMI, TYPE )
!**   Logical operation
!**       Intermediate routine for sending the message stored in
!**       MSGTXT to the screen and documentation files via the
!**       Message, that must be supplied by the user.
!**
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   Integer :: Type

   INTEGER   LEN, ERROR

   IF ( CMI%SMSG .GT. 18 .OR. CMI%DMSG .GT. 18 .OR. CMI%NMSG .GT. 0 .OR. CMI%SMSG .NE. CMI%DMSG ) THEN
      CALL CONOUT( CMI )
   ENDIF

   IF ( Type .eq. Asis ) Then            
      CMI%SMSG           = CMI%SMSG + 1
      CMI%MSGV(CMI%SMSG) = CMI%MSGTXT
   Elseif ( Type .eq. Blb ) Then         
      CMI%SMSG           = CMI%SMSG + 1
      CMI%MSGV(CMI%SMSG) = ' '
      CMI%SMSG           = CMI%SMSG + 1
      CMI%MSGV(CMI%SMSG) = CMI%MSGTXT
   Elseif ( Type .eq. Bla ) Then         
      CMI%SMSG           = CMI%SMSG + 1
      CMI%MSGV(CMI%SMSG) = CMI%MSGTXT
      CMI%SMSG           = CMI%SMSG + 1
      CMI%MSGV(CMI%SMSG) = ' '
   Elseif ( Type .eq. Blba ) Then        
      CMI%SMSG           = CMI%SMSG + 1
      CMI%MSGV(CMI%SMSG) = ' '
      CMI%SMSG           = CMI%SMSG + 1
      CMI%MSGV(CMI%SMSG) = CMI%MSGTXT
      CMI%SMSG           = CMI%SMSG + 1
      CMI%MSGV(CMI%SMSG) = ' '
   Endif

   CMI%DMSG = CMI%SMSG
   CALL CONOUT( CMI ) 

   END SUBROUTINE CO2SDOC

   SUBROUTINE COCLCKI( CMI )
!
!  Initialize the clock
!
      IMPLICIT NONE
   Type (conopt_model_info) CMI

   Integer :: Count, Count_Rate, Count_Max

   CALL SYSTEM_CLOCK( Count, Count_Rate, Count_Max )
   cmi%firstt    = Real( Count, CO_R ) / Real ( Count_Rate, CO_R )
   cmi%overflt   = 0.0
   cmi%count_old = Count
!
!  We have experienced that the clock goes backward on some systems
!  so we add a small accuracy of at least 10 ticks, but preferably
!  one second (Count_Rate). If Count_Max is not too large we use
!  Count_Max/1000 only.
!
   cmi%count_acc = Max( 10, Min( Count_Rate, Count_Max / 1000 ) )
   END SUBROUTINE COCLCKI

   DOUBLE PRECISION FUNCTION COCLCK( CMI )
!
!  Read the clock
!
      IMPLICIT NONE
   Type (conopt_model_info) CMI

   Integer :: Count, Count_Rate, Count_Max
   Real(CO_R) Tempt

   CALL SYSTEM_CLOCK( Count, Count_Rate, Count_Max )
   tempt = Real( Count, CO_R ) / Real ( Count_Rate, CO_R )
   if ( Count .lt. cmi%count_old ) then
!
!  Only count this as an overflow if the counter is really different.
!  We try to avoid problems with lousy clock that go backward a little.
!
      if ( abs(Count-cmi%count_old) > cmi%Count_Acc ) then
         cmi%overflt = cmi%overflt + Real( Count_Max, CO_R ) / Real( Count_Rate, CO_R )
      endif
   endif
   cmi%count_old = Count
   COCLCK        = tempt - cmi%firstt + cmi%overflt

   END FUNCTION COCLCK

   LOGICAL FUNCTION CORSLM( CMI )

      IMPLICIT NONE
   Type (conopt_model_info) CMI

   CORSLM = COCLCK( CMI ) .GT. CMI%RVTIME

   END FUNCTION CORSLM

   Subroutine CORemove_Row_From_Position(CMI, Irow, RPpr, RPnx, Rstr, Rlen )
!
!  Remove row Irow from the Row Position Structure when it is moved to
!  U during the factorization. We do not change Rstr.
!
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   Integer, Intent(IN) :: Irow
   Integer, Dimension(*), Intent(In Out) :: RPpr, RPnx
   Integer, Dimension(*), Intent(In)     :: Rstr, Rlen

   Integer :: Prev, Next, i, jj

   Prev = RPpr(Irow)
   Next = RPnx(Irow)
   If ( Prev .ne. 0 ) then
      RPnx(Prev) = Next
   Else
      CMI%RPfrst = Next
   Endif
   If ( Next .ne. 0 ) then
      RPpr(Next) = Prev
   Else
      CMI%RPlast = Prev
!
!  If the row is the last one we also update Lkrowf. There are some
!  considerations. We would in general allow a factor Rvlufc extra
!  space. However, we do not want to let Lkrowf increase. We must
!  also allow space for one extra element in case we are in Piv_2_by_X
!  or a similar routine, where one elements can have been removed.
!
      If ( CMI%RPlast .ne. 0 ) &
        CMI%Lkrowf = min( CMI%Lkrowf, &
                          RSTR(CMI%RPlast) + max( RLEN(CMI%RPlast)+1,  &
                                                  Int(RLEN(CMI%RPlast)*CMI%RVLUFC) ) - 1 )
   Endif

   End Subroutine CORemove_Row_From_Position

   Subroutine CORemove_Col_From_Position(CMI, ICol, CPpr, CPnx, Cstr, Clen )
!
!  Remove Column ICol from the Column Position Structure when it is
!  moved to L during the factorization. We do not change Cstr.
!
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   Integer, Intent(IN) :: ICol
   Integer, Dimension(*), Intent(In Out) :: CPpr, CPnx
   Integer, Dimension(*), Intent(In)     :: Cstr, Clen

   Integer :: Prev, Next, i, jj

   Prev = CPpr(ICol)
   Next = CPnx(ICol)
   If ( Prev .ne. 0 ) then
      CPnx(Prev) = Next
   Else
      CMI%CPfrst = Next
   Endif
   If ( Next .ne. 0 ) then
      CPpr(Next) = Prev
   Else
      CMI%CPlast = Prev
!
!  If the column is the last one we also update Lkcolf. There are some
!  considerations. We would in general allow a factor Rvlufc extra
!  space. However, we do not want to let Lkcolf increase. We must
!  also allow space for one extra element in case we are in Piv_2_by_X
!  or a similar routine, where one elements can have been removed.
!
      If ( CMI%CPlast .ne. 0 ) &
         CMI%LkColf = min( CMI%LkColf,  &
                           CSTR(CMI%CPlast) + max( CLEN(CMI%CPlast)+1, &
                                                   Int(CLEN(CMI%CPlast)*CMI%RVLUFC) ) - 1 )
   Endif

   End Subroutine CORemove_Col_From_Position

   SUBROUTINE COTSDG( CMI, ICOL, TEST, ZERO, XL, JL )
!**   LOGICAL OPERATION
!**       Test if a variable is degenerate and if so it adds it to
!**       the list by calling Coaddg. Fixed variables are not con-
!**       sidered degenerate.
!**   DESCRIPTION OF PARAMETERS
!**       Icol   - The number of the column to be added (input)
!**       Test   - If true then test if the variable is already
!**                in the list of degenerate variables, otherwise
!**                only test if it is at bound.
!**       Zero   - Logical. If .true. then the bound is set to
!**                zero, otherwise random.
!**   ABNORMAL CONDITIONS
!**       Returns if there is insufficient memory to increase the
!**       vectors.
!*
   Type (conopt_model_info) CMI
   REAL(CO_R) XL(*)
   INTEGER    JL(*)
   LOGICAL TEST, ZERO
   INTEGER ICOL

   INTEGER J, J1, LEV
   REAL(CO_R)  XMAX, XMIN

   XMAX = XL(CMI%LLXMAX+ICOL) - XL(CMI%LLCLMX+ICOL)
   XMIN = XL(CMI%LLXMIN+ICOL) + XL(CMI%LLCLMX+ICOL)
!  IF ( XMIN .GE. XMAX ) THEN
!     WRITE(CMI%MSGTXT,*) 'Cotsdg(',icol,') - Almost Fixed variable.'
!     CALL CO2DOC( CMI, Asis )
!  ENDIF
   IF ( TEST ) THEN
      DO J = 1, CMI%LJDEGI
         J1 = JL(CMI%LLDCOL+J)
         IF ( ICOL .EQ. ABS( J1 ) ) GO TO 101
      ENDDO
   ENDIF
   IF ( XL(CMI%LLXSOL+ICOL) .LE. XMIN ) THEN
      CALL COADDG( .TRUE. )
   ENDIF
   IF ( XL(CMI%LLXSOL+ICOL) .GE. XMAX ) THEN
      CALL COADDG( .FALSE. )
   ENDIF

   RETURN
!
!  I am not sure what is going on here !!
!
101 IF ( XL(CMI%LLXSOL+ICOL) .LT. XMAX .AND. XL(CMI%LLXSOL+ICOL) .GT. XMIN ) THEN
      DO LEV = 2, CMI%LKDLEV
         IF ( JL(CMI%LLDSTK+LEV) .GT. J ) THEN
            J1             = JL(CMI%LLDSTK+LEV)
            JL(CMI%LLDCOL+J)   = JL(CMI%LLDCOL+J1)
            XL(CMI%LLDBND+J)   = XL(CMI%LLDBND+J1)
            J              = J1
            JL(CMI%LLDSTK+LEV) = J1 - 1
         ENDIF
      ENDDO
      JL(CMI%LLDCOL+J) = JL(CMI%LLDCOL+CMI%LJDEGI)
      XL(CMI%LLDBND+J) = XL(CMI%LLDBND+CMI%LJDEGI)
      CMI%LJDEGI = CMI%LJDEGI - 1
! $if defined (testout)
      IF ( CMI%LODEGI .GT. 0 ) THEN
         WRITE(CMI%MSGTXT,"('Cotsdg: Column',i6,' removed from Dcol.')") ICOL
         CALL CO2DOC( CMI, Asis )
      ENDIF
   ELSE
      IF ( CMI%LODEGI .GT. 0 ) THEN
         WRITE(CMI%MSGTXT,"('Cotsdg: Column',i6,' is already in Dcol.')") ICOL
         CALL CO2DOC( CMI, Asis )
      ENDIF
! $endif
   ENDIF

   CONTAINS

   SUBROUTINE COADDG( MINBND )
!**   LOGICAL OPERATION
!**       Adds a degenerate variable to the list and
!**       generates a random bound
!**   DESCRIPTION OF PARAMETERS
!**       Icol   - The number of the column to be added (input)
!**       Minbnd - A logical variable that is true if the variable
!**                is at lower bound
!**       Zero   - Logical. If .true. then the bound is set to
!**                zero, otherwise random.
!**   ABNORMAL CONDITIONS
!**       Returns if there is insufficient memory to increase the
!**       vectors.
!*
      IMPLICIT NONE
   LOGICAL MINBND

   CMI%LJDEGI = CMI%LJDEGI + 1

   IF ( MINBND ) THEN
      JL(CMI%LLDCOL+CMI%LJDEGI) = -ICOL
   ELSE
      JL(CMI%LLDCOL+CMI%LJDEGI) = ICOL
   ENDIF

   IF ( ZERO ) THEN
      XL(CMI%LLDBND+CMI%LJDEGI) = 0.D0
   ELSE
      XL(CMI%LLDBND+CMI%LJDEGI) = 1.D0 + CORNDX( CMI )
   ENDIF

! $if defined (testout)
   IF ( CMI%LODEGI .GT. 1 ) THEN
      WRITE(CMI%MSGTXT,"('Coaddg: Column',i6,' with min=',l2,' becomes degen no',i5,' bound=',f10.7)") &
         ICOL, MINBND, CMI%LJDEGI, XL(CMI%LLDBND+CMI%LJDEGI)
      CALL CO2DOC( CMI, Asis )
   ENDIF
! $endif

   END SUBROUTINE COADDG

   END SUBROUTINE COTSDG
!
!  Routines used to process options, both in the control program and in
!  other options routines.
!
   SUBROUTINE COECRP( CMI, LINE, KNVERB, KNAME, IVAL, RVAL, LVAL, ITYPE )
!**   LOGICAL OPERATION
!**       WRITES THE LOG LINES WHEN THE SET, STEP, TEST, OR CRPRINT
!**       VERBS ARE EXECUTED.
!**   DESCRIPTION OF PARAMETERS
!**       LINE  - CONTAINS THE LINE NUMBER FOR THE LINE IN THE CONTROL
!**               PROGRAM THAT IS BEING EXECUTED.
!**       VERB  - CONTAINS THE NAME OF THE VERB THAT IS BEING EXECUTED
!**               AS AN ALPHANUMERIC CONSTANT.
!**       KNAME - CONTAINS THE NAME OF THE CR-CELL WHOSE VALUE IS
!**               PRINTED, STORED AS AN ALPHANUMERIC CONSTANT.
!**       IVAL  - CONTAINS THE VALUE OF THE CR-CELL IF IT IS INTEGER.
!**       RVAL  - CONTAINS THE VALUE OF THE CR-CELL IF IT IS REAL.
!**       LVAL  - CONTAINS THE VALUE OF THE CR-CELL IF IT IS LOGICAL.
!**       ITYPE - CONTAINS THE TYPE OF THE CR-CELL USING THE RULES DE-
!**               SCRIBED IN CPCCR.
!*
   Type (conopt_model_info) CMI
   REAL(CO_R)  RVAL
   INTEGER     IVAL
   LOGICAL     LVAL
   INTEGER LINE, ITYPE
   CHARACTER*8 KNAME, KNVERB

   IF ( ITYPE .EQ. TYPC_INT ) THEN
      WRITE(CMI%MSGTXT,"('  ***  Line',I5,2X,A8,2X,A8,' = ',I8)") LINE, KNVERB, KNAME, IVAL
   ELSEIF ( ITYPE .EQ. TYPC_REAL ) THEN
      WRITE(CMI%MSGTXT,"('  ***  Line',I5,2X,A8,2X,A8,' = ',1P,G20.10)") LINE, KNVERB, KNAME, RVAL
   ELSEIF ( ITYPE .EQ. TYPC_LOG ) THEN
      IF ( LVAL ) THEN
         WRITE(CMI%MSGTXT,"('  ***  Line',I5,2X,A8,2X,A8,' = TRUE')") LINE, KNVERB, KNAME
      ELSE
         WRITE(CMI%MSGTXT,"('  ***  Line',I5,2X,A8,2X,A8,' = FALSE')") LINE, KNVERB, KNAME
      ENDIF
   ENDIF
   CALL CO2DOC( CMI, 2 )

   END SUBROUTINE COECRP

   SUBROUTINE COESET( CMI, ITYPE, IPOS, IVAL, RVAL, LVAL, ICODE )
!**   LOGICAL OPERATION
!**       STORES A VALUE IN OR LOOKS UP A VALUE FROM A CR-CELL. IS USED
!**       DURING EXECUTION OF THE SET, STEP, TEST, AND CRPRINT VERBS.
!**   DESCRIPTION OF PARAMETERS
!**       ITYPE - GIVES THE type of the value
!**       IPOS  - CONTAINS THE RELATIVE POSITION WITHIN THE COMMON
!**               BLOCKS.
!**               CONTAINS THE VALUE TO BE STORED OR RETURNS THE VALUE
!**       IVAL  - THAT HAS BEEN LOOKED UP. THE DIFFERENT TYPES OF VARI-
!**       RVAL  - ABLES ARE RETURNED IN IVAL, RVAL, AND LVAL FOR
!**       LVAL  - INTEGER, REAL, AND LOGICAL RESPECTIVELY.
!**       ICODE - IF ICODE=0 THIS IS A LOOK UP, AND IF ICODE=1 THIS IS
!**               A STORE.
!*
   Type (conopt_model_info) CMI
   REAL(CO_R)  RVAL
   INTEGER     IVAL
   LOGICAL     LVAL
   INTEGER     ICODE, ITYPE, IPOS

   IF ( ITYPE .EQ. TYPC_INT ) THEN
      IF ( ICODE .EQ. 0 ) THEN
         Call Co_Get_CRI( CMI, Ipos, Ival )
      ELSE
         Call Co_Set_CRI( CMI, Ipos, Ival )
      ENDIF
   ELSEIF ( ITYPE .EQ. TYPC_REAL ) THEN
      IF ( ICODE .EQ. 0 ) THEN
         Call Co_Get_CRR( CMI, Ipos, Rval )
      ELSE
         Call Co_Set_CRR( CMI, Ipos, Rval )
      ENDIF
   ELSEIF ( ITYPE .EQ. TYPC_LOG ) THEN
      IF ( ICODE .EQ. 0 ) THEN
         Call Co_Get_CRL( CMI, Ipos, Lval )
      ELSE
         Call Co_Set_CRL( CMI, Ipos, Lval )
      ENDIF
   ENDIF

   END SUBROUTINE COESET

   SUBROUTINE COCCR( CMI, CELL, IP )
!**   LOGICAL OPERATION
!**       FINDS THE POSITION AND THE ATTRIBUTES OF A CR-CELL DURING THE
!**       COMPILATION OF THE CONTROL PROGRAM.
!**   DESCRIPTION OF PARAMETERS
!**       CELL - AN ALPHANUMERIC CELL THAT CONTAINS THE NAME OF THE
!**              CR-CELL WE WANT TO LOOK UP.
!**       IP   - AT RETURN IP CONTAINS THE POSITION IN CRNAME, WHERE
!**              THE CR-CELL IS FOUND.
!**   ABNORMAL CONDITIONS
!**       IF CRNAME(IP)=BLANK AT RETURN, THEN THE NAME IN CELL DOES NOT
!**       EXIST AS A CR-CELL.
!**

      IMPLICIT NONE
   Type (conopt_model_info) CMI

   CHARACTER*10 CELL
   INTEGER IP
   CHARACTER*8  CELLT

   CELLT = CELL(1:8)
!
!  Look up the Crcell name in CRNAME. The end of the vector is indicated
!  by a blank name.
!
   IP = 1
   DO WHILE ( CMI%CRNAME(IP) .NE. CELLT .AND. CMI%CRNAME(IP) .NE. '        ' )
      IP = IP + 1
   ENDDO

   END SUBROUTINE COCCR

   SUBROUTINE COCUP( IN, OUT, LEN )
!**   LOGICAL OPERATION
!**      CONVERTS A STRING TO UPPER CASE
!**   DESCRIPTION OF PARAMETERS
!**       IN  - AN ALPHANUMERIC PARAMETER CONTAINING 10 CHARACTERS AS
!**             INPUT TO COCUP. IN IS NOT CHANGED.
!**       OUT - AN ALPHANUMERIC PARAMETER THAT AT RETURN SHOULD CONTAIN
!**             AN UPPEER CASE VERSION OF IN.
!**       Len - Returns the length of the name under the assumption that
!**             it is left justified.
!*
      IMPLICIT NONE
   CHARACTER*10 IN, OUT
   INTEGER      LEN

   INTEGER      I, J
   CHARACTER*1  C
   CHARACTER*26 LOW, UPP

   DATA LOW /'abcdefghijklmnopqrstuvwxyz'/
   DATA UPP /'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/

   LEN = 0
   DO I = 1, 10
      C = IN(I:I)
      J = INDEX(LOW,C)
      IF ( J .NE. 0 ) THEN
         OUT(I:I) = UPP(J:J)
      ELSE
         OUT(I:I) = C
      ENDIF
      IF ( OUT(I:I) .NE. ' ' ) LEN = I
   ENDDO

   END SUBROUTINE COCUP

   SUBROUTINE COCLB( IN, OUT )
!**   LOGICAL OPERATION
!**       LEFT JUSTIFIES AN ALPHANUMERIC PARAMETER
!**   DESCRIPTION OF PARAMETERS
!**       IN  - AN ALPHANUMERIC PARAMETER CONTAINING 10 CHARACTERS AS
!**             INPUT TO COCLB. IN IS NOT CHANGED.
!**       OUT - AN ALPHANUMERIC PARAMETER THAT AT RETURN SHOULD CONTAIN
!**             A LEFT JUSTIFIES VERSION OF IN.
!**
      IMPLICIT NONE

   CHARACTER*10 OUT
   CHARACTER*10 IN

   CHARACTER*10 IN2
   INTEGER      I, LEN

   CALL COCUP( IN, IN2, LEN )
   OUT = '          '

   DO I = 1, 10
      IF ( IN2(I:I) .NE. ' ' ) THEN
         OUT(1:11-I) = IN2(I:10)
         EXIT
      ENDIF
   ENDDO

   RETURN


   END SUBROUTINE COCLB

   SUBROUTINE COCVAL( IPAR, ITYPE, IVAL, INT, LOG, RL )
!**   LOGICAL OPERATION
!**       DECODES A CHARACTER EXPRESSION STORED IN IPAR ACCORDING TO
!**       THE TYPE IN ITYPE.
!**   DESCRIPTION OF PARAMETERS
!**       IPAR  - A LEFT JUSTIFIED CHARACTER EXPRESSION THAT CONTAINS
!**               THE NUMBER OR LOGICAL VALUE TO BE DECODED.
!**       ITYPE - THE TYPE OF THE VARIABLE:
!**               TypC_Real - Real
!**               TypC_Int  - Integer
!**               TypC_Log  - Logical
!**       IVAL  - A RETURN CODE THAT TELLS IF IPAR HAS BEEN DECODED.
!**               0 MEANS THAT IPAR PROBABLY CONTAINS A NAME OF A CR-
!**               CELL THAT REMAINS IN IPAR, 1 THAT THE DECODE HAS
!**               BEEN SUCCESFUL AND THE RESULT IS IN INT, LOG, OR, RL,
!**               and 2 indicates that the value could not be decoded.
!**       INT   - THE DECODED VALUE IS RETURNED IN INT IF IT IS INTEGER.
!**       LOG   - THE DECODED VALUE IS RETURNED IN LOG IF IT IS LOGICAL.
!**       RL    - THE DECODED VALUE IS RETURNED IN RL IF IT IS REAL.
!**   ABNORMAL CONDITIONS
!**       IF AN ILLEGAL INTEGER OR REAL NUMBER IS DETECTED AN ERROR
!**       MESSAGE IS PRINTED, IVAL IS RETURNED AS 1, AND LKCPCE IS
!**       INCREASED BY 1.
!*
   CHARACTER*10 IPAR
   REAL(CO_R)       RL
   INTEGER      IVAL, ITYPE, INT
   LOGICAL      LOG

   CHARACTER*10 HELP
   REAL         VAL

   IVAL = 1
!
!  Initialize to avoid problems with undefined values
!
   LOG  = .FALSE.
   INT  = 123456
   RL   = 123456.789D0
!
!  Itype = TypC_Int: INTEGER. IF THE FIRST CHARACTER IS ALPABETIC, GO
!                    TO 6, ELSE DECODE. IN CASE OF ERROR, GO TO 7.
!
   IF ( ITYPE .EQ. TYPC_INT ) THEN
      IF ( IPAR(1:1) .GE. 'A' .AND. IPAR(1:1) .LE. 'Z' ) THEN
         IVAL = 0  
         RETURN
      ENDIF
      CALL COCRB(IPAR,HELP)
      READ(HELP,"(F10.0)",ERR=600) VAL
      IF ( VAL .GT. 0.0 ) THEN
         INT = VAL + 0.5
      ELSEIF ( VAL .LT. 0.0 ) THEN
         INT = VAL - 0.5
      ELSE
         INT = VAL
      ENDIF
   ELSEIF ( ITYPE .EQ. TYPC_REAL ) THEN
!
!  ITYPE = TypC_Real: REAL.
!
      IF ( IPAR(1:1) .GE. 'A' .AND. IPAR(1:1) .LE. 'Z' ) THEN
         IVAL = 0  
         RETURN
      ENDIF
      CALL COCRB(IPAR,HELP)
      READ(HELP,"(F10.0)",ERR=600) RL
   ELSEIF ( ITYPE .EQ. TYPC_LOG ) THEN
!
!  ITYPE = TypC_Log: LOGICAL. TEST IF IPAR IS EQUAL TO 'T', 'TRUE', 'ON',
!             or 'F', 'FALSE', or 'OFF'. IF NOT it must be a name.
!
      IF     ( IPAR .EQ. 'T         ' .OR. IPAR .EQ. 'TRUE      ' .OR. IPAR .EQ. 'ON        ' ) THEN
         LOG = .TRUE.
      ELSEIF ( IPAR .EQ. 'F         ' .OR. IPAR .EQ. 'FALSE     ' .OR. IPAR .EQ. 'OFF       ') THEN
         LOG = .FALSE.
      ELSE
         IVAL = 0  
      ENDIF
   ENDIF
   RETURN
!
!  ERROR: RETURN WITH IVAL = 2
!
  600 IVAL = 2
   RETURN

   CONTAINS

   SUBROUTINE COCRB( IN, OUT )
!**   LOGICAL OPERATION
!**       RIGHT JUSTIFIES AN ALPHANUMERIC PARAMETER.
!**   DESCRIPTION OF PARAMETERS
!**       IN    - CONTAINS A 10-CHARACTER PARAMETER TO BE RIGHT
!**               JUSTIFIED. IN IS NOT CHANGED.
!**       OUT   - 10-CHARACTER PARAMETER THAT RETURNS THE RIGHT
!**               JUSTIFIED VERSION OF IN.
!**
      IMPLICIT NONE

   CHARACTER*10 IN, OUT
   INTEGER      I

   OUT = '          '

   DO I=1,10
      IF ( IN(11-I:11-I) .NE. ' ' ) THEN
         OUT(I:10) = IN(1:11-I)
         EXIT
      ENDIF
   ENDDO

   END SUBROUTINE COCRB

   END SUBROUTINE COCVAL

   SUBROUTINE COTOKN( NUM, ILINE, OLINE, LAST, TOKEN, STOKEN, NTOKEN )
!**   Logical Operation
!**       Breaks the input line stored in Iline into tokens
!**       delimited by spaces, commas, = signs, or tabs.
!**
   Use CONOPT_Data
      IMPLICIT NONE

   CHARACTER*(CO_ILineLen) ILINE
   CHARACTER*(CO_OLineLen) OLINE
   CHARACTER*10 TOKEN(10)
   INTEGER NTOKEN, STOKEN(10), NUM, LAST
   INTEGER I, POS, ENDC, TOKBEG, TOKEND, TLAST
   CHARACTER*(CO_OLineLen) TLINE
   LOGICAL INWORD

!
!  Expand tabs:
!
   POS   = 1
   LAST  = 1
   OLINE = ' '
   DO I = 1, CO_ILINELEN
      IF ( POS .GT. CO_OLineLen ) EXIT
      IF ( ILINE(I:I) .NE. CHAR(9) ) THEN
         OLINE(POS:POS) = ILINE(I:I)
         IF ( ILINE(I:I) .NE. ' ' ) LAST = POS
         POS = POS + 1
      ELSE
         ENDC = MIN( (POS+7)/8*8, CO_OlineLen )
         OLINE(POS:ENDC) = ' '
         POS = ENDC + 1
      ENDIF
   ENDDO
!
!  Replace all commas, equal signs, colons, and semicolons by blanks
!
   DO I = 1, LAST
      IF ( OLINE(I:I) .EQ. '=' ) THEN
         TLINE(I:I) = ' '
      ELSEIF ( OLINE(I:I) .EQ. ',' ) THEN
         TLINE(I:I) = ' '
      ELSEIF ( OLINE(I:I) .EQ. ':' ) THEN
         TLINE(I:I) = ' '
      ELSEIF ( OLINE(I:I) .EQ. ';' ) THEN
         TLINE(I:I) = ' '
      ELSE
         TLINE(I:I) = OLINE(I:I)
      ENDIF
   ENDDO
!
!  Remove any comments following a # or ! sign
!
   TLAST = LAST
   I = INDEX( TLINE(1:TLAST), '#' )
   IF ( I .NE. 0 ) TLAST = I-1
   I = INDEX( TLINE(1:TLAST), '!' )
   IF ( I .NE. 0 ) TLAST = I-1
!
!  Break into tokens
!
   NTOKEN = 0
   IF ( OLINE(1:1) .EQ. '*' ) RETURN
   INWORD = .FALSE.
   DO I = 1, TLAST
      IF ( INWORD ) THEN
         IF ( TLINE(I:I) .EQ. ' ' ) THEN
            NTOKEN         = NTOKEN + 1
            TOKEND         = MIN( TOKBEG+9, I-1 )
            TOKEN(NTOKEN)  = TLINE(TOKBEG:TOKEND)
            STOKEN(NTOKEN) = TOKBEG
            INWORD         = .FALSE.
            IF ( NTOKEN .GE. 10 ) EXIT
         ENDIF
      ELSE
         IF ( TLINE(I:I) .NE. ' ' ) THEN
            TOKBEG = I
            INWORD = .TRUE.
         ENDIF
      ENDIF
   ENDDO
   IF ( INWORD ) THEN
      NTOKEN = NTOKEN + 1
      TOKEND = MIN( TOKBEG+9, TLAST )
      TOKEN(NTOKEN) = TLINE(TOKBEG:TOKEND)
      STOKEN(NTOKEN) = TOKBEG
   ENDIF
!
!  Remove (DEFAULT) from the list of tokens
!
   IF ( NTOKEN .GT. 0 ) THEN
      IF ( TOKEN(NTOKEN) .EQ. '(DEFAULT)' ) NTOKEN = NTOKEN - 1
   ENDIF

   END SUBROUTINE COTOKN

   SUBROUTINE COCEOF( ILINE, FOUND )
!**   Logical Operation
!**       Check for end of file and removes junk at the end.
!**       On some Unix systems there can be a problem when reading
!**       files without a new-line character at the end. Following
!**       a zero character there can be junk left from some other
!**       buffer. This routine checks for a zero character and if
!**       one is found, the rest of the line is cleared.
!**
   Use CONOPT_Data
      IMPLICIT NONE

   CHARACTER*(CO_ILINELEN) ILINE
   LOGICAL, Intent(Out) :: FOUND 
                                 ! was found

   INTEGER I

   DO I = 1, CO_ILINELEN
      IF ( ICHAR(ILINE(I:I)) .EQ. 0 ) THEN
         ILINE(I:CO_ILineLen) = ' '
         FOUND = .TRUE.
         RETURN
      ENDIF
   ENDDO
   FOUND = .FALSE.

   END SUBROUTINE COCEOF

   SUBROUTINE COGTCH( KL, RL )
!**   Logical Operation
!**      Converts a REAL(CO_R) to a character*8 using as little cheating
!**      as possible.
!*
   USE CONOPT_Data
      IMPLICIT NONE

   REAL(CO_R) RL
   CHARACTER*8 KL

   Integer (Kind=1) I_Local(8)
   REAL(CO_R) RL_LOCAL
   EQUIVALENCE (I_LOCAL,RL_LOCAL)

   INTEGER I, IARG

   RL_LOCAL = RL
   DO I = 1, 8
      IARG    = I_LOCAL(I)  
      KL(I:I) = CHAR( IARG )
   ENDDO

   END SUBROUTINE COGTCH

   SUBROUTINE COPTCH( KL, RL )
!**   Logical Operation
!**      Converts a character*8 to a REAL(CO_R) using as little cheating
!**      as possible.
!*
   USE CONOPT_Data
      IMPLICIT NONE
   REAL(CO_R) RL
   CHARACTER*8 KL

   Integer (Kind=1) I_Local(8)
   REAL(CO_R) RL_LOCAL
   EQUIVALENCE (I_LOCAL,RL_LOCAL)
   INTEGER I

   DO I = 1, 8
      I_LOCAL(I) = ICHAR( KL(I:I) )
   ENDDO
   RL = RL_LOCAL

   END SUBROUTINE COPTCH
!
!  The four next routines are pricing routines that computes -U*Jacobian
!  in some form. The differences are:
!
!  Coprc1: Computes Gr = -U*Jacobian for Icol = Rgfr(i), i=from, to
!  Coprc2: Computes Gr = Gr-U*Jacobian for Icol = Rgfr(i), i=from, to
!  Coprc3: Computes Gr = -U*Jacobian for Icol = Rgfr(i), i= from, Lknnfx AND Anrm >= 1.
!  Coprc4: Computes Gr = -U*Jacobian for all columns using a row-wise scan
!          of rows with nonzero U.
!
   SUBROUTINE COPRC1( CMI, GR, U, STCL, RNUM, JACE, RGFR, FROM, TO )
!**   Logical Operation
!**      Computes Gr = -U*Jacobian for a subset of the nonbasic
!**      columns defines by From and To.
!**   Description of parameters
!**      GR     - The vector in which some of the nonbasic positions
!**               will be defined.
!**      U      - A vector of row weights.
!**      FROM   - The columns with indiced Rgfr(i) for i = From to
!**      TO       To are updated.
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R)  GR(*), U(*), JACE(*)
   INTEGER STCL(*), RNUM(*), RGFR(*), FROM, TO

   REAL(CO_R)  S
   INTEGER IRG, J, J1, J2, ICOL

   DO IRG = FROM, TO
      ICOL = RGFR(IRG)
      IF ( ICOL .GT. CMI%LJNSTR ) THEN
         GR(ICOL) = - U(ICOL-CMI%LJNSTR)
      ELSE
         J1 = STCL(ICOL)
         J2 = STCL(ICOL+1) - 1
         IF ( J2 .LE. J1 + 1 ) THEN
            IF ( J2 .EQ. J1 ) THEN
               GR(ICOL) = - U( RNUM(J1) ) * JACE(J1)
            ELSEIF ( J2 .EQ. J1 + 1 ) THEN
               GR(ICOL) = - U( RNUM(J1) ) * JACE(J1) - U( RNUM(J1+1) ) * JACE(J1+1)
            ELSE
               GR(ICOL) = 0.D0
            ENDIF
         ELSE
            S  = 0.D0
            DO J = J1, J2
               S = S - U( RNUM(J) ) * JACE(J)
            ENDDO
            GR(ICOL) = S
         ENDIF
      ENDIF
   ENDDO

   END SUBROUTINE COPRC1

   SUBROUTINE COPRC2( CMI, GR, U, STCL, RNUM, JACE, RGFR, FROM, TO )
!**   Logical Operation
!**      Computes Gr = Gr-U*Jacobian for a subset of the nonbasic
!**      columns defines by From and To.
!**   Description of parameters
!**      GR     - The vector in which some of the nonbasic positions
!**               will be defined.
!**      U      - A vector of row weights.
!**      FROM   - The columns with indiced Rgfr(i) for i = From to
!**      TO       To are updated.
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R)  GR(*), U(*), JACE(*)
   INTEGER STCL(*), RNUM(*), RGFR(*), FROM, TO

   REAL(CO_R)  S
   INTEGER IRG, J, J1, J2, ICOL

   DO IRG = FROM, TO
      ICOL = RGFR(IRG)
      IF ( ICOL .GT. CMI%LJNSTR ) THEN
         GR(ICOL) = GR(ICOL) - U(ICOL-CMI%LJNSTR)
      ELSE
         J1 = STCL(ICOL)
         J2 = STCL(ICOL+1) - 1
         IF ( J2 .LE. J1 + 1 ) THEN
            IF ( J2 .EQ. J1 ) THEN
               GR(ICOL) = GR(ICOL) - U( RNUM(J1) ) * JACE(J1)
            ELSEIF ( J2 .EQ. J1 + 1 ) THEN
               GR(ICOL) = GR(ICOL) - U( RNUM(J1) ) * JACE(J1) - U( RNUM(J1+1) ) * JACE(J1+1)
            ELSE
               GR(ICOL) = 0.D0
            ENDIF
         ELSE
            S  = GR(ICOL)
            DO J = J1, J2
               S = S - U( RNUM(J) ) * JACE(J)
            ENDDO
            GR(ICOL) = S
         ENDIF
      ENDIF
   ENDDO

   END SUBROUTINE COPRC2

   SUBROUTINE COPRC3( CMI, GR, U, STCL, RNUM, JACE, RGFR, ANRM, FROM )
!**   Logical Operation
!**      Computes Gr = -U*Jacobian for a subset of the nonbasic
!**      columns defined by Rgfr(i), i = From to Lknnfx and Anrm being
!**      greater than or equal to 1.
!**   Description of parameters
!**      GR     - The vector in which some of the nonbasic positions
!**               will be defined.
!**      U      - A vector of row weights.
!**      FROM   - The columns with indices Rgfr(i) for i = From to
!**               LKNNFX.
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R)  GR(*), U(*), JACE(*), ANRM(*)
   INTEGER STCL(*), RNUM(*), RGFR(*), FROM

   REAL(CO_R)  S
   INTEGER IRG, J, J1, J2, ICOL

   DO IRG = FROM, CMI%LKNNFX
      ICOL = RGFR(IRG)
      IF ( ICOL .GT. CMI%LJNSTR ) THEN
         GR(ICOL) = - U(ICOL-CMI%LJNSTR)
      ELSE
         IF ( ANRM(ICOL) .GE. 1.D0) THEN
            J1 = STCL(ICOL)
            J2 = STCL(ICOL+1) - 1
            IF ( J2 .LE. J1 + 1 ) THEN
               IF ( J2 .EQ. J1 ) THEN
                  GR(ICOL) = - U( RNUM(J1) ) * JACE(J1)
               ELSEIF ( J2 .EQ. J1 + 1 ) THEN
                  GR(ICOL) = - U( RNUM(J1) ) * JACE(J1) - U( RNUM(J1+1) ) * JACE(J1+1)
               ELSE
                  GR(ICOL) = 0.D0
               ENDIF
            ELSE
               S  = 0.D0
               DO J = J1, J2
                  S = S - U( RNUM(J) ) * JACE(J)
               ENDDO
               GR(ICOL) = S
            ENDIF
         ENDIF
      ENDIF
   ENDDO

   END SUBROUTINE COPRC3

   SUBROUTINE COPRC4( CMI, GR, U, STLR, RCNU, RJAC, UIN )
!**   Logical Operation
!**      Computes Gr = -U*Jacobian for all variables using a row-vise
!**      method in which rows with zero U are skipped.
!**   Description of parameters
!**      GR     - The vector in which the result will be returned.
!**               Both basic and nonbasic positions will be filled.
!**      U      - A vector of row weights.
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R)  GR(*), U(*), RJAC(*)
   INTEGER STLR(*), RCNU(*), UIN(*)

   REAL(CO_R)  S
   INTEGER I, J, ICOL, IROW

   DO ICOL = 1, CMI%LJNSTR
      GR(ICOL) = 0.D0
   ENDDO

   CMI%LSUIN = .TRUE.
   CMI%LKUIN = 0

   DO IROW = 1, CMI%LJNROW
      S                   = U(IROW)
      GR(IROW+CMI%LJNSTR) = -S
      IF ( ABS( S ) .GT. CMI%RTEPS0 ) THEN
         CMI%LKUIN      = CMI%LKUIN + 1
         UIN(CMI%LKUIN) = IROW
      ENDIF
   ENDDO
!
!  If we could map from the column numbers into the nonbasic
!  indices then we could collect the sparsety pattern for Gr
!  at this point, assuming that LKUIN is very small. This could
!  then be used in Coanup and Cordgr.
!
   DO I = 1, CMI%LKUIN
      IROW = UIN(I)
      S    = U(IROW)
      DO J = STLR(IROW), STLR(IROW+1)-1
         ICOL     = RCNU(J)
         GR(ICOL) = GR(ICOL) - S * RJAC(J)
      ENDDO
   ENDDO

   END SUBROUTINE COPRC4

   SUBROUTINE COIRGR( CMI, XL, JL )
!**   Logical operation
!**      Initializes Rgfr and LKNNFX
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R) XL(*); INTEGER JL(*)

   INTEGER IRG, IRG1, ICOL

   IRG    = 0
   IRG1   = CMI%LJNSTR
   DO ICOL = 1, CMI%LJNCOL
      IF ( JL(CMI%LLBASC+ICOL) .LE. 0 ) THEN
         IF ( XL(CMI%LLXMIN+ICOL) .NE. XL(CMI%LLXMAX+ICOL) ) THEN
            JL(CMI%LLBASC+ICOL) = 0
            IRG                 = IRG + 1
            JL(CMI%LLRGFR+IRG)  = ICOL
         ELSE
            JL(CMI%LLBASC+ICOL) = -1
            JL(CMI%LLRGFR+IRG1) = ICOL
            IRG1                = IRG1 - 1
         ENDIF
      ENDIF
   ENDDO
   CMI%LKNNFX = IRG
   CMI%LKNSUP = 0

! $if defined (testout)
   IF ( CMI%LOREDG .GT. 0 ) THEN
      WRITE(CMI%MSGTXT,"('Coirgr: Rgfr recreated. LKNNFX=',I8)") CMI%LKNNFX
      CALL CO2DOC( CMI, Asis )
   ENDIF
! $endif

   END SUBROUTINE COIRGR


   SUBROUTINE COTANG( CMI, ALLV, X1, X2, DIR, RGFR, STCL, RNUM, JACE,  &
                      RNTO, CNTO, LS, LPIV, LROW, LMAT, CS, CL, IR,    &
                      BMAT, HLP1, RWCL, XL, JL )
!**   LOGICAL OPERATION
!**       Finds the tangent to the direction of change of all variables
!**       when the super basic variables changes in the direction Dir.
!**   DESCRIPTION OF PARAMETERS
!**       ALLV - Logical that is .true. when the tangent is needed for
!**              all variables, and .false. when the post-triangular
!**              component is not needed.
!**       X2   - returns the tangent direction for both basic and
!**              superbasic variables.
!**       None
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R) XL(*); INTEGER JL(*)

   REAL(CO_R)  X1(*), X2(*), DIR(*), JACE(*), LMAT(*), BMAT(*)
   INTEGER RGFR(*), STCL(*), RNUM(*), RNTO(*), CNTO(*), LS(*), LROW(*), LPIV(*), IR(*), &
           CS(*), CL(*), HLP1(*), RWCL(*)
   LOGICAL, Intent(IN) :: ALLV

   INTEGER ICOL, IROW, IS, J, indx
   REAL(CO_R)  DIR1, Dirmax
   DOUBLE PRECISION TTANGN
!
!  Move Dir to the superbasic positions in X2.
!
! $if defined (testout)
   IF ( CMI%LOTANG .GT. 0 ) THEN
      TTANGN = COCLCK( CMI )
      IF ( CMI%LOTANG .GT. 1 ) THEN
         WRITE(CMI%MSGTXT,"('On Entry to Cotang. Number of Superbasics=',I5)") CMI%LKNSUP
         CALL CO2DOC( CMI, Asis )
         CALL COPSRL( CMI, CMI%LNDIR , DIR , CMI%LKNSUP )
      ENDIF
   ENDIF
! $endif
!
!  During degenerate iteration we may look at non super-basic
!  columns. During the iteration in which degeneracy is started
!  LSDEGI has not been defined when Cotang is called and
!  X2 will not be defined as 0, but in this case only basic and
!  super basic columns will be added to the list Dcol.
!
   IF ( ALLV ) THEN
! $if defined (testout)
      IF ( CMI%LOTANG .GT. 1 ) THEN
         CMI%MSGTXT = 'Allv = true: clear X2 completely in Cotang'
         CALL CO2DOC( CMI, Asis )
      ENDIF
! $endif
      DO ICOL = 1, CMI%LJNCOL
         X2(ICOL) = 0.D0
      ENDDO
   ELSEIF ( CMI%LSDEGI ) THEN
      IF ( CMI%LJDEGI .LE. CMI%LJNCOL / 3 ) THEN
! $if defined (testout)
         IF ( CMI%LOTANG .GT. 1 ) THEN
            WRITE(CMI%MSGTXT,*) 'Doing a short X2 clear in Cotang. LJDEGI=',CMI%LJDEGI
            CALL CO2DOC( CMI, Asis )
         ENDIF
! $endif
         DO J = 1, CMI%LJDEGI
            X2(IABS(JL(CMI%LLDCOL+J))) = 0.D0
         ENDDO
      ELSE
! $if defined (testout)
         IF ( CMI%LOTANG .GT. 1 ) THEN
            CMI%MSGTXT = 'Doing a complete X2 clear in Cotang'
            CALL CO2DOC( CMI, Asis )
         ENDIF
! $endif
         DO ICOL = 1, CMI%LJNCOL
            X2(ICOL) = 0.D0
         ENDDO
      ENDIF
   ELSE
! $if defined (testout)
      IF ( CMI%LOTANG .GT. 1 ) THEN
         CMI%MSGTXT = 'X2 is not cleared in Cotang.'
         CALL CO2DOC( CMI, Asis )
      ENDIF
! $endif
   ENDIF
   IF ( CMI%LKNSUP .EQ. 1 .AND. .NOT. CMI%LSONDI .AND. .NOT. CMI%LSIOND ) THEN
!
!  There is only one superbasic column. Update it and remember it
!  in Nwk2 for potential use in Coanup.
!
      CMI%LKASUP = 1
      ICOL   = RGFR(1)
!
!  Update the superbasic column. The result will be returned in Nwk2
!
      CALL COUPCL( CMI, ICOL  , XL(CMI%LLNWK2+1), RNTO, CNTO, LS  , LPIV, LROW, LMAT, &
                   CS  , CL  , IR  , BMAT, HLP1, STCL, RNUM, JACE, .FALSE., XL, JL )
! $if defined (testout)
      IF ( CMI%LOTANG .GT. 1 ) THEN
         CMI%MSGTXT = 'The Updated Superbasic Column. Index=Rowno'
         CALL CO2DOC( CMI, Asis )
         CALL COPVRL( CMI, CMI%LNNWK2, XL(CMI%LLNWK2+1) )
      ENDIF
! $endif
      DIR1     = DIR(1)
      X2(ICOL) = DIR1
      DIR1     = -DIR1
      DO IROW = 1, CMI%LJNROW
         X2( RWCL(IROW) ) = XL(CMI%LLNWK2+IROW) * DIR1
      ENDDO
      CMI%RTMXUC = CMI%RTMXUC * ABS(DIR1)
! $if defined (testout)
      IF ( CMI%LOTANG .GT. 1 ) THEN
         WRITE(CMI%MSGTXT,*) 'Rtmxuc updated to', CMI%RTMXUC
         CALL CO2DOC( CMI, Asis )
      ENDIF
! $endif
   ELSE
!
!  There are more than one superbasic column.
!
      DO IROW = 1, CMI%LJNROW
         X1(IROW) = 0.D0
      ENDDO
      CMI%LKASUP = 0
      DO IS = 1, CMI%LKNSUP
         ICOL = RGFR(IS)
         DIR1 = DIR(IS)
         IF ( ABS(DIR1) .GT. 0.D0 ) THEN
            X2(ICOL) = DIR1
!
!  Compute the first order changes in the constraints from the
!  changes in superbasics.
!
            CMI%LKASUP = CMI%LKASUP + 1
            DO J = STCL(ICOL), STCL(ICOL+1)-1
               IROW     = RNUM(J)
               X1(IROW) = X1(IROW) - JACE(J) * DIR1
            ENDDO
         ELSE
            X2(ICOL) = 0.D0
         ENDIF
      ENDDO
!
!  Compute the changes in the basic variables by performing a
!  Coftrl on the vector of first order changes in the constraints.
!
! $if defined (testout)
      IF ( CMI%LOTANG .GT. 2 ) THEN
         CMI%MSGTXT = ' First order changes in constraints from superbasics'
         CALL CO2DOC( CMI, Asis )
         CALL COPSRL( CMI, CMI%LNX1  , X1, CMI%LJNROW )
         IF ( CMI%LOTANG .GT. 3 ) THEN
            CALL COPSRL( CMI, CMI%LNDIR , DIR , CMI%LKNSUP )
            CALL COPSJL( CMI, CMI%LNRGFR, RGFR, CMI%LKNSUP )
         ENDIF
      ENDIF
! $endif
      CALL COFTRL( CMI, ALLV, X1, X2, RNTO, CNTO, LS, LPIV, LROW, LMAT, &
                   CS, CL, IR, BMAT, HLP1, RWCL, XL, JL )
   ENDIF
! $if defined (testout)
   IF ( CMI%LOTANG .GT. 0 ) THEN
      IF ( CMI%LOTANG .GT. 1 ) THEN
         CMI%MSGTXT = ' The tangent vector is'
         CALL CO2DOC( CMI, Asis )
         CALL COPVRL( CMI, CMI%LNX2  , X2 )
      ENDIF
      TTANGN = COCLCK( CMI ) - TTANGN
      WRITE(CMI%MSGTXT,"('Time in Cotang:',f8.3,' Seconds')") TTANGN
      CALL CO2DOC( CMI, Asis )
   ENDIF
! $endif
! $if defined (testing)
   if ( CMI%LSTSLU .or. CMI%LSTSRI .or. CMI%LSTSUP ) then
      write(CMI%MSGTXT,*) 'Cotang: Testing Jac*Dir = 0. Allv=',allv
      CALL CO2DOC( CMI, Asis )
!
!  Test that Jacobian * Direction = 0.
!
      DO IROW = 1, CMI%LJNROW
         X1(IROW) = 0.D0
      ENDDO
      dirmax = 0.d0
!
!  Accumulate the superbasic component
!
      DO IS = 1, CMI%LKNSUP
         ICOL = RGFR(IS)
         DIR1 = X2(ICOL)
         dirmax = max(dirmax, dir1)
         DO J = STCL(ICOL), STCL(ICOL+1)-1
            IROW     = RNUM(J)
            X1(IROW) = X1(IROW) - JACE(J) * DIR1
         ENDDO
      ENDDO
!
!  Add the basic component
!
      do indx = 1, CMI%LJNROW
         icol = jl(CMI%LLRWCL+indx)
         DIR1 = X2(ICOL)
         dirmax = max(dirmax, dir1)
         DO J = STCL(ICOL), STCL(ICOL+1)-1
            IROW     = RNUM(J)
            X1(IROW) = X1(IROW) - JACE(J) * DIR1
         ENDDO
      ENDDO
!
!  Test that the residual is zero
!
      if ( allv ) then
         do irow = 1, CMI%LJNROW
            if ( abs(x1(irow)) .gt. 1.e-7 * dirmax ) then
               indx = jl(CMI%LLROTN+irow)
               write(CMI%MSGTXT,*) 'Cotang: Residual large in row',irow, ' (indx=',indx,'):',x1(irow),' Dirmax=',dirmax
               CALL CO2DOC( CMI, Asis )
            endif
        enddo
     else
         do indx = cmi%lktria+1, CMI%LJNROW
            irow = jl(cmi%llrnto+indx)
            if ( abs(x1(irow)) .gt. 1.e-7 * dirmax ) then
               write(CMI%MSGTXT,*) 'Cotang: Residual large in row',irow, ' (indx=',indx,'):',x1(irow),' Dirmax=',dirmax
               CALL CO2DOC( CMI, Asis )
            endif
        enddo
     endif
   endif
! $endif

   END SUBROUTINE COTANG

   SUBROUTINE COBTRL( CMI, GR, U, NWK1, RNTO, CNTO, COTN, CBTO, LS, LPIV, LROW, LMAT, LSTR, &
                      RS, RL, IC, AMAT, HLPZ, HEAP, ICOLCR )
!**   LOGICAL OPERATION
!**       Performs a Btran on a vector of length the number of vari-
!**       ables. Returns a transformed vector of length the number
!**       of rows.
!**   DESCRIPTION OF PARAMETERS
!**       GR     - The input vector that is going to be transformed. The
!**                basic part of Gr is multiplied to the right by the
!**                inverse basis matrix to yield U.
!**                The basic part of Gr is never changed.
!**       U      - An output vector that will return the basic part of
!**                Gr*Inverse basis.
!**       ICOLCR - If nonzero, then only position ICOLCR of GR is
!**                nonzero. The rest of GR is not defined. Icolcr must
!**                be a basic column.
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI

   REAL(CO_R)  GR(*), U(*), NWK1(*), LMAT(*), AMAT(*)
   INTEGER RNTO(*), CNTO(*), LS(*), LPIV(*), LROW(*), RS(*), RL(*), IC(*), CBTO(*), COTN(*), &
      LSTR(*), HLPZ(*), HEAP(*)
   INTEGER ICOLCR

   INTEGER INDX, INDXCR

   IF ( ICOLCR .NE. 0 ) THEN
      IF ( CMI%LJINCR .NE. 0 .AND. CBTO(CMI%LJINCR) .EQ. ICOLCR ) THEN
         INDXCR = CMI%LJINCR
      ELSE
         DO INDX = 1, CMI%LJNROW
            IF ( CBTO(INDX) .EQ. ICOLCR ) GO TO 103
         ENDDO
         WRITE(CMI%MSGTXT,*) 'Cobtrl with Icolcr=',icolcr,' not found in Cbto.'
         CALL CO2DOC( CMI, Asis )
         CALL COSYSE( CMI, 1006, .TRUE. )
         RETURN
103      INDXCR = INDX
         CMI%LJINCR = INDX
      ENDIF
      DO INDX = 1, CMI%LJNROW
         U(INDX)    = 0.D0
         NWK1(INDX) = 0.D0
      ENDDO
      NWK1(CNTO(INDXCR)) = GR(ICOLCR)
   ELSE
      DO INDX = 1, CMI%LJNROW
         NWK1(CNTO(INDX)) = GR( CBTO(INDX) )
      ENDDO
      INDXCR = 0
   ENDIF

   CALL COSXUY( CMI, U, NWK1, RNTO, CNTO, RS, RL, IC, AMAT, COTN, HLPZ, HEAP, INDXCR )

   CALL COSXL ( CMI, U, LS, LPIV, LROW, LMAT, LSTR )

   END SUBROUTINE COBTRL

   SUBROUTINE COFTRL( CMI, ALLV, U, GR, RNTO, CNTO, LS, LPIV, LROW, LMAT, CS, CL, IR, BMAT, &
                      HLP1, RWCL, XL, JL )
!**   LOGICAL OPERATION
!**       Performs an Ftran on the vector U of length LJNROW
!**       indexed over the rows, and returns the result in U and
!**       in the basic positions of Gr - a vector of length LJNCOL
!**       indexed over all columns.
!**   DESCRIPTION OF PARAMETERS
!**       ALLV   - If .false. then the post-triangular components may
!**                not be computed. If .true., also post-triangular
!**                elements are computed.
!**       U      - The vector to be transformed. The result is returned
!**                in U.
!**       GR     - The transformed vector is also returned in the basic
!**                positions of Gr. The nonbasic elements are not
!**                changed.
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R) XL(*); INTEGER JL(*)
   REAL(CO_R)  U(*), GR(*), LMAT(*), BMAT(*)
   INTEGER RNTO(*), CNTO(*), LS(*), LPIV(*), LROW(*), CS(*), CL(*), IR(*), HLP1(*), RWCL(*)
   LOGICAL, Intent(IN) :: ALLV

   INTEGER IROW

!
!  Transform the vector
!
   CALL COFTRC( CMI, ALLV, U, RNTO, CNTO, LS, LPIV, LROW, LMAT, CS, CL, IR, BMAT, HLP1, XL, JL )
!
!  Move the transformed vector to Gr.
!
   DO IROW = 1, CMI%LJNROW
      GR( RWCL(IROW) ) = U( IROW )
   ENDDO

   END SUBROUTINE COFTRL

   SUBROUTINE COFTRC( CMI, ALLV, W, RNTO, CNTO, LS, LPIV, LROW, LMAT, CS, CL, IR, BMAT, HLP1, XL, JL )
!**   LOGICAL OPERATION
!**       Performs an Ftran on a vector. The vector is assumed to have
!**       zeros in the pre-triangular rows.
!**   DESCRIPTION OF PARAMETERS
!**       W      - It must as input contain the (column) vector
!**                to be transformed. It will return the transformed
!**                vector.
!**
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R) XL(*); INTEGER JL(*)
   REAL(CO_R)  W(*), BMAT(*), LMAT(*)
   INTEGER RNTO(*), CNTO(*), LS(*), LPIV(*), LROW(*), CS(*), CL(*), IR(*), HLP1(*)
   LOGICAL, Intent(IN) :: ALLV
!
!  Solve L * X = W and save solution in W
!
   CALL COSLX ( CMI, W, LS, LPIV, LROW, LMAT, XL, JL )
!
!  Solve U * X = W and save solution in W.
!
   CALL COSUXY( CMI, ALLV, W, RNTO, CNTO, CS, CL, IR, BMAT, HLP1 )

   END SUBROUTINE COFTRC

   SUBROUTINE COSXL( CMI, X, LS, LPIV, LROW, LMAT, LSTR )
!**   LOGICAL OPERATION
!**       Solves the set of equations
!**       X * L = Y
!**       where X is the row-vector of unknowns. Y and X use the
!**       same space.
!**   DESCRIPTION OF PARAMETERS
!**       X - The vector of right hand sides (input) and the
!**           solution vector (output). The indices are the
!**           original row numbers, i.e. the output vector
!**           can be considered a vector of multipliers on the
!**           rows.
!**
      IMPLICIT NONE
   Type (conopt_model_info) CMI

   REAL(CO_R)  X(*), LMAT(*)
   INTEGER LS(*), LPIV(*), LROW(*), LSTR(*)

   INTEGER ICOL, J, JSTR, JEND, ICOL1, I
   REAL(CO_R)  XX
!
!  Apply the additional L elements in backward order
!
!  When do we use the double loop, where we can skip some rows,
!  and when do we use the single loop without much overhead?
!  Statistics with one GAMS model with 500 equ:
!  Factor  Cycles per call
!    3          10793
!    4          10479
!    5          10419
!
   IF ( CMI%LKLFIL-LS(CMI%LKLORG+1)+1 .GT. CMI%LKLSTR * 5 ) THEN
      JSTR = LSTR(CMI%LKLSTR+1)
      DO I = CMI%LKLSTR, 1, -1
         JEND = JSTR - 1
         JSTR = LSTR(I)
         XX   = X( LROW(JSTR) )
         IF ( XX .NE. 0.D0 ) THEN
            DO J = JSTR, JEND
               ICOL = LPIV(J)
               X(ICOL) = X(ICOL) - LMAT(J) * XX
            ENDDO
         ENDIF
      ENDDO
   ELSE
      JSTR = LS(CMI%LKLORG+1)
      DO J = CMI%LKLFIL, JSTR, -1
         ICOL    = LPIV(J)
         X(ICOL) = X(ICOL) - LMAT(J) * X( LROW(J) )
      ENDDO
   ENDIF
!
!  Apply the original L elements from the L-U facotrization in
!  backward order.
!
!  Some statistics for this test:
!  Factor  Cycles per call (for whole routine incl loop above)
!    0       10419
!    4        9410 (first loop only executed very few times)
!    5        9419 (first loop was never used)
!
   IF ( JSTR .GT. CMI%LKLORG * 4 ) THEN
      DO ICOL = CMI%LKLORG, 1, -1
         JEND  = JSTR - 1
         JSTR  = LS(ICOL)
         ICOL1 = LPIV(JSTR)
         IF ( JSTR .EQ. JEND ) THEN
            X(ICOL1) = X(ICOL1) - LMAT(JSTR) * X( LROW(JSTR) )
         ELSEIF ( JSTR .EQ. JEND-1 ) THEN
            X(ICOL1) = X(ICOL1) - LMAT(JSTR) * X( LROW(JSTR) )  &
                                - LMAT(JEND) * X( LROW(JEND) )
         ELSE
            XX   = X( ICOL1 )
            DO J = JSTR, JEND
               XX   = XX - LMAT(J) * X( LROW(J) )
            ENDDO
            X( ICOL1 ) = XX
         ENDIF
      ENDDO
   ELSE
      JSTR = JSTR-1
      DO J = JSTR, 1, -1
         ICOL    = LPIV(J)
         X(ICOL) = X(ICOL) - LMAT(J) * X( LROW(J) )
      ENDDO
   ENDIF

   END SUBROUTINE COSXL

   SUBROUTINE COUPCL( CMI, ICOL, WORK, RNTO, CNTO, LS, LPIV, LROW, LMAT, CS, CL, IR, BMAT, &
                      HLP1, STCL, RNUM, JACE, CLEAR, XL, JL )
!**   LOGICAL OPERATION
!**       Updates column icol from the Jacobian by premultiplying
!**       with the inverse basis and returns the column in work.
!**   DESCRIPTION OF PARAMETERS
!**       Icol   - The number of the column to be updated (input).
!**       Work   - The vector in which to return the updated
!**                column.
!**       Clear  - Logical that is true if Work is empty on entry
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R) XL(*); INTEGER JL(*)

   REAL(CO_R)  WORK(*), LMAT(*), BMAT(*), JACE(*)
   INTEGER RNTO(*), CNTO(*), LS(*), LPIV(*), LROW(*), CS(*), CL(*), IR(*), HLP1(*), STCL(*), RNUM(*)
   LOGICAL CLEAR

   INTEGER ICOL, IROW, J
!
!  Copy the original column to work after first clearing it if
!  necessary.
!
   IF ( .NOT. CLEAR ) THEN
      DO IROW = 1, CMI%LJNROW
         WORK(IROW) = 0.
      ENDDO
   ENDIF

   DO J = STCL(ICOL), STCL(ICOL+1) - 1
      WORK( RNUM(J) ) = JACE(J)
   ENDDO
!
!  Update the column
!
   CALL COFTRC( CMI, .TRUE., WORK, RNTO, CNTO, LS, LPIV, LROW, LMAT, CS, CL, IR, BMAT, HLP1, XL, JL  )

   END SUBROUTINE COUPCL

   SUBROUTINE COSLX( CMI, X, LS, LPIV, LROW, LMAT, XL, JL )
!**   LOGICAL OPERATION
!**       Solves the set of equations
!**       L * X = Y
!**       where X is the vector of unknowns. Y and X use the
!**       same space. The indices in X and Y are the original
!**       row numbers.
!**   DESCRIPTION OF PARAMETERS
!**       X - The vector of right hand sides (input) and the
!**           solution vector (output).
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R) XL(*); INTEGER JL(*)
   REAL(CO_R)  X(*), LMAT(*)
   INTEGER LS(*), LPIV(*), LROW(*)

   INTEGER IROW, ICOL, J, JSTR, JEND, I
   REAL(CO_R)  XX
!
!  Bypass the pre-triangular columns. The right hand side must have
!  zeros in the corresponding pivot rows.
!
!  Loop over the columns corresponding to the L factor from just after
!  the L-U factorization
!
!  Statistics for the following test:
!  Factor  Cycles (for whole routine)
!     0     4252 (without the test)
!     2     4254 (with the test)
!     3     6206
!
   JEND = CMI%LKLFPR
   IF ( LS(CMI%LKLORG+1) - JEND .GT. 2 * (CMI%LKLORG-CMI%LKLCPR) ) THEN
      DO ICOL = CMI%LKLCPR+1, CMI%LKLORG
         JSTR = JEND + 1
         JEND = LS(ICOL+1) - 1
         XX   = X( LPIV(JSTR) )
         IF ( XX .NE. 0.D0 ) THEN
            IF ( JSTR .EQ. JEND ) THEN
               IROW = LROW(JSTR)
               X(IROW) = X(IROW) - LMAT(JSTR) * XX
            ELSEIF ( JSTR .EQ. JEND-1 ) THEN
               IROW = LROW(JSTR)
               X(IROW) = X(IROW) - LMAT(JSTR) * XX
               IROW = LROW(JEND)
               X(IROW) = X(IROW) - LMAT(JEND) * XX
            ELSE
               DO J = JSTR, JEND
                  IROW = LROW(J)
                  X(IROW) = X(IROW) - LMAT(J) * XX
               ENDDO
            ENDIF
         ENDIF
      ENDDO
   ELSE
      JSTR = JEND + 1
      JEND = LS(CMI%LKLORG+1) - 1
      DO J = JSTR, JEND
         IROW    = LROW(J)
         X(IROW) = X(IROW) - LMAT(J) * X( LPIV(J) )
      ENDDO
   ENDIF
!
!  Loop over the elements (rows) created during the updates of the
!  L-U factorization
!
!  Statistics for the following test:
!  Factor  Cycles (for whole routine)
!     0     4541 (without the test)
!     3     4478
!     4     4280
!     5     4252
!
   IF ( CMI%LKLFIL - JEND .GT. 5 * CMI%LKLSTR ) THEN
      DO I = 1, CMI%LKLSTR
         JSTR = JEND + 1
         JEND = JL(CMI%LLLSTR+I+1)-1
         XX   = 0.D0
         DO J = JSTR, JEND
            XX = XX + LMAT(J) * X( LPIV(J) )
         ENDDO
         IROW    = LROW(JEND)
         X(IROW) = X(IROW) - XX
      ENDDO
   ELSE
      JSTR = JEND + 1
      DO J = JSTR, CMI%LKLFIL
         IROW    = LROW(J)
         X(IROW) = X(IROW) - LMAT(J) * X( LPIV(J) )
      ENDDO
   ENDIF

   END SUBROUTINE COSLX

   SUBROUTINE COSLXS( CMI, X, IX, JX, NX, LS, LPIV, LROW, LMAT, LSTR )
!**   LOGICAL OPERATION
!**       Solves the set of equations
!**       L * X = Y
!**       where X is the vector of unknowns. Y and X
!**       use the same space. The sparsety of X is stored
!**       in the first NX elements of IX, both on input and
!**       on output. IX may point to some 'cancelled' elements
!**       but cancellation does not propagate. JX is nonzero
!**       for the elements in IX. The indices are the original
!**       row numbers.
!**   DESCRIPTION OF PARAMETERS
!**       X  - The vector of right hand sides (input) and the
!**            solution vector (output).
!**       IX - Vector with the indices of the nonzeros in X,
!**            both as input and as output.
!**       JX - Indicator vector that is 1 if X is or has been
!**            nonzero, both as input and as output.
!**       NX - The number of nonzeros in X, both as input and
!**            output.
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI

   REAL(CO_R)  X(*), LMAT(*)
   INTEGER IX(*), JX(*), LS(*), LPIV(*), LROW(*), LSTR(*)

   REAL(CO_R)  XX
   INTEGER NX, IROW, ICOL, J, JSTR, JEND, IROWP, I

   JEND = CMI%LKLFPR
   DO ICOL = CMI%LKLCPR+1, CMI%LKLORG
      JSTR  = JEND + 1
      JEND  = LS(ICOL+1) - 1
      IROWP = LPIV(JSTR)
      IF ( JX(IROWP) .NE. 0 ) THEN
         XX = X( IROWP )
         IF ( XX .NE. 0.D0 ) THEN
            DO J = JSTR, JEND
               IROW    = LROW(J)
               X(IROW) = X(IROW) - LMAT(J) * XX
               IF ( JX(IROW) .EQ. 0 ) THEN
                  JX(IROW) = 1
                  NX       = NX + 1
                  IX(NX)   = IROW
               ENDIF
            ENDDO
         ENDIF
      ENDIF
   ENDDO

   DO I = 1, CMI%LKLSTR
      JSTR = JEND + 1
      JEND = LSTR(I+1)-1
      XX   = 0.D0
      DO J = JSTR, JEND
         XX = XX + LMAT(J) * X( LPIV(J) )
      ENDDO
      IROW    = LROW(JEND)
      X(IROW) = X(IROW) - XX
      IF ( JX(IROW) .EQ. 0 ) THEN
         IF ( X(IROW) .NE. 0.D0 ) THEN
            JX(IROW) = 1
            NX       = NX + 1
            IX(NX)   = IROW
         ENDIF
      ENDIF
   ENDDO

   END SUBROUTINE COSLXS

   SUBROUTINE COSXUY( CMI, X, Y, RNTO, CNTO, RS, RL, IC, AMAT, COTN, HLPZ, HEAP, INDXCR )
!**   LOGICAL OPERATION
!**       Solves the set of equations
!**       X * U = Y
!**       where X is the row-vector of unknowns. Y and X cannot
!**       use the same space. Y is changed.
!**   DESCRIPTION OF PARAMETERS
!**       X - The solution vector (output). The indices are
!**           old row numbers.
!**       Y - The vector of right hand sides (input)
!**           solution vector (output). The indices are old
!**           column numbers.
!**       HLPZ - Used to mark the columns that have a nonzero
!**              element in the heap
!**       HEAP - Used as a min-heap for the indices of the
!**              columns that have a nonzero value and have not
!**              been used so far.
!**       INDXCR - If 0 then the vector Y may contain several
!**                elements, otherwise Y contains one element
!**                only corresponding to index Indxcr.
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI

   REAL(CO_R)  X(*), Y(*), AMAT(*)
   INTEGER RNTO(*), CNTO(*), RS(*), RL(*), IC(*), COTN(*), HLPZ(*), HEAP(*)
   INTEGER INDXCR

   REAL(CO_R)  XX, YMAX
   INTEGER INDX, INDX1, IROW, ICOL, J, JSTR
   INTEGER NHEAP, IH, JH, KH, MOVE, TESTED, NROWD, DENSE
   PARAMETER ( DENSE = 10 )

   IF ( INDXCR .NE. 0 ) THEN
      NROWD = CMI%LJNROW + DENSE
!     YMAX = CMI%RTMINA
!     YMAX = CMI%RTEPS0
      ymax = 0.d0
      TESTED = 0
      IF ( INDXCR .LT. 0 ) THEN
!
!  There are a few elements in Y to start with, namely -Indxcr.
!  Their indices are in the first -Indxcr positions of Heap.
!  Start by creating a real heap:
!
         NHEAP = -INDXCR
         IF ( NHEAP .LE. 2 ) THEN
            IF ( NHEAP .EQ. 2 ) THEN
               IF ( HEAP(1) .GT. HEAP(2) ) THEN
                  INDX    = HEAP(2)
               ELSE
                  INDX    = HEAP(1)
                  HEAP(1) = HEAP(2)
               ENDIF
            ELSE
               INDX = HEAP(1)
            ENDIF
            NHEAP = NHEAP - 1
            GO TO 100
         ELSE
!
!  There are at least three elements in the heap. Use the Heapify
!  algorithm to create a heap. Add a large element at the end to
!  avoid testing for overflow.
!
            IF ( DENSE * NHEAP .GT. NROWD ) THEN
               INDX = 1
               GO TO 101
            ENDIF
            HEAP(NHEAP+1) = NROWD
            DO KH = NHEAP/2, 1, -1
               MOVE  = HEAP(KH)
               IH    = KH
               JH    = IH * 2
104            IF ( HEAP(JH) .GT. HEAP(JH+1) ) JH = JH + 1
               IF ( MOVE .GT. HEAP(JH) ) THEN
                  HEAP(IH) = HEAP(JH)
                  IH       = JH
                  JH       = JH * 2
                  IF ( JH .LE. NHEAP ) GO TO 104
               ENDIF
               HEAP(IH) = MOVE
            ENDDO
         ENDIF
         GO TO 105
      ELSE
!
!  There is only one nonzero to start with, namely in indx Indxcr.
!
         INDX  = INDXCR
         NHEAP = 0
      ENDIF
100   IF ( INDX + DENSE * NHEAP .GT. NROWD ) GO TO 101
      IROW = RNTO(INDX)
      IF ( INDX + DENSE * RL(IROW) .GT. NROWD ) GO TO 101
      ICOL = CNTO(INDX)
      HLPZ(ICOL) = 0
      TESTED = TESTED + 1
      IF ( ABS( Y(ICOL) ) .LE. YMAX ) THEN
         X(IROW) = 0.D0
      ELSE
         JSTR    = RS(IROW)
         XX      = Y(ICOL) / AMAT(JSTR)
         X(IROW) = XX
         DO J = JSTR+1, JSTR + RL(IROW) - 1
            ICOL    = IC(J)
            Y(ICOL) = Y(ICOL) - AMAT(J) * XX
            IF ( HLPZ(ICOL) .EQ. 0 ) THEN
               HLPZ(ICOL) = 1
               INDX       = COTN(ICOL)
               NHEAP      = NHEAP + 1
               IF ( NHEAP .EQ. 1 ) THEN
                  HEAP(1) = INDX
               ELSE
                  JH         = NHEAP
                  IH         = JH / 2
102               IF ( HEAP(IH) .GT. INDX ) THEN
                     HEAP(JH) = HEAP(IH)
                     JH       = IH
                     IH       = IH / 2
                     IF ( IH .GT. 0 ) GO TO 102
                  ENDIF
                  HEAP(JH) = INDX
               ENDIF
            ENDIF
         ENDDO
      ENDIF
105   IF ( NHEAP .GT. 0 ) THEN
         INDX  = HEAP(1)
         NHEAP = NHEAP - 1
         IF ( NHEAP .LE. 2 ) THEN
            IF ( NHEAP .EQ. 1 ) THEN
               HEAP(1) = HEAP(2)
            ELSEIF ( NHEAP .EQ. 2 ) THEN
               IF ( HEAP(2) .LT. HEAP(3) ) THEN
                  HEAP(1) = HEAP(2)
                  HEAP(2) = HEAP(3)
               ELSE
                  HEAP(1) = HEAP(3)
               ENDIF
            ENDIF
         ELSE
            MOVE  = HEAP(NHEAP+1)
            HEAP(NHEAP+1) = NROWD
            IH    = 1
            JH    = 2
!
!  We may look at an element past the end of the heap, but is will
!  not be selected since it has been set to Nrowd > LJNROW above
!
103         IF ( HEAP(JH) .GT. HEAP(JH+1) ) JH = JH + 1
            IF ( MOVE .GT. HEAP(JH) ) THEN
               HEAP(IH) = HEAP(JH)
               IH       = JH
               JH       = JH * 2
               IF ( JH .LE. NHEAP ) GO TO 103
            ENDIF
            HEAP(IH) = MOVE
         ENDIF
         GO TO 100
      ENDIF
      RETURN
!
!  The heap approach has become too dense - switch to straight
!  loop over indx.
!
101   INDX1 = INDX
      DO INDX = INDX1, CMI%LJNROW
         ICOL = CNTO(INDX)
         IROW = RNTO(INDX)
         HLPZ(ICOL) = 0
         IF ( ABS( Y(ICOL) ) .LE. YMAX ) THEN
            X(IROW) = 0.D0
         ELSE
            JSTR    = RS(IROW)
            XX      = Y(ICOL) / AMAT(JSTR)
            X(IROW) = XX
            IF ( RL(IROW) .LE. 2 ) THEN
               IF ( RL(IROW) .EQ. 2 ) THEN
                  ICOL    = IC(JSTR+1)
                  Y(ICOL) = Y(ICOL) - AMAT(JSTR+1) * XX
               ENDIF
            ELSE
               IF ( RL(IROW) .EQ. 3 ) THEN
                  ICOL    = IC(JSTR+1)
                  Y(ICOL) = Y(ICOL) - AMAT(JSTR+1) * XX
                  ICOL    = IC(JSTR+2)
                  Y(ICOL) = Y(ICOL) - AMAT(JSTR+2) * XX
               ELSE
                  DO J = JSTR+1, JSTR + RL(IROW) - 1
                     ICOL    = IC(J)
                     Y(ICOL) = Y(ICOL) - AMAT(J) * XX
                  ENDDO
               ENDIF
            ENDIF
         ENDIF
      ENDDO
      RETURN
   ENDIF
!
!  This is the case where Indxcr is zero, i.e. the sparsety pattern
!  of the incoming row is not known.
!
   ymax = 0.d0
   DO INDX = 1, CMI%LJNROW
      ICOL = CNTO(INDX)
      IROW = RNTO(INDX)
      IF ( ABS( Y(ICOL) ) .LE. YMAX ) THEN
         X(IROW) = 0.D0
      ELSE
         JSTR    = RS(IROW)
         XX      = Y(ICOL) / AMAT(JSTR)
         X(IROW) = XX
         IF ( RL(IROW) .LE. 2 ) THEN
            IF ( RL(IROW) .EQ. 2 ) THEN
               ICOL    = IC(JSTR+1)
               Y(ICOL) = Y(ICOL) - AMAT(JSTR+1) * XX
            ENDIF
         ELSE
            IF ( RL(IROW) .EQ. 3 ) THEN
               ICOL    = IC(JSTR+1)
               Y(ICOL) = Y(ICOL) - AMAT(JSTR+1) * XX
               ICOL    = IC(JSTR+2)
               Y(ICOL) = Y(ICOL) - AMAT(JSTR+2) * XX
            ELSE
               DO J = JSTR+1, JSTR + RL(IROW) - 1
                  ICOL    = IC(J)
                  Y(ICOL) = Y(ICOL) - AMAT(J) * XX
               ENDDO
            ENDIF
         ENDIF
      ENDIF
   ENDDO

   END SUBROUTINE COSXUY

   SUBROUTINE COSUXY( CMI, ALLV, Y, RNTO, CNTO, CS, CL, IR, BMAT, HLP1 )
!**       Solves the set of equations
!**       U * X = Y
!**       where X is the vector of unknowns. The result is
!**       returned in Y as a row-copy of the solution. Only the
!**       non-triangular rows are included in Y unless AllV is .true..
!**       Pre-triangular are assumed to be zero, and post-triangular
!**       are assumed to be computed using other methods. If AllV is
!**       .true. then the post-triangular rows are also computed.
!**       The number of nonzero elements in Y are returned in LKLUCL
!**       and the first LKLUCL elements in Hlp1 contain the row
!**       numbers of these elements.
!**   DESCRIPTION OF PARAMETERS
!**       Y - The vector of right hand sides (input) and the
!**           solution vector (output). The indices are old
!**           row numbers.
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI

   REAL(CO_R)  Y(*), BMAT(*), XX, YMAX, XMAX
   INTEGER RNTO(*), CNTO(*), CS(*), CL(*), IR(*), HLP1(*)
   LOGICAL, Intent(IN) :: ALLV

   INTEGER INDX, IROW, ICOL, J, JSTR, INDX2

   CMI%LKLUCL = 0
   YMAX   = CMI%RTMINA
   YMAX   = 0.D0
   XMAX   = CMI%RTMINA / CMI%RTEPS0
   IF ( ALLV ) THEN
      INDX2 = CMI%LKPRET+1
   ELSE
      INDX2 = CMI%LKTRIA+1
   ENDIF
   DO INDX = CMI%LJNROW, INDX2, -1
      IROW = RNTO(INDX)
      IF ( ABS( Y(IROW) ) .LE. YMAX ) THEN
         Y(IROW) = 0.D0
      ELSE
         ICOL = CNTO(INDX)
         JSTR    = CS(ICOL)
         XX      = Y(IROW) / BMAT(JSTR)
         Y(IROW) = XX
!
!  We keep track of the largest element stored in Y but only for
!  rows that are not triangular, since these rows are not scaled
!  in the same way as other rows.
!
         IF ( ABS(XX) .GT. XMAX .AND. INDX .GT. CMI%LKTRIA ) THEN
            XMAX = ABS(XX)
!           YMAX = CMI%RTEPS0 * XMAX
         ENDIF
         CMI%LKLUCL  = CMI%LKLUCL + 1
         HLP1(CMI%LKLUCL) = IROW
         IF ( CL(ICOL) .LE. 2 ) THEN
            IF ( CL(ICOL) .EQ. 2 ) THEN
               IROW    = IR(JSTR+1)
               Y(IROW) = Y(IROW) - BMAT(JSTR+1) * XX
            ENDIF
         ELSE
            IF ( CL(ICOL) .EQ. 3 ) THEN
               IROW    = IR(JSTR+1)
               Y(IROW) = Y(IROW) - BMAT(JSTR+1) * XX
               IROW    = IR(JSTR+2)
               Y(IROW) = Y(IROW) - BMAT(JSTR+2) * XX
            ELSE
               DO J = JSTR + 1, JSTR + CL(ICOL) - 1
                  IROW    = IR(J)
                  Y(IROW) = Y(IROW) - BMAT(J) * XX
               ENDDO
            ENDIF
         ENDIF
      ENDIF
   ENDDO

   CMI%RTMXUC = XMAX 
                     ! use elsewhere.
   RETURN

   END SUBROUTINE COSUXY

   REAL(CO_R) FUNCTION COANCP( CMI, ICOL, CLEAR, XL, JL )
!**       Computes the squared 2-norm of an updated column. As a
!**       byproduct, Nwk2 will be cleared after the call.
!**   Description of Parameters
!**       Icol  - The column to be updated. It will be nonbasic.
!**       Clear - Logical that is true if the work vector Nwk1 is
!**               known to be cleared.
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R) XL(*); INTEGER JL(*)
   INTEGER ICOL
   LOGICAL CLEAR

   REAL(CO_R)  NORM
   INTEGER I, IROW

   CMI%LKANUP = CMI%LKANUP + 1
!
!  Update the column. The result will be returned in Nwk2
!
   CALL COUPCL( CMI, ICOL  , XL(CMI%LLNWK2+1),        &
                JL(CMI%LLRNTO+1), JL(CMI%LLCNTO+1),   &
                JL(CMI%LLLSOR+1), JL(CMI%LLLPIV+1),   &
                JL(CMI%LLLROW+1), XL(CMI%LLLMAT+1),   &
                JL(CMI%LLCSTR+1), JL(CMI%LLCLEN+1),   &
                JL(CMI%LLIR  +1), XL(CMI%LLBMAT+1),   &
                JL(CMI%LLHLP1+1), JL(CMI%LLSTCL+1),   &
                JL(CMI%LLRNUM+1), XL(CMI%LLJACE+1),   &
                CLEAR, XL, JL )
!
!  Compute the squared 2-norm and clear the vector again.
!
   NORM = 1.D0
   DO I = 1, CMI%LKLUCL
      IROW            = JL(CMI%LLHLP1+I)
      NORM            = NORM + XL(CMI%LLNWK2+IROW) ** 2
      XL(CMI%LLNWK2+IROW) = 0.D0
   ENDDO

   COANCP = NORM

   END FUNCTION COANCP

   SUBROUTINE CORDGC( CMI, PRICE, SLOPE, XL, JL )
!**   Logical Operation
!**       Computes the Lagrange multipliers and if Price is True
!**       also the complete vector of reduced gradients.
!**       If price is false we just return the scalar product
!**       of the Dir vector with the reduced costs in SLOPE.
!*
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   REAL(CO_R) XL(*); INTEGER JL(*)
   REAL(CO_R)  SLOPE
   LOGICAL PRICE

   LOGICAL OBJNBS
   REAL(CO_R)  RGRA, TERM, MAX_TERM
   INTEGER IROW, ICOL, ICOLCR, INDX, J
!
!  Objnbs - Logical that is true if the objective function is
!           a nonbasic variable (phase 2 only)
!
!  Compute the Lagrange multipliers and the updated objective
!  function row by a call of Cobtrl.
!
   IF ( CMI%LKSLRS .GT. 0 ) THEN
      DO ICOL = 1, CMI%LJNSTR
         XL(CMI%LLRGRE+ICOL) = 0.D0
      ENDDO
      DO IROW = 1,CMI%LJNROW
         XL(CMI%LLRGRE+CMI%LJNSTR+IROW) = JL(CMI%LLIFSL+IROW)
      ENDDO
      ICOLCR = 0
      OBJNBS = .FALSE.
! $if defined (testout)
      if ( CMI%LOREDG .ge. 2 ) then
         DO IROW = 1,CMI%LJNROW
            if ( jl(CMI%LLIFSL+irow) .ne. 0 ) then
               icol = irow + CMI%LJNSTR
               write(CMI%MSGTXT,"('Row=',i5,' Col=',i6,' Bs=',i2,' Min=',1p,e13.6,' X=',1p,e13.6,' Max=',1p,e13.6)") &
                   Irow,icol,jl(CMI%LLBASC+icol), xl(CMI%LLXMIN+icol), xl(CMI%LLXSOL+icol), xl(CMI%LLXMAX+icol)
               CALL CO2DOC( CMI, Asis )
            if ( CMI%LOREDG .ge. 3 ) call coresi( irow )
            endif
         ENDDO
      endif
! $endif
   ELSE
! $if defined (testout)
      IF ( CMI%LOREDG .GT. 5 ) THEN
         DO ICOL = 1, CMI%LJNCOL
            XL(CMI%LLRGRE+ICOL) = 0.D0
         ENDDO
      ENDIF
! $endif
      IF ( .NOT. PRICE ) THEN
         DO ICOL = CMI%LJNSTR+1, CMI%LJNCOL
            XL(CMI%LLRGRE+ICOL) = 0.D0
         ENDDO
      ENDIF
      XL(CMI%LLRGRE+CMI%LJOBJC) = -CMI%RPSOBJ * CMI%RVSOBJ
      ICOLCR = CMI%LJOBJC
      IF ( CMI%LJOBJR .NE. 0 ) THEN
         CMI%LJINCR = JL(CMI%LLROTN+CMI%LJOBJR)
      ELSE
         CMI%LJINCR = 0
      ENDIF
      OBJNBS = JL(CMI%LLBASC+CMI%LJOBJC) .LE. 0
   ENDIF
! $if defined (testout)
   IF ( CMI%LOREDG .GT. 5 ) THEN
      CMI%MSGTXT = ' The gradient of the objective function'
      CALL CO2DOC( CMI, Asis )
      CALL COPVRL( CMI, CMI%LNRGRE, XL(CMI%LLRGRE+1) )
   ENDIF
   IF ( CMI%LOREDG .GT. 1 ) THEN
      WRITE(CMI%MSGTXT,*) 'Cordgc: Objnbs=',objnbs,' Icolcr=',Icolcr,' Ljincr=',cmi%ljincr
      CALL CO2DOC( CMI, Asis )
   ENDIF
! $endif
   IF ( OBJNBS ) THEN
      DO IROW = 1, CMI%LJNROW
         XL(CMI%LLUM  +IROW) = 0.D0
      ENDDO
   ELSE
      CALL COBTRL( CMI, XL(CMI%LLRGRE+1), XL(CMI%LLUM  +1),  &
                   XL(CMI%LLNWK1+1), JL(CMI%LLRNTO+1),       &
                   JL(CMI%LLCNTO+1), JL(CMI%LLCOTN+1),       &
                   JL(CMI%LLCBTO+1), JL(CMI%LLLSOR+1),       &
                   JL(CMI%LLLPIV+1), JL(CMI%LLLROW+1),       &
                   XL(CMI%LLLMAT+1), JL(CMI%LLLSTR+1),       &
                   JL(CMI%LLRSTR+1), JL(CMI%LLRLEN+1),       &
                   JL(CMI%LLIC  +1), XL(CMI%LLAMAT+1),       &
                   JL(CMI%LLHLPZ+1), JL(CMI%LLHEAP+1),       &
                   ICOLCR )
   ENDIF

   IF ( PRICE ) THEN
      IF ( OBJNBS ) THEN
         DO ICOL = 1, CMI%LJNCOL
            XL(CMI%LLRGRE+ICOL) = 0.D0
         ENDDO
         XL(CMI%LLRGRE+CMI%LJOBJC) = -CMI%RPSOBJ * CMI%RVSOBJ
      ELSEIF ( ICOLCR .NE. 0 ) THEN
         CALL COPRC1( CMI, XL(CMI%LLRGRE+1), XL(CMI%LLUM  +1), JL(CMI%LLSTCL+1), JL(CMI%LLRNUM+1),  &
                      XL(CMI%LLJACE+1), JL(CMI%LLRGFR+1), 1, CMI%LKNNFX )
! $if defined (testout)
         IF ( CMI%LOREDG .GT. 1 ) THEN
            WRITE(CMI%MSGTXT,*) 'Cordgc: After calling Coprc1. LKNNFX=', CMI%LKNNFX
            CALL CO2DOC( CMI, Asis )
         ENDIF
! $endif
      ELSE
         CALL COPRC2( CMI, XL(CMI%LLRGRE+1), XL(CMI%LLUM  +1), JL(CMI%LLSTCL+1), JL(CMI%LLRNUM+1), &
                      XL(CMI%LLJACE+1), JL(CMI%LLRGFR+1), 1, CMI%LKNNFX )
! $if defined (testout)
         IF ( CMI%LOREDG .GT. 1 ) THEN
            WRITE(CMI%MSGTXT,*) 'Cordgc: After calling Coprc2. LKNNFX=', CMI%LKNNFX
            CALL CO2DOC( CMI, Asis )
         ENDIF
! $endif
      ENDIF
   ELSE
      SLOPE = 0.D0
      DO INDX = 1, CMI%LKNSUP
         MAX_TERM = 0.D0
         IF ( XL(CMI%LLDIR +INDX) .NE. 0.D0 ) THEN
            ICOL = JL(CMI%LLRGFR+INDX)
            IF ( ICOL .LE. CMI%LJNSTR ) THEN
               RGRA = 0.D0
               DO J = JL(CMI%LLSTCL+ICOL), JL(CMI%LLSTCL+ICOL+1) - 1
                  TERM = XL(CMI%LLUM  +JL(CMI%LLRNUM+J)) * XL(CMI%LLJACE+J)
                  MAX_TERM = MAX( MAX_TERM, ABS(TERM) )
                  RGRA = RGRA - TERM
               ENDDO
            ELSE
               RGRA = XL(CMI%LLRGRE+ICOL) -  XL(CMI%LLUM  +ICOL-CMI%LJNSTR)
               MAX_TERM = MAX( MAX_TERM, ABS(XL(CMI%LLUM  +ICOL-CMI%LJNSTR)) )
            ENDIF
! $if defined (testout)
            IF ( CMI%LOREDG .GT. 5 ) THEN
               WRITE(CMI%MSGTXT,*) 'Superbasic',indx,' = col',icol,' has Rgra=',rgra,' Max_Term=',Max_TERM
               CALL CO2DOC( CMI, Asis )
            ENDIF
! $endif
            SLOPE = SLOPE + XL(CMI%LLDIR +INDX) * RGRA
         ENDIF
      ENDDO
   ENDIF

! $if defined (testout)
   IF ( CMI%LOREDG .GT. 3 ) THEN
      CMI%MSGTXT = ' The lagrange multipliers'
      CALL CO2DOC( CMI, Asis )
      CALL COPVRL( CMI, CMI%LNUM  , XL(CMI%LLUM  +1) )
      IF ( CMI%LOREDG .GT. 4 ) THEN
         IF ( PRICE ) THEN
            CMI%MSGTXT = ' The updated gradient of the objective function'
            CALL CO2DOC( CMI, Asis )
            CALL COPVRL( CMI, CMI%LNRGRE, XL(CMI%LLRGRE+1) )
         ELSE
            WRITE(CMI%MSGTXT,*) 'The slope along the direction DIR=',slope
            CALL CO2DOC( CMI, Asis )
         ENDIF
      ENDIF
   ENDIF

   CONTAINS

   SUBROUTINE CORESI( IROWMI )
!**   LOGICAL OPERATION
!**      Prints information about row Irowmi including derivative
!**      values, Xsol values and lower and upper bounds
!**   DESCRIPTION OF PARAMETERS
!**       IROWMI - The number of the interesting row.
!*
   INTEGER IROWMI

   INTEGER J, ICOL
   LOGICAL NLJAC

   NLJAC = .FALSE.
   WRITE(CMI%MSGTXT,"('Information about row',I6,'. Residual=',1P,E17.10,' u=',1P,E17.10)") &
      IROWMI, XL(CMI%LLGRES+IROWMI), XL(CMI%LLUM  +IROWMI)
   CALL CO2DOC( CMI, Asis )
   CMI%MSGTXT = '   col bs nl        Jac              Xmin             Xsol             Xmax'
   DO J = 1, CMI%LJCNUM
      IF ( JL(CMI%LLRNUM+J) .EQ. IROWMI ) THEN
         ICOL = JL(CMI%LLCNUM+J)
         IF ( .NOT. CMI%LSLINR ) NLJAC = JL(CMI%LLJACT+J) .NE. 0
         WRITE(CMI%MSGTXT,"(I6,L2,L3,1P,4E17.9)") ICOL, JL(CMI%LLBASC+ICOL) .NE. 0, NLJAC, &
            XL(CMI%LLJACE+J), XL(CMI%LLXMIN+ICOL), XL(CMI%LLXSOL+ICOL), XL(CMI%LLXMAX+ICOL)
         CALL CO2DOC( CMI, Asis )
      ENDIF
   ENDDO

   END SUBROUTINE CORESI
! $endif

   END SUBROUTINE CORDGC

   SUBROUTINE COPTML( CMI, OPTIM1, OPTIM2 )
!**   LOGICAL OPERATION
!**       Defines the current solution as optimal (.true.) or
!**       not (.false.). There are two tests, Optim1 is only looking
!**       at the reduced gradient and is rather strict. Optim2 is
!**       also including second order information.
!**
      IMPLICIT NONE

   Type (conopt_model_info) CMI
   LOGICAL OPTIM1, OPTIM2

   REAL(CO_R) DIRTST
   REAL(CO_R), Parameter :: One = 1.d0

   IF ( CMI%LKNOON .GT. 0 ) THEN
      DIRTST = CMI%RVRGRM / SQRT( 2.0 ** CMI%LKNOON )
   ELSE
      DIRTST = CMI%RVRGRM
   ENDIF
!
!  The optimality tolerance used to depend on whether we were feasible
!  or not. We do not want to stop early in Phase 1 if we have had a
!  feasible solution before. We should get something better for keeping
!  feasible solutions and we do have scaling now so the tolerance is
!  kept as the user defined it.
!
   IF ( CMI%LSSCAL ) THEN
      CMI%RTREDI = CMI%RTREDG
   ELSE
!
!  No scaling: This can be a user option or it can indicate that the
!  model is triangular. The tolerance in Phase 2 used to be scaled:
!  Reduced Cost = dfobj / dxn and we consided the relatived change in
!  objective resulting in (dfobj/fobj) / dxn and the tolerance was
!  therefore scaled with fobj or rather RVOBJ1. However, this does not
!  take into account the scaling of xn that is variable for the various
!  nonbasic variables. So the scaling has been dropped.
!
      IF ( CMI%LJPHAS .EQ. 2 ) THEN
!         CMI%RTREDI = MAX( CMI%RTREDG, CMI%RTEPS0*CMI%RVOBJ1 )
         CMI%RTREDI = CMI%RTREDG
      ELSE
         CMI%RTREDI = MIN( CMI%RVOBJ1*CMI%RTREDG, CMI%RTEPS0 )
      ENDIF
   ENDIF
   CMI%LSHESI = .FALSE. 
   OPTIM1 = DIRTST .LE. CMI%RTREDI
   IF ( .NOT. OPTIM1 .AND. MAX( CMI%LKSTAL, CMI%LKSTL2 ) .GE. MIN( 10, CMI%LFSTAL/2 ) &
                     .AND. MAX( CMI%LKHSIT, CMI%LK2DIT) .GT. CMI%LKITER-4 ) THEN
      IF ( DIRTST .LE. CMI%RVHESN*CMI%RTEPSM*10.D0 ) THEN
         OPTIM1     = .TRUE. 
         CMI%LSHESI = .TRUE.
! $if defined (testout)
         IF ( CMI%LORHES .GE. 1 ) THEN
            write(CMI%MSGTXT,*) 'Coptml: OPTIM1 defined as .true. based on the Hessian norm. Dirtst=',Dirtst, &
                                ' and RVHESN=',cmi%rvhesn
            CALL CO2DOC( CMI, Asis )
         ENDIF
! $endif
      ENDIF
   ENDIF
   OPTIM2 = OPTIM1
   IF ( ( ( CMI%LKNICR .GE. CMI%LFNICR-2 ) .OR.   &
          ( CMI%RTOBJT .LE. CMI%RTDFMN .AND.      &
            CMI%RTNEW .LE. CMI%RTNWMJ) ) .AND.    &
        ( CMI%LJRAGE .GT. CMI%LKNSUP / 2 ) )      &
       OPTIM2 = OPTIM2                            &
       .OR. DIRTST .LE. CMI%RTDFMN * SQRT( CMI%RVHSSM )  &
       .OR. ( (CMI%LMSMOD .EQ. SRC_QN .OR. CMI%LMSMOD .EQ. SRC_SQP ) .AND. -CMI%RVSLOP .LT. CMI%RTDFMN )
! $if defined (testout)
   IF ( CMI%LORHES .GT. 1 ) THEN
      write(CMI%MSGTXT,*) 'Coptml: LKNICR=',CMI%LKNICR,' LFNICR=',CMI%LFNICR,' RTDFMN=',CMI%RTDFMN
      CALL CO2DOC( CMI, Asis )
      write(CMI%MSGTXT,*) 'RTNEW=',CMI%RTNEW,' RTNWMJ=',CMI%RTNWMJ,' LJRAGE=',CMI%LJRAGE
      CALL CO2DOC( CMI, Asis )
      write(CMI%MSGTXT,*) 'LKNSUP=',CMI%LKNSUP,' RVHSSM=',CMI%RVHSSM,' Dirtst=',dirtst
      CALL CO2DOC( CMI, Asis )
      write(CMI%MSGTXT,*) 'RVSLOP=',CMI%RVSLOP,' RTREDG=',CMI%RTREDG,' RTREDI=',CMI%RTREDI
      CALL CO2DOC( CMI, Asis )
      write(CMI%MSGTXT,*) 'Optim1=',optim1,' Optim2=',Optim2,' LKSLOP=',CMI%LKSLOP,' LFSLOP=',CMI%LFSLOP
      CALL CO2DOC( CMI, Asis )
   ENDIF
! $endif
!
!  If the model is declared optimal based on Optim2 only the check again if 2nd derivatives are
!  large so we can use the better message issued when Lshesi is .true.
!
   IF ( OPTIM2 .AND. .NOT. OPTIM1 .AND. MAX( CMI%LKHSIT, CMI%LK2DIT) .GT. CMI%LKITER-4 ) THEN
      IF ( DIRTST .LE. CMI%RVHESN*CMI%RTEPSM*10.D0 ) THEN
         CMI%LSHESI = .TRUE.
! $if defined (testout)
         IF ( CMI%LORHES .GE. 1 ) THEN
            write(CMI%MSGTXT,*) 'Coptml: Optim2 = t: Lshesi turned on based on the Hessian norm. RVHESN=',cmi%rvhesn
            CALL CO2DOC( CMI, Asis )
         ENDIF
! $endif
      ENDIF
   ENDIF

   END SUBROUTINE COPTML

   SUBROUTINE Make_JCNM( CMI, JL, IROW, J1, J2, NUMNZ, IROW1 )
!
!  Creates the list of Column numbers needed as input to FDEval.
!  The input is CONOPT row number Irow.
!  The output is the vector of column numbers, Jcnm, and the row number,
!  Irow1, in Fortran or C base plus the start and end index in Rcnu,
!  J1 and J2.
!
      IMPLICIT NONE
   Type (conopt_model_info) CMI
   INTEGER JL(*), J1, J2, NUMNZ, IROW, IROW1
   INTEGER J

   J1 = JL(CMI%LLSTLR+IROW) + JL(CMI%LLLNLR+IROW)
   J2 = JL(CMI%LLSTLR+IROW+1) - 1
   NUMNZ = 0
   IF ( CMI%LSBAS0 ) THEN
      IROW1 = IROW - 1
      DO J = J1, J2
         NUMNZ                = NUMNZ + 1
         JL(CMI%LLJCNM+NUMNZ) = JL(CMI%LLRCNU+J) - 1
      ENDDO
   ELSE
      IROW1 = IROW
      DO J = J1, J2
         NUMNZ                = NUMNZ + 1
         JL(CMI%LLJCNM+NUMNZ) = JL(CMI%LLRCNU+J)
      ENDDO
   ENDIF

   END SUBROUTINE Make_JCNM

   SUBROUTINE PerturbX( CMI, XL, X, ICOL, USXUNS, XOLD, DX )
!
!  Finds a suitable perturbation for the non-fixed variable Icol
!  to be used for testing first and 2nd derivatives.
!  We compare Xsol to the bounds and determine if a move up or down
!  gives us an appropriate step.
!  The actual change is made in X, that can represent Xsol or Xuns
!  depending on whether scaling is off or on.
!
      IMPLICIT NONE

   Type (conopt_model_info) CMI

   INTEGER ICOL
   LOGICAL USXUNS
   REAL(CO_R) XOLD, DX, XL(*), X(*)
   REAL(CO_R) XNEW

   DX   = MAX( ONE, ABS(XL(CMI%LLXSOL+ICOL))) * CMI%RTEPS2
   XNEW = XL(CMI%LLXSOL+ICOL) + DX
   IF ( XNEW .GT. XL(CMI%LLXMAX+ICOL) ) THEN
      IF ( XL(CMI%LLXMAX+ICOL)-XL(CMI%LLXSOL+ICOL) .GT. XL(CMI%LLXSOL+ICOL)-XL(CMI%LLXMIN+ICOL) ) THEN
         DX   = XL(CMI%LLXMAX+ICOL) - XL(CMI%LLXSOL+ICOL)
         XNEW = XL(CMI%LLXMAX+ICOL)
      ELSE
         XNEW = MAX( XL(CMI%LLXMIN+ICOL), XL(CMI%LLXSOL+ICOL) - DX )
         DX   = XNEW - XL(CMI%LLXSOL+ICOL)
      ENDIF
   ENDIF
   IF ( USXUNS ) THEN
      XNEW = XNEW * XL(CMI%LLCSCL+ICOL)
      DX   = DX   * XL(CMI%LLCSCL+ICOL)
   ENDIF
   XOLD    = X(ICOL)
   X(ICOL) = XNEW

   END SUBROUTINE PerturbX

! $if defined (nonan)
   LOGICAL FUNCTION ISNAN( X )
!
!  Function for testing if a number is NaN = Not A Number
!  Is used to test return values from user routines.
!  If the system does not have a routine it is possible just to
!  turn the test off using Isnan = .false.
!
   REAL(CO_R) X
   ISNAN = .FALSE.
   END FUNCTION ISNAN
! $endif

   LOGICAL FUNCTION COISNAN( X )
!
!  Function for testing if a number is NaN = Not A Number or overflows
!  what we would normally like to see in function and derivative
!  values. We use 1.D40 as the upper bound, well above Rtamxj = 1.D30.
!  Is used to test all (?) return values from user routines.
!  If the system does not have a routine it is possible just to
!  turn the test off using Isnan = .false.
!
   REAL(CO_R) X
   IF ( ISNAN(X) ) THEN
      COISNAN = .TRUE.
   ELSEIF ( ABS(X) .GE. 1.D40 ) THEN
      COISNAN = .TRUE.
   ELSE
      COISNAN = .FALSE.
   ENDIF
   END FUNCTION COISNAN

END Module CONOPT_Utilities
